***************************************************************************
*                                                                         *
*     Written by: Manfred Christ                                          *
*     Modified by: Mansoor A. Chishtie          December 2nd, 1996        *
*        Improved exceution time by 6 cycles per iteration.               *
*                                                                         *
*     Cycles:                                                             *
*     Epilog code: 15 cycles                                              *
*     Looped code: 31 * N/8                                               *
*     Prolog code: 2 cycles                                               *
*                                                                         *
*                                                                         *
***************************************************************************
;
;
; stage3: number of cycles: 6.5+9+6+9.5= Total 31 cycles
;
stage3      .macro

        .global STAGE3,MCR3,end?
        
        .asg    AR2,P
        .asg    AR3,Q
        
STAGE3: STM     #DATA+0,P   ; pointer to DATA       pr,pi
        STM     #DATA+8,Q   ; pointer to DATA + 8   qr,qi
        LD      #-1,ASM     ; ASM=-1
        STM     #9,AR1      
        STM     #2,AR4
        .if     N>8
        STM     #N/8-1,BRC  ; execute N/8-1 times '4 macros'
        RPTBD   end?        ;
        .endif              ;
        LD      #SIN45,DP
        LD      SIN45,T     ; load to sin(45)
***************************************************************************
*                                                                         *
*     MACRO requires   number of words/number of cycles: 6.5              *
*                                                                         *
*        PR'=(PR+QR)/2      PI'=(PI+QI)/2                                 *
*        QR'=(PR-QR)/2      QI'=(PI-QI)/2                                 *
*                                                                         *
*  version 0.99    from Manfred Christ     update:  2. May. 94            *
***************************************************************************
;                                         (contents of register after exec.)
;                                                         AR2  AR3
;                                                         ---  ---
MCR3  LD    *P,16,A         ; A :=       PR                PR   QR
      SUB   *Q,16,A,B       ; B :        PR-QR             PR   QR
      ST    B,*Q            ; QR:= (1/2)(PR-QR)
||    ADD   *Q+,B           ; B :=      (PR+QR)            PR   QI
      ST    B,*P+           ; PR:= (1/2)(PR+QR)
||    LD    *Q,A            ; A :=          QI             PI   QI
      ST    A,*Q            ; Dummy write
||    SUB   *P,B            ; B :=      (PI-QI)            PI   QI
      ST    B,*Q+           ; QI:= (1/2)(PI-QI)            PI   QR+1
||    ADD   *P,B            ; B :=      (PI+QI)
      ST    B,*P+           ; PI:= (1/2)(PI+QI)            PR+1 QR+1
      
      
***************************************************************************
*                                                                         *
*     MACRO requires   number of words/number of cycles: 9                *
*                                                                         *
*  T=SIN(45)=COS(45)=W45                                                  *
*                                                                         *
*                                                                         *
*        PR'= PR + (W*QI + W*QR) = PR + W * QI + W * QR    (<- AR2)       *
*        QR'= PR - (W*QI + W*QR) = PR - W * QI - W * QR    (<- AR3)       *
*        PI'= PI + (W*QI - W*QR) = PI + W * QI - W * QR    (<- AR2+1)     *
*        QI'= PI - (W*QI - W*QR) = PI - W * QI + W * QR    (<- AR3+2)     *
*                                                                         *
*        PR'= PR +  W * (QI + QR)    (<- AR2)                             *
*        QR'= PR -  W * (QI + QR)    (<- AR3)                             *
*        PI'= PI +  W * (QI - QR)    (<- AR2+1)                           *
*        QI'= PI -  W * (QI - QR)    (<- AR3+1)                           *
*                                                                         *
*  version 0.99    from Manfred Christ     update: 2. May. 94             *
*                                                                         *
***************************************************************************

||    MPY   *Q+,A         ;A   =  QR*W                    PR   QI
      MVMM  AR4,AR0       ;Index = 2
      MAC   *Q-,A         ;A  :=     (QR*W +QI*W)         PR   QR
      ADD   *P,16,A,B     ;B  := (PR+(QR*W +QI*W ))       PR   QR
      ST    B,*P    ;<<ASM;PR':= (PR+(QR*W +QI*W ))/2     PI   QR
||    SUB   *P+,B         ;B  := (PR-(QR*W +QI*W ))       PI   QR
      ST    B,*Q    ;<<ASM;QR':= (PR-(QR*W +QI*W ))/2
||    MPY   *Q+,A         ;A  :=      QR*W                PI   QI
      MAS   *Q,A          ;A  := (   (QR*W -QI*W ))       PI   QI
      ADD   *P,16,A,B     ;B  := (PI+(QR*W -QI*W ))       PI   QI
      ST    B,*Q+0%       ;QI':= (PI+(QR*W -QI*W ))/2     PI   QI+1
||    SUB   *P,B          ;B  := (PI-(QR*W -QI*W ))       PI   QI+1
      ST    B,*P+         ;PI':= (PI-(QR*W -QI*W ))/2     PR+1 QI+1
***************************************************************************
*                                                                         *
*     MACRO 'PBY2I'    number of words/number of cycles: 6                *
*                                                                         *
*        PR'=(PR+QI)/2      PI'=(PI-QR)/2                                 *
*        QR'=(PR-QI)/2      QI'=(PI+QR)/2                                 *
*                                                                         *
*  version 0.99    from Manfred Christ     update:  2. May. 94            *
*                                                                         *
***************************************************************************
;                                         (contents of register after exec.)
;                                                     AR2      AR3
;                                                     ---      ---
||    LD    *Q-,A           ; A   :=     QI           PR       QR
      ADD   *P,A,B          ; B   := (PR+QI)          PR       QR
      ST    B,*P            ; PR' := (PR+QI)/2
||    SUB   *P+,B           ; B   := (PR-QI)          PI       QR
      ST    B,*Q            ; QR' := (PR-QI)/2
||    LD    *Q+,A           ; A   :=     QR           PI       QI
      ADD   *P,A,B          ; B   := (PI+QR)          PI       QI
      ST    B,*Q+           ; QI' := (PI+QR)/2        PI       QR+1
||    SUB   *P,B            ; B   := (PI-QR)
      ST    B,*P+           ; PI' := (PI-QR)/2        PR+1     QR+1


***************************************************************************
*                                                                         *
*     MACRO requires   number of words/number of cycles: 9.5              *
*                                                                         *
*  version 0.99    from: Manfred Christ   update:  2. May. 94             *
*                                                                         *
*   ENTRANCE IN THE MACRO: AR2->PR,PI                                     *
*                          AR3->QR,QI                                     *
*                          TREG=W=COS(45)=SIN(45)                         *
*                                                                         *
*       EXIT OF THE MACRO: AR2->PR+1,PI+1                                 *
*                          AR3->QR+1,QI+1                                 *
*                                                                         *
*        PR'= PR + (W*QI - W*QR) = PR + W * QI - W * QR    (<- AR1)       *
*        QR'= PR - (W*QI - W*QR) = PR - W * QI + W * QR    (<- AR2)       *
*        PI'= PI - (W*QI + W*QR) = PI - W * QI - W * QR    (<- AR1+1)     *
*        QI'= PI + (W*QI + W*QR) = PI + W * QI + W * QR    (<- AR1+2)     *
*                                                                         *
*        PR'= PR + W*(QI - QR)  = PR - W *(QR -QI)   (<- AR2)             *
*        QR'= PR - W*(QI - QR)  = PR - W *(QR -QI)   (<- AR3)             *
*        PI'= PI - W*(QI + QR)     (<- AR2+1)                             *
*        QI'= PI + W*(QI + QR)     (<- AR3+1)                             *
*                                                                         *
* BK==0 !!!!!                                                             *
*                                                                         *
***************************************************************************
;                                                           AR2 AR3
;                                                           --- ---
||    MPY   *Q+,A          ;A  :=  QR*W                     PR  QI
      MVMM  AR1,AR0        ;Index = 9
      MAS   *Q-,A          ;A  := (QR*W -QI*W )             PR  QR
      ADD   *P,16,A,B      ;B  := (PR+(QR*W -QI*W ))        PR  QR
      ST    B,*Q+    ;<<ASM;QR':= (PR+(QR*W -QI*W ))/2      PR  QI
||    SUB   *P,B           ;B  := (PR-(QR*W -QI*W ))     
      ST    B,*P+    ;<<ASM;PR':= (PR-(QR*W -QI*W ))/2
||    MAC   *Q,A           ;A  := QR*W                      PI  QI
      MAC   *Q,A           ;A  := (   (QR*W +QI*W ))        PI  QI
      ADD   *P,16,A,B      ;B  := (PI+(QR*W +QI*W ))        PI  QI
      ST    B,*Q+0%   ;<ASM;QI':= (PI+(QR*W +QI*W ))/2      PI  QR+1
||    SUB   *P,B           ;B  := (PI-(QR*W +QI*W ))        
      STH   B,ASM,*P+0%    ;PI':= (PI-(QR*W +QI*W ))/2      PR+1QR+1
end?  .set  $-1
      
      STM   #-2,AR0        ;Index used in stdmacro macro
      .endm
