; Estabrom.asm
; Data ROM tables for the GSM EFR speech codec.

; This file contains all the data ROM tables that were defined in the reference
; C code, v 2.0.

	.def	r_mean_lsf			; 10 words
	.def	r_dico1_lsf			; 512 words
	.def	r_dico2_lsf			; 1024 words
	.def	r_dico3_lsf			; 1024 words
	.def	r_dico4_lsf			; 1024 words
	.def	r_dico5_lsf			; 256 words
	.def	r_f_gamma1			; 10 words
	.def	r_pred_6			; 61 words
	.def	r_inter_6			; 25 words
	.def	r_qua_gain_pitch		; 16 words
	.def	r_qua_gain_code 		; 32 words
	.def	r_window_232_8			; 240 words
	.def	r_window_160_80 		; 240 words
	.def	r_dhf_mask			; 57 words
	.def	r_interp_factor 		; 24 words



	.def	r_grid				; 61 words
	.def	r_inv_sqrt			; 49 words
	.def	r_lag_hl			; 20 words
	.def	r_log2				; 33 words, log2.tab
	.def	r_cos				; 65 words, lsp_lsf.tab
	.def	r_slope 			; 64 words, lsp_lsf.tab
	.def	r_pow2				; 33 words, pow2.tab
	.def	r_f_gamma2			; 10 words
	.def	r_dgray 			; 8 words
	.def	r_lsp_old			; 10 words
	.def	r_pdown 			; 7 words
	.def	r_f_gamma3			; 10 words
	.def	r_f_gamma4			; 10 words
	.def	r_cdown 			; 7 words
	.def	r_ab			; 5 words

	.def	r_sid_codeword			; 11 words

        .def    r_a
        .def    r_b
        .def    r_bitno
        .def    r_lag_l
        .def    r_lag_h
        .def    r_sid_codeword_bit
	
	.sect	  "estabrom"


r_grid:
	.field	32760,16		; r_grid[0] @ 0
	.field	32723,16		; r_grid[1] @ 16
	.field	32588,16		; r_grid[2] @ 32
	.field	32364,16		; r_grid[3] @ 48
	.field	32051,16		; r_grid[4] @ 64
	.field	31651,16		; r_grid[5] @ 80
	.field	31164,16		; r_grid[6] @ 96
	.field	30591,16		; r_grid[7] @ 112
	.field	29935,16		; r_grid[8] @ 128
	.field	29196,16		; r_grid[9] @ 144
	.field	28377,16		; r_grid[10] @ 160
	.field	27481,16		; r_grid[11] @ 176
	.field	26509,16		; r_grid[12] @ 192
	.field	25465,16		; r_grid[13] @ 208
	.field	24351,16		; r_grid[14] @ 224
	.field	23170,16		; r_grid[15] @ 240
	.field	21926,16		; r_grid[16] @ 256
	.field	20621,16		; r_grid[17] @ 272
	.field	19260,16		; r_grid[18] @ 288
	.field	17846,16		; r_grid[19] @ 304
	.field	16384,16		; r_grid[20] @ 320
	.field	14876,16		; r_grid[21] @ 336
	.field	13327,16		; r_grid[22] @ 352
	.field	11743,16		; r_grid[23] @ 368
	.field	10125,16		; r_grid[24] @ 384
	.field	8480,16 		; r_grid[25] @ 400
	.field	6812,16 		; r_grid[26] @ 416
	.field	5126,16 		; r_grid[27] @ 432
	.field	3425,16 		; r_grid[28] @ 448
	.field	1714,16 		; r_grid[29] @ 464
	.field	0,16			; r_grid[30] @ 480
	.field	-1714,16		; r_grid[31] @ 496
	.field	-3425,16		; r_grid[32] @ 512
	.field	-5126,16		; r_grid[33] @ 528
	.field	-6812,16		; r_grid[34] @ 544
	.field	-8480,16		; r_grid[35] @ 560
	.field	-10125,16		; r_grid[36] @ 576
	.field	-11743,16		; r_grid[37] @ 592
	.field	-13327,16		; r_grid[38] @ 608
	.field	-14876,16		; r_grid[39] @ 624
	.field	-16384,16		; r_grid[40] @ 640
	.field	-17846,16		; r_grid[41] @ 656
	.field	-19260,16		; r_grid[42] @ 672
	.field	-20621,16		; r_grid[43] @ 688
	.field	-21926,16		; r_grid[44] @ 704
	.field	-23170,16		; r_grid[45] @ 720
	.field	-24351,16		; r_grid[46] @ 736
	.field	-25465,16		; r_grid[47] @ 752
	.field	-26509,16		; r_grid[48] @ 768
	.field	-27481,16		; r_grid[49] @ 784
	.field	-28377,16		; r_grid[50] @ 800
	.field	-29196,16		; r_grid[51] @ 816
	.field	-29935,16		; r_grid[52] @ 832
	.field	-30591,16		; r_grid[53] @ 848
	.field	-31164,16		; r_grid[54] @ 864
	.field	-31651,16		; r_grid[55] @ 880
	.field	-32051,16		; r_grid[56] @ 896
	.field	-32364,16		; r_grid[57] @ 912
	.field	-32588,16		; r_grid[58] @ 928
	.field	-32723,16		; r_grid[59] @ 944
	.field	-32760,16		; r_grid[60] @ 960



r_inv_sqrt:
	.field	32767,16		; r_inv_sqrt[0] @ 0
	.field	31790,16		; r_inv_sqrt[1] @ 16
	.field	30894,16		; r_inv_sqrt[2] @ 32
	.field	30070,16		; r_inv_sqrt[3] @ 48
	.field	29309,16		; r_inv_sqrt[4] @ 64
	.field	28602,16		; r_inv_sqrt[5] @ 80
	.field	27945,16		; r_inv_sqrt[6] @ 96
	.field	27330,16		; r_inv_sqrt[7] @ 112
	.field	26755,16		; r_inv_sqrt[8] @ 128
	.field	26214,16		; r_inv_sqrt[9] @ 144
	.field	25705,16		; r_inv_sqrt[10] @ 160
	.field	25225,16		; r_inv_sqrt[11] @ 176
	.field	24770,16		; r_inv_sqrt[12] @ 192
	.field	24339,16		; r_inv_sqrt[13] @ 208
	.field	23930,16		; r_inv_sqrt[14] @ 224
	.field	23541,16		; r_inv_sqrt[15] @ 240
	.field	23170,16		; r_inv_sqrt[16] @ 256
	.field	22817,16		; r_inv_sqrt[17] @ 272
	.field	22479,16		; r_inv_sqrt[18] @ 288
	.field	22155,16		; r_inv_sqrt[19] @ 304
	.field	21845,16		; r_inv_sqrt[20] @ 320
	.field	21548,16		; r_inv_sqrt[21] @ 336
	.field	21263,16		; r_inv_sqrt[22] @ 352
	.field	20988,16		; r_inv_sqrt[23] @ 368
	.field	20724,16		; r_inv_sqrt[24] @ 384
	.field	20470,16		; r_inv_sqrt[25] @ 400
	.field	20225,16		; r_inv_sqrt[26] @ 416
	.field	19988,16		; r_inv_sqrt[27] @ 432
	.field	19760,16		; r_inv_sqrt[28] @ 448
	.field	19539,16		; r_inv_sqrt[29] @ 464
	.field	19326,16		; r_inv_sqrt[30] @ 480
	.field	19119,16		; r_inv_sqrt[31] @ 496
	.field	18919,16		; r_inv_sqrt[32] @ 512
	.field	18725,16		; r_inv_sqrt[33] @ 528
	.field	18536,16		; r_inv_sqrt[34] @ 544
	.field	18354,16		; r_inv_sqrt[35] @ 560
	.field	18176,16		; r_inv_sqrt[36] @ 576
	.field	18004,16		; r_inv_sqrt[37] @ 592
	.field	17837,16		; r_inv_sqrt[38] @ 608
	.field	17674,16		; r_inv_sqrt[39] @ 624
	.field	17515,16		; r_inv_sqrt[40] @ 640
	.field	17361,16		; r_inv_sqrt[41] @ 656
	.field	17211,16		; r_inv_sqrt[42] @ 672
	.field	17064,16		; r_inv_sqrt[43] @ 688
	.field	16921,16		; r_inv_sqrt[44] @ 704
	.field	16782,16		; r_inv_sqrt[45] @ 720
	.field	16646,16		; r_inv_sqrt[46] @ 736
	.field	16514,16		; r_inv_sqrt[47] @ 752
	.field	16384,16		; r_inv_sqrt[48] @ 768



	.align	2
r_lag_hl:
	.field	32728,16		; r_lag_h[0] @ 0
	.field	11904,16		; r_lag_l[0] @ 0
	.field	32619,16		; r_lag_h[1] @ 16
	.field	17280,16		; r_lag_l[1] @ 16
	.field	32438,16		; r_lag_h[2] @ 32
	.field	30720,16		; r_lag_l[2] @ 32
	.field	32187,16		; r_lag_h[3] @ 48
	.field	25856,16		; r_lag_l[3] @ 48
	.field	31867,16		; r_lag_h[4] @ 64
	.field	24192,16		; r_lag_l[4] @ 64
	.field	31480,16		; r_lag_h[5] @ 80
	.field	28992,16		; r_lag_l[5] @ 80
	.field	31029,16		; r_lag_h[6] @ 96
	.field	24384,16		; r_lag_l[6] @ 96
	.field	30517,16		; r_lag_h[7] @ 112
	.field	7360,16 		; r_lag_l[7] @ 112
	.field	29946,16		; r_lag_h[8] @ 128
	.field	19520,16		; r_lag_l[8] @ 128
	.field	29321,16		; r_lag_h[9] @ 144
	.field	14784,16		; r_lag_l[9] @ 144



r_log2:
	.field	0,16			; r_log2[0] @ 0
	.field	1455,16 		; r_log2[1] @ 16
	.field	2866,16 		; r_log2[2] @ 32
	.field	4236,16 		; r_log2[3] @ 48
	.field	5568,16 		; r_log2[4] @ 64
	.field	6863,16 		; r_log2[5] @ 80
	.field	8124,16 		; r_log2[6] @ 96
	.field	9352,16 		; r_log2[7] @ 112
	.field	10549,16		; r_log2[8] @ 128
	.field	11716,16		; r_log2[9] @ 144
	.field	12855,16		; r_log2[10] @ 160
	.field	13967,16		; r_log2[11] @ 176
	.field	15054,16		; r_log2[12] @ 192
	.field	16117,16		; r_log2[13] @ 208
	.field	17156,16		; r_log2[14] @ 224
	.field	18172,16		; r_log2[15] @ 240
	.field	19167,16		; r_log2[16] @ 256
	.field	20142,16		; r_log2[17] @ 272
	.field	21097,16		; r_log2[18] @ 288
	.field	22033,16		; r_log2[19] @ 304
	.field	22951,16		; r_log2[20] @ 320
	.field	23852,16		; r_log2[21] @ 336
	.field	24735,16		; r_log2[22] @ 352
	.field	25603,16		; r_log2[23] @ 368
	.field	26455,16		; r_log2[24] @ 384
	.field	27291,16		; r_log2[25] @ 400
	.field	28113,16		; r_log2[26] @ 416
	.field	28922,16		; r_log2[27] @ 432
	.field	29716,16		; r_log2[28] @ 448
	.field	30497,16		; r_log2[29] @ 464
	.field	31266,16		; r_log2[30] @ 480
	.field	32023,16		; r_log2[31] @ 496
	.field	32767,16		; r_log2[32] @ 512


r_cos:
	.field	32767,16		; r_cos[0] @ 0
	.field	32729,16		; r_cos[1] @ 16
	.field	32610,16		; r_cos[2] @ 32
	.field	32413,16		; r_cos[3] @ 48
	.field	32138,16		; r_cos[4] @ 64
	.field	31786,16		; r_cos[5] @ 80
	.field	31357,16		; r_cos[6] @ 96
	.field	30853,16		; r_cos[7] @ 112
	.field	30274,16		; r_cos[8] @ 128
	.field	29622,16		; r_cos[9] @ 144
	.field	28899,16		; r_cos[10] @ 160
	.field	28106,16		; r_cos[11] @ 176
	.field	27246,16		; r_cos[12] @ 192
	.field	26320,16		; r_cos[13] @ 208
	.field	25330,16		; r_cos[14] @ 224
	.field	24279,16		; r_cos[15] @ 240
	.field	23170,16		; r_cos[16] @ 256
	.field	22006,16		; r_cos[17] @ 272
	.field	20788,16		; r_cos[18] @ 288
	.field	19520,16		; r_cos[19] @ 304
	.field	18205,16		; r_cos[20] @ 320
	.field	16846,16		; r_cos[21] @ 336
	.field	15447,16		; r_cos[22] @ 352
	.field	14010,16		; r_cos[23] @ 368
	.field	12540,16		; r_cos[24] @ 384
	.field	11039,16		; r_cos[25] @ 400
	.field	9512,16 		; r_cos[26] @ 416
	.field	7962,16 		; r_cos[27] @ 432
	.field	6393,16 		; r_cos[28] @ 448
	.field	4808,16 		; r_cos[29] @ 464
	.field	3212,16 		; r_cos[30] @ 480
	.field	1608,16 		; r_cos[31] @ 496
	.field	0,16			; r_cos[32] @ 512
	.field	-1608,16		; r_cos[33] @ 528
	.field	-3212,16		; r_cos[34] @ 544
	.field	-4808,16		; r_cos[35] @ 560
	.field	-6393,16		; r_cos[36] @ 576
	.field	-7962,16		; r_cos[37] @ 592
	.field	-9512,16		; r_cos[38] @ 608
	.field	-11039,16		; r_cos[39] @ 624
	.field	-12540,16		; r_cos[40] @ 640
	.field	-14010,16		; r_cos[41] @ 656
	.field	-15447,16		; r_cos[42] @ 672
	.field	-16846,16		; r_cos[43] @ 688
	.field	-18205,16		; r_cos[44] @ 704
	.field	-19520,16		; r_cos[45] @ 720
	.field	-20788,16		; r_cos[46] @ 736
	.field	-22006,16		; r_cos[47] @ 752
	.field	-23170,16		; r_cos[48] @ 768
	.field	-24279,16		; r_cos[49] @ 784
	.field	-25330,16		; r_cos[50] @ 800
	.field	-26320,16		; r_cos[51] @ 816
	.field	-27246,16		; r_cos[52] @ 832
	.field	-28106,16		; r_cos[53] @ 848
	.field	-28899,16		; r_cos[54] @ 864
	.field	-29622,16		; r_cos[55] @ 880
	.field	-30274,16		; r_cos[56] @ 896
	.field	-30853,16		; r_cos[57] @ 912
	.field	-31357,16		; r_cos[58] @ 928
	.field	-31786,16		; r_cos[59] @ 944
	.field	-32138,16		; r_cos[60] @ 960
	.field	-32413,16		; r_cos[61] @ 976
	.field	-32610,16		; r_cos[62] @ 992
	.field	-32729,16		; r_cos[63] @ 1008
	.field	-32768,16		; r_cos[64] @ 1024



r_slope:
	.field	-26887,16		; r_slope[0] @ 0
	.field	-8812,16		; r_slope[1] @ 16
	.field	-5323,16		; r_slope[2] @ 32
	.field	-3813,16		; r_slope[3] @ 48
	.field	-2979,16		; r_slope[4] @ 64
	.field	-2444,16		; r_slope[5] @ 80
	.field	-2081,16		; r_slope[6] @ 96
	.field	-1811,16		; r_slope[7] @ 112
	.field	-1608,16		; r_slope[8] @ 128
	.field	-1450,16		; r_slope[9] @ 144
	.field	-1322,16		; r_slope[10] @ 160
	.field	-1219,16		; r_slope[11] @ 176
	.field	-1132,16		; r_slope[12] @ 192
	.field	-1059,16		; r_slope[13] @ 208
	.field	-998,16 		; r_slope[14] @ 224
	.field	-946,16 		; r_slope[15] @ 240
	.field	-901,16 		; r_slope[16] @ 256
	.field	-861,16 		; r_slope[17] @ 272
	.field	-827,16 		; r_slope[18] @ 288
	.field	-797,16 		; r_slope[19] @ 304
	.field	-772,16 		; r_slope[20] @ 320
	.field	-750,16 		; r_slope[21] @ 336
	.field	-730,16 		; r_slope[22] @ 352
	.field	-713,16 		; r_slope[23] @ 368
	.field	-699,16 		; r_slope[24] @ 384
	.field	-687,16 		; r_slope[25] @ 400
	.field	-677,16 		; r_slope[26] @ 416
	.field	-668,16 		; r_slope[27] @ 432
	.field	-662,16 		; r_slope[28] @ 448
	.field	-657,16 		; r_slope[29] @ 464
	.field	-654,16 		; r_slope[30] @ 480
	.field	-652,16 		; r_slope[31] @ 496
	.field	-652,16 		; r_slope[32] @ 512
	.field	-654,16 		; r_slope[33] @ 528
	.field	-657,16 		; r_slope[34] @ 544
	.field	-662,16 		; r_slope[35] @ 560
	.field	-668,16 		; r_slope[36] @ 576
	.field	-677,16 		; r_slope[37] @ 592
	.field	-687,16 		; r_slope[38] @ 608
	.field	-699,16 		; r_slope[39] @ 624
	.field	-713,16 		; r_slope[40] @ 640
	.field	-730,16 		; r_slope[41] @ 656
	.field	-750,16 		; r_slope[42] @ 672
	.field	-772,16 		; r_slope[43] @ 688
	.field	-797,16 		; r_slope[44] @ 704
	.field	-827,16 		; r_slope[45] @ 720
	.field	-861,16 		; r_slope[46] @ 736
	.field	-901,16 		; r_slope[47] @ 752
	.field	-946,16 		; r_slope[48] @ 768
	.field	-998,16 		; r_slope[49] @ 784
	.field	-1059,16		; r_slope[50] @ 800
	.field	-1132,16		; r_slope[51] @ 816
	.field	-1219,16		; r_slope[52] @ 832
	.field	-1322,16		; r_slope[53] @ 848
	.field	-1450,16		; r_slope[54] @ 864
	.field	-1608,16		; r_slope[55] @ 880
	.field	-1811,16		; r_slope[56] @ 896
	.field	-2081,16		; r_slope[57] @ 912
	.field	-2444,16		; r_slope[58] @ 928
	.field	-2979,16		; r_slope[59] @ 944
	.field	-3813,16		; r_slope[60] @ 960
	.field	-5323,16		; r_slope[61] @ 976
	.field	-8812,16		; r_slope[62] @ 992
	.field	-26887,16		; r_slope[63] @ 1008


r_pow2:
	.field	16384,16		; r_pow2[0] @ 0
	.field	16743,16		; r_pow2[1] @ 16
	.field	17109,16		; r_pow2[2] @ 32
	.field	17484,16		; r_pow2[3] @ 48
	.field	17867,16		; r_pow2[4] @ 64
	.field	18258,16		; r_pow2[5] @ 80
	.field	18658,16		; r_pow2[6] @ 96
	.field	19066,16		; r_pow2[7] @ 112
	.field	19484,16		; r_pow2[8] @ 128
	.field	19911,16		; r_pow2[9] @ 144
	.field	20347,16		; r_pow2[10] @ 160
	.field	20792,16		; r_pow2[11] @ 176
	.field	21247,16		; r_pow2[12] @ 192
	.field	21713,16		; r_pow2[13] @ 208
	.field	22188,16		; r_pow2[14] @ 224
	.field	22674,16		; r_pow2[15] @ 240
	.field	23170,16		; r_pow2[16] @ 256
	.field	23678,16		; r_pow2[17] @ 272
	.field	24196,16		; r_pow2[18] @ 288
	.field	24726,16		; r_pow2[19] @ 304
	.field	25268,16		; r_pow2[20] @ 320
	.field	25821,16		; r_pow2[21] @ 336
	.field	26386,16		; r_pow2[22] @ 352
	.field	26964,16		; r_pow2[23] @ 368
	.field	27554,16		; r_pow2[24] @ 384
	.field	28158,16		; r_pow2[25] @ 400
	.field	28774,16		; r_pow2[26] @ 416
	.field	29405,16		; r_pow2[27] @ 432
	.field	30048,16		; r_pow2[28] @ 448
	.field	30706,16		; r_pow2[29] @ 464
	.field	31379,16		; r_pow2[30] @ 480
	.field	32066,16		; r_pow2[31] @ 496
	.field	32767,16		; r_pow2[32] @ 512

r_mean_lsf:
	.field	1384,16 		; r_mean_lsf[0] @ 0
	.field	2077,16 		; r_mean_lsf[1] @ 16
	.field	3420,16 		; r_mean_lsf[2] @ 32
	.field	5108,16 		; r_mean_lsf[3] @ 48
	.field	6742,16 		; r_mean_lsf[4] @ 64
	.field	8122,16 		; r_mean_lsf[5] @ 80
	.field	9863,16 		; r_mean_lsf[6] @ 96
	.field	11092,16		; r_mean_lsf[7] @ 112
	.field	12714,16		; r_mean_lsf[8] @ 128
	.field	13701,16		; r_mean_lsf[9] @ 144

r_dico1_lsf:
	.field	-451,16 		; r_dico1_lsf[0] @ 0
	.field	-1065,16		; r_dico1_lsf[1] @ 16
	.field	-529,16 		; r_dico1_lsf[2] @ 32
	.field	-1305,16		; r_dico1_lsf[3] @ 48
	.field	-450,16 		; r_dico1_lsf[4] @ 64
	.field	-756,16 		; r_dico1_lsf[5] @ 80
	.field	-497,16 		; r_dico1_lsf[6] @ 96
	.field	-863,16 		; r_dico1_lsf[7] @ 112
	.field	-384,16 		; r_dico1_lsf[8] @ 128
	.field	-619,16 		; r_dico1_lsf[9] @ 144
	.field	-413,16 		; r_dico1_lsf[10] @ 160
	.field	-669,16 		; r_dico1_lsf[11] @ 176
	.field	-317,16 		; r_dico1_lsf[12] @ 192
	.field	-538,16 		; r_dico1_lsf[13] @ 208
	.field	-331,16 		; r_dico1_lsf[14] @ 224
	.field	-556,16 		; r_dico1_lsf[15] @ 240
	.field	-414,16 		; r_dico1_lsf[16] @ 256
	.field	-508,16 		; r_dico1_lsf[17] @ 272
	.field	-424,16 		; r_dico1_lsf[18] @ 288
	.field	-378,16 		; r_dico1_lsf[19] @ 304
	.field	-274,16 		; r_dico1_lsf[20] @ 320
	.field	-324,16 		; r_dico1_lsf[21] @ 336
	.field	-434,16 		; r_dico1_lsf[22] @ 352
	.field	-614,16 		; r_dico1_lsf[23] @ 368
	.field	-226,16 		; r_dico1_lsf[24] @ 384
	.field	-500,16 		; r_dico1_lsf[25] @ 400
	.field	-232,16 		; r_dico1_lsf[26] @ 416
	.field	-514,16 		; r_dico1_lsf[27] @ 432
	.field	-263,16 		; r_dico1_lsf[28] @ 448
	.field	-377,16 		; r_dico1_lsf[29] @ 464
	.field	-298,16 		; r_dico1_lsf[30] @ 480
	.field	-410,16 		; r_dico1_lsf[31] @ 496
	.field	-151,16 		; r_dico1_lsf[32] @ 512
	.field	-710,16 		; r_dico1_lsf[33] @ 528
	.field	-174,16 		; r_dico1_lsf[34] @ 544
	.field	-818,16 		; r_dico1_lsf[35] @ 560
	.field	-149,16 		; r_dico1_lsf[36] @ 576
	.field	-412,16 		; r_dico1_lsf[37] @ 592
	.field	-156,16 		; r_dico1_lsf[38] @ 608
	.field	-429,16 		; r_dico1_lsf[39] @ 624
	.field	-288,16 		; r_dico1_lsf[40] @ 640
	.field	-462,16 		; r_dico1_lsf[41] @ 656
	.field	-186,16 		; r_dico1_lsf[42] @ 672
	.field	-203,16 		; r_dico1_lsf[43] @ 688
	.field	-170,16 		; r_dico1_lsf[44] @ 704
	.field	-302,16 		; r_dico1_lsf[45] @ 720
	.field	-191,16 		; r_dico1_lsf[46] @ 736
	.field	-321,16 		; r_dico1_lsf[47] @ 752
	.field	-131,16 		; r_dico1_lsf[48] @ 768
	.field	-147,16 		; r_dico1_lsf[49] @ 784
	.field	-297,16 		; r_dico1_lsf[50] @ 800
	.field	-395,16 		; r_dico1_lsf[51] @ 816
	.field	-228,16 		; r_dico1_lsf[52] @ 832
	.field	-214,16 		; r_dico1_lsf[53] @ 848
	.field	-245,16 		; r_dico1_lsf[54] @ 864
	.field	-192,16 		; r_dico1_lsf[55] @ 880
	.field	-67,16			; r_dico1_lsf[56] @ 896
	.field	-316,16 		; r_dico1_lsf[57] @ 912
	.field	-71,16			; r_dico1_lsf[58] @ 928
	.field	-327,16 		; r_dico1_lsf[59] @ 944
	.field	-104,16 		; r_dico1_lsf[60] @ 960
	.field	-205,16 		; r_dico1_lsf[61] @ 976
	.field	-94,16			; r_dico1_lsf[62] @ 992
	.field	-183,16 		; r_dico1_lsf[63] @ 1008
	.field	-143,16 		; r_dico1_lsf[64] @ 1024
	.field	-38,16			; r_dico1_lsf[65] @ 1040
	.field	-193,16 		; r_dico1_lsf[66] @ 1056
	.field	-95,16			; r_dico1_lsf[67] @ 1072
	.field	16,16			; r_dico1_lsf[68] @ 1088
	.field	-76,16			; r_dico1_lsf[69] @ 1104
	.field	-124,16 		; r_dico1_lsf[70] @ 1120
	.field	-248,16 		; r_dico1_lsf[71] @ 1136
	.field	23,16			; r_dico1_lsf[72] @ 1152
	.field	-237,16 		; r_dico1_lsf[73] @ 1168
	.field	24,16			; r_dico1_lsf[74] @ 1184
	.field	-244,16 		; r_dico1_lsf[75] @ 1200
	.field	18,16			; r_dico1_lsf[76] @ 1216
	.field	-136,16 		; r_dico1_lsf[77] @ 1232
	.field	44,16			; r_dico1_lsf[78] @ 1248
	.field	-111,16 		; r_dico1_lsf[79] @ 1264
	.field	-33,16			; r_dico1_lsf[80] @ 1280
	.field	-24,16			; r_dico1_lsf[81] @ 1296
	.field	-25,16			; r_dico1_lsf[82] @ 1312
	.field	0,16			; r_dico1_lsf[83] @ 1328
	.field	149,16			; r_dico1_lsf[84] @ 1344
	.field	19,16			; r_dico1_lsf[85] @ 1360
	.field	23,16			; r_dico1_lsf[86] @ 1376
	.field	-143,16 		; r_dico1_lsf[87] @ 1392
	.field	158,16			; r_dico1_lsf[88] @ 1408
	.field	-169,16 		; r_dico1_lsf[89] @ 1424
	.field	174,16			; r_dico1_lsf[90] @ 1440
	.field	-181,16 		; r_dico1_lsf[91] @ 1456
	.field	133,16			; r_dico1_lsf[92] @ 1472
	.field	-55,16			; r_dico1_lsf[93] @ 1488
	.field	165,16			; r_dico1_lsf[94] @ 1504
	.field	-26,16			; r_dico1_lsf[95] @ 1520
	.field	111,16			; r_dico1_lsf[96] @ 1536
	.field	84,16			; r_dico1_lsf[97] @ 1552
	.field	98,16			; r_dico1_lsf[98] @ 1568
	.field	75,16			; r_dico1_lsf[99] @ 1584
	.field	87,16			; r_dico1_lsf[100] @ 1600
	.field	183,16			; r_dico1_lsf[101] @ 1616
	.field	-115,16 		; r_dico1_lsf[102] @ 1632
	.field	-11,16			; r_dico1_lsf[103] @ 1648
	.field	-8,16			; r_dico1_lsf[104] @ 1664
	.field	130,16			; r_dico1_lsf[105] @ 1680
	.field	11,16			; r_dico1_lsf[106] @ 1696
	.field	170,16			; r_dico1_lsf[107] @ 1712
	.field	254,16			; r_dico1_lsf[108] @ 1728
	.field	77,16			; r_dico1_lsf[109] @ 1744
	.field	205,16			; r_dico1_lsf[110] @ 1760
	.field	17,16			; r_dico1_lsf[111] @ 1776
	.field	183,16			; r_dico1_lsf[112] @ 1792
	.field	112,16			; r_dico1_lsf[113] @ 1808
	.field	262,16			; r_dico1_lsf[114] @ 1824
	.field	194,16			; r_dico1_lsf[115] @ 1840
	.field	202,16			; r_dico1_lsf[116] @ 1856
	.field	287,16			; r_dico1_lsf[117] @ 1872
	.field	95,16			; r_dico1_lsf[118] @ 1888
	.field	189,16			; r_dico1_lsf[119] @ 1904
	.field	-42,16			; r_dico1_lsf[120] @ 1920
	.field	-105,16 		; r_dico1_lsf[121] @ 1936
	.field	234,16			; r_dico1_lsf[122] @ 1952
	.field	179,16			; r_dico1_lsf[123] @ 1968
	.field	39,16			; r_dico1_lsf[124] @ 1984
	.field	186,16			; r_dico1_lsf[125] @ 2000
	.field	163,16			; r_dico1_lsf[126] @ 2016
	.field	345,16			; r_dico1_lsf[127] @ 2032
	.field	332,16			; r_dico1_lsf[128] @ 2048
	.field	199,16			; r_dico1_lsf[129] @ 2064
	.field	299,16			; r_dico1_lsf[130] @ 2080
	.field	161,16			; r_dico1_lsf[131] @ 2096
	.field	-54,16			; r_dico1_lsf[132] @ 2112
	.field	285,16			; r_dico1_lsf[133] @ 2128
	.field	-78,16			; r_dico1_lsf[134] @ 2144
	.field	281,16			; r_dico1_lsf[135] @ 2160
	.field	-133,16 		; r_dico1_lsf[136] @ 2176
	.field	141,16			; r_dico1_lsf[137] @ 2192
	.field	-182,16 		; r_dico1_lsf[138] @ 2208
	.field	111,16			; r_dico1_lsf[139] @ 2224
	.field	249,16			; r_dico1_lsf[140] @ 2240
	.field	341,16			; r_dico1_lsf[141] @ 2256
	.field	271,16			; r_dico1_lsf[142] @ 2272
	.field	364,16			; r_dico1_lsf[143] @ 2288
	.field	93,16			; r_dico1_lsf[144] @ 2304
	.field	403,16			; r_dico1_lsf[145] @ 2320
	.field	75,16			; r_dico1_lsf[146] @ 2336
	.field	391,16			; r_dico1_lsf[147] @ 2352
	.field	92,16			; r_dico1_lsf[148] @ 2368
	.field	510,16			; r_dico1_lsf[149] @ 2384
	.field	-138,16 		; r_dico1_lsf[150] @ 2400
	.field	220,16			; r_dico1_lsf[151] @ 2416
	.field	-185,16 		; r_dico1_lsf[152] @ 2432
	.field	-29,16			; r_dico1_lsf[153] @ 2448
	.field	-34,16			; r_dico1_lsf[154] @ 2464
	.field	361,16			; r_dico1_lsf[155] @ 2480
	.field	-115,16 		; r_dico1_lsf[156] @ 2496
	.field	320,16			; r_dico1_lsf[157] @ 2512
	.field	3,16			; r_dico1_lsf[158] @ 2528
	.field	554,16			; r_dico1_lsf[159] @ 2544
	.field	99,16			; r_dico1_lsf[160] @ 2560
	.field	286,16			; r_dico1_lsf[161] @ 2576
	.field	218,16			; r_dico1_lsf[162] @ 2592
	.field	591,16			; r_dico1_lsf[163] @ 2608
	.field	-245,16 		; r_dico1_lsf[164] @ 2624
	.field	406,16			; r_dico1_lsf[165] @ 2640
	.field	-268,16 		; r_dico1_lsf[166] @ 2656
	.field	453,16			; r_dico1_lsf[167] @ 2672
	.field	0,16			; r_dico1_lsf[168] @ 2688
	.field	580,16			; r_dico1_lsf[169] @ 2704
	.field	25,16			; r_dico1_lsf[170] @ 2720
	.field	606,16			; r_dico1_lsf[171] @ 2736
	.field	275,16			; r_dico1_lsf[172] @ 2752
	.field	532,16			; r_dico1_lsf[173] @ 2768
	.field	148,16			; r_dico1_lsf[174] @ 2784
	.field	450,16			; r_dico1_lsf[175] @ 2800
	.field	-73,16			; r_dico1_lsf[176] @ 2816
	.field	739,16			; r_dico1_lsf[177] @ 2832
	.field	-285,16 		; r_dico1_lsf[178] @ 2848
	.field	518,16			; r_dico1_lsf[179] @ 2864
	.field	-288,16 		; r_dico1_lsf[180] @ 2880
	.field	94,16			; r_dico1_lsf[181] @ 2896
	.field	-203,16 		; r_dico1_lsf[182] @ 2912
	.field	674,16			; r_dico1_lsf[183] @ 2928
	.field	-140,16 		; r_dico1_lsf[184] @ 2944
	.field	-74,16			; r_dico1_lsf[185] @ 2960
	.field	205,16			; r_dico1_lsf[186] @ 2976
	.field	714,16			; r_dico1_lsf[187] @ 2992
	.field	-114,16 		; r_dico1_lsf[188] @ 3008
	.field	299,16			; r_dico1_lsf[189] @ 3024
	.field	176,16			; r_dico1_lsf[190] @ 3040
	.field	923,16			; r_dico1_lsf[191] @ 3056
	.field	182,16			; r_dico1_lsf[192] @ 3072
	.field	557,16			; r_dico1_lsf[193] @ 3088
	.field	240,16			; r_dico1_lsf[194] @ 3104
	.field	705,16			; r_dico1_lsf[195] @ 3120
	.field	-16,16			; r_dico1_lsf[196] @ 3136
	.field	513,16			; r_dico1_lsf[197] @ 3152
	.field	485,16			; r_dico1_lsf[198] @ 3168
	.field	593,16			; r_dico1_lsf[199] @ 3184
	.field	293,16			; r_dico1_lsf[200] @ 3200
	.field	384,16			; r_dico1_lsf[201] @ 3216
	.field	451,16			; r_dico1_lsf[202] @ 3232
	.field	617,16			; r_dico1_lsf[203] @ 3248
	.field	-38,16			; r_dico1_lsf[204] @ 3264
	.field	50,16			; r_dico1_lsf[205] @ 3280
	.field	563,16			; r_dico1_lsf[206] @ 3296
	.field	529,16			; r_dico1_lsf[207] @ 3312
	.field	303,16			; r_dico1_lsf[208] @ 3328
	.field	209,16			; r_dico1_lsf[209] @ 3344
	.field	459,16			; r_dico1_lsf[210] @ 3360
	.field	363,16			; r_dico1_lsf[211] @ 3376
	.field	433,16			; r_dico1_lsf[212] @ 3392
	.field	452,16			; r_dico1_lsf[213] @ 3408
	.field	450,16			; r_dico1_lsf[214] @ 3424
	.field	454,16			; r_dico1_lsf[215] @ 3440
	.field	367,16			; r_dico1_lsf[216] @ 3456
	.field	606,16			; r_dico1_lsf[217] @ 3472
	.field	477,16			; r_dico1_lsf[218] @ 3488
	.field	741,16			; r_dico1_lsf[219] @ 3504
	.field	432,16			; r_dico1_lsf[220] @ 3520
	.field	353,16			; r_dico1_lsf[221] @ 3536
	.field	368,16			; r_dico1_lsf[222] @ 3552
	.field	267,16			; r_dico1_lsf[223] @ 3568
	.field	361,16			; r_dico1_lsf[224] @ 3584
	.field	716,16			; r_dico1_lsf[225] @ 3600
	.field	273,16			; r_dico1_lsf[226] @ 3616
	.field	583,16			; r_dico1_lsf[227] @ 3632
	.field	453,16			; r_dico1_lsf[228] @ 3648
	.field	166,16			; r_dico1_lsf[229] @ 3664
	.field	510,16			; r_dico1_lsf[230] @ 3680
	.field	172,16			; r_dico1_lsf[231] @ 3696
	.field	201,16			; r_dico1_lsf[232] @ 3712
	.field	629,16			; r_dico1_lsf[233] @ 3728
	.field	274,16			; r_dico1_lsf[234] @ 3744
	.field	191,16			; r_dico1_lsf[235] @ 3760
	.field	568,16			; r_dico1_lsf[236] @ 3776
	.field	639,16			; r_dico1_lsf[237] @ 3792
	.field	302,16			; r_dico1_lsf[238] @ 3808
	.field	298,16			; r_dico1_lsf[239] @ 3824
	.field	634,16			; r_dico1_lsf[240] @ 3840
	.field	387,16			; r_dico1_lsf[241] @ 3856
	.field	643,16			; r_dico1_lsf[242] @ 3872
	.field	350,16			; r_dico1_lsf[243] @ 3888
	.field	587,16			; r_dico1_lsf[244] @ 3904
	.field	560,16			; r_dico1_lsf[245] @ 3920
	.field	612,16			; r_dico1_lsf[246] @ 3936
	.field	565,16			; r_dico1_lsf[247] @ 3952
	.field	600,16			; r_dico1_lsf[248] @ 3968
	.field	788,16			; r_dico1_lsf[249] @ 3984
	.field	487,16			; r_dico1_lsf[250] @ 4000
	.field	672,16			; r_dico1_lsf[251] @ 4016
	.field	512,16			; r_dico1_lsf[252] @ 4032
	.field	1015,16 		; r_dico1_lsf[253] @ 4048
	.field	321,16			; r_dico1_lsf[254] @ 4064
	.field	333,16			; r_dico1_lsf[255] @ 4080
	.field	357,16			; r_dico1_lsf[256] @ 4096
	.field	854,16			; r_dico1_lsf[257] @ 4112
	.field	-125,16 		; r_dico1_lsf[258] @ 4128
	.field	413,16			; r_dico1_lsf[259] @ 4144
	.field	474,16			; r_dico1_lsf[260] @ 4160
	.field	712,16			; r_dico1_lsf[261] @ 4176
	.field	17,16			; r_dico1_lsf[262] @ 4192
	.field	-151,16 		; r_dico1_lsf[263] @ 4208
	.field	564,16			; r_dico1_lsf[264] @ 4224
	.field	285,16			; r_dico1_lsf[265] @ 4240
	.field	270,16			; r_dico1_lsf[266] @ 4256
	.field	-241,16 		; r_dico1_lsf[267] @ 4272
	.field	971,16			; r_dico1_lsf[268] @ 4288
	.field	889,16			; r_dico1_lsf[269] @ 4304
	.field	489,16			; r_dico1_lsf[270] @ 4320
	.field	220,16			; r_dico1_lsf[271] @ 4336
	.field	510,16			; r_dico1_lsf[272] @ 4352
	.field	896,16			; r_dico1_lsf[273] @ 4368
	.field	549,16			; r_dico1_lsf[274] @ 4384
	.field	924,16			; r_dico1_lsf[275] @ 4400
	.field	327,16			; r_dico1_lsf[276] @ 4416
	.field	825,16			; r_dico1_lsf[277] @ 4432
	.field	290,16			; r_dico1_lsf[278] @ 4448
	.field	911,16			; r_dico1_lsf[279] @ 4464
	.field	540,16			; r_dico1_lsf[280] @ 4480
	.field	1108,16 		; r_dico1_lsf[281] @ 4496
	.field	158,16			; r_dico1_lsf[282] @ 4512
	.field	805,16			; r_dico1_lsf[283] @ 4528
	.field	199,16			; r_dico1_lsf[284] @ 4544
	.field	957,16			; r_dico1_lsf[285] @ 4560
	.field	511,16			; r_dico1_lsf[286] @ 4576
	.field	730,16			; r_dico1_lsf[287] @ 4592
	.field	100,16			; r_dico1_lsf[288] @ 4608
	.field	874,16			; r_dico1_lsf[289] @ 4624
	.field	13,16			; r_dico1_lsf[290] @ 4640
	.field	791,16			; r_dico1_lsf[291] @ 4656
	.field	435,16			; r_dico1_lsf[292] @ 4672
	.field	632,16			; r_dico1_lsf[293] @ 4688
	.field	676,16			; r_dico1_lsf[294] @ 4704
	.field	972,16			; r_dico1_lsf[295] @ 4720
	.field	249,16			; r_dico1_lsf[296] @ 4736
	.field	900,16			; r_dico1_lsf[297] @ 4752
	.field	467,16			; r_dico1_lsf[298] @ 4768
	.field	1218,16 		; r_dico1_lsf[299] @ 4784
	.field	781,16			; r_dico1_lsf[300] @ 4800
	.field	1074,16 		; r_dico1_lsf[301] @ 4816
	.field	585,16			; r_dico1_lsf[302] @ 4832
	.field	785,16			; r_dico1_lsf[303] @ 4848
	.field	-23,16			; r_dico1_lsf[304] @ 4864
	.field	669,16			; r_dico1_lsf[305] @ 4880
	.field	267,16			; r_dico1_lsf[306] @ 4896
	.field	1043,16 		; r_dico1_lsf[307] @ 4912
	.field	619,16			; r_dico1_lsf[308] @ 4928
	.field	1084,16 		; r_dico1_lsf[309] @ 4944
	.field	615,16			; r_dico1_lsf[310] @ 4960
	.field	1145,16 		; r_dico1_lsf[311] @ 4976
	.field	622,16			; r_dico1_lsf[312] @ 4992
	.field	905,16			; r_dico1_lsf[313] @ 5008
	.field	916,16			; r_dico1_lsf[314] @ 5024
	.field	1049,16 		; r_dico1_lsf[315] @ 5040
	.field	80,16			; r_dico1_lsf[316] @ 5056
	.field	331,16			; r_dico1_lsf[317] @ 5072
	.field	584,16			; r_dico1_lsf[318] @ 5088
	.field	1075,16 		; r_dico1_lsf[319] @ 5104
	.field	89,16			; r_dico1_lsf[320] @ 5120
	.field	639,16			; r_dico1_lsf[321] @ 5136
	.field	988,16			; r_dico1_lsf[322] @ 5152
	.field	961,16			; r_dico1_lsf[323] @ 5168
	.field	770,16			; r_dico1_lsf[324] @ 5184
	.field	720,16			; r_dico1_lsf[325] @ 5200
	.field	798,16			; r_dico1_lsf[326] @ 5216
	.field	699,16			; r_dico1_lsf[327] @ 5232
	.field	492,16			; r_dico1_lsf[328] @ 5248
	.field	447,16			; r_dico1_lsf[329] @ 5264
	.field	899,16			; r_dico1_lsf[330] @ 5280
	.field	627,16			; r_dico1_lsf[331] @ 5296
	.field	271,16			; r_dico1_lsf[332] @ 5312
	.field	1188,16 		; r_dico1_lsf[333] @ 5328
	.field	725,16			; r_dico1_lsf[334] @ 5344
	.field	1333,16 		; r_dico1_lsf[335] @ 5360
	.field	87,16			; r_dico1_lsf[336] @ 5376
	.field	603,16			; r_dico1_lsf[337] @ 5392
	.field	832,16			; r_dico1_lsf[338] @ 5408
	.field	1603,16 		; r_dico1_lsf[339] @ 5424
	.field	616,16			; r_dico1_lsf[340] @ 5440
	.field	1127,16 		; r_dico1_lsf[341] @ 5456
	.field	890,16			; r_dico1_lsf[342] @ 5472
	.field	1505,16 		; r_dico1_lsf[343] @ 5488
	.field	1000,16 		; r_dico1_lsf[344] @ 5504
	.field	1156,16 		; r_dico1_lsf[345] @ 5520
	.field	866,16			; r_dico1_lsf[346] @ 5536
	.field	1009,16 		; r_dico1_lsf[347] @ 5552
	.field	995,16			; r_dico1_lsf[348] @ 5568
	.field	827,16			; r_dico1_lsf[349] @ 5584
	.field	1149,16 		; r_dico1_lsf[350] @ 5600
	.field	858,16			; r_dico1_lsf[351] @ 5616
	.field	817,16			; r_dico1_lsf[352] @ 5632
	.field	1450,16 		; r_dico1_lsf[353] @ 5648
	.field	773,16			; r_dico1_lsf[354] @ 5664
	.field	1320,16 		; r_dico1_lsf[355] @ 5680
	.field	500,16			; r_dico1_lsf[356] @ 5696
	.field	1389,16 		; r_dico1_lsf[357] @ 5712
	.field	312,16			; r_dico1_lsf[358] @ 5728
	.field	1153,16 		; r_dico1_lsf[359] @ 5744
	.field	-20,16			; r_dico1_lsf[360] @ 5760
	.field	1084,16 		; r_dico1_lsf[361] @ 5776
	.field	64,16			; r_dico1_lsf[362] @ 5792
	.field	1283,16 		; r_dico1_lsf[363] @ 5808
	.field	2,16			; r_dico1_lsf[364] @ 5824
	.field	1172,16 		; r_dico1_lsf[365] @ 5840
	.field	399,16			; r_dico1_lsf[366] @ 5856
	.field	1869,16 		; r_dico1_lsf[367] @ 5872
	.field	514,16			; r_dico1_lsf[368] @ 5888
	.field	1706,16 		; r_dico1_lsf[369] @ 5904
	.field	502,16			; r_dico1_lsf[370] @ 5920
	.field	1636,16 		; r_dico1_lsf[371] @ 5936
	.field	886,16			; r_dico1_lsf[372] @ 5952
	.field	1522,16 		; r_dico1_lsf[373] @ 5968
	.field	416,16			; r_dico1_lsf[374] @ 5984
	.field	600,16			; r_dico1_lsf[375] @ 6000
	.field	1131,16 		; r_dico1_lsf[376] @ 6016
	.field	1350,16 		; r_dico1_lsf[377] @ 6032
	.field	1275,16 		; r_dico1_lsf[378] @ 6048
	.field	1390,16 		; r_dico1_lsf[379] @ 6064
	.field	889,16			; r_dico1_lsf[380] @ 6080
	.field	1795,16 		; r_dico1_lsf[381] @ 6096
	.field	914,16			; r_dico1_lsf[382] @ 6112
	.field	1766,16 		; r_dico1_lsf[383] @ 6128
	.field	227,16			; r_dico1_lsf[384] @ 6144
	.field	1183,16 		; r_dico1_lsf[385] @ 6160
	.field	1250,16 		; r_dico1_lsf[386] @ 6176
	.field	1826,16 		; r_dico1_lsf[387] @ 6192
	.field	505,16			; r_dico1_lsf[388] @ 6208
	.field	1854,16 		; r_dico1_lsf[389] @ 6224
	.field	919,16			; r_dico1_lsf[390] @ 6240
	.field	2353,16 		; r_dico1_lsf[391] @ 6256
	.field	-199,16 		; r_dico1_lsf[392] @ 6272
	.field	431,16			; r_dico1_lsf[393] @ 6288
	.field	152,16			; r_dico1_lsf[394] @ 6304
	.field	1735,16 		; r_dico1_lsf[395] @ 6320
	.field	-213,16 		; r_dico1_lsf[396] @ 6336
	.field	-28,16			; r_dico1_lsf[397] @ 6352
	.field	392,16			; r_dico1_lsf[398] @ 6368
	.field	1334,16 		; r_dico1_lsf[399] @ 6384
	.field	-153,16 		; r_dico1_lsf[400] @ 6400
	.field	-52,16			; r_dico1_lsf[401] @ 6416
	.field	978,16			; r_dico1_lsf[402] @ 6432
	.field	1151,16 		; r_dico1_lsf[403] @ 6448
	.field	-323,16 		; r_dico1_lsf[404] @ 6464
	.field	-400,16 		; r_dico1_lsf[405] @ 6480
	.field	813,16			; r_dico1_lsf[406] @ 6496
	.field	1703,16 		; r_dico1_lsf[407] @ 6512
	.field	-136,16 		; r_dico1_lsf[408] @ 6528
	.field	84,16			; r_dico1_lsf[409] @ 6544
	.field	1449,16 		; r_dico1_lsf[410] @ 6560
	.field	2015,16 		; r_dico1_lsf[411] @ 6576
	.field	-331,16 		; r_dico1_lsf[412] @ 6592
	.field	-143,16 		; r_dico1_lsf[413] @ 6608
	.field	-137,16 		; r_dico1_lsf[414] @ 6624
	.field	1192,16 		; r_dico1_lsf[415] @ 6640
	.field	-256,16 		; r_dico1_lsf[416] @ 6656
	.field	534,16			; r_dico1_lsf[417] @ 6672
	.field	-157,16 		; r_dico1_lsf[418] @ 6688
	.field	1031,16 		; r_dico1_lsf[419] @ 6704
	.field	-307,16 		; r_dico1_lsf[420] @ 6720
	.field	-439,16 		; r_dico1_lsf[421] @ 6736
	.field	542,16			; r_dico1_lsf[422] @ 6752
	.field	731,16			; r_dico1_lsf[423] @ 6768
	.field	-329,16 		; r_dico1_lsf[424] @ 6784
	.field	-420,16 		; r_dico1_lsf[425] @ 6800
	.field	-97,16			; r_dico1_lsf[426] @ 6816
	.field	616,16			; r_dico1_lsf[427] @ 6832
	.field	-362,16 		; r_dico1_lsf[428] @ 6848
	.field	-168,16 		; r_dico1_lsf[429] @ 6864
	.field	-322,16 		; r_dico1_lsf[430] @ 6880
	.field	366,16			; r_dico1_lsf[431] @ 6896
	.field	-247,16 		; r_dico1_lsf[432] @ 6912
	.field	-110,16 		; r_dico1_lsf[433] @ 6928
	.field	-211,16 		; r_dico1_lsf[434] @ 6944
	.field	89,16			; r_dico1_lsf[435] @ 6960
	.field	-196,16 		; r_dico1_lsf[436] @ 6976
	.field	-309,16 		; r_dico1_lsf[437] @ 6992
	.field	20,16			; r_dico1_lsf[438] @ 7008
	.field	59,16			; r_dico1_lsf[439] @ 7024
	.field	-364,16 		; r_dico1_lsf[440] @ 7040
	.field	-463,16 		; r_dico1_lsf[441] @ 7056
	.field	-286,16 		; r_dico1_lsf[442] @ 7072
	.field	89,16			; r_dico1_lsf[443] @ 7088
	.field	-336,16 		; r_dico1_lsf[444] @ 7104
	.field	175,16			; r_dico1_lsf[445] @ 7120
	.field	-432,16 		; r_dico1_lsf[446] @ 7136
	.field	141,16			; r_dico1_lsf[447] @ 7152
	.field	-379,16 		; r_dico1_lsf[448] @ 7168
	.field	-190,16 		; r_dico1_lsf[449] @ 7184
	.field	-434,16 		; r_dico1_lsf[450] @ 7200
	.field	-196,16 		; r_dico1_lsf[451] @ 7216
	.field	-79,16			; r_dico1_lsf[452] @ 7232
	.field	150,16			; r_dico1_lsf[453] @ 7248
	.field	-278,16 		; r_dico1_lsf[454] @ 7264
	.field	-227,16 		; r_dico1_lsf[455] @ 7280
	.field	-280,16 		; r_dico1_lsf[456] @ 7296
	.field	166,16			; r_dico1_lsf[457] @ 7312
	.field	-555,16 		; r_dico1_lsf[458] @ 7328
	.field	-422,16 		; r_dico1_lsf[459] @ 7344
	.field	-155,16 		; r_dico1_lsf[460] @ 7360
	.field	541,16			; r_dico1_lsf[461] @ 7376
	.field	-366,16 		; r_dico1_lsf[462] @ 7392
	.field	54,16			; r_dico1_lsf[463] @ 7408
	.field	-29,16			; r_dico1_lsf[464] @ 7424
	.field	-83,16			; r_dico1_lsf[465] @ 7440
	.field	-301,16 		; r_dico1_lsf[466] @ 7456
	.field	-774,16 		; r_dico1_lsf[467] @ 7472
	.field	186,16			; r_dico1_lsf[468] @ 7488
	.field	628,16			; r_dico1_lsf[469] @ 7504
	.field	-397,16 		; r_dico1_lsf[470] @ 7520
	.field	-264,16 		; r_dico1_lsf[471] @ 7536
	.field	242,16			; r_dico1_lsf[472] @ 7552
	.field	293,16			; r_dico1_lsf[473] @ 7568
	.field	-197,16 		; r_dico1_lsf[474] @ 7584
	.field	-585,16 		; r_dico1_lsf[475] @ 7600
	.field	124,16			; r_dico1_lsf[476] @ 7616
	.field	410,16			; r_dico1_lsf[477] @ 7632
	.field	53,16			; r_dico1_lsf[478] @ 7648
	.field	-133,16 		; r_dico1_lsf[479] @ 7664
	.field	10,16			; r_dico1_lsf[480] @ 7680
	.field	340,16			; r_dico1_lsf[481] @ 7696
	.field	-570,16 		; r_dico1_lsf[482] @ 7712
	.field	-1065,16		; r_dico1_lsf[483] @ 7728
	.field	65,16			; r_dico1_lsf[484] @ 7744
	.field	-446,16 		; r_dico1_lsf[485] @ 7760
	.field	68,16			; r_dico1_lsf[486] @ 7776
	.field	-493,16 		; r_dico1_lsf[487] @ 7792
	.field	383,16			; r_dico1_lsf[488] @ 7808
	.field	937,16			; r_dico1_lsf[489] @ 7824
	.field	-357,16 		; r_dico1_lsf[490] @ 7840
	.field	-711,16 		; r_dico1_lsf[491] @ 7856
	.field	-359,16 		; r_dico1_lsf[492] @ 7872
	.field	-250,16 		; r_dico1_lsf[493] @ 7888
	.field	-677,16 		; r_dico1_lsf[494] @ 7904
	.field	-1068,16		; r_dico1_lsf[495] @ 7920
	.field	292,16			; r_dico1_lsf[496] @ 7936
	.field	-26,16			; r_dico1_lsf[497] @ 7952
	.field	363,16			; r_dico1_lsf[498] @ 7968
	.field	6,16			; r_dico1_lsf[499] @ 7984
	.field	607,16			; r_dico1_lsf[500] @ 8000
	.field	1313,16 		; r_dico1_lsf[501] @ 8016
	.field	-127,16 		; r_dico1_lsf[502] @ 8032
	.field	-10,16			; r_dico1_lsf[503] @ 8048
	.field	1513,16 		; r_dico1_lsf[504] @ 8064
	.field	1886,16 		; r_dico1_lsf[505] @ 8080
	.field	713,16			; r_dico1_lsf[506] @ 8096
	.field	972,16			; r_dico1_lsf[507] @ 8112
	.field	1469,16 		; r_dico1_lsf[508] @ 8128
	.field	2181,16 		; r_dico1_lsf[509] @ 8144
	.field	1443,16 		; r_dico1_lsf[510] @ 8160
	.field	2016,16 		; r_dico1_lsf[511] @ 8176

r_dico2_lsf:
	.field	-1631,16		; r_dico2_lsf[0] @ 0
	.field	-1600,16		; r_dico2_lsf[1] @ 16
	.field	-1796,16		; r_dico2_lsf[2] @ 32
	.field	-2290,16		; r_dico2_lsf[3] @ 48
	.field	-1027,16		; r_dico2_lsf[4] @ 64
	.field	-1770,16		; r_dico2_lsf[5] @ 80
	.field	-1100,16		; r_dico2_lsf[6] @ 96
	.field	-2025,16		; r_dico2_lsf[7] @ 112
	.field	-1277,16		; r_dico2_lsf[8] @ 128
	.field	-1388,16		; r_dico2_lsf[9] @ 144
	.field	-1367,16		; r_dico2_lsf[10] @ 160
	.field	-1534,16		; r_dico2_lsf[11] @ 176
	.field	-947,16 		; r_dico2_lsf[12] @ 192
	.field	-1461,16		; r_dico2_lsf[13] @ 208
	.field	-972,16 		; r_dico2_lsf[14] @ 224
	.field	-1524,16		; r_dico2_lsf[15] @ 240
	.field	-999,16 		; r_dico2_lsf[16] @ 256
	.field	-1222,16		; r_dico2_lsf[17] @ 272
	.field	-1020,16		; r_dico2_lsf[18] @ 288
	.field	-1172,16		; r_dico2_lsf[19] @ 304
	.field	-815,16 		; r_dico2_lsf[20] @ 320
	.field	-987,16 		; r_dico2_lsf[21] @ 336
	.field	-992,16 		; r_dico2_lsf[22] @ 352
	.field	-1371,16		; r_dico2_lsf[23] @ 368
	.field	-1216,16		; r_dico2_lsf[24] @ 384
	.field	-1006,16		; r_dico2_lsf[25] @ 400
	.field	-1289,16		; r_dico2_lsf[26] @ 416
	.field	-1094,16		; r_dico2_lsf[27] @ 432
	.field	-744,16 		; r_dico2_lsf[28] @ 448
	.field	-1268,16		; r_dico2_lsf[29] @ 464
	.field	-755,16 		; r_dico2_lsf[30] @ 480
	.field	-1293,16		; r_dico2_lsf[31] @ 496
	.field	-862,16 		; r_dico2_lsf[32] @ 512
	.field	-923,16 		; r_dico2_lsf[33] @ 528
	.field	-905,16 		; r_dico2_lsf[34] @ 544
	.field	-984,16 		; r_dico2_lsf[35] @ 560
	.field	-678,16 		; r_dico2_lsf[36] @ 576
	.field	-1051,16		; r_dico2_lsf[37] @ 592
	.field	-685,16 		; r_dico2_lsf[38] @ 608
	.field	-1050,16		; r_dico2_lsf[39] @ 624
	.field	-1087,16		; r_dico2_lsf[40] @ 640
	.field	-985,16 		; r_dico2_lsf[41] @ 656
	.field	-1062,16		; r_dico2_lsf[42] @ 672
	.field	-679,16 		; r_dico2_lsf[43] @ 688
	.field	-989,16 		; r_dico2_lsf[44] @ 704
	.field	-641,16 		; r_dico2_lsf[45] @ 720
	.field	-1127,16		; r_dico2_lsf[46] @ 736
	.field	-976,16 		; r_dico2_lsf[47] @ 752
	.field	-762,16 		; r_dico2_lsf[48] @ 768
	.field	-654,16 		; r_dico2_lsf[49] @ 784
	.field	-890,16 		; r_dico2_lsf[50] @ 800
	.field	-806,16 		; r_dico2_lsf[51] @ 816
	.field	-833,16 		; r_dico2_lsf[52] @ 832
	.field	-1091,16		; r_dico2_lsf[53] @ 848
	.field	-706,16 		; r_dico2_lsf[54] @ 864
	.field	-629,16 		; r_dico2_lsf[55] @ 880
	.field	-621,16 		; r_dico2_lsf[56] @ 896
	.field	-806,16 		; r_dico2_lsf[57] @ 912
	.field	-640,16 		; r_dico2_lsf[58] @ 928
	.field	-812,16 		; r_dico2_lsf[59] @ 944
	.field	-775,16 		; r_dico2_lsf[60] @ 960
	.field	-634,16 		; r_dico2_lsf[61] @ 976
	.field	-779,16 		; r_dico2_lsf[62] @ 992
	.field	-543,16 		; r_dico2_lsf[63] @ 1008
	.field	-996,16 		; r_dico2_lsf[64] @ 1024
	.field	-565,16 		; r_dico2_lsf[65] @ 1040
	.field	-1075,16		; r_dico2_lsf[66] @ 1056
	.field	-580,16 		; r_dico2_lsf[67] @ 1072
	.field	-546,16 		; r_dico2_lsf[68] @ 1088
	.field	-611,16 		; r_dico2_lsf[69] @ 1104
	.field	-572,16 		; r_dico2_lsf[70] @ 1120
	.field	-619,16 		; r_dico2_lsf[71] @ 1136
	.field	-760,16 		; r_dico2_lsf[72] @ 1152
	.field	-290,16 		; r_dico2_lsf[73] @ 1168
	.field	-879,16 		; r_dico2_lsf[74] @ 1184
	.field	-526,16 		; r_dico2_lsf[75] @ 1200
	.field	-823,16 		; r_dico2_lsf[76] @ 1216
	.field	-462,16 		; r_dico2_lsf[77] @ 1232
	.field	-795,16 		; r_dico2_lsf[78] @ 1248
	.field	-253,16 		; r_dico2_lsf[79] @ 1264
	.field	-553,16 		; r_dico2_lsf[80] @ 1280
	.field	-415,16 		; r_dico2_lsf[81] @ 1296
	.field	-589,16 		; r_dico2_lsf[82] @ 1312
	.field	-439,16 		; r_dico2_lsf[83] @ 1328
	.field	-533,16 		; r_dico2_lsf[84] @ 1344
	.field	-340,16 		; r_dico2_lsf[85] @ 1360
	.field	-692,16 		; r_dico2_lsf[86] @ 1376
	.field	-935,16 		; r_dico2_lsf[87] @ 1392
	.field	-505,16 		; r_dico2_lsf[88] @ 1408
	.field	-772,16 		; r_dico2_lsf[89] @ 1424
	.field	-702,16 		; r_dico2_lsf[90] @ 1440
	.field	-1131,16		; r_dico2_lsf[91] @ 1456
	.field	-263,16 		; r_dico2_lsf[92] @ 1472
	.field	-306,16 		; r_dico2_lsf[93] @ 1488
	.field	-971,16 		; r_dico2_lsf[94] @ 1504
	.field	-483,16 		; r_dico2_lsf[95] @ 1520
	.field	-445,16 		; r_dico2_lsf[96] @ 1536
	.field	-74,16			; r_dico2_lsf[97] @ 1552
	.field	-555,16 		; r_dico2_lsf[98] @ 1568
	.field	-548,16 		; r_dico2_lsf[99] @ 1584
	.field	-614,16 		; r_dico2_lsf[100] @ 1600
	.field	-129,16 		; r_dico2_lsf[101] @ 1616
	.field	-693,16 		; r_dico2_lsf[102] @ 1632
	.field	-234,16 		; r_dico2_lsf[103] @ 1648
	.field	-396,16 		; r_dico2_lsf[104] @ 1664
	.field	-246,16 		; r_dico2_lsf[105] @ 1680
	.field	-475,16 		; r_dico2_lsf[106] @ 1696
	.field	-250,16 		; r_dico2_lsf[107] @ 1712
	.field	-265,16 		; r_dico2_lsf[108] @ 1728
	.field	-404,16 		; r_dico2_lsf[109] @ 1744
	.field	-376,16 		; r_dico2_lsf[110] @ 1760
	.field	-514,16 		; r_dico2_lsf[111] @ 1776
	.field	-417,16 		; r_dico2_lsf[112] @ 1792
	.field	-510,16 		; r_dico2_lsf[113] @ 1808
	.field	-300,16 		; r_dico2_lsf[114] @ 1824
	.field	-313,16 		; r_dico2_lsf[115] @ 1840
	.field	-334,16 		; r_dico2_lsf[116] @ 1856
	.field	-664,16 		; r_dico2_lsf[117] @ 1872
	.field	-463,16 		; r_dico2_lsf[118] @ 1888
	.field	-814,16 		; r_dico2_lsf[119] @ 1904
	.field	-386,16 		; r_dico2_lsf[120] @ 1920
	.field	-704,16 		; r_dico2_lsf[121] @ 1936
	.field	-337,16 		; r_dico2_lsf[122] @ 1952
	.field	-615,16 		; r_dico2_lsf[123] @ 1968
	.field	-234,16 		; r_dico2_lsf[124] @ 1984
	.field	-201,16 		; r_dico2_lsf[125] @ 2000
	.field	-233,16 		; r_dico2_lsf[126] @ 2016
	.field	-239,16 		; r_dico2_lsf[127] @ 2032
	.field	-167,16 		; r_dico2_lsf[128] @ 2048
	.field	-567,16 		; r_dico2_lsf[129] @ 2064
	.field	-203,16 		; r_dico2_lsf[130] @ 2080
	.field	-619,16 		; r_dico2_lsf[131] @ 2096
	.field	-147,16 		; r_dico2_lsf[132] @ 2112
	.field	-415,16 		; r_dico2_lsf[133] @ 2128
	.field	-115,16 		; r_dico2_lsf[134] @ 2144
	.field	-352,16 		; r_dico2_lsf[135] @ 2160
	.field	-166,16 		; r_dico2_lsf[136] @ 2176
	.field	-750,16 		; r_dico2_lsf[137] @ 2192
	.field	-171,16 		; r_dico2_lsf[138] @ 2208
	.field	-761,16 		; r_dico2_lsf[139] @ 2224
	.field	-270,16 		; r_dico2_lsf[140] @ 2240
	.field	-879,16 		; r_dico2_lsf[141] @ 2256
	.field	-264,16 		; r_dico2_lsf[142] @ 2272
	.field	-903,16 		; r_dico2_lsf[143] @ 2288
	.field	-367,16 		; r_dico2_lsf[144] @ 2304
	.field	-744,16 		; r_dico2_lsf[145] @ 2320
	.field	43,16			; r_dico2_lsf[146] @ 2336
	.field	-475,16 		; r_dico2_lsf[147] @ 2352
	.field	14,16			; r_dico2_lsf[148] @ 2368
	.field	-653,16 		; r_dico2_lsf[149] @ 2384
	.field	43,16			; r_dico2_lsf[150] @ 2400
	.field	-670,16 		; r_dico2_lsf[151] @ 2416
	.field	11,16			; r_dico2_lsf[152] @ 2432
	.field	-448,16 		; r_dico2_lsf[153] @ 2448
	.field	-59,16			; r_dico2_lsf[154] @ 2464
	.field	-521,16 		; r_dico2_lsf[155] @ 2480
	.field	-126,16 		; r_dico2_lsf[156] @ 2496
	.field	-119,16 		; r_dico2_lsf[157] @ 2512
	.field	-155,16 		; r_dico2_lsf[158] @ 2528
	.field	-613,16 		; r_dico2_lsf[159] @ 2544
	.field	-42,16			; r_dico2_lsf[160] @ 2560
	.field	-863,16 		; r_dico2_lsf[161] @ 2576
	.field	-27,16			; r_dico2_lsf[162] @ 2592
	.field	-931,16 		; r_dico2_lsf[163] @ 2608
	.field	136,16			; r_dico2_lsf[164] @ 2624
	.field	-483,16 		; r_dico2_lsf[165] @ 2640
	.field	183,16			; r_dico2_lsf[166] @ 2656
	.field	-468,16 		; r_dico2_lsf[167] @ 2672
	.field	55,16			; r_dico2_lsf[168] @ 2688
	.field	-298,16 		; r_dico2_lsf[169] @ 2704
	.field	55,16			; r_dico2_lsf[170] @ 2720
	.field	-304,16 		; r_dico2_lsf[171] @ 2736
	.field	313,16			; r_dico2_lsf[172] @ 2752
	.field	-609,16 		; r_dico2_lsf[173] @ 2768
	.field	313,16			; r_dico2_lsf[174] @ 2784
	.field	-720,16 		; r_dico2_lsf[175] @ 2800
	.field	322,16			; r_dico2_lsf[176] @ 2816
	.field	-167,16 		; r_dico2_lsf[177] @ 2832
	.field	100,16			; r_dico2_lsf[178] @ 2848
	.field	-541,16 		; r_dico2_lsf[179] @ 2864
	.field	-3,16			; r_dico2_lsf[180] @ 2880
	.field	-119,16 		; r_dico2_lsf[181] @ 2896
	.field	-111,16 		; r_dico2_lsf[182] @ 2912
	.field	-187,16 		; r_dico2_lsf[183] @ 2928
	.field	233,16			; r_dico2_lsf[184] @ 2944
	.field	-236,16 		; r_dico2_lsf[185] @ 2960
	.field	260,16			; r_dico2_lsf[186] @ 2976
	.field	-234,16 		; r_dico2_lsf[187] @ 2992
	.field	26,16			; r_dico2_lsf[188] @ 3008
	.field	-165,16 		; r_dico2_lsf[189] @ 3024
	.field	134,16			; r_dico2_lsf[190] @ 3040
	.field	-45,16			; r_dico2_lsf[191] @ 3056
	.field	-40,16			; r_dico2_lsf[192] @ 3072
	.field	-549,16 		; r_dico2_lsf[193] @ 3088
	.field	360,16			; r_dico2_lsf[194] @ 3104
	.field	-203,16 		; r_dico2_lsf[195] @ 3120
	.field	378,16			; r_dico2_lsf[196] @ 3136
	.field	-388,16 		; r_dico2_lsf[197] @ 3152
	.field	450,16			; r_dico2_lsf[198] @ 3168
	.field	-383,16 		; r_dico2_lsf[199] @ 3184
	.field	275,16			; r_dico2_lsf[200] @ 3200
	.field	20,16			; r_dico2_lsf[201] @ 3216
	.field	182,16			; r_dico2_lsf[202] @ 3232
	.field	-103,16 		; r_dico2_lsf[203] @ 3248
	.field	246,16			; r_dico2_lsf[204] @ 3264
	.field	-111,16 		; r_dico2_lsf[205] @ 3280
	.field	431,16			; r_dico2_lsf[206] @ 3296
	.field	37,16			; r_dico2_lsf[207] @ 3312
	.field	462,16			; r_dico2_lsf[208] @ 3328
	.field	-146,16 		; r_dico2_lsf[209] @ 3344
	.field	487,16			; r_dico2_lsf[210] @ 3360
	.field	-157,16 		; r_dico2_lsf[211] @ 3376
	.field	-284,16 		; r_dico2_lsf[212] @ 3392
	.field	-59,16			; r_dico2_lsf[213] @ 3408
	.field	503,16			; r_dico2_lsf[214] @ 3424
	.field	-184,16 		; r_dico2_lsf[215] @ 3440
	.field	24,16			; r_dico2_lsf[216] @ 3456
	.field	53,16			; r_dico2_lsf[217] @ 3472
	.field	-3,16			; r_dico2_lsf[218] @ 3488
	.field	54,16			; r_dico2_lsf[219] @ 3504
	.field	122,16			; r_dico2_lsf[220] @ 3520
	.field	259,16			; r_dico2_lsf[221] @ 3536
	.field	333,16			; r_dico2_lsf[222] @ 3552
	.field	66,16			; r_dico2_lsf[223] @ 3568
	.field	484,16			; r_dico2_lsf[224] @ 3584
	.field	104,16			; r_dico2_lsf[225] @ 3600
	.field	436,16			; r_dico2_lsf[226] @ 3616
	.field	68,16			; r_dico2_lsf[227] @ 3632
	.field	195,16			; r_dico2_lsf[228] @ 3648
	.field	116,16			; r_dico2_lsf[229] @ 3664
	.field	190,16			; r_dico2_lsf[230] @ 3680
	.field	206,16			; r_dico2_lsf[231] @ 3696
	.field	269,16			; r_dico2_lsf[232] @ 3712
	.field	-9,16			; r_dico2_lsf[233] @ 3728
	.field	482,16			; r_dico2_lsf[234] @ 3744
	.field	352,16			; r_dico2_lsf[235] @ 3760
	.field	382,16			; r_dico2_lsf[236] @ 3776
	.field	285,16			; r_dico2_lsf[237] @ 3792
	.field	399,16			; r_dico2_lsf[238] @ 3808
	.field	277,16			; r_dico2_lsf[239] @ 3824
	.field	452,16			; r_dico2_lsf[240] @ 3840
	.field	256,16			; r_dico2_lsf[241] @ 3856
	.field	69,16			; r_dico2_lsf[242] @ 3872
	.field	186,16			; r_dico2_lsf[243] @ 3888
	.field	13,16			; r_dico2_lsf[244] @ 3904
	.field	297,16			; r_dico2_lsf[245] @ 3920
	.field	-13,16			; r_dico2_lsf[246] @ 3936
	.field	259,16			; r_dico2_lsf[247] @ 3952
	.field	-95,16			; r_dico2_lsf[248] @ 3968
	.field	30,16			; r_dico2_lsf[249] @ 3984
	.field	56,16			; r_dico2_lsf[250] @ 4000
	.field	394,16			; r_dico2_lsf[251] @ 4016
	.field	196,16			; r_dico2_lsf[252] @ 4032
	.field	425,16			; r_dico2_lsf[253] @ 4048
	.field	205,16			; r_dico2_lsf[254] @ 4064
	.field	456,16			; r_dico2_lsf[255] @ 4080
	.field	281,16			; r_dico2_lsf[256] @ 4096
	.field	577,16			; r_dico2_lsf[257] @ 4112
	.field	15,16			; r_dico2_lsf[258] @ 4128
	.field	191,16			; r_dico2_lsf[259] @ 4144
	.field	375,16			; r_dico2_lsf[260] @ 4160
	.field	290,16			; r_dico2_lsf[261] @ 4176
	.field	407,16			; r_dico2_lsf[262] @ 4192
	.field	576,16			; r_dico2_lsf[263] @ 4208
	.field	-56,16			; r_dico2_lsf[264] @ 4224
	.field	227,16			; r_dico2_lsf[265] @ 4240
	.field	544,16			; r_dico2_lsf[266] @ 4256
	.field	405,16			; r_dico2_lsf[267] @ 4272
	.field	0,16			; r_dico2_lsf[268] @ 4288
	.field	549,16			; r_dico2_lsf[269] @ 4304
	.field	-92,16			; r_dico2_lsf[270] @ 4320
	.field	528,16			; r_dico2_lsf[271] @ 4336
	.field	-229,16 		; r_dico2_lsf[272] @ 4352
	.field	351,16			; r_dico2_lsf[273] @ 4368
	.field	-245,16 		; r_dico2_lsf[274] @ 4384
	.field	338,16			; r_dico2_lsf[275] @ 4400
	.field	-362,16 		; r_dico2_lsf[276] @ 4416
	.field	435,16			; r_dico2_lsf[277] @ 4432
	.field	167,16			; r_dico2_lsf[278] @ 4448
	.field	527,16			; r_dico2_lsf[279] @ 4464
	.field	-75,16			; r_dico2_lsf[280] @ 4480
	.field	302,16			; r_dico2_lsf[281] @ 4496
	.field	91,16			; r_dico2_lsf[282] @ 4512
	.field	824,16			; r_dico2_lsf[283] @ 4528
	.field	129,16			; r_dico2_lsf[284] @ 4544
	.field	599,16			; r_dico2_lsf[285] @ 4560
	.field	496,16			; r_dico2_lsf[286] @ 4576
	.field	679,16			; r_dico2_lsf[287] @ 4592
	.field	186,16			; r_dico2_lsf[288] @ 4608
	.field	749,16			; r_dico2_lsf[289] @ 4624
	.field	153,16			; r_dico2_lsf[290] @ 4640
	.field	737,16			; r_dico2_lsf[291] @ 4656
	.field	-281,16 		; r_dico2_lsf[292] @ 4672
	.field	600,16			; r_dico2_lsf[293] @ 4688
	.field	-348,16 		; r_dico2_lsf[294] @ 4704
	.field	615,16			; r_dico2_lsf[295] @ 4720
	.field	-236,16 		; r_dico2_lsf[296] @ 4736
	.field	769,16			; r_dico2_lsf[297] @ 4752
	.field	41,16			; r_dico2_lsf[298] @ 4768
	.field	881,16			; r_dico2_lsf[299] @ 4784
	.field	38,16			; r_dico2_lsf[300] @ 4800
	.field	890,16			; r_dico2_lsf[301] @ 4816
	.field	-220,16 		; r_dico2_lsf[302] @ 4832
	.field	841,16			; r_dico2_lsf[303] @ 4848
	.field	-357,16 		; r_dico2_lsf[304] @ 4864
	.field	883,16			; r_dico2_lsf[305] @ 4880
	.field	-393,16 		; r_dico2_lsf[306] @ 4896
	.field	903,16			; r_dico2_lsf[307] @ 4912
	.field	-634,16 		; r_dico2_lsf[308] @ 4928
	.field	474,16			; r_dico2_lsf[309] @ 4944
	.field	-444,16 		; r_dico2_lsf[310] @ 4960
	.field	850,16			; r_dico2_lsf[311] @ 4976
	.field	-175,16 		; r_dico2_lsf[312] @ 4992
	.field	678,16			; r_dico2_lsf[313] @ 5008
	.field	-493,16 		; r_dico2_lsf[314] @ 5024
	.field	242,16			; r_dico2_lsf[315] @ 5040
	.field	-519,16 		; r_dico2_lsf[316] @ 5056
	.field	785,16			; r_dico2_lsf[317] @ 5072
	.field	-714,16 		; r_dico2_lsf[318] @ 5088
	.field	582,16			; r_dico2_lsf[319] @ 5104
	.field	-541,16 		; r_dico2_lsf[320] @ 5120
	.field	366,16			; r_dico2_lsf[321] @ 5136
	.field	-543,16 		; r_dico2_lsf[322] @ 5152
	.field	434,16			; r_dico2_lsf[323] @ 5168
	.field	-597,16 		; r_dico2_lsf[324] @ 5184
	.field	500,16			; r_dico2_lsf[325] @ 5200
	.field	-765,16 		; r_dico2_lsf[326] @ 5216
	.field	222,16			; r_dico2_lsf[327] @ 5232
	.field	-702,16 		; r_dico2_lsf[328] @ 5248
	.field	917,16			; r_dico2_lsf[329] @ 5264
	.field	-743,16 		; r_dico2_lsf[330] @ 5280
	.field	962,16			; r_dico2_lsf[331] @ 5296
	.field	-869,16 		; r_dico2_lsf[332] @ 5312
	.field	501,16			; r_dico2_lsf[333] @ 5328
	.field	-899,16 		; r_dico2_lsf[334] @ 5344
	.field	548,16			; r_dico2_lsf[335] @ 5360
	.field	-379,16 		; r_dico2_lsf[336] @ 5376
	.field	200,16			; r_dico2_lsf[337] @ 5392
	.field	-435,16 		; r_dico2_lsf[338] @ 5408
	.field	157,16			; r_dico2_lsf[339] @ 5424
	.field	-819,16 		; r_dico2_lsf[340] @ 5440
	.field	214,16			; r_dico2_lsf[341] @ 5456
	.field	-861,16 		; r_dico2_lsf[342] @ 5472
	.field	157,16			; r_dico2_lsf[343] @ 5488
	.field	-614,16 		; r_dico2_lsf[344] @ 5504
	.field	40,16			; r_dico2_lsf[345] @ 5520
	.field	-632,16 		; r_dico2_lsf[346] @ 5536
	.field	94,16			; r_dico2_lsf[347] @ 5552
	.field	-883,16 		; r_dico2_lsf[348] @ 5568
	.field	-54,16			; r_dico2_lsf[349] @ 5584
	.field	-741,16 		; r_dico2_lsf[350] @ 5600
	.field	516,16			; r_dico2_lsf[351] @ 5616
	.field	-501,16 		; r_dico2_lsf[352] @ 5632
	.field	298,16			; r_dico2_lsf[353] @ 5648
	.field	-614,16 		; r_dico2_lsf[354] @ 5664
	.field	-171,16 		; r_dico2_lsf[355] @ 5680
	.field	-870,16 		; r_dico2_lsf[356] @ 5696
	.field	-161,16 		; r_dico2_lsf[357] @ 5712
	.field	-865,16 		; r_dico2_lsf[358] @ 5728
	.field	-23,16			; r_dico2_lsf[359] @ 5744
	.field	-818,16 		; r_dico2_lsf[360] @ 5760
	.field	93,16			; r_dico2_lsf[361] @ 5776
	.field	-1015,16		; r_dico2_lsf[362] @ 5792
	.field	-267,16 		; r_dico2_lsf[363] @ 5808
	.field	-662,16 		; r_dico2_lsf[364] @ 5824
	.field	-359,16 		; r_dico2_lsf[365] @ 5840
	.field	-549,16 		; r_dico2_lsf[366] @ 5856
	.field	2,16			; r_dico2_lsf[367] @ 5872
	.field	-442,16 		; r_dico2_lsf[368] @ 5888
	.field	-121,16 		; r_dico2_lsf[369] @ 5904
	.field	-377,16 		; r_dico2_lsf[370] @ 5920
	.field	0,16			; r_dico2_lsf[371] @ 5936
	.field	-227,16 		; r_dico2_lsf[372] @ 5952
	.field	33,16			; r_dico2_lsf[373] @ 5968
	.field	-414,16 		; r_dico2_lsf[374] @ 5984
	.field	-126,16 		; r_dico2_lsf[375] @ 6000
	.field	-129,16 		; r_dico2_lsf[376] @ 6016
	.field	212,16			; r_dico2_lsf[377] @ 6032
	.field	-934,16 		; r_dico2_lsf[378] @ 6048
	.field	34,16			; r_dico2_lsf[379] @ 6064
	.field	-1082,16		; r_dico2_lsf[380] @ 6080
	.field	-282,16 		; r_dico2_lsf[381] @ 6096
	.field	-1119,16		; r_dico2_lsf[382] @ 6112
	.field	-268,16 		; r_dico2_lsf[383] @ 6128
	.field	-710,16 		; r_dico2_lsf[384] @ 6144
	.field	-825,16 		; r_dico2_lsf[385] @ 6160
	.field	-420,16 		; r_dico2_lsf[386] @ 6176
	.field	-191,16 		; r_dico2_lsf[387] @ 6192
	.field	-1076,16		; r_dico2_lsf[388] @ 6208
	.field	-928,16 		; r_dico2_lsf[389] @ 6224
	.field	-917,16 		; r_dico2_lsf[390] @ 6240
	.field	-93,16			; r_dico2_lsf[391] @ 6256
	.field	-628,16 		; r_dico2_lsf[392] @ 6272
	.field	-358,16 		; r_dico2_lsf[393] @ 6288
	.field	97,16			; r_dico2_lsf[394] @ 6304
	.field	7,16			; r_dico2_lsf[395] @ 6320
	.field	-206,16 		; r_dico2_lsf[396] @ 6336
	.field	-393,16 		; r_dico2_lsf[397] @ 6352
	.field	-101,16 		; r_dico2_lsf[398] @ 6368
	.field	24,16			; r_dico2_lsf[399] @ 6384
	.field	-203,16 		; r_dico2_lsf[400] @ 6400
	.field	38,16			; r_dico2_lsf[401] @ 6416
	.field	-168,16 		; r_dico2_lsf[402] @ 6432
	.field	83,16			; r_dico2_lsf[403] @ 6448
	.field	-599,16 		; r_dico2_lsf[404] @ 6464
	.field	-423,16 		; r_dico2_lsf[405] @ 6480
	.field	-279,16 		; r_dico2_lsf[406] @ 6496
	.field	426,16			; r_dico2_lsf[407] @ 6512
	.field	-700,16 		; r_dico2_lsf[408] @ 6528
	.field	118,16			; r_dico2_lsf[409] @ 6544
	.field	-75,16			; r_dico2_lsf[410] @ 6560
	.field	206,16			; r_dico2_lsf[411] @ 6576
	.field	-981,16 		; r_dico2_lsf[412] @ 6592
	.field	-673,16 		; r_dico2_lsf[413] @ 6608
	.field	-680,16 		; r_dico2_lsf[414] @ 6624
	.field	417,16			; r_dico2_lsf[415] @ 6640
	.field	-367,16 		; r_dico2_lsf[416] @ 6656
	.field	37,16			; r_dico2_lsf[417] @ 6672
	.field	-279,16 		; r_dico2_lsf[418] @ 6688
	.field	474,16			; r_dico2_lsf[419] @ 6704
	.field	-129,16 		; r_dico2_lsf[420] @ 6720
	.field	-318,16 		; r_dico2_lsf[421] @ 6736
	.field	319,16			; r_dico2_lsf[422] @ 6752
	.field	296,16			; r_dico2_lsf[423] @ 6768
	.field	-626,16 		; r_dico2_lsf[424] @ 6784
	.field	-39,16			; r_dico2_lsf[425] @ 6800
	.field	343,16			; r_dico2_lsf[426] @ 6816
	.field	602,16			; r_dico2_lsf[427] @ 6832
	.field	-696,16 		; r_dico2_lsf[428] @ 6848
	.field	-39,16			; r_dico2_lsf[429] @ 6864
	.field	-303,16 		; r_dico2_lsf[430] @ 6880
	.field	940,16			; r_dico2_lsf[431] @ 6896
	.field	104,16			; r_dico2_lsf[432] @ 6912
	.field	233,16			; r_dico2_lsf[433] @ 6928
	.field	-380,16 		; r_dico2_lsf[434] @ 6944
	.field	137,16			; r_dico2_lsf[435] @ 6960
	.field	-36,16			; r_dico2_lsf[436] @ 6976
	.field	269,16			; r_dico2_lsf[437] @ 6992
	.field	-75,16			; r_dico2_lsf[438] @ 7008
	.field	-214,16 		; r_dico2_lsf[439] @ 7024
	.field	120,16			; r_dico2_lsf[440] @ 7040
	.field	43,16			; r_dico2_lsf[441] @ 7056
	.field	-529,16 		; r_dico2_lsf[442] @ 7072
	.field	-477,16 		; r_dico2_lsf[443] @ 7088
	.field	459,16			; r_dico2_lsf[444] @ 7104
	.field	164,16			; r_dico2_lsf[445] @ 7120
	.field	-202,16 		; r_dico2_lsf[446] @ 7136
	.field	-229,16 		; r_dico2_lsf[447] @ 7152
	.field	-49,16			; r_dico2_lsf[448] @ 7168
	.field	-167,16 		; r_dico2_lsf[449] @ 7184
	.field	609,16			; r_dico2_lsf[450] @ 7200
	.field	792,16			; r_dico2_lsf[451] @ 7216
	.field	98,16			; r_dico2_lsf[452] @ 7232
	.field	-220,16 		; r_dico2_lsf[453] @ 7248
	.field	915,16			; r_dico2_lsf[454] @ 7264
	.field	148,16			; r_dico2_lsf[455] @ 7280
	.field	293,16			; r_dico2_lsf[456] @ 7296
	.field	283,16			; r_dico2_lsf[457] @ 7312
	.field	869,16			; r_dico2_lsf[458] @ 7328
	.field	91,16			; r_dico2_lsf[459] @ 7344
	.field	575,16			; r_dico2_lsf[460] @ 7360
	.field	394,16			; r_dico2_lsf[461] @ 7376
	.field	326,16			; r_dico2_lsf[462] @ 7392
	.field	-78,16			; r_dico2_lsf[463] @ 7408
	.field	717,16			; r_dico2_lsf[464] @ 7424
	.field	67,16			; r_dico2_lsf[465] @ 7440
	.field	365,16			; r_dico2_lsf[466] @ 7456
	.field	-323,16 		; r_dico2_lsf[467] @ 7472
	.field	616,16			; r_dico2_lsf[468] @ 7488
	.field	-36,16			; r_dico2_lsf[469] @ 7504
	.field	731,16			; r_dico2_lsf[470] @ 7520
	.field	27,16			; r_dico2_lsf[471] @ 7536
	.field	619,16			; r_dico2_lsf[472] @ 7552
	.field	238,16			; r_dico2_lsf[473] @ 7568
	.field	632,16			; r_dico2_lsf[474] @ 7584
	.field	273,16			; r_dico2_lsf[475] @ 7600
	.field	448,16			; r_dico2_lsf[476] @ 7616
	.field	99,16			; r_dico2_lsf[477] @ 7632
	.field	801,16			; r_dico2_lsf[478] @ 7648
	.field	476,16			; r_dico2_lsf[479] @ 7664
	.field	869,16			; r_dico2_lsf[480] @ 7680
	.field	273,16			; r_dico2_lsf[481] @ 7696
	.field	685,16			; r_dico2_lsf[482] @ 7712
	.field	64,16			; r_dico2_lsf[483] @ 7728
	.field	789,16			; r_dico2_lsf[484] @ 7744
	.field	72,16			; r_dico2_lsf[485] @ 7760
	.field	1021,16 		; r_dico2_lsf[486] @ 7776
	.field	217,16			; r_dico2_lsf[487] @ 7792
	.field	793,16			; r_dico2_lsf[488] @ 7808
	.field	459,16			; r_dico2_lsf[489] @ 7824
	.field	734,16			; r_dico2_lsf[490] @ 7840
	.field	360,16			; r_dico2_lsf[491] @ 7856
	.field	646,16			; r_dico2_lsf[492] @ 7872
	.field	480,16			; r_dico2_lsf[493] @ 7888
	.field	360,16			; r_dico2_lsf[494] @ 7904
	.field	322,16			; r_dico2_lsf[495] @ 7920
	.field	429,16			; r_dico2_lsf[496] @ 7936
	.field	464,16			; r_dico2_lsf[497] @ 7952
	.field	638,16			; r_dico2_lsf[498] @ 7968
	.field	430,16			; r_dico2_lsf[499] @ 7984
	.field	756,16			; r_dico2_lsf[500] @ 8000
	.field	363,16			; r_dico2_lsf[501] @ 8016
	.field	1000,16 		; r_dico2_lsf[502] @ 8032
	.field	404,16			; r_dico2_lsf[503] @ 8048
	.field	683,16			; r_dico2_lsf[504] @ 8064
	.field	528,16			; r_dico2_lsf[505] @ 8080
	.field	602,16			; r_dico2_lsf[506] @ 8096
	.field	615,16			; r_dico2_lsf[507] @ 8112
	.field	655,16			; r_dico2_lsf[508] @ 8128
	.field	413,16			; r_dico2_lsf[509] @ 8144
	.field	946,16			; r_dico2_lsf[510] @ 8160
	.field	687,16			; r_dico2_lsf[511] @ 8176
	.field	937,16			; r_dico2_lsf[512] @ 8192
	.field	602,16			; r_dico2_lsf[513] @ 8208
	.field	904,16			; r_dico2_lsf[514] @ 8224
	.field	604,16			; r_dico2_lsf[515] @ 8240
	.field	555,16			; r_dico2_lsf[516] @ 8256
	.field	737,16			; r_dico2_lsf[517] @ 8272
	.field	786,16			; r_dico2_lsf[518] @ 8288
	.field	662,16			; r_dico2_lsf[519] @ 8304
	.field	467,16			; r_dico2_lsf[520] @ 8320
	.field	654,16			; r_dico2_lsf[521] @ 8336
	.field	362,16			; r_dico2_lsf[522] @ 8352
	.field	589,16			; r_dico2_lsf[523] @ 8368
	.field	929,16			; r_dico2_lsf[524] @ 8384
	.field	710,16			; r_dico2_lsf[525] @ 8400
	.field	498,16			; r_dico2_lsf[526] @ 8416
	.field	478,16			; r_dico2_lsf[527] @ 8432
	.field	415,16			; r_dico2_lsf[528] @ 8448
	.field	420,16			; r_dico2_lsf[529] @ 8464
	.field	693,16			; r_dico2_lsf[530] @ 8480
	.field	883,16			; r_dico2_lsf[531] @ 8496
	.field	813,16			; r_dico2_lsf[532] @ 8512
	.field	683,16			; r_dico2_lsf[533] @ 8528
	.field	781,16			; r_dico2_lsf[534] @ 8544
	.field	925,16			; r_dico2_lsf[535] @ 8560
	.field	913,16			; r_dico2_lsf[536] @ 8576
	.field	939,16			; r_dico2_lsf[537] @ 8592
	.field	726,16			; r_dico2_lsf[538] @ 8608
	.field	732,16			; r_dico2_lsf[539] @ 8624
	.field	491,16			; r_dico2_lsf[540] @ 8640
	.field	853,16			; r_dico2_lsf[541] @ 8656
	.field	531,16			; r_dico2_lsf[542] @ 8672
	.field	948,16			; r_dico2_lsf[543] @ 8688
	.field	734,16			; r_dico2_lsf[544] @ 8704
	.field	963,16			; r_dico2_lsf[545] @ 8720
	.field	315,16			; r_dico2_lsf[546] @ 8736
	.field	808,16			; r_dico2_lsf[547] @ 8752
	.field	761,16			; r_dico2_lsf[548] @ 8768
	.field	755,16			; r_dico2_lsf[549] @ 8784
	.field	1144,16 		; r_dico2_lsf[550] @ 8800
	.field	760,16			; r_dico2_lsf[551] @ 8816
	.field	655,16			; r_dico2_lsf[552] @ 8832
	.field	1076,16 		; r_dico2_lsf[553] @ 8848
	.field	826,16			; r_dico2_lsf[554] @ 8864
	.field	1057,16 		; r_dico2_lsf[555] @ 8880
	.field	1091,16 		; r_dico2_lsf[556] @ 8896
	.field	838,16			; r_dico2_lsf[557] @ 8912
	.field	1003,16 		; r_dico2_lsf[558] @ 8928
	.field	808,16			; r_dico2_lsf[559] @ 8944
	.field	1047,16 		; r_dico2_lsf[560] @ 8960
	.field	1133,16 		; r_dico2_lsf[561] @ 8976
	.field	659,16			; r_dico2_lsf[562] @ 8992
	.field	1101,16 		; r_dico2_lsf[563] @ 9008
	.field	992,16			; r_dico2_lsf[564] @ 9024
	.field	1050,16 		; r_dico2_lsf[565] @ 9040
	.field	1074,16 		; r_dico2_lsf[566] @ 9056
	.field	1075,16 		; r_dico2_lsf[567] @ 9072
	.field	971,16			; r_dico2_lsf[568] @ 9088
	.field	694,16			; r_dico2_lsf[569] @ 9104
	.field	1226,16 		; r_dico2_lsf[570] @ 9120
	.field	1054,16 		; r_dico2_lsf[571] @ 9136
	.field	571,16			; r_dico2_lsf[572] @ 9152
	.field	841,16			; r_dico2_lsf[573] @ 9168
	.field	884,16			; r_dico2_lsf[574] @ 9184
	.field	1404,16 		; r_dico2_lsf[575] @ 9200
	.field	1379,16 		; r_dico2_lsf[576] @ 9216
	.field	1096,16 		; r_dico2_lsf[577] @ 9232
	.field	1080,16 		; r_dico2_lsf[578] @ 9248
	.field	861,16			; r_dico2_lsf[579] @ 9264
	.field	1231,16 		; r_dico2_lsf[580] @ 9280
	.field	735,16			; r_dico2_lsf[581] @ 9296
	.field	1284,16 		; r_dico2_lsf[582] @ 9312
	.field	760,16			; r_dico2_lsf[583] @ 9328
	.field	1272,16 		; r_dico2_lsf[584] @ 9344
	.field	991,16			; r_dico2_lsf[585] @ 9360
	.field	1367,16 		; r_dico2_lsf[586] @ 9376
	.field	1053,16 		; r_dico2_lsf[587] @ 9392
	.field	1257,16 		; r_dico2_lsf[588] @ 9408
	.field	700,16			; r_dico2_lsf[589] @ 9424
	.field	1050,16 		; r_dico2_lsf[590] @ 9440
	.field	534,16			; r_dico2_lsf[591] @ 9456
	.field	988,16			; r_dico2_lsf[592] @ 9472
	.field	453,16			; r_dico2_lsf[593] @ 9488
	.field	1264,16 		; r_dico2_lsf[594] @ 9504
	.field	599,16			; r_dico2_lsf[595] @ 9520
	.field	1140,16 		; r_dico2_lsf[596] @ 9536
	.field	679,16			; r_dico2_lsf[597] @ 9552
	.field	1621,16 		; r_dico2_lsf[598] @ 9568
	.field	815,16			; r_dico2_lsf[599] @ 9584
	.field	1384,16 		; r_dico2_lsf[600] @ 9600
	.field	521,16			; r_dico2_lsf[601] @ 9616
	.field	1317,16 		; r_dico2_lsf[602] @ 9632
	.field	393,16			; r_dico2_lsf[603] @ 9648
	.field	1564,16 		; r_dico2_lsf[604] @ 9664
	.field	805,16			; r_dico2_lsf[605] @ 9680
	.field	1448,16 		; r_dico2_lsf[606] @ 9696
	.field	686,16			; r_dico2_lsf[607] @ 9712
	.field	1068,16 		; r_dico2_lsf[608] @ 9728
	.field	648,16			; r_dico2_lsf[609] @ 9744
	.field	875,16			; r_dico2_lsf[610] @ 9760
	.field	307,16			; r_dico2_lsf[611] @ 9776
	.field	1083,16 		; r_dico2_lsf[612] @ 9792
	.field	361,16			; r_dico2_lsf[613] @ 9808
	.field	1047,16 		; r_dico2_lsf[614] @ 9824
	.field	317,16			; r_dico2_lsf[615] @ 9840
	.field	1417,16 		; r_dico2_lsf[616] @ 9856
	.field	964,16			; r_dico2_lsf[617] @ 9872
	.field	675,16			; r_dico2_lsf[618] @ 9888
	.field	571,16			; r_dico2_lsf[619] @ 9904
	.field	1152,16 		; r_dico2_lsf[620] @ 9920
	.field	79,16			; r_dico2_lsf[621] @ 9936
	.field	1114,16 		; r_dico2_lsf[622] @ 9952
	.field	-47,16			; r_dico2_lsf[623] @ 9968
	.field	1530,16 		; r_dico2_lsf[624] @ 9984
	.field	311,16			; r_dico2_lsf[625] @ 10000
	.field	1721,16 		; r_dico2_lsf[626] @ 10016
	.field	314,16			; r_dico2_lsf[627] @ 10032
	.field	1166,16 		; r_dico2_lsf[628] @ 10048
	.field	689,16			; r_dico2_lsf[629] @ 10064
	.field	514,16			; r_dico2_lsf[630] @ 10080
	.field	-94,16			; r_dico2_lsf[631] @ 10096
	.field	349,16			; r_dico2_lsf[632] @ 10112
	.field	282,16			; r_dico2_lsf[633] @ 10128
	.field	1412,16 		; r_dico2_lsf[634] @ 10144
	.field	328,16			; r_dico2_lsf[635] @ 10160
	.field	1025,16 		; r_dico2_lsf[636] @ 10176
	.field	487,16			; r_dico2_lsf[637] @ 10192
	.field	-65,16			; r_dico2_lsf[638] @ 10208
	.field	57,16			; r_dico2_lsf[639] @ 10224
	.field	805,16			; r_dico2_lsf[640] @ 10240
	.field	970,16			; r_dico2_lsf[641] @ 10256
	.field	36,16			; r_dico2_lsf[642] @ 10272
	.field	62,16			; r_dico2_lsf[643] @ 10288
	.field	769,16			; r_dico2_lsf[644] @ 10304
	.field	-263,16 		; r_dico2_lsf[645] @ 10320
	.field	791,16			; r_dico2_lsf[646] @ 10336
	.field	-346,16 		; r_dico2_lsf[647] @ 10352
	.field	637,16			; r_dico2_lsf[648] @ 10368
	.field	699,16			; r_dico2_lsf[649] @ 10384
	.field	-137,16 		; r_dico2_lsf[650] @ 10400
	.field	620,16			; r_dico2_lsf[651] @ 10416
	.field	534,16			; r_dico2_lsf[652] @ 10432
	.field	541,16			; r_dico2_lsf[653] @ 10448
	.field	-735,16 		; r_dico2_lsf[654] @ 10464
	.field	194,16			; r_dico2_lsf[655] @ 10480
	.field	711,16			; r_dico2_lsf[656] @ 10496
	.field	300,16			; r_dico2_lsf[657] @ 10512
	.field	-268,16 		; r_dico2_lsf[658] @ 10528
	.field	-863,16 		; r_dico2_lsf[659] @ 10544
	.field	926,16			; r_dico2_lsf[660] @ 10560
	.field	769,16			; r_dico2_lsf[661] @ 10576
	.field	-708,16 		; r_dico2_lsf[662] @ 10592
	.field	-428,16 		; r_dico2_lsf[663] @ 10608
	.field	506,16			; r_dico2_lsf[664] @ 10624
	.field	174,16			; r_dico2_lsf[665] @ 10640
	.field	-892,16 		; r_dico2_lsf[666] @ 10656
	.field	-630,16 		; r_dico2_lsf[667] @ 10672
	.field	435,16			; r_dico2_lsf[668] @ 10688
	.field	547,16			; r_dico2_lsf[669] @ 10704
	.field	-1435,16		; r_dico2_lsf[670] @ 10720
	.field	-258,16 		; r_dico2_lsf[671] @ 10736
	.field	621,16			; r_dico2_lsf[672] @ 10752
	.field	471,16			; r_dico2_lsf[673] @ 10768
	.field	-1018,16		; r_dico2_lsf[674] @ 10784
	.field	-1368,16		; r_dico2_lsf[675] @ 10800
	.field	-393,16 		; r_dico2_lsf[676] @ 10816
	.field	521,16			; r_dico2_lsf[677] @ 10832
	.field	-920,16 		; r_dico2_lsf[678] @ 10848
	.field	-686,16 		; r_dico2_lsf[679] @ 10864
	.field	-25,16			; r_dico2_lsf[680] @ 10880
	.field	20,16			; r_dico2_lsf[681] @ 10896
	.field	-982,16 		; r_dico2_lsf[682] @ 10912
	.field	-1156,16		; r_dico2_lsf[683] @ 10928
	.field	340,16			; r_dico2_lsf[684] @ 10944
	.field	9,16			; r_dico2_lsf[685] @ 10960
	.field	-1558,16		; r_dico2_lsf[686] @ 10976
	.field	-1135,16		; r_dico2_lsf[687] @ 10992
	.field	-352,16 		; r_dico2_lsf[688] @ 11008
	.field	48,16			; r_dico2_lsf[689] @ 11024
	.field	-1579,16		; r_dico2_lsf[690] @ 11040
	.field	-402,16 		; r_dico2_lsf[691] @ 11056
	.field	-887,16 		; r_dico2_lsf[692] @ 11072
	.field	6,16			; r_dico2_lsf[693] @ 11088
	.field	-1156,16		; r_dico2_lsf[694] @ 11104
	.field	-888,16 		; r_dico2_lsf[695] @ 11120
	.field	-548,16 		; r_dico2_lsf[696] @ 11136
	.field	-352,16 		; r_dico2_lsf[697] @ 11152
	.field	-1643,16		; r_dico2_lsf[698] @ 11168
	.field	-1168,16		; r_dico2_lsf[699] @ 11184
	.field	-159,16 		; r_dico2_lsf[700] @ 11200
	.field	610,16			; r_dico2_lsf[701] @ 11216
	.field	-2024,16		; r_dico2_lsf[702] @ 11232
	.field	-963,16 		; r_dico2_lsf[703] @ 11248
	.field	-225,16 		; r_dico2_lsf[704] @ 11264
	.field	193,16			; r_dico2_lsf[705] @ 11280
	.field	-1656,16		; r_dico2_lsf[706] @ 11296
	.field	-1960,16		; r_dico2_lsf[707] @ 11312
	.field	-245,16 		; r_dico2_lsf[708] @ 11328
	.field	-493,16 		; r_dico2_lsf[709] @ 11344
	.field	-964,16 		; r_dico2_lsf[710] @ 11360
	.field	-1680,16		; r_dico2_lsf[711] @ 11376
	.field	-936,16 		; r_dico2_lsf[712] @ 11392
	.field	-635,16 		; r_dico2_lsf[713] @ 11408
	.field	-1299,16		; r_dico2_lsf[714] @ 11424
	.field	-1744,16		; r_dico2_lsf[715] @ 11440
	.field	-1388,16		; r_dico2_lsf[716] @ 11456
	.field	-604,16 		; r_dico2_lsf[717] @ 11472
	.field	-1540,16		; r_dico2_lsf[718] @ 11488
	.field	-835,16 		; r_dico2_lsf[719] @ 11504
	.field	-1397,16		; r_dico2_lsf[720] @ 11520
	.field	-135,16 		; r_dico2_lsf[721] @ 11536
	.field	-1588,16		; r_dico2_lsf[722] @ 11552
	.field	-290,16 		; r_dico2_lsf[723] @ 11568
	.field	-1670,16		; r_dico2_lsf[724] @ 11584
	.field	-712,16 		; r_dico2_lsf[725] @ 11600
	.field	-2011,16		; r_dico2_lsf[726] @ 11616
	.field	-1632,16		; r_dico2_lsf[727] @ 11632
	.field	-1663,16		; r_dico2_lsf[728] @ 11648
	.field	-27,16			; r_dico2_lsf[729] @ 11664
	.field	-2258,16		; r_dico2_lsf[730] @ 11680
	.field	-811,16 		; r_dico2_lsf[731] @ 11696
	.field	-1157,16		; r_dico2_lsf[732] @ 11712
	.field	184,16			; r_dico2_lsf[733] @ 11728
	.field	-1265,16		; r_dico2_lsf[734] @ 11744
	.field	189,16			; r_dico2_lsf[735] @ 11760
	.field	-1367,16		; r_dico2_lsf[736] @ 11776
	.field	586,16			; r_dico2_lsf[737] @ 11792
	.field	-2011,16		; r_dico2_lsf[738] @ 11808
	.field	201,16			; r_dico2_lsf[739] @ 11824
	.field	-790,16 		; r_dico2_lsf[740] @ 11840
	.field	712,16			; r_dico2_lsf[741] @ 11856
	.field	-1210,16		; r_dico2_lsf[742] @ 11872
	.field	3,16			; r_dico2_lsf[743] @ 11888
	.field	-1033,16		; r_dico2_lsf[744] @ 11904
	.field	808,16			; r_dico2_lsf[745] @ 11920
	.field	-1251,16		; r_dico2_lsf[746] @ 11936
	.field	830,16			; r_dico2_lsf[747] @ 11952
	.field	-111,16 		; r_dico2_lsf[748] @ 11968
	.field	635,16			; r_dico2_lsf[749] @ 11984
	.field	-1636,16		; r_dico2_lsf[750] @ 12000
	.field	447,16			; r_dico2_lsf[751] @ 12016
	.field	-463,16 		; r_dico2_lsf[752] @ 12032
	.field	-949,16 		; r_dico2_lsf[753] @ 12048
	.field	-445,16 		; r_dico2_lsf[754] @ 12064
	.field	-928,16 		; r_dico2_lsf[755] @ 12080
	.field	-504,16 		; r_dico2_lsf[756] @ 12096
	.field	-1162,16		; r_dico2_lsf[757] @ 12112
	.field	-501,16 		; r_dico2_lsf[758] @ 12128
	.field	-1211,16		; r_dico2_lsf[759] @ 12144
	.field	144,16			; r_dico2_lsf[760] @ 12160
	.field	-351,16 		; r_dico2_lsf[761] @ 12176
	.field	-372,16 		; r_dico2_lsf[762] @ 12192
	.field	-1052,16		; r_dico2_lsf[763] @ 12208
	.field	-283,16 		; r_dico2_lsf[764] @ 12224
	.field	-1059,16		; r_dico2_lsf[765] @ 12240
	.field	-279,16 		; r_dico2_lsf[766] @ 12256
	.field	-1123,16		; r_dico2_lsf[767] @ 12272
	.field	-575,16 		; r_dico2_lsf[768] @ 12288
	.field	-1438,16		; r_dico2_lsf[769] @ 12304
	.field	-587,16 		; r_dico2_lsf[770] @ 12320
	.field	-1614,16		; r_dico2_lsf[771] @ 12336
	.field	-935,16 		; r_dico2_lsf[772] @ 12352
	.field	-984,16 		; r_dico2_lsf[773] @ 12368
	.field	229,16			; r_dico2_lsf[774] @ 12384
	.field	690,16			; r_dico2_lsf[775] @ 12400
	.field	-921,16 		; r_dico2_lsf[776] @ 12416
	.field	-719,16 		; r_dico2_lsf[777] @ 12432
	.field	-403,16 		; r_dico2_lsf[778] @ 12448
	.field	1362,16 		; r_dico2_lsf[779] @ 12464
	.field	-685,16 		; r_dico2_lsf[780] @ 12480
	.field	-465,16 		; r_dico2_lsf[781] @ 12496
	.field	874,16			; r_dico2_lsf[782] @ 12512
	.field	397,16			; r_dico2_lsf[783] @ 12528
	.field	-509,16 		; r_dico2_lsf[784] @ 12544
	.field	-46,16			; r_dico2_lsf[785] @ 12560
	.field	317,16			; r_dico2_lsf[786] @ 12576
	.field	1334,16 		; r_dico2_lsf[787] @ 12592
	.field	-485,16 		; r_dico2_lsf[788] @ 12608
	.field	456,16			; r_dico2_lsf[789] @ 12624
	.field	813,16			; r_dico2_lsf[790] @ 12640
	.field	439,16			; r_dico2_lsf[791] @ 12656
	.field	-411,16 		; r_dico2_lsf[792] @ 12672
	.field	339,16			; r_dico2_lsf[793] @ 12688
	.field	898,16			; r_dico2_lsf[794] @ 12704
	.field	1067,16 		; r_dico2_lsf[795] @ 12720
	.field	-425,16 		; r_dico2_lsf[796] @ 12736
	.field	46,16			; r_dico2_lsf[797] @ 12752
	.field	1441,16 		; r_dico2_lsf[798] @ 12768
	.field	497,16			; r_dico2_lsf[799] @ 12784
	.field	-909,16 		; r_dico2_lsf[800] @ 12800
	.field	-800,16 		; r_dico2_lsf[801] @ 12816
	.field	1465,16 		; r_dico2_lsf[802] @ 12832
	.field	1046,16 		; r_dico2_lsf[803] @ 12848
	.field	-254,16 		; r_dico2_lsf[804] @ 12864
	.field	-321,16 		; r_dico2_lsf[805] @ 12880
	.field	1430,16 		; r_dico2_lsf[806] @ 12896
	.field	1165,16 		; r_dico2_lsf[807] @ 12912
	.field	68,16			; r_dico2_lsf[808] @ 12928
	.field	350,16			; r_dico2_lsf[809] @ 12944
	.field	1034,16 		; r_dico2_lsf[810] @ 12960
	.field	666,16			; r_dico2_lsf[811] @ 12976
	.field	370,16			; r_dico2_lsf[812] @ 12992
	.field	11,16			; r_dico2_lsf[813] @ 13008
	.field	1311,16 		; r_dico2_lsf[814] @ 13024
	.field	790,16			; r_dico2_lsf[815] @ 13040
	.field	143,16			; r_dico2_lsf[816] @ 13056
	.field	232,16			; r_dico2_lsf[817] @ 13072
	.field	1041,16 		; r_dico2_lsf[818] @ 13088
	.field	1562,16 		; r_dico2_lsf[819] @ 13104
	.field	-114,16 		; r_dico2_lsf[820] @ 13120
	.field	663,16			; r_dico2_lsf[821] @ 13136
	.field	1616,16 		; r_dico2_lsf[822] @ 13152
	.field	1078,16 		; r_dico2_lsf[823] @ 13168
	.field	454,16			; r_dico2_lsf[824] @ 13184
	.field	579,16			; r_dico2_lsf[825] @ 13200
	.field	1275,16 		; r_dico2_lsf[826] @ 13216
	.field	1040,16 		; r_dico2_lsf[827] @ 13232
	.field	-76,16			; r_dico2_lsf[828] @ 13248
	.field	909,16			; r_dico2_lsf[829] @ 13264
	.field	752,16			; r_dico2_lsf[830] @ 13280
	.field	1067,16 		; r_dico2_lsf[831] @ 13296
	.field	153,16			; r_dico2_lsf[832] @ 13312
	.field	512,16			; r_dico2_lsf[833] @ 13328
	.field	348,16			; r_dico2_lsf[834] @ 13344
	.field	1214,16 		; r_dico2_lsf[835] @ 13360
	.field	614,16			; r_dico2_lsf[836] @ 13376
	.field	385,16			; r_dico2_lsf[837] @ 13392
	.field	1843,16 		; r_dico2_lsf[838] @ 13408
	.field	808,16			; r_dico2_lsf[839] @ 13424
	.field	269,16			; r_dico2_lsf[840] @ 13440
	.field	1034,16 		; r_dico2_lsf[841] @ 13456
	.field	203,16			; r_dico2_lsf[842] @ 13472
	.field	1086,16 		; r_dico2_lsf[843] @ 13488
	.field	652,16			; r_dico2_lsf[844] @ 13504
	.field	1017,16 		; r_dico2_lsf[845] @ 13520
	.field	1783,16 		; r_dico2_lsf[846] @ 13536
	.field	1130,16 		; r_dico2_lsf[847] @ 13552
	.field	429,16			; r_dico2_lsf[848] @ 13568
	.field	1327,16 		; r_dico2_lsf[849] @ 13584
	.field	387,16			; r_dico2_lsf[850] @ 13600
	.field	1384,16 		; r_dico2_lsf[851] @ 13616
	.field	-49,16			; r_dico2_lsf[852] @ 13632
	.field	1183,16 		; r_dico2_lsf[853] @ 13648
	.field	-72,16			; r_dico2_lsf[854] @ 13664
	.field	1215,16 		; r_dico2_lsf[855] @ 13680
	.field	-416,16 		; r_dico2_lsf[856] @ 13696
	.field	1001,16 		; r_dico2_lsf[857] @ 13712
	.field	544,16			; r_dico2_lsf[858] @ 13728
	.field	1749,16 		; r_dico2_lsf[859] @ 13744
	.field	-352,16 		; r_dico2_lsf[860] @ 13760
	.field	1223,16 		; r_dico2_lsf[861] @ 13776
	.field	-502,16 		; r_dico2_lsf[862] @ 13792
	.field	1199,16 		; r_dico2_lsf[863] @ 13808
	.field	-589,16 		; r_dico2_lsf[864] @ 13824
	.field	569,16			; r_dico2_lsf[865] @ 13840
	.field	-227,16 		; r_dico2_lsf[866] @ 13856
	.field	1630,16 		; r_dico2_lsf[867] @ 13872
	.field	-142,16 		; r_dico2_lsf[868] @ 13888
	.field	1578,16 		; r_dico2_lsf[869] @ 13904
	.field	-230,16 		; r_dico2_lsf[870] @ 13920
	.field	1715,16 		; r_dico2_lsf[871] @ 13936
	.field	-714,16 		; r_dico2_lsf[872] @ 13952
	.field	1288,16 		; r_dico2_lsf[873] @ 13968
	.field	-838,16 		; r_dico2_lsf[874] @ 13984
	.field	1398,16 		; r_dico2_lsf[875] @ 14000
	.field	1131,16 		; r_dico2_lsf[876] @ 14016
	.field	1357,16 		; r_dico2_lsf[877] @ 14032
	.field	-208,16 		; r_dico2_lsf[878] @ 14048
	.field	1232,16 		; r_dico2_lsf[879] @ 14064
	.field	437,16			; r_dico2_lsf[880] @ 14080
	.field	965,16			; r_dico2_lsf[881] @ 14096
	.field	-929,16 		; r_dico2_lsf[882] @ 14112
	.field	818,16			; r_dico2_lsf[883] @ 14128
	.field	811,16			; r_dico2_lsf[884] @ 14144
	.field	1410,16 		; r_dico2_lsf[885] @ 14160
	.field	859,16			; r_dico2_lsf[886] @ 14176
	.field	1507,16 		; r_dico2_lsf[887] @ 14192
	.field	164,16			; r_dico2_lsf[888] @ 14208
	.field	1212,16 		; r_dico2_lsf[889] @ 14224
	.field	1387,16 		; r_dico2_lsf[890] @ 14240
	.field	1793,16 		; r_dico2_lsf[891] @ 14256
	.field	484,16			; r_dico2_lsf[892] @ 14272
	.field	1874,16 		; r_dico2_lsf[893] @ 14288
	.field	456,16			; r_dico2_lsf[894] @ 14304
	.field	2063,16 		; r_dico2_lsf[895] @ 14320
	.field	996,16			; r_dico2_lsf[896] @ 14336
	.field	1170,16 		; r_dico2_lsf[897] @ 14352
	.field	1326,16 		; r_dico2_lsf[898] @ 14368
	.field	1402,16 		; r_dico2_lsf[899] @ 14384
	.field	1316,16 		; r_dico2_lsf[900] @ 14400
	.field	1360,16 		; r_dico2_lsf[901] @ 14416
	.field	1135,16 		; r_dico2_lsf[902] @ 14432
	.field	1262,16 		; r_dico2_lsf[903] @ 14448
	.field	1234,16 		; r_dico2_lsf[904] @ 14464
	.field	1618,16 		; r_dico2_lsf[905] @ 14480
	.field	1361,16 		; r_dico2_lsf[906] @ 14496
	.field	1768,16 		; r_dico2_lsf[907] @ 14512
	.field	1421,16 		; r_dico2_lsf[908] @ 14528
	.field	1227,16 		; r_dico2_lsf[909] @ 14544
	.field	1584,16 		; r_dico2_lsf[910] @ 14560
	.field	1347,16 		; r_dico2_lsf[911] @ 14576
	.field	854,16			; r_dico2_lsf[912] @ 14592
	.field	672,16			; r_dico2_lsf[913] @ 14608
	.field	1685,16 		; r_dico2_lsf[914] @ 14624
	.field	1566,16 		; r_dico2_lsf[915] @ 14640
	.field	1139,16 		; r_dico2_lsf[916] @ 14656
	.field	1270,16 		; r_dico2_lsf[917] @ 14672
	.field	2016,16 		; r_dico2_lsf[918] @ 14688
	.field	1825,16 		; r_dico2_lsf[919] @ 14704
	.field	1773,16 		; r_dico2_lsf[920] @ 14720
	.field	1581,16 		; r_dico2_lsf[921] @ 14736
	.field	1532,16 		; r_dico2_lsf[922] @ 14752
	.field	1460,16 		; r_dico2_lsf[923] @ 14768
	.field	1487,16 		; r_dico2_lsf[924] @ 14784
	.field	946,16			; r_dico2_lsf[925] @ 14800
	.field	1659,16 		; r_dico2_lsf[926] @ 14816
	.field	1021,16 		; r_dico2_lsf[927] @ 14832
	.field	1744,16 		; r_dico2_lsf[928] @ 14848
	.field	1212,16 		; r_dico2_lsf[929] @ 14864
	.field	1392,16 		; r_dico2_lsf[930] @ 14880
	.field	977,16			; r_dico2_lsf[931] @ 14896
	.field	1772,16 		; r_dico2_lsf[932] @ 14912
	.field	1161,16 		; r_dico2_lsf[933] @ 14928
	.field	1826,16 		; r_dico2_lsf[934] @ 14944
	.field	1164,16 		; r_dico2_lsf[935] @ 14960
	.field	1718,16 		; r_dico2_lsf[936] @ 14976
	.field	1429,16 		; r_dico2_lsf[937] @ 14992
	.field	1973,16 		; r_dico2_lsf[938] @ 15008
	.field	1591,16 		; r_dico2_lsf[939] @ 15024
	.field	1185,16 		; r_dico2_lsf[940] @ 15040
	.field	864,16			; r_dico2_lsf[941] @ 15056
	.field	2132,16 		; r_dico2_lsf[942] @ 15072
	.field	1061,16 		; r_dico2_lsf[943] @ 15088
	.field	1799,16 		; r_dico2_lsf[944] @ 15104
	.field	814,16			; r_dico2_lsf[945] @ 15120
	.field	1838,16 		; r_dico2_lsf[946] @ 15136
	.field	757,16			; r_dico2_lsf[947] @ 15152
	.field	2104,16 		; r_dico2_lsf[948] @ 15168
	.field	1315,16 		; r_dico2_lsf[949] @ 15184
	.field	2054,16 		; r_dico2_lsf[950] @ 15200
	.field	1258,16 		; r_dico2_lsf[951] @ 15216
	.field	2113,16 		; r_dico2_lsf[952] @ 15232
	.field	915,16			; r_dico2_lsf[953] @ 15248
	.field	2331,16 		; r_dico2_lsf[954] @ 15264
	.field	930,16			; r_dico2_lsf[955] @ 15280
	.field	1467,16 		; r_dico2_lsf[956] @ 15296
	.field	1147,16 		; r_dico2_lsf[957] @ 15312
	.field	2590,16 		; r_dico2_lsf[958] @ 15328
	.field	1439,16 		; r_dico2_lsf[959] @ 15344
	.field	2245,16 		; r_dico2_lsf[960] @ 15360
	.field	1744,16 		; r_dico2_lsf[961] @ 15376
	.field	2090,16 		; r_dico2_lsf[962] @ 15392
	.field	1620,16 		; r_dico2_lsf[963] @ 15408
	.field	2358,16 		; r_dico2_lsf[964] @ 15424
	.field	1454,16 		; r_dico2_lsf[965] @ 15440
	.field	2666,16 		; r_dico2_lsf[966] @ 15456
	.field	1506,16 		; r_dico2_lsf[967] @ 15472
	.field	1876,16 		; r_dico2_lsf[968] @ 15488
	.field	1837,16 		; r_dico2_lsf[969] @ 15504
	.field	2070,16 		; r_dico2_lsf[970] @ 15520
	.field	1975,16 		; r_dico2_lsf[971] @ 15536
	.field	1739,16 		; r_dico2_lsf[972] @ 15552
	.field	1577,16 		; r_dico2_lsf[973] @ 15568
	.field	682,16			; r_dico2_lsf[974] @ 15584
	.field	1289,16 		; r_dico2_lsf[975] @ 15600
	.field	1584,16 		; r_dico2_lsf[976] @ 15616
	.field	2045,16 		; r_dico2_lsf[977] @ 15632
	.field	1454,16 		; r_dico2_lsf[978] @ 15648
	.field	2098,16 		; r_dico2_lsf[979] @ 15664
	.field	2498,16 		; r_dico2_lsf[980] @ 15680
	.field	2004,16 		; r_dico2_lsf[981] @ 15696
	.field	2711,16 		; r_dico2_lsf[982] @ 15712
	.field	2066,16 		; r_dico2_lsf[983] @ 15728
	.field	726,16			; r_dico2_lsf[984] @ 15744
	.field	1588,16 		; r_dico2_lsf[985] @ 15760
	.field	2756,16 		; r_dico2_lsf[986] @ 15776
	.field	2336,16 		; r_dico2_lsf[987] @ 15792
	.field	228,16			; r_dico2_lsf[988] @ 15808
	.field	847,16			; r_dico2_lsf[989] @ 15824
	.field	2456,16 		; r_dico2_lsf[990] @ 15840
	.field	1659,16 		; r_dico2_lsf[991] @ 15856
	.field	36,16			; r_dico2_lsf[992] @ 15872
	.field	301,16			; r_dico2_lsf[993] @ 15888
	.field	1942,16 		; r_dico2_lsf[994] @ 15904
	.field	1957,16 		; r_dico2_lsf[995] @ 15920
	.field	-446,16 		; r_dico2_lsf[996] @ 15936
	.field	-96,16			; r_dico2_lsf[997] @ 15952
	.field	2154,16 		; r_dico2_lsf[998] @ 15968
	.field	1396,16 		; r_dico2_lsf[999] @ 15984
	.field	1533,16 		; r_dico2_lsf[1000] @ 16000
	.field	1101,16 		; r_dico2_lsf[1001] @ 16016
	.field	14,16			; r_dico2_lsf[1002] @ 16032
	.field	608,16			; r_dico2_lsf[1003] @ 16048
	.field	-923,16 		; r_dico2_lsf[1004] @ 16064
	.field	-732,16 		; r_dico2_lsf[1005] @ 16080
	.field	1383,16 		; r_dico2_lsf[1006] @ 16096
	.field	1982,16 		; r_dico2_lsf[1007] @ 16112
	.field	1345,16 		; r_dico2_lsf[1008] @ 16128
	.field	952,16			; r_dico2_lsf[1009] @ 16144
	.field	-680,16 		; r_dico2_lsf[1010] @ 16160
	.field	321,16			; r_dico2_lsf[1011] @ 16176
	.field	1281,16 		; r_dico2_lsf[1012] @ 16192
	.field	1268,16 		; r_dico2_lsf[1013] @ 16208
	.field	-1594,16		; r_dico2_lsf[1014] @ 16224
	.field	365,16			; r_dico2_lsf[1015] @ 16240
	.field	941,16			; r_dico2_lsf[1016] @ 16256
	.field	946,16			; r_dico2_lsf[1017] @ 16272
	.field	-1737,16		; r_dico2_lsf[1018] @ 16288
	.field	-822,16 		; r_dico2_lsf[1019] @ 16304
	.field	2374,16 		; r_dico2_lsf[1020] @ 16320
	.field	2787,16 		; r_dico2_lsf[1021] @ 16336
	.field	1821,16 		; r_dico2_lsf[1022] @ 16352
	.field	2788,16 		; r_dico2_lsf[1023] @ 16368

r_dico3_lsf:
	.field	-1812,16		; r_dico3_lsf[0] @ 0
	.field	-2275,16		; r_dico3_lsf[1] @ 16
	.field	-1879,16		; r_dico3_lsf[2] @ 32
	.field	-2537,16		; r_dico3_lsf[3] @ 48
	.field	-1640,16		; r_dico3_lsf[4] @ 64
	.field	-1848,16		; r_dico3_lsf[5] @ 80
	.field	-1695,16		; r_dico3_lsf[6] @ 96
	.field	-2004,16		; r_dico3_lsf[7] @ 112
	.field	-1220,16		; r_dico3_lsf[8] @ 128
	.field	-1912,16		; r_dico3_lsf[9] @ 144
	.field	-1221,16		; r_dico3_lsf[10] @ 160
	.field	-2106,16		; r_dico3_lsf[11] @ 176
	.field	-1559,16		; r_dico3_lsf[12] @ 192
	.field	-1588,16		; r_dico3_lsf[13] @ 208
	.field	-1573,16		; r_dico3_lsf[14] @ 224
	.field	-1556,16		; r_dico3_lsf[15] @ 240
	.field	-1195,16		; r_dico3_lsf[16] @ 256
	.field	-1615,16		; r_dico3_lsf[17] @ 272
	.field	-1224,16		; r_dico3_lsf[18] @ 288
	.field	-1727,16		; r_dico3_lsf[19] @ 304
	.field	-1359,16		; r_dico3_lsf[20] @ 320
	.field	-1151,16		; r_dico3_lsf[21] @ 336
	.field	-1616,16		; r_dico3_lsf[22] @ 352
	.field	-1948,16		; r_dico3_lsf[23] @ 368
	.field	-1274,16		; r_dico3_lsf[24] @ 384
	.field	-1391,16		; r_dico3_lsf[25] @ 400
	.field	-1305,16		; r_dico3_lsf[26] @ 416
	.field	-1403,16		; r_dico3_lsf[27] @ 432
	.field	-1607,16		; r_dico3_lsf[28] @ 448
	.field	-1179,16		; r_dico3_lsf[29] @ 464
	.field	-1676,16		; r_dico3_lsf[30] @ 480
	.field	-1311,16		; r_dico3_lsf[31] @ 496
	.field	-1443,16		; r_dico3_lsf[32] @ 512
	.field	-1478,16		; r_dico3_lsf[33] @ 528
	.field	-1367,16		; r_dico3_lsf[34] @ 544
	.field	-898,16 		; r_dico3_lsf[35] @ 560
	.field	-1256,16		; r_dico3_lsf[36] @ 576
	.field	-1059,16		; r_dico3_lsf[37] @ 592
	.field	-1331,16		; r_dico3_lsf[38] @ 608
	.field	-1134,16		; r_dico3_lsf[39] @ 624
	.field	-982,16 		; r_dico3_lsf[40] @ 640
	.field	-1133,16		; r_dico3_lsf[41] @ 656
	.field	-1149,16		; r_dico3_lsf[42] @ 672
	.field	-1504,16		; r_dico3_lsf[43] @ 688
	.field	-1080,16		; r_dico3_lsf[44] @ 704
	.field	-1308,16		; r_dico3_lsf[45] @ 720
	.field	-1020,16		; r_dico3_lsf[46] @ 736
	.field	-1183,16		; r_dico3_lsf[47] @ 752
	.field	-980,16 		; r_dico3_lsf[48] @ 768
	.field	-1486,16		; r_dico3_lsf[49] @ 784
	.field	-967,16 		; r_dico3_lsf[50] @ 800
	.field	-1495,16		; r_dico3_lsf[51] @ 816
	.field	-988,16 		; r_dico3_lsf[52] @ 832
	.field	-922,16 		; r_dico3_lsf[53] @ 848
	.field	-1047,16		; r_dico3_lsf[54] @ 864
	.field	-1077,16		; r_dico3_lsf[55] @ 880
	.field	-838,16 		; r_dico3_lsf[56] @ 896
	.field	-1179,16		; r_dico3_lsf[57] @ 912
	.field	-858,16 		; r_dico3_lsf[58] @ 928
	.field	-1222,16		; r_dico3_lsf[59] @ 944
	.field	-1131,16		; r_dico3_lsf[60] @ 960
	.field	-1041,16		; r_dico3_lsf[61] @ 976
	.field	-1064,16		; r_dico3_lsf[62] @ 992
	.field	-767,16 		; r_dico3_lsf[63] @ 1008
	.field	-872,16 		; r_dico3_lsf[64] @ 1024
	.field	-1157,16		; r_dico3_lsf[65] @ 1040
	.field	-701,16 		; r_dico3_lsf[66] @ 1056
	.field	-880,16 		; r_dico3_lsf[67] @ 1072
	.field	-706,16 		; r_dico3_lsf[68] @ 1088
	.field	-906,16 		; r_dico3_lsf[69] @ 1104
	.field	-774,16 		; r_dico3_lsf[70] @ 1120
	.field	-1016,16		; r_dico3_lsf[71] @ 1136
	.field	-578,16 		; r_dico3_lsf[72] @ 1152
	.field	-1080,16		; r_dico3_lsf[73] @ 1168
	.field	-801,16 		; r_dico3_lsf[74] @ 1184
	.field	-1478,16		; r_dico3_lsf[75] @ 1200
	.field	-591,16 		; r_dico3_lsf[76] @ 1216
	.field	-1111,16		; r_dico3_lsf[77] @ 1232
	.field	-592,16 		; r_dico3_lsf[78] @ 1248
	.field	-1146,16		; r_dico3_lsf[79] @ 1264
	.field	-713,16 		; r_dico3_lsf[80] @ 1280
	.field	-1388,16		; r_dico3_lsf[81] @ 1296
	.field	-640,16 		; r_dico3_lsf[82] @ 1312
	.field	-1376,16		; r_dico3_lsf[83] @ 1328
	.field	-597,16 		; r_dico3_lsf[84] @ 1344
	.field	-1059,16		; r_dico3_lsf[85] @ 1360
	.field	-416,16 		; r_dico3_lsf[86] @ 1376
	.field	-903,16 		; r_dico3_lsf[87] @ 1392
	.field	-686,16 		; r_dico3_lsf[88] @ 1408
	.field	-832,16 		; r_dico3_lsf[89] @ 1424
	.field	-661,16 		; r_dico3_lsf[90] @ 1440
	.field	-708,16 		; r_dico3_lsf[91] @ 1456
	.field	-444,16 		; r_dico3_lsf[92] @ 1472
	.field	-868,16 		; r_dico3_lsf[93] @ 1488
	.field	-490,16 		; r_dico3_lsf[94] @ 1504
	.field	-921,16 		; r_dico3_lsf[95] @ 1520
	.field	-374,16 		; r_dico3_lsf[96] @ 1536
	.field	-776,16 		; r_dico3_lsf[97] @ 1552
	.field	-619,16 		; r_dico3_lsf[98] @ 1568
	.field	-1170,16		; r_dico3_lsf[99] @ 1584
	.field	-585,16 		; r_dico3_lsf[100] @ 1600
	.field	-549,16 		; r_dico3_lsf[101] @ 1616
	.field	-769,16 		; r_dico3_lsf[102] @ 1632
	.field	-795,16 		; r_dico3_lsf[103] @ 1648
	.field	-435,16 		; r_dico3_lsf[104] @ 1664
	.field	-659,16 		; r_dico3_lsf[105] @ 1680
	.field	-530,16 		; r_dico3_lsf[106] @ 1696
	.field	-741,16 		; r_dico3_lsf[107] @ 1712
	.field	-498,16 		; r_dico3_lsf[108] @ 1728
	.field	-837,16 		; r_dico3_lsf[109] @ 1744
	.field	-357,16 		; r_dico3_lsf[110] @ 1760
	.field	-597,16 		; r_dico3_lsf[111] @ 1776
	.field	-279,16 		; r_dico3_lsf[112] @ 1792
	.field	-871,16 		; r_dico3_lsf[113] @ 1808
	.field	-243,16 		; r_dico3_lsf[114] @ 1824
	.field	-887,16 		; r_dico3_lsf[115] @ 1840
	.field	-282,16 		; r_dico3_lsf[116] @ 1856
	.field	-665,16 		; r_dico3_lsf[117] @ 1872
	.field	-280,16 		; r_dico3_lsf[118] @ 1888
	.field	-667,16 		; r_dico3_lsf[119] @ 1904
	.field	-165,16 		; r_dico3_lsf[120] @ 1920
	.field	-560,16 		; r_dico3_lsf[121] @ 1936
	.field	-394,16 		; r_dico3_lsf[122] @ 1952
	.field	-903,16 		; r_dico3_lsf[123] @ 1968
	.field	-362,16 		; r_dico3_lsf[124] @ 1984
	.field	-410,16 		; r_dico3_lsf[125] @ 2000
	.field	-448,16 		; r_dico3_lsf[126] @ 2016
	.field	-583,16 		; r_dico3_lsf[127] @ 2032
	.field	-409,16 		; r_dico3_lsf[128] @ 2048
	.field	-574,16 		; r_dico3_lsf[129] @ 2064
	.field	-313,16 		; r_dico3_lsf[130] @ 2080
	.field	-357,16 		; r_dico3_lsf[131] @ 2096
	.field	-637,16 		; r_dico3_lsf[132] @ 2112
	.field	-548,16 		; r_dico3_lsf[133] @ 2128
	.field	-570,16 		; r_dico3_lsf[134] @ 2144
	.field	-436,16 		; r_dico3_lsf[135] @ 2160
	.field	-896,16 		; r_dico3_lsf[136] @ 2176
	.field	-504,16 		; r_dico3_lsf[137] @ 2192
	.field	-382,16 		; r_dico3_lsf[138] @ 2208
	.field	-757,16 		; r_dico3_lsf[139] @ 2224
	.field	-58,16			; r_dico3_lsf[140] @ 2240
	.field	-481,16 		; r_dico3_lsf[141] @ 2256
	.field	-165,16 		; r_dico3_lsf[142] @ 2272
	.field	-618,16 		; r_dico3_lsf[143] @ 2288
	.field	-191,16 		; r_dico3_lsf[144] @ 2304
	.field	-374,16 		; r_dico3_lsf[145] @ 2320
	.field	-234,16 		; r_dico3_lsf[146] @ 2336
	.field	-382,16 		; r_dico3_lsf[147] @ 2352
	.field	-222,16 		; r_dico3_lsf[148] @ 2368
	.field	-683,16 		; r_dico3_lsf[149] @ 2384
	.field	-25,16			; r_dico3_lsf[150] @ 2400
	.field	-480,16 		; r_dico3_lsf[151] @ 2416
	.field	-418,16 		; r_dico3_lsf[152] @ 2432
	.field	-359,16 		; r_dico3_lsf[153] @ 2448
	.field	-730,16 		; r_dico3_lsf[154] @ 2464
	.field	-353,16 		; r_dico3_lsf[155] @ 2480
	.field	-324,16 		; r_dico3_lsf[156] @ 2496
	.field	-157,16 		; r_dico3_lsf[157] @ 2512
	.field	-432,16 		; r_dico3_lsf[158] @ 2528
	.field	-322,16 		; r_dico3_lsf[159] @ 2544
	.field	-394,16 		; r_dico3_lsf[160] @ 2560
	.field	-303,16 		; r_dico3_lsf[161] @ 2576
	.field	-284,16 		; r_dico3_lsf[162] @ 2592
	.field	-104,16 		; r_dico3_lsf[163] @ 2608
	.field	-601,16 		; r_dico3_lsf[164] @ 2624
	.field	-289,16 		; r_dico3_lsf[165] @ 2640
	.field	-556,16 		; r_dico3_lsf[166] @ 2656
	.field	-196,16 		; r_dico3_lsf[167] @ 2672
	.field	-588,16 		; r_dico3_lsf[168] @ 2688
	.field	-150,16 		; r_dico3_lsf[169] @ 2704
	.field	-659,16 		; r_dico3_lsf[170] @ 2720
	.field	-608,16 		; r_dico3_lsf[171] @ 2736
	.field	-473,16 		; r_dico3_lsf[172] @ 2752
	.field	-24,16			; r_dico3_lsf[173] @ 2768
	.field	-68,16			; r_dico3_lsf[174] @ 2784
	.field	-448,16 		; r_dico3_lsf[175] @ 2800
	.field	-474,16 		; r_dico3_lsf[176] @ 2816
	.field	-8,16			; r_dico3_lsf[177] @ 2832
	.field	-506,16 		; r_dico3_lsf[178] @ 2848
	.field	-45,16			; r_dico3_lsf[179] @ 2864
	.field	-748,16 		; r_dico3_lsf[180] @ 2880
	.field	-184,16 		; r_dico3_lsf[181] @ 2896
	.field	-844,16 		; r_dico3_lsf[182] @ 2912
	.field	-252,16 		; r_dico3_lsf[183] @ 2928
	.field	-901,16 		; r_dico3_lsf[184] @ 2944
	.field	-91,16			; r_dico3_lsf[185] @ 2960
	.field	-584,16 		; r_dico3_lsf[186] @ 2976
	.field	-97,16			; r_dico3_lsf[187] @ 2992
	.field	-652,16 		; r_dico3_lsf[188] @ 3008
	.field	138,16			; r_dico3_lsf[189] @ 3024
	.field	-764,16 		; r_dico3_lsf[190] @ 3040
	.field	-131,16 		; r_dico3_lsf[191] @ 3056
	.field	-678,16 		; r_dico3_lsf[192] @ 3072
	.field	-12,16			; r_dico3_lsf[193] @ 3088
	.field	-670,16 		; r_dico3_lsf[194] @ 3104
	.field	165,16			; r_dico3_lsf[195] @ 3120
	.field	-259,16 		; r_dico3_lsf[196] @ 3136
	.field	-3,16			; r_dico3_lsf[197] @ 3152
	.field	-840,16 		; r_dico3_lsf[198] @ 3168
	.field	-107,16 		; r_dico3_lsf[199] @ 3184
	.field	-909,16 		; r_dico3_lsf[200] @ 3200
	.field	37,16			; r_dico3_lsf[201] @ 3216
	.field	-992,16 		; r_dico3_lsf[202] @ 3232
	.field	44,16			; r_dico3_lsf[203] @ 3248
	.field	-854,16 		; r_dico3_lsf[204] @ 3264
	.field	-415,16 		; r_dico3_lsf[205] @ 3280
	.field	-839,16 		; r_dico3_lsf[206] @ 3296
	.field	13,16			; r_dico3_lsf[207] @ 3312
	.field	-1001,16		; r_dico3_lsf[208] @ 3328
	.field	-271,16 		; r_dico3_lsf[209] @ 3344
	.field	-1026,16		; r_dico3_lsf[210] @ 3360
	.field	-309,16 		; r_dico3_lsf[211] @ 3376
	.field	-798,16 		; r_dico3_lsf[212] @ 3392
	.field	-478,16 		; r_dico3_lsf[213] @ 3408
	.field	-832,16 		; r_dico3_lsf[214] @ 3424
	.field	-488,16 		; r_dico3_lsf[215] @ 3440
	.field	-943,16 		; r_dico3_lsf[216] @ 3456
	.field	168,16			; r_dico3_lsf[217] @ 3472
	.field	-1112,16		; r_dico3_lsf[218] @ 3488
	.field	-387,16 		; r_dico3_lsf[219] @ 3504
	.field	-1185,16		; r_dico3_lsf[220] @ 3520
	.field	-101,16 		; r_dico3_lsf[221] @ 3536
	.field	-1183,16		; r_dico3_lsf[222] @ 3552
	.field	-40,16			; r_dico3_lsf[223] @ 3568
	.field	-941,16 		; r_dico3_lsf[224] @ 3584
	.field	-316,16 		; r_dico3_lsf[225] @ 3600
	.field	-1030,16		; r_dico3_lsf[226] @ 3616
	.field	-770,16 		; r_dico3_lsf[227] @ 3632
	.field	-1044,16		; r_dico3_lsf[228] @ 3648
	.field	-625,16 		; r_dico3_lsf[229] @ 3664
	.field	-1081,16		; r_dico3_lsf[230] @ 3680
	.field	-538,16 		; r_dico3_lsf[231] @ 3696
	.field	-1224,16		; r_dico3_lsf[232] @ 3712
	.field	-299,16 		; r_dico3_lsf[233] @ 3728
	.field	-1312,16		; r_dico3_lsf[234] @ 3744
	.field	-436,16 		; r_dico3_lsf[235] @ 3760
	.field	-1197,16		; r_dico3_lsf[236] @ 3776
	.field	-663,16 		; r_dico3_lsf[237] @ 3792
	.field	-1167,16		; r_dico3_lsf[238] @ 3808
	.field	-161,16 		; r_dico3_lsf[239] @ 3824
	.field	-1216,16		; r_dico3_lsf[240] @ 3840
	.field	-690,16 		; r_dico3_lsf[241] @ 3856
	.field	-1237,16		; r_dico3_lsf[242] @ 3872
	.field	-831,16 		; r_dico3_lsf[243] @ 3888
	.field	-1432,16		; r_dico3_lsf[244] @ 3904
	.field	-720,16 		; r_dico3_lsf[245] @ 3920
	.field	-1403,16		; r_dico3_lsf[246] @ 3936
	.field	-493,16 		; r_dico3_lsf[247] @ 3952
	.field	-898,16 		; r_dico3_lsf[248] @ 3968
	.field	-740,16 		; r_dico3_lsf[249] @ 3984
	.field	-922,16 		; r_dico3_lsf[250] @ 4000
	.field	-801,16 		; r_dico3_lsf[251] @ 4016
	.field	-1102,16		; r_dico3_lsf[252] @ 4032
	.field	-402,16 		; r_dico3_lsf[253] @ 4048
	.field	-1579,16		; r_dico3_lsf[254] @ 4064
	.field	-964,16 		; r_dico3_lsf[255] @ 4080
	.field	-1061,16		; r_dico3_lsf[256] @ 4096
	.field	-638,16 		; r_dico3_lsf[257] @ 4112
	.field	-1269,16		; r_dico3_lsf[258] @ 4128
	.field	-1438,16		; r_dico3_lsf[259] @ 4144
	.field	-1499,16		; r_dico3_lsf[260] @ 4160
	.field	-934,16 		; r_dico3_lsf[261] @ 4176
	.field	-1502,16		; r_dico3_lsf[262] @ 4192
	.field	-895,16 		; r_dico3_lsf[263] @ 4208
	.field	-1598,16		; r_dico3_lsf[264] @ 4224
	.field	-564,16 		; r_dico3_lsf[265] @ 4240
	.field	-1723,16		; r_dico3_lsf[266] @ 4256
	.field	-717,16 		; r_dico3_lsf[267] @ 4272
	.field	-606,16 		; r_dico3_lsf[268] @ 4288
	.field	-597,16 		; r_dico3_lsf[269] @ 4304
	.field	-1166,16		; r_dico3_lsf[270] @ 4320
	.field	-1085,16		; r_dico3_lsf[271] @ 4336
	.field	-1369,16		; r_dico3_lsf[272] @ 4352
	.field	-468,16 		; r_dico3_lsf[273] @ 4368
	.field	-1946,16		; r_dico3_lsf[274] @ 4384
	.field	-1493,16		; r_dico3_lsf[275] @ 4400
	.field	-1838,16		; r_dico3_lsf[276] @ 4416
	.field	-953,16 		; r_dico3_lsf[277] @ 4432
	.field	-1932,16		; r_dico3_lsf[278] @ 4448
	.field	-931,16 		; r_dico3_lsf[279] @ 4464
	.field	-1499,16		; r_dico3_lsf[280] @ 4480
	.field	-188,16 		; r_dico3_lsf[281] @ 4496
	.field	-1635,16		; r_dico3_lsf[282] @ 4512
	.field	-421,16 		; r_dico3_lsf[283] @ 4528
	.field	-1457,16		; r_dico3_lsf[284] @ 4544
	.field	-338,16 		; r_dico3_lsf[285] @ 4560
	.field	-1448,16		; r_dico3_lsf[286] @ 4576
	.field	-22,16			; r_dico3_lsf[287] @ 4592
	.field	-1942,16		; r_dico3_lsf[288] @ 4608
	.field	-422,16 		; r_dico3_lsf[289] @ 4624
	.field	-2006,16		; r_dico3_lsf[290] @ 4640
	.field	-249,16 		; r_dico3_lsf[291] @ 4656
	.field	-496,16 		; r_dico3_lsf[292] @ 4672
	.field	-114,16 		; r_dico3_lsf[293] @ 4688
	.field	-1910,16		; r_dico3_lsf[294] @ 4704
	.field	-755,16 		; r_dico3_lsf[295] @ 4720
	.field	-1289,16		; r_dico3_lsf[296] @ 4736
	.field	174,16			; r_dico3_lsf[297] @ 4752
	.field	-1451,16		; r_dico3_lsf[298] @ 4768
	.field	-109,16 		; r_dico3_lsf[299] @ 4784
	.field	-482,16 		; r_dico3_lsf[300] @ 4800
	.field	-257,16 		; r_dico3_lsf[301] @ 4816
	.field	-1221,16		; r_dico3_lsf[302] @ 4832
	.field	-508,16 		; r_dico3_lsf[303] @ 4848
	.field	-1617,16		; r_dico3_lsf[304] @ 4864
	.field	151,16			; r_dico3_lsf[305] @ 4880
	.field	-1694,16		; r_dico3_lsf[306] @ 4896
	.field	208,16			; r_dico3_lsf[307] @ 4912
	.field	-654,16 		; r_dico3_lsf[308] @ 4928
	.field	107,16			; r_dico3_lsf[309] @ 4944
	.field	-1651,16		; r_dico3_lsf[310] @ 4960
	.field	29,16			; r_dico3_lsf[311] @ 4976
	.field	-1141,16		; r_dico3_lsf[312] @ 4992
	.field	279,16			; r_dico3_lsf[313] @ 5008
	.field	-1215,16		; r_dico3_lsf[314] @ 5024
	.field	306,16			; r_dico3_lsf[315] @ 5040
	.field	-1228,16		; r_dico3_lsf[316] @ 5056
	.field	-506,16 		; r_dico3_lsf[317] @ 5072
	.field	-730,16 		; r_dico3_lsf[318] @ 5088
	.field	-175,16 		; r_dico3_lsf[319] @ 5104
	.field	-1236,16		; r_dico3_lsf[320] @ 5120
	.field	-101,16 		; r_dico3_lsf[321] @ 5136
	.field	-969,16 		; r_dico3_lsf[322] @ 5152
	.field	551,16			; r_dico3_lsf[323] @ 5168
	.field	-870,16 		; r_dico3_lsf[324] @ 5184
	.field	278,16			; r_dico3_lsf[325] @ 5200
	.field	-823,16 		; r_dico3_lsf[326] @ 5216
	.field	315,16			; r_dico3_lsf[327] @ 5232
	.field	-563,16 		; r_dico3_lsf[328] @ 5248
	.field	376,16			; r_dico3_lsf[329] @ 5264
	.field	-1051,16		; r_dico3_lsf[330] @ 5280
	.field	228,16			; r_dico3_lsf[331] @ 5296
	.field	-507,16 		; r_dico3_lsf[332] @ 5312
	.field	280,16			; r_dico3_lsf[333] @ 5328
	.field	-599,16 		; r_dico3_lsf[334] @ 5344
	.field	281,16			; r_dico3_lsf[335] @ 5360
	.field	-758,16 		; r_dico3_lsf[336] @ 5376
	.field	253,16			; r_dico3_lsf[337] @ 5392
	.field	-305,16 		; r_dico3_lsf[338] @ 5408
	.field	379,16			; r_dico3_lsf[339] @ 5424
	.field	-755,16 		; r_dico3_lsf[340] @ 5440
	.field	-134,16 		; r_dico3_lsf[341] @ 5456
	.field	-611,16 		; r_dico3_lsf[342] @ 5472
	.field	660,16			; r_dico3_lsf[343] @ 5488
	.field	-824,16 		; r_dico3_lsf[344] @ 5504
	.field	536,16			; r_dico3_lsf[345] @ 5520
	.field	-817,16 		; r_dico3_lsf[346] @ 5536
	.field	646,16			; r_dico3_lsf[347] @ 5552
	.field	-413,16 		; r_dico3_lsf[348] @ 5568
	.field	49,16			; r_dico3_lsf[349] @ 5584
	.field	-341,16 		; r_dico3_lsf[350] @ 5600
	.field	177,16			; r_dico3_lsf[351] @ 5616
	.field	-453,16 		; r_dico3_lsf[352] @ 5632
	.field	526,16			; r_dico3_lsf[353] @ 5648
	.field	-482,16 		; r_dico3_lsf[354] @ 5664
	.field	589,16			; r_dico3_lsf[355] @ 5680
	.field	-71,16			; r_dico3_lsf[356] @ 5696
	.field	339,16			; r_dico3_lsf[357] @ 5712
	.field	-657,16 		; r_dico3_lsf[358] @ 5728
	.field	264,16			; r_dico3_lsf[359] @ 5744
	.field	-244,16 		; r_dico3_lsf[360] @ 5760
	.field	295,16			; r_dico3_lsf[361] @ 5776
	.field	-237,16 		; r_dico3_lsf[362] @ 5792
	.field	315,16			; r_dico3_lsf[363] @ 5808
	.field	-387,16 		; r_dico3_lsf[364] @ 5824
	.field	569,16			; r_dico3_lsf[365] @ 5840
	.field	-506,16 		; r_dico3_lsf[366] @ 5856
	.field	-9,16			; r_dico3_lsf[367] @ 5872
	.field	-377,16 		; r_dico3_lsf[368] @ 5888
	.field	14,16			; r_dico3_lsf[369] @ 5904
	.field	-160,16 		; r_dico3_lsf[370] @ 5920
	.field	661,16			; r_dico3_lsf[371] @ 5936
	.field	-216,16 		; r_dico3_lsf[372] @ 5952
	.field	40,16			; r_dico3_lsf[373] @ 5968
	.field	-308,16 		; r_dico3_lsf[374] @ 5984
	.field	-46,16			; r_dico3_lsf[375] @ 6000
	.field	95,16			; r_dico3_lsf[376] @ 6016
	.field	214,16			; r_dico3_lsf[377] @ 6032
	.field	-242,16 		; r_dico3_lsf[378] @ 6048
	.field	167,16			; r_dico3_lsf[379] @ 6064
	.field	-86,16			; r_dico3_lsf[380] @ 6080
	.field	192,16			; r_dico3_lsf[381] @ 6096
	.field	-56,16			; r_dico3_lsf[382] @ 6112
	.field	27,16			; r_dico3_lsf[383] @ 6128
	.field	-76,16			; r_dico3_lsf[384] @ 6144
	.field	31,16			; r_dico3_lsf[385] @ 6160
	.field	36,16			; r_dico3_lsf[386] @ 6176
	.field	309,16			; r_dico3_lsf[387] @ 6192
	.field	-106,16 		; r_dico3_lsf[388] @ 6208
	.field	-182,16 		; r_dico3_lsf[389] @ 6224
	.field	-113,16 		; r_dico3_lsf[390] @ 6240
	.field	74,16			; r_dico3_lsf[391] @ 6256
	.field	-441,16 		; r_dico3_lsf[392] @ 6272
	.field	-22,16			; r_dico3_lsf[393] @ 6288
	.field	23,16			; r_dico3_lsf[394] @ 6304
	.field	139,16			; r_dico3_lsf[395] @ 6320
	.field	81,16			; r_dico3_lsf[396] @ 6336
	.field	-11,16			; r_dico3_lsf[397] @ 6352
	.field	44,16			; r_dico3_lsf[398] @ 6368
	.field	15,16			; r_dico3_lsf[399] @ 6384
	.field	-87,16			; r_dico3_lsf[400] @ 6400
	.field	-137,16 		; r_dico3_lsf[401] @ 6416
	.field	-118,16 		; r_dico3_lsf[402] @ 6432
	.field	-207,16 		; r_dico3_lsf[403] @ 6448
	.field	-158,16 		; r_dico3_lsf[404] @ 6464
	.field	-58,16			; r_dico3_lsf[405] @ 6480
	.field	272,16			; r_dico3_lsf[406] @ 6496
	.field	-92,16			; r_dico3_lsf[407] @ 6512
	.field	-156,16 		; r_dico3_lsf[408] @ 6528
	.field	-441,16 		; r_dico3_lsf[409] @ 6544
	.field	8,16			; r_dico3_lsf[410] @ 6560
	.field	-136,16 		; r_dico3_lsf[411] @ 6576
	.field	128,16			; r_dico3_lsf[412] @ 6592
	.field	-221,16 		; r_dico3_lsf[413] @ 6608
	.field	101,16			; r_dico3_lsf[414] @ 6624
	.field	-218,16 		; r_dico3_lsf[415] @ 6640
	.field	40,16			; r_dico3_lsf[416] @ 6656
	.field	-197,16 		; r_dico3_lsf[417] @ 6672
	.field	-76,16			; r_dico3_lsf[418] @ 6688
	.field	-456,16 		; r_dico3_lsf[419] @ 6704
	.field	9,16			; r_dico3_lsf[420] @ 6720
	.field	-445,16 		; r_dico3_lsf[421] @ 6736
	.field	33,16			; r_dico3_lsf[422] @ 6752
	.field	-423,16 		; r_dico3_lsf[423] @ 6768
	.field	226,16			; r_dico3_lsf[424] @ 6784
	.field	60,16			; r_dico3_lsf[425] @ 6800
	.field	73,16			; r_dico3_lsf[426] @ 6816
	.field	-222,16 		; r_dico3_lsf[427] @ 6832
	.field	156,16			; r_dico3_lsf[428] @ 6848
	.field	-399,16 		; r_dico3_lsf[429] @ 6864
	.field	280,16			; r_dico3_lsf[430] @ 6880
	.field	-318,16 		; r_dico3_lsf[431] @ 6896
	.field	245,16			; r_dico3_lsf[432] @ 6912
	.field	-341,16 		; r_dico3_lsf[433] @ 6928
	.field	166,16			; r_dico3_lsf[434] @ 6944
	.field	-499,16 		; r_dico3_lsf[435] @ 6960
	.field	339,16			; r_dico3_lsf[436] @ 6976
	.field	-190,16 		; r_dico3_lsf[437] @ 6992
	.field	327,16			; r_dico3_lsf[438] @ 7008
	.field	-219,16 		; r_dico3_lsf[439] @ 7024
	.field	325,16			; r_dico3_lsf[440] @ 7040
	.field	-137,16 		; r_dico3_lsf[441] @ 7056
	.field	-89,16			; r_dico3_lsf[442] @ 7072
	.field	-596,16 		; r_dico3_lsf[443] @ 7088
	.field	100,16			; r_dico3_lsf[444] @ 7104
	.field	-627,16 		; r_dico3_lsf[445] @ 7120
	.field	144,16			; r_dico3_lsf[446] @ 7136
	.field	-677,16 		; r_dico3_lsf[447] @ 7152
	.field	487,16			; r_dico3_lsf[448] @ 7168
	.field	28,16			; r_dico3_lsf[449] @ 7184
	.field	252,16			; r_dico3_lsf[450] @ 7200
	.field	-391,16 		; r_dico3_lsf[451] @ 7216
	.field	214,16			; r_dico3_lsf[452] @ 7232
	.field	-41,16			; r_dico3_lsf[453] @ 7248
	.field	282,16			; r_dico3_lsf[454] @ 7264
	.field	-28,16			; r_dico3_lsf[455] @ 7280
	.field	99,16			; r_dico3_lsf[456] @ 7296
	.field	-286,16 		; r_dico3_lsf[457] @ 7312
	.field	331,16			; r_dico3_lsf[458] @ 7328
	.field	49,16			; r_dico3_lsf[459] @ 7344
	.field	459,16			; r_dico3_lsf[460] @ 7360
	.field	-388,16 		; r_dico3_lsf[461] @ 7376
	.field	565,16			; r_dico3_lsf[462] @ 7392
	.field	-369,16 		; r_dico3_lsf[463] @ 7408
	.field	436,16			; r_dico3_lsf[464] @ 7424
	.field	28,16			; r_dico3_lsf[465] @ 7440
	.field	336,16			; r_dico3_lsf[466] @ 7456
	.field	-9,16			; r_dico3_lsf[467] @ 7472
	.field	397,16			; r_dico3_lsf[468] @ 7488
	.field	-167,16 		; r_dico3_lsf[469] @ 7504
	.field	618,16			; r_dico3_lsf[470] @ 7520
	.field	34,16			; r_dico3_lsf[471] @ 7536
	.field	596,16			; r_dico3_lsf[472] @ 7552
	.field	-17,16			; r_dico3_lsf[473] @ 7568
	.field	561,16			; r_dico3_lsf[474] @ 7584
	.field	-140,16 		; r_dico3_lsf[475] @ 7600
	.field	299,16			; r_dico3_lsf[476] @ 7616
	.field	79,16			; r_dico3_lsf[477] @ 7632
	.field	522,16			; r_dico3_lsf[478] @ 7648
	.field	125,16			; r_dico3_lsf[479] @ 7664
	.field	203,16			; r_dico3_lsf[480] @ 7680
	.field	2,16			; r_dico3_lsf[481] @ 7696
	.field	244,16			; r_dico3_lsf[482] @ 7712
	.field	288,16			; r_dico3_lsf[483] @ 7728
	.field	255,16			; r_dico3_lsf[484] @ 7744
	.field	211,16			; r_dico3_lsf[485] @ 7760
	.field	175,16			; r_dico3_lsf[486] @ 7776
	.field	82,16			; r_dico3_lsf[487] @ 7792
	.field	596,16			; r_dico3_lsf[488] @ 7808
	.field	187,16			; r_dico3_lsf[489] @ 7824
	.field	517,16			; r_dico3_lsf[490] @ 7840
	.field	108,16			; r_dico3_lsf[491] @ 7856
	.field	381,16			; r_dico3_lsf[492] @ 7872
	.field	255,16			; r_dico3_lsf[493] @ 7888
	.field	365,16			; r_dico3_lsf[494] @ 7904
	.field	297,16			; r_dico3_lsf[495] @ 7920
	.field	497,16			; r_dico3_lsf[496] @ 7936
	.field	352,16			; r_dico3_lsf[497] @ 7952
	.field	327,16			; r_dico3_lsf[498] @ 7968
	.field	-82,16			; r_dico3_lsf[499] @ 7984
	.field	25,16			; r_dico3_lsf[500] @ 8000
	.field	210,16			; r_dico3_lsf[501] @ 8016
	.field	371,16			; r_dico3_lsf[502] @ 8032
	.field	245,16			; r_dico3_lsf[503] @ 8048
	.field	261,16			; r_dico3_lsf[504] @ 8064
	.field	3,16			; r_dico3_lsf[505] @ 8080
	.field	545,16			; r_dico3_lsf[506] @ 8096
	.field	449,16			; r_dico3_lsf[507] @ 8112
	.field	140,16			; r_dico3_lsf[508] @ 8128
	.field	294,16			; r_dico3_lsf[509] @ 8144
	.field	44,16			; r_dico3_lsf[510] @ 8160
	.field	295,16			; r_dico3_lsf[511] @ 8176
	.field	212,16			; r_dico3_lsf[512] @ 8192
	.field	347,16			; r_dico3_lsf[513] @ 8208
	.field	244,16			; r_dico3_lsf[514] @ 8224
	.field	494,16			; r_dico3_lsf[515] @ 8240
	.field	331,16			; r_dico3_lsf[516] @ 8256
	.field	528,16			; r_dico3_lsf[517] @ 8272
	.field	201,16			; r_dico3_lsf[518] @ 8288
	.field	307,16			; r_dico3_lsf[519] @ 8304
	.field	349,16			; r_dico3_lsf[520] @ 8320
	.field	411,16			; r_dico3_lsf[521] @ 8336
	.field	613,16			; r_dico3_lsf[522] @ 8352
	.field	284,16			; r_dico3_lsf[523] @ 8368
	.field	614,16			; r_dico3_lsf[524] @ 8384
	.field	413,16			; r_dico3_lsf[525] @ 8400
	.field	464,16			; r_dico3_lsf[526] @ 8416
	.field	322,16			; r_dico3_lsf[527] @ 8432
	.field	624,16			; r_dico3_lsf[528] @ 8448
	.field	397,16			; r_dico3_lsf[529] @ 8464
	.field	97,16			; r_dico3_lsf[530] @ 8480
	.field	200,16			; r_dico3_lsf[531] @ 8496
	.field	-160,16 		; r_dico3_lsf[532] @ 8512
	.field	384,16			; r_dico3_lsf[533] @ 8528
	.field	149,16			; r_dico3_lsf[534] @ 8544
	.field	362,16			; r_dico3_lsf[535] @ 8560
	.field	495,16			; r_dico3_lsf[536] @ 8576
	.field	525,16			; r_dico3_lsf[537] @ 8592
	.field	269,16			; r_dico3_lsf[538] @ 8608
	.field	585,16			; r_dico3_lsf[539] @ 8624
	.field	33,16			; r_dico3_lsf[540] @ 8640
	.field	491,16			; r_dico3_lsf[541] @ 8656
	.field	-121,16 		; r_dico3_lsf[542] @ 8672
	.field	433,16			; r_dico3_lsf[543] @ 8688
	.field	427,16			; r_dico3_lsf[544] @ 8704
	.field	611,16			; r_dico3_lsf[545] @ 8720
	.field	498,16			; r_dico3_lsf[546] @ 8736
	.field	516,16			; r_dico3_lsf[547] @ 8752
	.field	171,16			; r_dico3_lsf[548] @ 8768
	.field	443,16			; r_dico3_lsf[549] @ 8784
	.field	497,16			; r_dico3_lsf[550] @ 8800
	.field	666,16			; r_dico3_lsf[551] @ 8816
	.field	440,16			; r_dico3_lsf[552] @ 8832
	.field	275,16			; r_dico3_lsf[553] @ 8848
	.field	566,16			; r_dico3_lsf[554] @ 8864
	.field	575,16			; r_dico3_lsf[555] @ 8880
	.field	146,16			; r_dico3_lsf[556] @ 8896
	.field	639,16			; r_dico3_lsf[557] @ 8912
	.field	155,16			; r_dico3_lsf[558] @ 8928
	.field	670,16			; r_dico3_lsf[559] @ 8944
	.field	-33,16			; r_dico3_lsf[560] @ 8960
	.field	173,16			; r_dico3_lsf[561] @ 8976
	.field	212,16			; r_dico3_lsf[562] @ 8992
	.field	696,16			; r_dico3_lsf[563] @ 9008
	.field	-166,16 		; r_dico3_lsf[564] @ 9024
	.field	601,16			; r_dico3_lsf[565] @ 9040
	.field	-191,16 		; r_dico3_lsf[566] @ 9056
	.field	695,16			; r_dico3_lsf[567] @ 9072
	.field	-489,16 		; r_dico3_lsf[568] @ 9088
	.field	503,16			; r_dico3_lsf[569] @ 9104
	.field	175,16			; r_dico3_lsf[570] @ 9120
	.field	742,16			; r_dico3_lsf[571] @ 9136
	.field	214,16			; r_dico3_lsf[572] @ 9152
	.field	476,16			; r_dico3_lsf[573] @ 9168
	.field	372,16			; r_dico3_lsf[574] @ 9184
	.field	1083,16 		; r_dico3_lsf[575] @ 9200
	.field	578,16			; r_dico3_lsf[576] @ 9216
	.field	530,16			; r_dico3_lsf[577] @ 9232
	.field	586,16			; r_dico3_lsf[578] @ 9248
	.field	777,16			; r_dico3_lsf[579] @ 9264
	.field	425,16			; r_dico3_lsf[580] @ 9280
	.field	874,16			; r_dico3_lsf[581] @ 9296
	.field	315,16			; r_dico3_lsf[582] @ 9312
	.field	841,16			; r_dico3_lsf[583] @ 9328
	.field	374,16			; r_dico3_lsf[584] @ 9344
	.field	848,16			; r_dico3_lsf[585] @ 9360
	.field	-165,16 		; r_dico3_lsf[586] @ 9376
	.field	565,16			; r_dico3_lsf[587] @ 9392
	.field	35,16			; r_dico3_lsf[588] @ 9408
	.field	991,16			; r_dico3_lsf[589] @ 9424
	.field	-39,16			; r_dico3_lsf[590] @ 9440
	.field	1062,16 		; r_dico3_lsf[591] @ 9456
	.field	329,16			; r_dico3_lsf[592] @ 9472
	.field	712,16			; r_dico3_lsf[593] @ 9488
	.field	786,16			; r_dico3_lsf[594] @ 9504
	.field	840,16			; r_dico3_lsf[595] @ 9520
	.field	645,16			; r_dico3_lsf[596] @ 9536
	.field	795,16			; r_dico3_lsf[597] @ 9552
	.field	661,16			; r_dico3_lsf[598] @ 9568
	.field	676,16			; r_dico3_lsf[599] @ 9584
	.field	571,16			; r_dico3_lsf[600] @ 9600
	.field	918,16			; r_dico3_lsf[601] @ 9616
	.field	632,16			; r_dico3_lsf[602] @ 9632
	.field	1079,16 		; r_dico3_lsf[603] @ 9648
	.field	673,16			; r_dico3_lsf[604] @ 9664
	.field	817,16			; r_dico3_lsf[605] @ 9680
	.field	318,16			; r_dico3_lsf[606] @ 9696
	.field	388,16			; r_dico3_lsf[607] @ 9712
	.field	874,16			; r_dico3_lsf[608] @ 9728
	.field	1012,16 		; r_dico3_lsf[609] @ 9744
	.field	564,16			; r_dico3_lsf[610] @ 9760
	.field	848,16			; r_dico3_lsf[611] @ 9776
	.field	880,16			; r_dico3_lsf[612] @ 9792
	.field	620,16			; r_dico3_lsf[613] @ 9808
	.field	557,16			; r_dico3_lsf[614] @ 9824
	.field	479,16			; r_dico3_lsf[615] @ 9840
	.field	671,16			; r_dico3_lsf[616] @ 9856
	.field	453,16			; r_dico3_lsf[617] @ 9872
	.field	692,16			; r_dico3_lsf[618] @ 9888
	.field	468,16			; r_dico3_lsf[619] @ 9904
	.field	840,16			; r_dico3_lsf[620] @ 9920
	.field	642,16			; r_dico3_lsf[621] @ 9936
	.field	844,16			; r_dico3_lsf[622] @ 9952
	.field	645,16			; r_dico3_lsf[623] @ 9968
	.field	506,16			; r_dico3_lsf[624] @ 9984
	.field	428,16			; r_dico3_lsf[625] @ 10000
	.field	897,16			; r_dico3_lsf[626] @ 10016
	.field	567,16			; r_dico3_lsf[627] @ 10032
	.field	837,16			; r_dico3_lsf[628] @ 10048
	.field	387,16			; r_dico3_lsf[629] @ 10064
	.field	962,16			; r_dico3_lsf[630] @ 10080
	.field	499,16			; r_dico3_lsf[631] @ 10096
	.field	691,16			; r_dico3_lsf[632] @ 10112
	.field	561,16			; r_dico3_lsf[633] @ 10128
	.field	939,16			; r_dico3_lsf[634] @ 10144
	.field	926,16			; r_dico3_lsf[635] @ 10160
	.field	783,16			; r_dico3_lsf[636] @ 10176
	.field	296,16			; r_dico3_lsf[637] @ 10192
	.field	790,16			; r_dico3_lsf[638] @ 10208
	.field	268,16			; r_dico3_lsf[639] @ 10224
	.field	1028,16 		; r_dico3_lsf[640] @ 10240
	.field	530,16			; r_dico3_lsf[641] @ 10256
	.field	874,16			; r_dico3_lsf[642] @ 10272
	.field	329,16			; r_dico3_lsf[643] @ 10288
	.field	548,16			; r_dico3_lsf[644] @ 10304
	.field	143,16			; r_dico3_lsf[645] @ 10320
	.field	675,16			; r_dico3_lsf[646] @ 10336
	.field	291,16			; r_dico3_lsf[647] @ 10352
	.field	503,16			; r_dico3_lsf[648] @ 10368
	.field	66,16			; r_dico3_lsf[649] @ 10384
	.field	1041,16 		; r_dico3_lsf[650] @ 10400
	.field	359,16			; r_dico3_lsf[651] @ 10416
	.field	786,16			; r_dico3_lsf[652] @ 10432
	.field	97,16			; r_dico3_lsf[653] @ 10448
	.field	805,16			; r_dico3_lsf[654] @ 10464
	.field	33,16			; r_dico3_lsf[655] @ 10480
	.field	837,16			; r_dico3_lsf[656] @ 10496
	.field	470,16			; r_dico3_lsf[657] @ 10512
	.field	511,16			; r_dico3_lsf[658] @ 10528
	.field	49,16			; r_dico3_lsf[659] @ 10544
	.field	1092,16 		; r_dico3_lsf[660] @ 10560
	.field	327,16			; r_dico3_lsf[661] @ 10576
	.field	1174,16 		; r_dico3_lsf[662] @ 10592
	.field	323,16			; r_dico3_lsf[663] @ 10608
	.field	3,16			; r_dico3_lsf[664] @ 10624
	.field	242,16			; r_dico3_lsf[665] @ 10640
	.field	872,16			; r_dico3_lsf[666] @ 10656
	.field	474,16			; r_dico3_lsf[667] @ 10672
	.field	689,16			; r_dico3_lsf[668] @ 10688
	.field	429,16			; r_dico3_lsf[669] @ 10704
	.field	1329,16 		; r_dico3_lsf[670] @ 10720
	.field	678,16			; r_dico3_lsf[671] @ 10736
	.field	1042,16 		; r_dico3_lsf[672] @ 10752
	.field	620,16			; r_dico3_lsf[673] @ 10768
	.field	1109,16 		; r_dico3_lsf[674] @ 10784
	.field	664,16			; r_dico3_lsf[675] @ 10800
	.field	321,16			; r_dico3_lsf[676] @ 10816
	.field	193,16			; r_dico3_lsf[677] @ 10832
	.field	889,16			; r_dico3_lsf[678] @ 10848
	.field	950,16			; r_dico3_lsf[679] @ 10864
	.field	1153,16 		; r_dico3_lsf[680] @ 10880
	.field	874,16			; r_dico3_lsf[681] @ 10896
	.field	893,16			; r_dico3_lsf[682] @ 10912
	.field	635,16			; r_dico3_lsf[683] @ 10928
	.field	877,16			; r_dico3_lsf[684] @ 10944
	.field	862,16			; r_dico3_lsf[685] @ 10960
	.field	948,16			; r_dico3_lsf[686] @ 10976
	.field	913,16			; r_dico3_lsf[687] @ 10992
	.field	1293,16 		; r_dico3_lsf[688] @ 11008
	.field	665,16			; r_dico3_lsf[689] @ 11024
	.field	1320,16 		; r_dico3_lsf[690] @ 11040
	.field	639,16			; r_dico3_lsf[691] @ 11056
	.field	997,16			; r_dico3_lsf[692] @ 11072
	.field	793,16			; r_dico3_lsf[693] @ 11088
	.field	1402,16 		; r_dico3_lsf[694] @ 11104
	.field	1030,16 		; r_dico3_lsf[695] @ 11120
	.field	1176,16 		; r_dico3_lsf[696] @ 11136
	.field	1012,16 		; r_dico3_lsf[697] @ 11152
	.field	1110,16 		; r_dico3_lsf[698] @ 11168
	.field	959,16			; r_dico3_lsf[699] @ 11184
	.field	1410,16 		; r_dico3_lsf[700] @ 11200
	.field	925,16			; r_dico3_lsf[701] @ 11216
	.field	1403,16 		; r_dico3_lsf[702] @ 11232
	.field	915,16			; r_dico3_lsf[703] @ 11248
	.field	543,16			; r_dico3_lsf[704] @ 11264
	.field	862,16			; r_dico3_lsf[705] @ 11280
	.field	1116,16 		; r_dico3_lsf[706] @ 11296
	.field	1222,16 		; r_dico3_lsf[707] @ 11312
	.field	835,16			; r_dico3_lsf[708] @ 11328
	.field	1190,16 		; r_dico3_lsf[709] @ 11344
	.field	835,16			; r_dico3_lsf[710] @ 11360
	.field	1190,16 		; r_dico3_lsf[711] @ 11376
	.field	959,16			; r_dico3_lsf[712] @ 11392
	.field	1148,16 		; r_dico3_lsf[713] @ 11408
	.field	1147,16 		; r_dico3_lsf[714] @ 11424
	.field	1376,16 		; r_dico3_lsf[715] @ 11440
	.field	1300,16 		; r_dico3_lsf[716] @ 11456
	.field	1193,16 		; r_dico3_lsf[717] @ 11472
	.field	1415,16 		; r_dico3_lsf[718] @ 11488
	.field	1231,16 		; r_dico3_lsf[719] @ 11504
	.field	1335,16 		; r_dico3_lsf[720] @ 11520
	.field	1341,16 		; r_dico3_lsf[721] @ 11536
	.field	746,16			; r_dico3_lsf[722] @ 11552
	.field	1092,16 		; r_dico3_lsf[723] @ 11568
	.field	1711,16 		; r_dico3_lsf[724] @ 11584
	.field	1283,16 		; r_dico3_lsf[725] @ 11600
	.field	1389,16 		; r_dico3_lsf[726] @ 11616
	.field	1073,16 		; r_dico3_lsf[727] @ 11632
	.field	1334,16 		; r_dico3_lsf[728] @ 11648
	.field	1566,16 		; r_dico3_lsf[729] @ 11664
	.field	1153,16 		; r_dico3_lsf[730] @ 11680
	.field	1475,16 		; r_dico3_lsf[731] @ 11696
	.field	1645,16 		; r_dico3_lsf[732] @ 11712
	.field	1137,16 		; r_dico3_lsf[733] @ 11728
	.field	1825,16 		; r_dico3_lsf[734] @ 11744
	.field	1220,16 		; r_dico3_lsf[735] @ 11760
	.field	1056,16 		; r_dico3_lsf[736] @ 11776
	.field	1382,16 		; r_dico3_lsf[737] @ 11792
	.field	1521,16 		; r_dico3_lsf[738] @ 11808
	.field	1730,16 		; r_dico3_lsf[739] @ 11824
	.field	1632,16 		; r_dico3_lsf[740] @ 11840
	.field	1545,16 		; r_dico3_lsf[741] @ 11856
	.field	1620,16 		; r_dico3_lsf[742] @ 11872
	.field	1542,16 		; r_dico3_lsf[743] @ 11888
	.field	855,16			; r_dico3_lsf[744] @ 11904
	.field	1596,16 		; r_dico3_lsf[745] @ 11920
	.field	865,16			; r_dico3_lsf[746] @ 11936
	.field	1667,16 		; r_dico3_lsf[747] @ 11952
	.field	693,16			; r_dico3_lsf[748] @ 11968
	.field	885,16			; r_dico3_lsf[749] @ 11984
	.field	1716,16 		; r_dico3_lsf[750] @ 12000
	.field	1519,16 		; r_dico3_lsf[751] @ 12016
	.field	1167,16 		; r_dico3_lsf[752] @ 12032
	.field	1296,16 		; r_dico3_lsf[753] @ 12048
	.field	2209,16 		; r_dico3_lsf[754] @ 12064
	.field	1760,16 		; r_dico3_lsf[755] @ 12080
	.field	1952,16 		; r_dico3_lsf[756] @ 12096
	.field	1493,16 		; r_dico3_lsf[757] @ 12112
	.field	2020,16 		; r_dico3_lsf[758] @ 12128
	.field	1482,16 		; r_dico3_lsf[759] @ 12144
	.field	1534,16 		; r_dico3_lsf[760] @ 12160
	.field	1866,16 		; r_dico3_lsf[761] @ 12176
	.field	1694,16 		; r_dico3_lsf[762] @ 12192
	.field	2008,16 		; r_dico3_lsf[763] @ 12208
	.field	1566,16 		; r_dico3_lsf[764] @ 12224
	.field	748,16			; r_dico3_lsf[765] @ 12240
	.field	1761,16 		; r_dico3_lsf[766] @ 12256
	.field	825,16			; r_dico3_lsf[767] @ 12272
	.field	294,16			; r_dico3_lsf[768] @ 12288
	.field	1392,16 		; r_dico3_lsf[769] @ 12304
	.field	1084,16 		; r_dico3_lsf[770] @ 12320
	.field	2058,16 		; r_dico3_lsf[771] @ 12336
	.field	621,16			; r_dico3_lsf[772] @ 12352
	.field	1315,16 		; r_dico3_lsf[773] @ 12368
	.field	365,16			; r_dico3_lsf[774] @ 12384
	.field	1287,16 		; r_dico3_lsf[775] @ 12400
	.field	198,16			; r_dico3_lsf[776] @ 12416
	.field	1028,16 		; r_dico3_lsf[777] @ 12432
	.field	488,16			; r_dico3_lsf[778] @ 12448
	.field	1408,16 		; r_dico3_lsf[779] @ 12464
	.field	249,16			; r_dico3_lsf[780] @ 12480
	.field	403,16			; r_dico3_lsf[781] @ 12496
	.field	1014,16 		; r_dico3_lsf[782] @ 12512
	.field	1561,16 		; r_dico3_lsf[783] @ 12528
	.field	324,16			; r_dico3_lsf[784] @ 12544
	.field	363,16			; r_dico3_lsf[785] @ 12560
	.field	1645,16 		; r_dico3_lsf[786] @ 12576
	.field	1044,16 		; r_dico3_lsf[787] @ 12592
	.field	193,16			; r_dico3_lsf[788] @ 12608
	.field	367,16			; r_dico3_lsf[789] @ 12624
	.field	2034,16 		; r_dico3_lsf[790] @ 12640
	.field	1859,16 		; r_dico3_lsf[791] @ 12656
	.field	-251,16 		; r_dico3_lsf[792] @ 12672
	.field	579,16			; r_dico3_lsf[793] @ 12688
	.field	750,16			; r_dico3_lsf[794] @ 12704
	.field	994,16			; r_dico3_lsf[795] @ 12720
	.field	-243,16 		; r_dico3_lsf[796] @ 12736
	.field	30,16			; r_dico3_lsf[797] @ 12752
	.field	1325,16 		; r_dico3_lsf[798] @ 12768
	.field	879,16			; r_dico3_lsf[799] @ 12784
	.field	-28,16			; r_dico3_lsf[800] @ 12800
	.field	-169,16 		; r_dico3_lsf[801] @ 12816
	.field	624,16			; r_dico3_lsf[802] @ 12832
	.field	917,16			; r_dico3_lsf[803] @ 12848
	.field	-453,16 		; r_dico3_lsf[804] @ 12864
	.field	159,16			; r_dico3_lsf[805] @ 12880
	.field	186,16			; r_dico3_lsf[806] @ 12896
	.field	1370,16 		; r_dico3_lsf[807] @ 12912
	.field	-614,16 		; r_dico3_lsf[808] @ 12928
	.field	6,16			; r_dico3_lsf[809] @ 12944
	.field	537,16			; r_dico3_lsf[810] @ 12960
	.field	392,16			; r_dico3_lsf[811] @ 12976
	.field	-94,16			; r_dico3_lsf[812] @ 12992
	.field	-291,16 		; r_dico3_lsf[813] @ 13008
	.field	781,16			; r_dico3_lsf[814] @ 13024
	.field	229,16			; r_dico3_lsf[815] @ 13040
	.field	-128,16 		; r_dico3_lsf[816] @ 13056
	.field	-298,16 		; r_dico3_lsf[817] @ 13072
	.field	245,16			; r_dico3_lsf[818] @ 13088
	.field	491,16			; r_dico3_lsf[819] @ 13104
	.field	-701,16 		; r_dico3_lsf[820] @ 13120
	.field	-648,16 		; r_dico3_lsf[821] @ 13136
	.field	972,16			; r_dico3_lsf[822] @ 13152
	.field	789,16			; r_dico3_lsf[823] @ 13168
	.field	-501,16 		; r_dico3_lsf[824] @ 13184
	.field	-640,16 		; r_dico3_lsf[825] @ 13200
	.field	178,16			; r_dico3_lsf[826] @ 13216
	.field	255,16			; r_dico3_lsf[827] @ 13232
	.field	-365,16 		; r_dico3_lsf[828] @ 13248
	.field	-390,16 		; r_dico3_lsf[829] @ 13264
	.field	-255,16 		; r_dico3_lsf[830] @ 13280
	.field	317,16			; r_dico3_lsf[831] @ 13296
	.field	-958,16 		; r_dico3_lsf[832] @ 13312
	.field	-294,16 		; r_dico3_lsf[833] @ 13328
	.field	-191,16 		; r_dico3_lsf[834] @ 13344
	.field	228,16			; r_dico3_lsf[835] @ 13360
	.field	-775,16 		; r_dico3_lsf[836] @ 13376
	.field	-447,16 		; r_dico3_lsf[837] @ 13392
	.field	157,16			; r_dico3_lsf[838] @ 13408
	.field	-237,16 		; r_dico3_lsf[839] @ 13424
	.field	-657,16 		; r_dico3_lsf[840] @ 13440
	.field	-720,16 		; r_dico3_lsf[841] @ 13456
	.field	-407,16 		; r_dico3_lsf[842] @ 13472
	.field	92,16			; r_dico3_lsf[843] @ 13488
	.field	-117,16 		; r_dico3_lsf[844] @ 13504
	.field	-611,16 		; r_dico3_lsf[845] @ 13520
	.field	334,16			; r_dico3_lsf[846] @ 13536
	.field	-230,16 		; r_dico3_lsf[847] @ 13552
	.field	-679,16 		; r_dico3_lsf[848] @ 13568
	.field	-1084,16		; r_dico3_lsf[849] @ 13584
	.field	-144,16 		; r_dico3_lsf[850] @ 13600
	.field	-317,16 		; r_dico3_lsf[851] @ 13616
	.field	-901,16 		; r_dico3_lsf[852] @ 13632
	.field	-861,16 		; r_dico3_lsf[853] @ 13648
	.field	-738,16 		; r_dico3_lsf[854] @ 13664
	.field	-360,16 		; r_dico3_lsf[855] @ 13680
	.field	-85,16			; r_dico3_lsf[856] @ 13696
	.field	-727,16 		; r_dico3_lsf[857] @ 13712
	.field	-90,16			; r_dico3_lsf[858] @ 13728
	.field	-787,16 		; r_dico3_lsf[859] @ 13744
	.field	100,16			; r_dico3_lsf[860] @ 13760
	.field	-22,16			; r_dico3_lsf[861] @ 13776
	.field	-391,16 		; r_dico3_lsf[862] @ 13792
	.field	-263,16 		; r_dico3_lsf[863] @ 13808
	.field	-56,16			; r_dico3_lsf[864] @ 13824
	.field	-73,16			; r_dico3_lsf[865] @ 13840
	.field	-337,16 		; r_dico3_lsf[866] @ 13856
	.field	-754,16 		; r_dico3_lsf[867] @ 13872
	.field	5,16			; r_dico3_lsf[868] @ 13888
	.field	-189,16 		; r_dico3_lsf[869] @ 13904
	.field	-706,16 		; r_dico3_lsf[870] @ 13920
	.field	-624,16 		; r_dico3_lsf[871] @ 13936
	.field	89,16			; r_dico3_lsf[872] @ 13952
	.field	-344,16 		; r_dico3_lsf[873] @ 13968
	.field	-135,16 		; r_dico3_lsf[874] @ 13984
	.field	-1113,16		; r_dico3_lsf[875] @ 14000
	.field	-353,16 		; r_dico3_lsf[876] @ 14016
	.field	-237,16 		; r_dico3_lsf[877] @ 14032
	.field	-684,16 		; r_dico3_lsf[878] @ 14048
	.field	-1135,16		; r_dico3_lsf[879] @ 14064
	.field	-275,16 		; r_dico3_lsf[880] @ 14080
	.field	-1102,16		; r_dico3_lsf[881] @ 14096
	.field	-269,16 		; r_dico3_lsf[882] @ 14112
	.field	-1203,16		; r_dico3_lsf[883] @ 14128
	.field	152,16			; r_dico3_lsf[884] @ 14144
	.field	145,16			; r_dico3_lsf[885] @ 14160
	.field	-722,16 		; r_dico3_lsf[886] @ 14176
	.field	-1232,16		; r_dico3_lsf[887] @ 14192
	.field	49,16			; r_dico3_lsf[888] @ 14208
	.field	80,16			; r_dico3_lsf[889] @ 14224
	.field	-1248,16		; r_dico3_lsf[890] @ 14240
	.field	-776,16 		; r_dico3_lsf[891] @ 14256
	.field	-248,16 		; r_dico3_lsf[892] @ 14272
	.field	391,16			; r_dico3_lsf[893] @ 14288
	.field	-732,16 		; r_dico3_lsf[894] @ 14304
	.field	-547,16 		; r_dico3_lsf[895] @ 14320
	.field	469,16			; r_dico3_lsf[896] @ 14336
	.field	218,16			; r_dico3_lsf[897] @ 14352
	.field	-255,16 		; r_dico3_lsf[898] @ 14368
	.field	-864,16 		; r_dico3_lsf[899] @ 14384
	.field	69,16			; r_dico3_lsf[900] @ 14400
	.field	366,16			; r_dico3_lsf[901] @ 14416
	.field	-166,16 		; r_dico3_lsf[902] @ 14432
	.field	-485,16 		; r_dico3_lsf[903] @ 14448
	.field	-688,16 		; r_dico3_lsf[904] @ 14464
	.field	191,16			; r_dico3_lsf[905] @ 14480
	.field	-1212,16		; r_dico3_lsf[906] @ 14496
	.field	-1196,16		; r_dico3_lsf[907] @ 14512
	.field	-170,16 		; r_dico3_lsf[908] @ 14528
	.field	-169,16 		; r_dico3_lsf[909] @ 14544
	.field	-1308,16		; r_dico3_lsf[910] @ 14560
	.field	-1631,16		; r_dico3_lsf[911] @ 14576
	.field	321,16			; r_dico3_lsf[912] @ 14592
	.field	470,16			; r_dico3_lsf[913] @ 14608
	.field	-1419,16		; r_dico3_lsf[914] @ 14624
	.field	-1243,16		; r_dico3_lsf[915] @ 14640
	.field	-64,16			; r_dico3_lsf[916] @ 14656
	.field	272,16			; r_dico3_lsf[917] @ 14672
	.field	-1361,16		; r_dico3_lsf[918] @ 14688
	.field	-248,16 		; r_dico3_lsf[919] @ 14704
	.field	492,16			; r_dico3_lsf[920] @ 14720
	.field	565,16			; r_dico3_lsf[921] @ 14736
	.field	-721,16 		; r_dico3_lsf[922] @ 14752
	.field	-609,16 		; r_dico3_lsf[923] @ 14768
	.field	195,16			; r_dico3_lsf[924] @ 14784
	.field	485,16			; r_dico3_lsf[925] @ 14800
	.field	-573,16 		; r_dico3_lsf[926] @ 14816
	.field	-133,16 		; r_dico3_lsf[927] @ 14832
	.field	427,16			; r_dico3_lsf[928] @ 14848
	.field	202,16			; r_dico3_lsf[929] @ 14864
	.field	-171,16 		; r_dico3_lsf[930] @ 14880
	.field	-118,16 		; r_dico3_lsf[931] @ 14896
	.field	199,16			; r_dico3_lsf[932] @ 14912
	.field	575,16			; r_dico3_lsf[933] @ 14928
	.field	2,16			; r_dico3_lsf[934] @ 14944
	.field	-31,16			; r_dico3_lsf[935] @ 14960
	.field	694,16			; r_dico3_lsf[936] @ 14976
	.field	755,16			; r_dico3_lsf[937] @ 14992
	.field	-1366,16		; r_dico3_lsf[938] @ 15008
	.field	-39,16			; r_dico3_lsf[939] @ 15024
	.field	552,16			; r_dico3_lsf[940] @ 15040
	.field	557,16			; r_dico3_lsf[941] @ 15056
	.field	-489,16 		; r_dico3_lsf[942] @ 15072
	.field	271,16			; r_dico3_lsf[943] @ 15088
	.field	680,16			; r_dico3_lsf[944] @ 15104
	.field	537,16			; r_dico3_lsf[945] @ 15120
	.field	13,16			; r_dico3_lsf[946] @ 15136
	.field	-453,16 		; r_dico3_lsf[947] @ 15152
	.field	855,16			; r_dico3_lsf[948] @ 15168
	.field	954,16			; r_dico3_lsf[949] @ 15184
	.field	-133,16 		; r_dico3_lsf[950] @ 15200
	.field	-52,16			; r_dico3_lsf[951] @ 15216
	.field	-81,16			; r_dico3_lsf[952] @ 15232
	.field	738,16			; r_dico3_lsf[953] @ 15248
	.field	-1169,16		; r_dico3_lsf[954] @ 15264
	.field	637,16			; r_dico3_lsf[955] @ 15280
	.field	1055,16 		; r_dico3_lsf[956] @ 15296
	.field	1059,16 		; r_dico3_lsf[957] @ 15312
	.field	-95,16			; r_dico3_lsf[958] @ 15328
	.field	676,16			; r_dico3_lsf[959] @ 15344
	.field	1259,16 		; r_dico3_lsf[960] @ 15360
	.field	1081,16 		; r_dico3_lsf[961] @ 15376
	.field	489,16			; r_dico3_lsf[962] @ 15392
	.field	305,16			; r_dico3_lsf[963] @ 15408
	.field	-449,16 		; r_dico3_lsf[964] @ 15424
	.field	954,16			; r_dico3_lsf[965] @ 15440
	.field	-534,16 		; r_dico3_lsf[966] @ 15456
	.field	996,16			; r_dico3_lsf[967] @ 15472
	.field	-969,16 		; r_dico3_lsf[968] @ 15488
	.field	866,16			; r_dico3_lsf[969] @ 15504
	.field	-1058,16		; r_dico3_lsf[970] @ 15520
	.field	1059,16 		; r_dico3_lsf[971] @ 15536
	.field	-1294,16		; r_dico3_lsf[972] @ 15552
	.field	618,16			; r_dico3_lsf[973] @ 15568
	.field	-1416,16		; r_dico3_lsf[974] @ 15584
	.field	617,16			; r_dico3_lsf[975] @ 15600
	.field	-458,16 		; r_dico3_lsf[976] @ 15616
	.field	1366,16 		; r_dico3_lsf[977] @ 15632
	.field	-159,16 		; r_dico3_lsf[978] @ 15648
	.field	1821,16 		; r_dico3_lsf[979] @ 15664
	.field	-774,16 		; r_dico3_lsf[980] @ 15680
	.field	-528,16 		; r_dico3_lsf[981] @ 15696
	.field	-14,16			; r_dico3_lsf[982] @ 15712
	.field	1110,16 		; r_dico3_lsf[983] @ 15728
	.field	-1202,16		; r_dico3_lsf[984] @ 15744
	.field	-901,16 		; r_dico3_lsf[985] @ 15760
	.field	-772,16 		; r_dico3_lsf[986] @ 15776
	.field	433,16			; r_dico3_lsf[987] @ 15792
	.field	-1256,16		; r_dico3_lsf[988] @ 15808
	.field	-1255,16		; r_dico3_lsf[989] @ 15824
	.field	-1011,16		; r_dico3_lsf[990] @ 15840
	.field	-302,16 		; r_dico3_lsf[991] @ 15856
	.field	-602,16 		; r_dico3_lsf[992] @ 15872
	.field	-585,16 		; r_dico3_lsf[993] @ 15888
	.field	-759,16 		; r_dico3_lsf[994] @ 15904
	.field	-1618,16		; r_dico3_lsf[995] @ 15920
	.field	-760,16 		; r_dico3_lsf[996] @ 15936
	.field	-1549,16		; r_dico3_lsf[997] @ 15952
	.field	-840,16 		; r_dico3_lsf[998] @ 15968
	.field	-1921,16		; r_dico3_lsf[999] @ 15984
	.field	-816,16 		; r_dico3_lsf[1000] @ 16000
	.field	-539,16 		; r_dico3_lsf[1001] @ 16016
	.field	-1769,16		; r_dico3_lsf[1002] @ 16032
	.field	-2235,16		; r_dico3_lsf[1003] @ 16048
	.field	-227,16 		; r_dico3_lsf[1004] @ 16064
	.field	-36,16			; r_dico3_lsf[1005] @ 16080
	.field	-2034,16		; r_dico3_lsf[1006] @ 16096
	.field	-1831,16		; r_dico3_lsf[1007] @ 16112
	.field	-2107,16		; r_dico3_lsf[1008] @ 16128
	.field	-1126,16		; r_dico3_lsf[1009] @ 16144
	.field	-2471,16		; r_dico3_lsf[1010] @ 16160
	.field	-1816,16		; r_dico3_lsf[1011] @ 16176
	.field	-1470,16		; r_dico3_lsf[1012] @ 16192
	.field	252,16			; r_dico3_lsf[1013] @ 16208
	.field	-2701,16		; r_dico3_lsf[1014] @ 16224
	.field	-415,16 		; r_dico3_lsf[1015] @ 16240
	.field	-571,16 		; r_dico3_lsf[1016] @ 16256
	.field	-467,16 		; r_dico3_lsf[1017] @ 16272
	.field	1509,16 		; r_dico3_lsf[1018] @ 16288
	.field	1554,16 		; r_dico3_lsf[1019] @ 16304
	.field	2180,16 		; r_dico3_lsf[1020] @ 16320
	.field	1975,16 		; r_dico3_lsf[1021] @ 16336
	.field	2326,16 		; r_dico3_lsf[1022] @ 16352
	.field	2020,16 		; r_dico3_lsf[1023] @ 16368


r_dico4_lsf:
	.field	-1857,16		; r_dico4_lsf[0] @ 0
	.field	-1681,16		; r_dico4_lsf[1] @ 16
	.field	-1857,16		; r_dico4_lsf[2] @ 32
	.field	-1755,16		; r_dico4_lsf[3] @ 48
	.field	-2056,16		; r_dico4_lsf[4] @ 64
	.field	-1150,16		; r_dico4_lsf[5] @ 80
	.field	-2134,16		; r_dico4_lsf[6] @ 96
	.field	-1654,16		; r_dico4_lsf[7] @ 112
	.field	-1619,16		; r_dico4_lsf[8] @ 128
	.field	-1099,16		; r_dico4_lsf[9] @ 144
	.field	-1704,16		; r_dico4_lsf[10] @ 160
	.field	-1131,16		; r_dico4_lsf[11] @ 176
	.field	-1345,16		; r_dico4_lsf[12] @ 192
	.field	-1608,16		; r_dico4_lsf[13] @ 208
	.field	-1359,16		; r_dico4_lsf[14] @ 224
	.field	-1638,16		; r_dico4_lsf[15] @ 240
	.field	-1338,16		; r_dico4_lsf[16] @ 256
	.field	-1293,16		; r_dico4_lsf[17] @ 272
	.field	-1325,16		; r_dico4_lsf[18] @ 288
	.field	-1265,16		; r_dico4_lsf[19] @ 304
	.field	-1664,16		; r_dico4_lsf[20] @ 320
	.field	-1649,16		; r_dico4_lsf[21] @ 336
	.field	-1487,16		; r_dico4_lsf[22] @ 352
	.field	-851,16 		; r_dico4_lsf[23] @ 368
	.field	-1346,16		; r_dico4_lsf[24] @ 384
	.field	-1832,16		; r_dico4_lsf[25] @ 400
	.field	-1413,16		; r_dico4_lsf[26] @ 416
	.field	-2188,16		; r_dico4_lsf[27] @ 432
	.field	-1282,16		; r_dico4_lsf[28] @ 448
	.field	-681,16 		; r_dico4_lsf[29] @ 464
	.field	-1785,16		; r_dico4_lsf[30] @ 480
	.field	-1649,16		; r_dico4_lsf[31] @ 496
	.field	-966,16 		; r_dico4_lsf[32] @ 512
	.field	-1082,16		; r_dico4_lsf[33] @ 528
	.field	-1183,16		; r_dico4_lsf[34] @ 544
	.field	-1676,16		; r_dico4_lsf[35] @ 560
	.field	-1054,16		; r_dico4_lsf[36] @ 576
	.field	-1073,16		; r_dico4_lsf[37] @ 592
	.field	-1142,16		; r_dico4_lsf[38] @ 608
	.field	-1158,16		; r_dico4_lsf[39] @ 624
	.field	-1207,16		; r_dico4_lsf[40] @ 640
	.field	-744,16 		; r_dico4_lsf[41] @ 656
	.field	-1274,16		; r_dico4_lsf[42] @ 672
	.field	-997,16 		; r_dico4_lsf[43] @ 688
	.field	-934,16 		; r_dico4_lsf[44] @ 704
	.field	-1383,16		; r_dico4_lsf[45] @ 720
	.field	-927,16 		; r_dico4_lsf[46] @ 736
	.field	-1416,16		; r_dico4_lsf[47] @ 752
	.field	-1010,16		; r_dico4_lsf[48] @ 768
	.field	-1305,16		; r_dico4_lsf[49] @ 784
	.field	-783,16 		; r_dico4_lsf[50] @ 800
	.field	-955,16 		; r_dico4_lsf[51] @ 816
	.field	-1049,16		; r_dico4_lsf[52] @ 832
	.field	-900,16 		; r_dico4_lsf[53] @ 848
	.field	-993,16 		; r_dico4_lsf[54] @ 864
	.field	-817,16 		; r_dico4_lsf[55] @ 880
	.field	-737,16 		; r_dico4_lsf[56] @ 896
	.field	-823,16 		; r_dico4_lsf[57] @ 912
	.field	-972,16 		; r_dico4_lsf[58] @ 928
	.field	-1189,16		; r_dico4_lsf[59] @ 944
	.field	-738,16 		; r_dico4_lsf[60] @ 960
	.field	-1094,16		; r_dico4_lsf[61] @ 976
	.field	-738,16 		; r_dico4_lsf[62] @ 992
	.field	-1154,16		; r_dico4_lsf[63] @ 1008
	.field	-784,16 		; r_dico4_lsf[64] @ 1024
	.field	-801,16 		; r_dico4_lsf[65] @ 1040
	.field	-810,16 		; r_dico4_lsf[66] @ 1056
	.field	-786,16 		; r_dico4_lsf[67] @ 1072
	.field	-892,16 		; r_dico4_lsf[68] @ 1088
	.field	-520,16 		; r_dico4_lsf[69] @ 1104
	.field	-1000,16		; r_dico4_lsf[70] @ 1120
	.field	-818,16 		; r_dico4_lsf[71] @ 1136
	.field	-644,16 		; r_dico4_lsf[72] @ 1152
	.field	-965,16 		; r_dico4_lsf[73] @ 1168
	.field	-577,16 		; r_dico4_lsf[74] @ 1184
	.field	-882,16 		; r_dico4_lsf[75] @ 1200
	.field	-541,16 		; r_dico4_lsf[76] @ 1216
	.field	-694,16 		; r_dico4_lsf[77] @ 1232
	.field	-671,16 		; r_dico4_lsf[78] @ 1248
	.field	-917,16 		; r_dico4_lsf[79] @ 1264
	.field	-595,16 		; r_dico4_lsf[80] @ 1280
	.field	-642,16 		; r_dico4_lsf[81] @ 1296
	.field	-646,16 		; r_dico4_lsf[82] @ 1312
	.field	-615,16 		; r_dico4_lsf[83] @ 1328
	.field	-956,16 		; r_dico4_lsf[84] @ 1344
	.field	-621,16 		; r_dico4_lsf[85] @ 1360
	.field	-925,16 		; r_dico4_lsf[86] @ 1376
	.field	-515,16 		; r_dico4_lsf[87] @ 1392
	.field	-727,16 		; r_dico4_lsf[88] @ 1408
	.field	-483,16 		; r_dico4_lsf[89] @ 1424
	.field	-815,16 		; r_dico4_lsf[90] @ 1440
	.field	-485,16 		; r_dico4_lsf[91] @ 1456
	.field	-840,16 		; r_dico4_lsf[92] @ 1472
	.field	-578,16 		; r_dico4_lsf[93] @ 1488
	.field	-440,16 		; r_dico4_lsf[94] @ 1504
	.field	-713,16 		; r_dico4_lsf[95] @ 1520
	.field	-578,16 		; r_dico4_lsf[96] @ 1536
	.field	-325,16 		; r_dico4_lsf[97] @ 1552
	.field	-657,16 		; r_dico4_lsf[98] @ 1568
	.field	-670,16 		; r_dico4_lsf[99] @ 1584
	.field	-386,16 		; r_dico4_lsf[100] @ 1600
	.field	-570,16 		; r_dico4_lsf[101] @ 1616
	.field	-441,16 		; r_dico4_lsf[102] @ 1632
	.field	-666,16 		; r_dico4_lsf[103] @ 1648
	.field	-514,16 		; r_dico4_lsf[104] @ 1664
	.field	-787,16 		; r_dico4_lsf[105] @ 1680
	.field	-392,16 		; r_dico4_lsf[106] @ 1696
	.field	-529,16 		; r_dico4_lsf[107] @ 1712
	.field	-522,16 		; r_dico4_lsf[108] @ 1728
	.field	-453,16 		; r_dico4_lsf[109] @ 1744
	.field	-487,16 		; r_dico4_lsf[110] @ 1760
	.field	-423,16 		; r_dico4_lsf[111] @ 1776
	.field	-616,16 		; r_dico4_lsf[112] @ 1792
	.field	-585,16 		; r_dico4_lsf[113] @ 1808
	.field	-617,16 		; r_dico4_lsf[114] @ 1824
	.field	-157,16 		; r_dico4_lsf[115] @ 1840
	.field	-662,16 		; r_dico4_lsf[116] @ 1856
	.field	-268,16 		; r_dico4_lsf[117] @ 1872
	.field	-680,16 		; r_dico4_lsf[118] @ 1888
	.field	-348,16 		; r_dico4_lsf[119] @ 1904
	.field	-322,16 		; r_dico4_lsf[120] @ 1920
	.field	-323,16 		; r_dico4_lsf[121] @ 1936
	.field	-632,16 		; r_dico4_lsf[122] @ 1952
	.field	-444,16 		; r_dico4_lsf[123] @ 1968
	.field	-304,16 		; r_dico4_lsf[124] @ 1984
	.field	-430,16 		; r_dico4_lsf[125] @ 2000
	.field	-332,16 		; r_dico4_lsf[126] @ 2016
	.field	-458,16 		; r_dico4_lsf[127] @ 2032
	.field	-277,16 		; r_dico4_lsf[128] @ 2048
	.field	-468,16 		; r_dico4_lsf[129] @ 2064
	.field	-659,16 		; r_dico4_lsf[130] @ 2080
	.field	-793,16 		; r_dico4_lsf[131] @ 2096
	.field	-319,16 		; r_dico4_lsf[132] @ 2112
	.field	-636,16 		; r_dico4_lsf[133] @ 2128
	.field	-227,16 		; r_dico4_lsf[134] @ 2144
	.field	-554,16 		; r_dico4_lsf[135] @ 2160
	.field	-373,16 		; r_dico4_lsf[136] @ 2176
	.field	-347,16 		; r_dico4_lsf[137] @ 2192
	.field	-334,16 		; r_dico4_lsf[138] @ 2208
	.field	-210,16 		; r_dico4_lsf[139] @ 2224
	.field	-456,16 		; r_dico4_lsf[140] @ 2240
	.field	-192,16 		; r_dico4_lsf[141] @ 2256
	.field	-530,16 		; r_dico4_lsf[142] @ 2272
	.field	-242,16 		; r_dico4_lsf[143] @ 2288
	.field	-216,16 		; r_dico4_lsf[144] @ 2304
	.field	-198,16 		; r_dico4_lsf[145] @ 2320
	.field	-366,16 		; r_dico4_lsf[146] @ 2336
	.field	-370,16 		; r_dico4_lsf[147] @ 2352
	.field	-338,16 		; r_dico4_lsf[148] @ 2368
	.field	-161,16 		; r_dico4_lsf[149] @ 2384
	.field	-409,16 		; r_dico4_lsf[150] @ 2400
	.field	-748,16 		; r_dico4_lsf[151] @ 2416
	.field	-107,16 		; r_dico4_lsf[152] @ 2432
	.field	-380,16 		; r_dico4_lsf[153] @ 2448
	.field	-294,16 		; r_dico4_lsf[154] @ 2464
	.field	-643,16 		; r_dico4_lsf[155] @ 2480
	.field	-223,16 		; r_dico4_lsf[156] @ 2496
	.field	-665,16 		; r_dico4_lsf[157] @ 2512
	.field	-234,16 		; r_dico4_lsf[158] @ 2528
	.field	-741,16 		; r_dico4_lsf[159] @ 2544
	.field	-141,16 		; r_dico4_lsf[160] @ 2560
	.field	-496,16 		; r_dico4_lsf[161] @ 2576
	.field	-130,16 		; r_dico4_lsf[162] @ 2592
	.field	-510,16 		; r_dico4_lsf[163] @ 2608
	.field	-139,16 		; r_dico4_lsf[164] @ 2624
	.field	-327,16 		; r_dico4_lsf[165] @ 2640
	.field	-172,16 		; r_dico4_lsf[166] @ 2656
	.field	-305,16 		; r_dico4_lsf[167] @ 2672
	.field	-306,16 		; r_dico4_lsf[168] @ 2688
	.field	-580,16 		; r_dico4_lsf[169] @ 2704
	.field	-164,16 		; r_dico4_lsf[170] @ 2720
	.field	-263,16 		; r_dico4_lsf[171] @ 2736
	.field	-262,16 		; r_dico4_lsf[172] @ 2752
	.field	-172,16 		; r_dico4_lsf[173] @ 2768
	.field	-67,16			; r_dico4_lsf[174] @ 2784
	.field	-402,16 		; r_dico4_lsf[175] @ 2800
	.field	31,16			; r_dico4_lsf[176] @ 2816
	.field	-366,16 		; r_dico4_lsf[177] @ 2832
	.field	-10,16			; r_dico4_lsf[178] @ 2848
	.field	-436,16 		; r_dico4_lsf[179] @ 2864
	.field	-86,16			; r_dico4_lsf[180] @ 2880
	.field	-527,16 		; r_dico4_lsf[181] @ 2896
	.field	71,16			; r_dico4_lsf[182] @ 2912
	.field	-377,16 		; r_dico4_lsf[183] @ 2928
	.field	-22,16			; r_dico4_lsf[184] @ 2944
	.field	-609,16 		; r_dico4_lsf[185] @ 2960
	.field	-12,16			; r_dico4_lsf[186] @ 2976
	.field	-678,16 		; r_dico4_lsf[187] @ 2992
	.field	-67,16			; r_dico4_lsf[188] @ 3008
	.field	-319,16 		; r_dico4_lsf[189] @ 3024
	.field	63,16			; r_dico4_lsf[190] @ 3040
	.field	-191,16 		; r_dico4_lsf[191] @ 3056
	.field	35,16			; r_dico4_lsf[192] @ 3072
	.field	-181,16 		; r_dico4_lsf[193] @ 3088
	.field	-39,16			; r_dico4_lsf[194] @ 3104
	.field	-242,16 		; r_dico4_lsf[195] @ 3120
	.field	126,16			; r_dico4_lsf[196] @ 3136
	.field	-167,16 		; r_dico4_lsf[197] @ 3152
	.field	-140,16 		; r_dico4_lsf[198] @ 3168
	.field	-544,16 		; r_dico4_lsf[199] @ 3184
	.field	155,16			; r_dico4_lsf[200] @ 3200
	.field	-297,16 		; r_dico4_lsf[201] @ 3216
	.field	174,16			; r_dico4_lsf[202] @ 3232
	.field	-297,16 		; r_dico4_lsf[203] @ 3248
	.field	38,16			; r_dico4_lsf[204] @ 3264
	.field	-8,16			; r_dico4_lsf[205] @ 3280
	.field	117,16			; r_dico4_lsf[206] @ 3296
	.field	-380,16 		; r_dico4_lsf[207] @ 3312
	.field	197,16			; r_dico4_lsf[208] @ 3328
	.field	-452,16 		; r_dico4_lsf[209] @ 3344
	.field	240,16			; r_dico4_lsf[210] @ 3360
	.field	-522,16 		; r_dico4_lsf[211] @ 3376
	.field	223,16			; r_dico4_lsf[212] @ 3392
	.field	-103,16 		; r_dico4_lsf[213] @ 3408
	.field	110,16			; r_dico4_lsf[214] @ 3424
	.field	-187,16 		; r_dico4_lsf[215] @ 3440
	.field	87,16			; r_dico4_lsf[216] @ 3456
	.field	-155,16 		; r_dico4_lsf[217] @ 3472
	.field	169,16			; r_dico4_lsf[218] @ 3488
	.field	-47,16			; r_dico4_lsf[219] @ 3504
	.field	157,16			; r_dico4_lsf[220] @ 3520
	.field	26,16			; r_dico4_lsf[221] @ 3536
	.field	-83,16			; r_dico4_lsf[222] @ 3552
	.field	-100,16 		; r_dico4_lsf[223] @ 3568
	.field	128,16			; r_dico4_lsf[224] @ 3584
	.field	80,16			; r_dico4_lsf[225] @ 3600
	.field	209,16			; r_dico4_lsf[226] @ 3616
	.field	-62,16			; r_dico4_lsf[227] @ 3632
	.field	6,16			; r_dico4_lsf[228] @ 3648
	.field	7,16			; r_dico4_lsf[229] @ 3664
	.field	22,16			; r_dico4_lsf[230] @ 3680
	.field	5,16			; r_dico4_lsf[231] @ 3696
	.field	318,16			; r_dico4_lsf[232] @ 3712
	.field	-20,16			; r_dico4_lsf[233] @ 3728
	.field	248,16			; r_dico4_lsf[234] @ 3744
	.field	-45,16			; r_dico4_lsf[235] @ 3760
	.field	-200,16 		; r_dico4_lsf[236] @ 3776
	.field	-63,16			; r_dico4_lsf[237] @ 3792
	.field	156,16			; r_dico4_lsf[238] @ 3808
	.field	-69,16			; r_dico4_lsf[239] @ 3824
	.field	250,16			; r_dico4_lsf[240] @ 3840
	.field	-183,16 		; r_dico4_lsf[241] @ 3856
	.field	369,16			; r_dico4_lsf[242] @ 3872
	.field	-126,16 		; r_dico4_lsf[243] @ 3888
	.field	-113,16 		; r_dico4_lsf[244] @ 3904
	.field	-76,16			; r_dico4_lsf[245] @ 3920
	.field	-142,16 		; r_dico4_lsf[246] @ 3936
	.field	-122,16 		; r_dico4_lsf[247] @ 3952
	.field	-64,16			; r_dico4_lsf[248] @ 3968
	.field	-254,16 		; r_dico4_lsf[249] @ 3984
	.field	-31,16			; r_dico4_lsf[250] @ 4000
	.field	35,16			; r_dico4_lsf[251] @ 4016
	.field	-177,16 		; r_dico4_lsf[252] @ 4032
	.field	-71,16			; r_dico4_lsf[253] @ 4048
	.field	-7,16			; r_dico4_lsf[254] @ 4064
	.field	171,16			; r_dico4_lsf[255] @ 4080
	.field	93,16			; r_dico4_lsf[256] @ 4096
	.field	27,16			; r_dico4_lsf[257] @ 4112
	.field	108,16			; r_dico4_lsf[258] @ 4128
	.field	212,16			; r_dico4_lsf[259] @ 4144
	.field	-330,16 		; r_dico4_lsf[260] @ 4160
	.field	-209,16 		; r_dico4_lsf[261] @ 4176
	.field	-123,16 		; r_dico4_lsf[262] @ 4192
	.field	-70,16			; r_dico4_lsf[263] @ 4208
	.field	-279,16 		; r_dico4_lsf[264] @ 4224
	.field	95,16			; r_dico4_lsf[265] @ 4240
	.field	-96,16			; r_dico4_lsf[266] @ 4256
	.field	20,16			; r_dico4_lsf[267] @ 4272
	.field	-188,16 		; r_dico4_lsf[268] @ 4288
	.field	-61,16			; r_dico4_lsf[269] @ 4304
	.field	-314,16 		; r_dico4_lsf[270] @ 4320
	.field	87,16			; r_dico4_lsf[271] @ 4336
	.field	-300,16 		; r_dico4_lsf[272] @ 4352
	.field	-78,16			; r_dico4_lsf[273] @ 4368
	.field	-354,16 		; r_dico4_lsf[274] @ 4384
	.field	-134,16 		; r_dico4_lsf[275] @ 4400
	.field	11,16			; r_dico4_lsf[276] @ 4416
	.field	122,16			; r_dico4_lsf[277] @ 4432
	.field	-140,16 		; r_dico4_lsf[278] @ 4448
	.field	122,16			; r_dico4_lsf[279] @ 4464
	.field	-275,16 		; r_dico4_lsf[280] @ 4480
	.field	152,16			; r_dico4_lsf[281] @ 4496
	.field	-293,16 		; r_dico4_lsf[282] @ 4512
	.field	140,16			; r_dico4_lsf[283] @ 4528
	.field	-82,16			; r_dico4_lsf[284] @ 4544
	.field	138,16			; r_dico4_lsf[285] @ 4560
	.field	-321,16 		; r_dico4_lsf[286] @ 4576
	.field	-111,16 		; r_dico4_lsf[287] @ 4592
	.field	-480,16 		; r_dico4_lsf[288] @ 4608
	.field	-156,16 		; r_dico4_lsf[289] @ 4624
	.field	-359,16 		; r_dico4_lsf[290] @ 4640
	.field	76,16			; r_dico4_lsf[291] @ 4656
	.field	-254,16 		; r_dico4_lsf[292] @ 4672
	.field	-40,16			; r_dico4_lsf[293] @ 4688
	.field	-635,16 		; r_dico4_lsf[294] @ 4704
	.field	-96,16			; r_dico4_lsf[295] @ 4720
	.field	-522,16 		; r_dico4_lsf[296] @ 4736
	.field	79,16			; r_dico4_lsf[297] @ 4752
	.field	-507,16 		; r_dico4_lsf[298] @ 4768
	.field	8,16			; r_dico4_lsf[299] @ 4784
	.field	-268,16 		; r_dico4_lsf[300] @ 4800
	.field	303,16			; r_dico4_lsf[301] @ 4816
	.field	-539,16 		; r_dico4_lsf[302] @ 4832
	.field	68,16			; r_dico4_lsf[303] @ 4848
	.field	-446,16 		; r_dico4_lsf[304] @ 4864
	.field	61,16			; r_dico4_lsf[305] @ 4880
	.field	-522,16 		; r_dico4_lsf[306] @ 4896
	.field	306,16			; r_dico4_lsf[307] @ 4912
	.field	111,16			; r_dico4_lsf[308] @ 4928
	.field	189,16			; r_dico4_lsf[309] @ 4944
	.field	-435,16 		; r_dico4_lsf[310] @ 4960
	.field	122,16			; r_dico4_lsf[311] @ 4976
	.field	-379,16 		; r_dico4_lsf[312] @ 4992
	.field	166,16			; r_dico4_lsf[313] @ 5008
	.field	-571,16 		; r_dico4_lsf[314] @ 5024
	.field	-398,16 		; r_dico4_lsf[315] @ 5040
	.field	-632,16 		; r_dico4_lsf[316] @ 5056
	.field	-74,16			; r_dico4_lsf[317] @ 5072
	.field	-747,16 		; r_dico4_lsf[318] @ 5088
	.field	-95,16			; r_dico4_lsf[319] @ 5104
	.field	-455,16 		; r_dico4_lsf[320] @ 5120
	.field	194,16			; r_dico4_lsf[321] @ 5136
	.field	-952,16 		; r_dico4_lsf[322] @ 5152
	.field	83,16			; r_dico4_lsf[323] @ 5168
	.field	-798,16 		; r_dico4_lsf[324] @ 5184
	.field	192,16			; r_dico4_lsf[325] @ 5200
	.field	-755,16 		; r_dico4_lsf[326] @ 5216
	.field	192,16			; r_dico4_lsf[327] @ 5232
	.field	-781,16 		; r_dico4_lsf[328] @ 5248
	.field	-162,16 		; r_dico4_lsf[329] @ 5264
	.field	-619,16 		; r_dico4_lsf[330] @ 5280
	.field	234,16			; r_dico4_lsf[331] @ 5296
	.field	-663,16 		; r_dico4_lsf[332] @ 5312
	.field	-297,16 		; r_dico4_lsf[333] @ 5328
	.field	-488,16 		; r_dico4_lsf[334] @ 5344
	.field	-109,16 		; r_dico4_lsf[335] @ 5360
	.field	-964,16 		; r_dico4_lsf[336] @ 5376
	.field	-132,16 		; r_dico4_lsf[337] @ 5392
	.field	-838,16 		; r_dico4_lsf[338] @ 5408
	.field	-68,16			; r_dico4_lsf[339] @ 5424
	.field	-843,16 		; r_dico4_lsf[340] @ 5440
	.field	58,16			; r_dico4_lsf[341] @ 5456
	.field	-1112,16		; r_dico4_lsf[342] @ 5472
	.field	-86,16			; r_dico4_lsf[343] @ 5488
	.field	-805,16 		; r_dico4_lsf[344] @ 5504
	.field	-299,16 		; r_dico4_lsf[345] @ 5520
	.field	-944,16 		; r_dico4_lsf[346] @ 5536
	.field	-253,16 		; r_dico4_lsf[347] @ 5552
	.field	-778,16 		; r_dico4_lsf[348] @ 5568
	.field	-50,16			; r_dico4_lsf[349] @ 5584
	.field	-965,16 		; r_dico4_lsf[350] @ 5600
	.field	-549,16 		; r_dico4_lsf[351] @ 5616
	.field	-352,16 		; r_dico4_lsf[352] @ 5632
	.field	-98,16			; r_dico4_lsf[353] @ 5648
	.field	-992,16 		; r_dico4_lsf[354] @ 5664
	.field	-343,16 		; r_dico4_lsf[355] @ 5680
	.field	-1117,16		; r_dico4_lsf[356] @ 5696
	.field	-315,16 		; r_dico4_lsf[357] @ 5712
	.field	-1117,16		; r_dico4_lsf[358] @ 5728
	.field	-307,16 		; r_dico4_lsf[359] @ 5744
	.field	-1155,16		; r_dico4_lsf[360] @ 5760
	.field	-374,16 		; r_dico4_lsf[361] @ 5776
	.field	-637,16 		; r_dico4_lsf[362] @ 5792
	.field	-230,16 		; r_dico4_lsf[363] @ 5808
	.field	-1166,16		; r_dico4_lsf[364] @ 5824
	.field	-43,16			; r_dico4_lsf[365] @ 5840
	.field	-1299,16		; r_dico4_lsf[366] @ 5856
	.field	-100,16 		; r_dico4_lsf[367] @ 5872
	.field	-925,16 		; r_dico4_lsf[368] @ 5888
	.field	-393,16 		; r_dico4_lsf[369] @ 5904
	.field	-1274,16		; r_dico4_lsf[370] @ 5920
	.field	-600,16 		; r_dico4_lsf[371] @ 5936
	.field	-689,16 		; r_dico4_lsf[372] @ 5952
	.field	-130,16 		; r_dico4_lsf[373] @ 5968
	.field	-1479,16		; r_dico4_lsf[374] @ 5984
	.field	-312,16 		; r_dico4_lsf[375] @ 6000
	.field	-1321,16		; r_dico4_lsf[376] @ 6016
	.field	-254,16 		; r_dico4_lsf[377] @ 6032
	.field	-1464,16		; r_dico4_lsf[378] @ 6048
	.field	-442,16 		; r_dico4_lsf[379] @ 6064
	.field	-1292,16		; r_dico4_lsf[380] @ 6080
	.field	-613,16 		; r_dico4_lsf[381] @ 6096
	.field	-1261,16		; r_dico4_lsf[382] @ 6112
	.field	-503,16 		; r_dico4_lsf[383] @ 6128
	.field	-1501,16		; r_dico4_lsf[384] @ 6144
	.field	-368,16 		; r_dico4_lsf[385] @ 6160
	.field	-1322,16		; r_dico4_lsf[386] @ 6176
	.field	26,16			; r_dico4_lsf[387] @ 6192
	.field	-1432,16		; r_dico4_lsf[388] @ 6208
	.field	-66,16			; r_dico4_lsf[389] @ 6224
	.field	-1743,16		; r_dico4_lsf[390] @ 6240
	.field	-161,16 		; r_dico4_lsf[391] @ 6256
	.field	-1644,16		; r_dico4_lsf[392] @ 6272
	.field	-467,16 		; r_dico4_lsf[393] @ 6288
	.field	-1760,16		; r_dico4_lsf[394] @ 6304
	.field	-548,16 		; r_dico4_lsf[395] @ 6320
	.field	-1393,16		; r_dico4_lsf[396] @ 6336
	.field	-568,16 		; r_dico4_lsf[397] @ 6352
	.field	-1556,16		; r_dico4_lsf[398] @ 6368
	.field	-871,16 		; r_dico4_lsf[399] @ 6384
	.field	-1495,16		; r_dico4_lsf[400] @ 6400
	.field	-1034,16		; r_dico4_lsf[401] @ 6416
	.field	-1387,16		; r_dico4_lsf[402] @ 6432
	.field	-571,16 		; r_dico4_lsf[403] @ 6448
	.field	-1917,16		; r_dico4_lsf[404] @ 6464
	.field	-528,16 		; r_dico4_lsf[405] @ 6480
	.field	-1783,16		; r_dico4_lsf[406] @ 6496
	.field	-123,16 		; r_dico4_lsf[407] @ 6512
	.field	-1897,16		; r_dico4_lsf[408] @ 6528
	.field	-231,16 		; r_dico4_lsf[409] @ 6544
	.field	-2054,16		; r_dico4_lsf[410] @ 6560
	.field	-323,16 		; r_dico4_lsf[411] @ 6576
	.field	-2052,16		; r_dico4_lsf[412] @ 6592
	.field	-906,16 		; r_dico4_lsf[413] @ 6608
	.field	-1976,16		; r_dico4_lsf[414] @ 6624
	.field	-567,16 		; r_dico4_lsf[415] @ 6640
	.field	-1917,16		; r_dico4_lsf[416] @ 6656
	.field	-620,16 		; r_dico4_lsf[417] @ 6672
	.field	-2047,16		; r_dico4_lsf[418] @ 6688
	.field	-989,16 		; r_dico4_lsf[419] @ 6704
	.field	-1077,16		; r_dico4_lsf[420] @ 6720
	.field	-370,16 		; r_dico4_lsf[421] @ 6736
	.field	-2031,16		; r_dico4_lsf[422] @ 6752
	.field	-704,16 		; r_dico4_lsf[423] @ 6768
	.field	-2355,16		; r_dico4_lsf[424] @ 6784
	.field	-749,16 		; r_dico4_lsf[425] @ 6800
	.field	-2740,16		; r_dico4_lsf[426] @ 6816
	.field	-1089,16		; r_dico4_lsf[427] @ 6832
	.field	-1909,16		; r_dico4_lsf[428] @ 6848
	.field	159,16			; r_dico4_lsf[429] @ 6864
	.field	-2012,16		; r_dico4_lsf[430] @ 6880
	.field	248,16			; r_dico4_lsf[431] @ 6896
	.field	-626,16 		; r_dico4_lsf[432] @ 6912
	.field	-123,16 		; r_dico4_lsf[433] @ 6928
	.field	-2339,16		; r_dico4_lsf[434] @ 6944
	.field	-962,16 		; r_dico4_lsf[435] @ 6960
	.field	-669,16 		; r_dico4_lsf[436] @ 6976
	.field	-408,16 		; r_dico4_lsf[437] @ 6992
	.field	-1379,16		; r_dico4_lsf[438] @ 7008
	.field	-1174,16		; r_dico4_lsf[439] @ 7024
	.field	-452,16 		; r_dico4_lsf[440] @ 7040
	.field	-364,16 		; r_dico4_lsf[441] @ 7056
	.field	-1044,16		; r_dico4_lsf[442] @ 7072
	.field	-735,16 		; r_dico4_lsf[443] @ 7088
	.field	-132,16 		; r_dico4_lsf[444] @ 7104
	.field	183,16			; r_dico4_lsf[445] @ 7120
	.field	-1620,16		; r_dico4_lsf[446] @ 7136
	.field	-752,16 		; r_dico4_lsf[447] @ 7152
	.field	-547,16 		; r_dico4_lsf[448] @ 7168
	.field	-307,16 		; r_dico4_lsf[449] @ 7184
	.field	-777,16 		; r_dico4_lsf[450] @ 7200
	.field	-1261,16		; r_dico4_lsf[451] @ 7216
	.field	-98,16			; r_dico4_lsf[452] @ 7232
	.field	41,16			; r_dico4_lsf[453] @ 7248
	.field	-880,16 		; r_dico4_lsf[454] @ 7264
	.field	-1091,16		; r_dico4_lsf[455] @ 7280
	.field	-257,16 		; r_dico4_lsf[456] @ 7296
	.field	97,16			; r_dico4_lsf[457] @ 7312
	.field	-1602,16		; r_dico4_lsf[458] @ 7328
	.field	-1833,16		; r_dico4_lsf[459] @ 7344
	.field	31,16			; r_dico4_lsf[460] @ 7360
	.field	-26,16			; r_dico4_lsf[461] @ 7376
	.field	-644,16 		; r_dico4_lsf[462] @ 7392
	.field	-561,16 		; r_dico4_lsf[463] @ 7408
	.field	-180,16 		; r_dico4_lsf[464] @ 7424
	.field	-546,16 		; r_dico4_lsf[465] @ 7440
	.field	-385,16 		; r_dico4_lsf[466] @ 7456
	.field	-1095,16		; r_dico4_lsf[467] @ 7472
	.field	-410,16 		; r_dico4_lsf[468] @ 7488
	.field	-802,16 		; r_dico4_lsf[469] @ 7504
	.field	-414,16 		; r_dico4_lsf[470] @ 7520
	.field	-827,16 		; r_dico4_lsf[471] @ 7536
	.field	-457,16 		; r_dico4_lsf[472] @ 7552
	.field	-970,16 		; r_dico4_lsf[473] @ 7568
	.field	-490,16 		; r_dico4_lsf[474] @ 7584
	.field	-1109,16		; r_dico4_lsf[475] @ 7600
	.field	-215,16 		; r_dico4_lsf[476] @ 7616
	.field	-916,16 		; r_dico4_lsf[477] @ 7632
	.field	-144,16 		; r_dico4_lsf[478] @ 7648
	.field	-937,16 		; r_dico4_lsf[479] @ 7664
	.field	-493,16 		; r_dico4_lsf[480] @ 7680
	.field	-1269,16		; r_dico4_lsf[481] @ 7696
	.field	-517,16 		; r_dico4_lsf[482] @ 7712
	.field	-1507,16		; r_dico4_lsf[483] @ 7728
	.field	181,16			; r_dico4_lsf[484] @ 7744
	.field	101,16			; r_dico4_lsf[485] @ 7760
	.field	-332,16 		; r_dico4_lsf[486] @ 7776
	.field	-889,16 		; r_dico4_lsf[487] @ 7792
	.field	-836,16 		; r_dico4_lsf[488] @ 7808
	.field	-937,16 		; r_dico4_lsf[489] @ 7824
	.field	-559,16 		; r_dico4_lsf[490] @ 7840
	.field	-429,16 		; r_dico4_lsf[491] @ 7856
	.field	-629,16 		; r_dico4_lsf[492] @ 7872
	.field	-547,16 		; r_dico4_lsf[493] @ 7888
	.field	-183,16 		; r_dico4_lsf[494] @ 7904
	.field	-337,16 		; r_dico4_lsf[495] @ 7920
	.field	-545,16 		; r_dico4_lsf[496] @ 7936
	.field	-82,16			; r_dico4_lsf[497] @ 7952
	.field	-250,16 		; r_dico4_lsf[498] @ 7968
	.field	-286,16 		; r_dico4_lsf[499] @ 7984
	.field	5,16			; r_dico4_lsf[500] @ 8000
	.field	-132,16 		; r_dico4_lsf[501] @ 8016
	.field	-348,16 		; r_dico4_lsf[502] @ 8032
	.field	-252,16 		; r_dico4_lsf[503] @ 8048
	.field	-293,16 		; r_dico4_lsf[504] @ 8064
	.field	-472,16 		; r_dico4_lsf[505] @ 8080
	.field	-158,16 		; r_dico4_lsf[506] @ 8096
	.field	100,16			; r_dico4_lsf[507] @ 8112
	.field	-29,16			; r_dico4_lsf[508] @ 8128
	.field	197,16			; r_dico4_lsf[509] @ 8144
	.field	-236,16 		; r_dico4_lsf[510] @ 8160
	.field	-424,16 		; r_dico4_lsf[511] @ 8176
	.field	-861,16 		; r_dico4_lsf[512] @ 8192
	.field	-213,16 		; r_dico4_lsf[513] @ 8208
	.field	-140,16 		; r_dico4_lsf[514] @ 8224
	.field	-7,16			; r_dico4_lsf[515] @ 8240
	.field	-427,16 		; r_dico4_lsf[516] @ 8256
	.field	-443,16 		; r_dico4_lsf[517] @ 8272
	.field	187,16			; r_dico4_lsf[518] @ 8288
	.field	-97,16			; r_dico4_lsf[519] @ 8304
	.field	-684,16 		; r_dico4_lsf[520] @ 8320
	.field	-736,16 		; r_dico4_lsf[521] @ 8336
	.field	-293,16 		; r_dico4_lsf[522] @ 8352
	.field	258,16			; r_dico4_lsf[523] @ 8368
	.field	-368,16 		; r_dico4_lsf[524] @ 8384
	.field	-152,16 		; r_dico4_lsf[525] @ 8400
	.field	-150,16 		; r_dico4_lsf[526] @ 8416
	.field	392,16			; r_dico4_lsf[527] @ 8432
	.field	-609,16 		; r_dico4_lsf[528] @ 8448
	.field	175,16			; r_dico4_lsf[529] @ 8464
	.field	-142,16 		; r_dico4_lsf[530] @ 8480
	.field	299,16			; r_dico4_lsf[531] @ 8496
	.field	-138,16 		; r_dico4_lsf[532] @ 8512
	.field	152,16			; r_dico4_lsf[533] @ 8528
	.field	-119,16 		; r_dico4_lsf[534] @ 8544
	.field	329,16			; r_dico4_lsf[535] @ 8560
	.field	-486,16 		; r_dico4_lsf[536] @ 8576
	.field	-52,16			; r_dico4_lsf[537] @ 8592
	.field	293,16			; r_dico4_lsf[538] @ 8608
	.field	198,16			; r_dico4_lsf[539] @ 8624
	.field	-183,16 		; r_dico4_lsf[540] @ 8640
	.field	117,16			; r_dico4_lsf[541] @ 8656
	.field	175,16			; r_dico4_lsf[542] @ 8672
	.field	331,16			; r_dico4_lsf[543] @ 8688
	.field	-58,16			; r_dico4_lsf[544] @ 8704
	.field	-274,16 		; r_dico4_lsf[545] @ 8720
	.field	231,16			; r_dico4_lsf[546] @ 8736
	.field	300,16			; r_dico4_lsf[547] @ 8752
	.field	-288,16 		; r_dico4_lsf[548] @ 8768
	.field	330,16			; r_dico4_lsf[549] @ 8784
	.field	-305,16 		; r_dico4_lsf[550] @ 8800
	.field	372,16			; r_dico4_lsf[551] @ 8816
	.field	-111,16 		; r_dico4_lsf[552] @ 8832
	.field	409,16			; r_dico4_lsf[553] @ 8848
	.field	-9,16			; r_dico4_lsf[554] @ 8864
	.field	423,16			; r_dico4_lsf[555] @ 8880
	.field	83,16			; r_dico4_lsf[556] @ 8896
	.field	256,16			; r_dico4_lsf[557] @ 8912
	.field	67,16			; r_dico4_lsf[558] @ 8928
	.field	367,16			; r_dico4_lsf[559] @ 8944
	.field	-19,16			; r_dico4_lsf[560] @ 8960
	.field	248,16			; r_dico4_lsf[561] @ 8976
	.field	91,16			; r_dico4_lsf[562] @ 8992
	.field	113,16			; r_dico4_lsf[563] @ 9008
	.field	-35,16			; r_dico4_lsf[564] @ 9024
	.field	406,16			; r_dico4_lsf[565] @ 9040
	.field	-191,16 		; r_dico4_lsf[566] @ 9056
	.field	154,16			; r_dico4_lsf[567] @ 9072
	.field	238,16			; r_dico4_lsf[568] @ 9088
	.field	296,16			; r_dico4_lsf[569] @ 9104
	.field	5,16			; r_dico4_lsf[570] @ 9120
	.field	197,16			; r_dico4_lsf[571] @ 9136
	.field	141,16			; r_dico4_lsf[572] @ 9152
	.field	221,16			; r_dico4_lsf[573] @ 9168
	.field	313,16			; r_dico4_lsf[574] @ 9184
	.field	198,16			; r_dico4_lsf[575] @ 9200
	.field	211,16			; r_dico4_lsf[576] @ 9216
	.field	421,16			; r_dico4_lsf[577] @ 9232
	.field	244,16			; r_dico4_lsf[578] @ 9248
	.field	334,16			; r_dico4_lsf[579] @ 9264
	.field	88,16			; r_dico4_lsf[580] @ 9280
	.field	426,16			; r_dico4_lsf[581] @ 9296
	.field	-243,16 		; r_dico4_lsf[582] @ 9312
	.field	454,16			; r_dico4_lsf[583] @ 9328
	.field	202,16			; r_dico4_lsf[584] @ 9344
	.field	552,16			; r_dico4_lsf[585] @ 9360
	.field	-5,16			; r_dico4_lsf[586] @ 9376
	.field	403,16			; r_dico4_lsf[587] @ 9392
	.field	291,16			; r_dico4_lsf[588] @ 9408
	.field	185,16			; r_dico4_lsf[589] @ 9424
	.field	219,16			; r_dico4_lsf[590] @ 9440
	.field	301,16			; r_dico4_lsf[591] @ 9456
	.field	251,16			; r_dico4_lsf[592] @ 9472
	.field	138,16			; r_dico4_lsf[593] @ 9488
	.field	128,16			; r_dico4_lsf[594] @ 9504
	.field	69,16			; r_dico4_lsf[595] @ 9520
	.field	197,16			; r_dico4_lsf[596] @ 9536
	.field	288,16			; r_dico4_lsf[597] @ 9552
	.field	-140,16 		; r_dico4_lsf[598] @ 9568
	.field	-61,16			; r_dico4_lsf[599] @ 9584
	.field	188,16			; r_dico4_lsf[600] @ 9600
	.field	361,16			; r_dico4_lsf[601] @ 9616
	.field	197,16			; r_dico4_lsf[602] @ 9632
	.field	598,16			; r_dico4_lsf[603] @ 9648
	.field	442,16			; r_dico4_lsf[604] @ 9664
	.field	273,16			; r_dico4_lsf[605] @ 9680
	.field	290,16			; r_dico4_lsf[606] @ 9696
	.field	143,16			; r_dico4_lsf[607] @ 9712
	.field	472,16			; r_dico4_lsf[608] @ 9728
	.field	482,16			; r_dico4_lsf[609] @ 9744
	.field	157,16			; r_dico4_lsf[610] @ 9760
	.field	370,16			; r_dico4_lsf[611] @ 9776
	.field	415,16			; r_dico4_lsf[612] @ 9792
	.field	321,16			; r_dico4_lsf[613] @ 9808
	.field	372,16			; r_dico4_lsf[614] @ 9824
	.field	385,16			; r_dico4_lsf[615] @ 9840
	.field	402,16			; r_dico4_lsf[616] @ 9856
	.field	552,16			; r_dico4_lsf[617] @ 9872
	.field	155,16			; r_dico4_lsf[618] @ 9888
	.field	24,16			; r_dico4_lsf[619] @ 9904
	.field	550,16			; r_dico4_lsf[620] @ 9920
	.field	263,16			; r_dico4_lsf[621] @ 9936
	.field	-11,16			; r_dico4_lsf[622] @ 9952
	.field	21,16			; r_dico4_lsf[623] @ 9968
	.field	360,16			; r_dico4_lsf[624] @ 9984
	.field	227,16			; r_dico4_lsf[625] @ 10000
	.field	147,16			; r_dico4_lsf[626] @ 10016
	.field	-254,16 		; r_dico4_lsf[627] @ 10032
	.field	424,16			; r_dico4_lsf[628] @ 10048
	.field	97,16			; r_dico4_lsf[629] @ 10064
	.field	366,16			; r_dico4_lsf[630] @ 10080
	.field	-13,16			; r_dico4_lsf[631] @ 10096
	.field	375,16			; r_dico4_lsf[632] @ 10112
	.field	141,16			; r_dico4_lsf[633] @ 10128
	.field	449,16			; r_dico4_lsf[634] @ 10144
	.field	232,16			; r_dico4_lsf[635] @ 10160
	.field	396,16			; r_dico4_lsf[636] @ 10176
	.field	507,16			; r_dico4_lsf[637] @ 10192
	.field	474,16			; r_dico4_lsf[638] @ 10208
	.field	272,16			; r_dico4_lsf[639] @ 10224
	.field	701,16			; r_dico4_lsf[640] @ 10240
	.field	324,16			; r_dico4_lsf[641] @ 10256
	.field	362,16			; r_dico4_lsf[642] @ 10272
	.field	-47,16			; r_dico4_lsf[643] @ 10288
	.field	587,16			; r_dico4_lsf[644] @ 10304
	.field	148,16			; r_dico4_lsf[645] @ 10320
	.field	543,16			; r_dico4_lsf[646] @ 10336
	.field	69,16			; r_dico4_lsf[647] @ 10352
	.field	400,16			; r_dico4_lsf[648] @ 10368
	.field	-51,16			; r_dico4_lsf[649] @ 10384
	.field	561,16			; r_dico4_lsf[650] @ 10400
	.field	59,16			; r_dico4_lsf[651] @ 10416
	.field	220,16			; r_dico4_lsf[652] @ 10432
	.field	-10,16			; r_dico4_lsf[653] @ 10448
	.field	352,16			; r_dico4_lsf[654] @ 10464
	.field	147,16			; r_dico4_lsf[655] @ 10480
	.field	206,16			; r_dico4_lsf[656] @ 10496
	.field	211,16			; r_dico4_lsf[657] @ 10512
	.field	653,16			; r_dico4_lsf[658] @ 10528
	.field	185,16			; r_dico4_lsf[659] @ 10544
	.field	563,16			; r_dico4_lsf[660] @ 10560
	.field	297,16			; r_dico4_lsf[661] @ 10576
	.field	565,16			; r_dico4_lsf[662] @ 10592
	.field	284,16			; r_dico4_lsf[663] @ 10608
	.field	594,16			; r_dico4_lsf[664] @ 10624
	.field	121,16			; r_dico4_lsf[665] @ 10640
	.field	766,16			; r_dico4_lsf[666] @ 10656
	.field	192,16			; r_dico4_lsf[667] @ 10672
	.field	398,16			; r_dico4_lsf[668] @ 10688
	.field	118,16			; r_dico4_lsf[669] @ 10704
	.field	642,16			; r_dico4_lsf[670] @ 10720
	.field	434,16			; r_dico4_lsf[671] @ 10736
	.field	233,16			; r_dico4_lsf[672] @ 10752
	.field	264,16			; r_dico4_lsf[673] @ 10768
	.field	481,16			; r_dico4_lsf[674] @ 10784
	.field	467,16			; r_dico4_lsf[675] @ 10800
	.field	129,16			; r_dico4_lsf[676] @ 10816
	.field	-165,16 		; r_dico4_lsf[677] @ 10832
	.field	699,16			; r_dico4_lsf[678] @ 10848
	.field	239,16			; r_dico4_lsf[679] @ 10864
	.field	90,16			; r_dico4_lsf[680] @ 10880
	.field	26,16			; r_dico4_lsf[681] @ 10896
	.field	342,16			; r_dico4_lsf[682] @ 10912
	.field	474,16			; r_dico4_lsf[683] @ 10928
	.field	-55,16			; r_dico4_lsf[684] @ 10944
	.field	27,16			; r_dico4_lsf[685] @ 10960
	.field	388,16			; r_dico4_lsf[686] @ 10976
	.field	94,16			; r_dico4_lsf[687] @ 10992
	.field	-172,16 		; r_dico4_lsf[688] @ 11008
	.field	0,16			; r_dico4_lsf[689] @ 11024
	.field	725,16			; r_dico4_lsf[690] @ 11040
	.field	379,16			; r_dico4_lsf[691] @ 11056
	.field	-60,16			; r_dico4_lsf[692] @ 11072
	.field	337,16			; r_dico4_lsf[693] @ 11088
	.field	370,16			; r_dico4_lsf[694] @ 11104
	.field	465,16			; r_dico4_lsf[695] @ 11120
	.field	95,16			; r_dico4_lsf[696] @ 11136
	.field	319,16			; r_dico4_lsf[697] @ 11152
	.field	806,16			; r_dico4_lsf[698] @ 11168
	.field	595,16			; r_dico4_lsf[699] @ 11184
	.field	78,16			; r_dico4_lsf[700] @ 11200
	.field	260,16			; r_dico4_lsf[701] @ 11216
	.field	497,16			; r_dico4_lsf[702] @ 11232
	.field	851,16			; r_dico4_lsf[703] @ 11248
	.field	210,16			; r_dico4_lsf[704] @ 11264
	.field	560,16			; r_dico4_lsf[705] @ 11280
	.field	458,16			; r_dico4_lsf[706] @ 11296
	.field	574,16			; r_dico4_lsf[707] @ 11312
	.field	-464,16 		; r_dico4_lsf[708] @ 11328
	.field	202,16			; r_dico4_lsf[709] @ 11344
	.field	497,16			; r_dico4_lsf[710] @ 11360
	.field	625,16			; r_dico4_lsf[711] @ 11376
	.field	-202,16 		; r_dico4_lsf[712] @ 11392
	.field	152,16			; r_dico4_lsf[713] @ 11408
	.field	48,16			; r_dico4_lsf[714] @ 11424
	.field	712,16			; r_dico4_lsf[715] @ 11440
	.field	-20,16			; r_dico4_lsf[716] @ 11456
	.field	566,16			; r_dico4_lsf[717] @ 11472
	.field	100,16			; r_dico4_lsf[718] @ 11488
	.field	715,16			; r_dico4_lsf[719] @ 11504
	.field	455,16			; r_dico4_lsf[720] @ 11520
	.field	468,16			; r_dico4_lsf[721] @ 11536
	.field	411,16			; r_dico4_lsf[722] @ 11552
	.field	605,16			; r_dico4_lsf[723] @ 11568
	.field	319,16			; r_dico4_lsf[724] @ 11584
	.field	646,16			; r_dico4_lsf[725] @ 11600
	.field	195,16			; r_dico4_lsf[726] @ 11616
	.field	615,16			; r_dico4_lsf[727] @ 11632
	.field	401,16			; r_dico4_lsf[728] @ 11648
	.field	538,16			; r_dico4_lsf[729] @ 11664
	.field	680,16			; r_dico4_lsf[730] @ 11680
	.field	739,16			; r_dico4_lsf[731] @ 11696
	.field	201,16			; r_dico4_lsf[732] @ 11712
	.field	667,16			; r_dico4_lsf[733] @ 11728
	.field	434,16			; r_dico4_lsf[734] @ 11744
	.field	954,16			; r_dico4_lsf[735] @ 11760
	.field	454,16			; r_dico4_lsf[736] @ 11776
	.field	425,16			; r_dico4_lsf[737] @ 11792
	.field	646,16			; r_dico4_lsf[738] @ 11808
	.field	491,16			; r_dico4_lsf[739] @ 11824
	.field	606,16			; r_dico4_lsf[740] @ 11840
	.field	681,16			; r_dico4_lsf[741] @ 11856
	.field	416,16			; r_dico4_lsf[742] @ 11872
	.field	508,16			; r_dico4_lsf[743] @ 11888
	.field	497,16			; r_dico4_lsf[744] @ 11904
	.field	822,16			; r_dico4_lsf[745] @ 11920
	.field	426,16			; r_dico4_lsf[746] @ 11936
	.field	815,16			; r_dico4_lsf[747] @ 11952
	.field	660,16			; r_dico4_lsf[748] @ 11968
	.field	647,16			; r_dico4_lsf[749] @ 11984
	.field	628,16			; r_dico4_lsf[750] @ 12000
	.field	716,16			; r_dico4_lsf[751] @ 12016
	.field	697,16			; r_dico4_lsf[752] @ 12032
	.field	466,16			; r_dico4_lsf[753] @ 12048
	.field	618,16			; r_dico4_lsf[754] @ 12064
	.field	457,16			; r_dico4_lsf[755] @ 12080
	.field	685,16			; r_dico4_lsf[756] @ 12096
	.field	460,16			; r_dico4_lsf[757] @ 12112
	.field	365,16			; r_dico4_lsf[758] @ 12128
	.field	309,16			; r_dico4_lsf[759] @ 12144
	.field	721,16			; r_dico4_lsf[760] @ 12160
	.field	567,16			; r_dico4_lsf[761] @ 12176
	.field	836,16			; r_dico4_lsf[762] @ 12192
	.field	601,16			; r_dico4_lsf[763] @ 12208
	.field	609,16			; r_dico4_lsf[764] @ 12224
	.field	300,16			; r_dico4_lsf[765] @ 12240
	.field	825,16			; r_dico4_lsf[766] @ 12256
	.field	459,16			; r_dico4_lsf[767] @ 12272
	.field	943,16			; r_dico4_lsf[768] @ 12288
	.field	687,16			; r_dico4_lsf[769] @ 12304
	.field	681,16			; r_dico4_lsf[770] @ 12320
	.field	533,16			; r_dico4_lsf[771] @ 12336
	.field	915,16			; r_dico4_lsf[772] @ 12352
	.field	598,16			; r_dico4_lsf[773] @ 12368
	.field	591,16			; r_dico4_lsf[774] @ 12384
	.field	243,16			; r_dico4_lsf[775] @ 12400
	.field	876,16			; r_dico4_lsf[776] @ 12416
	.field	451,16			; r_dico4_lsf[777] @ 12432
	.field	874,16			; r_dico4_lsf[778] @ 12448
	.field	420,16			; r_dico4_lsf[779] @ 12464
	.field	786,16			; r_dico4_lsf[780] @ 12480
	.field	317,16			; r_dico4_lsf[781] @ 12496
	.field	732,16			; r_dico4_lsf[782] @ 12512
	.field	220,16			; r_dico4_lsf[783] @ 12528
	.field	922,16			; r_dico4_lsf[784] @ 12544
	.field	317,16			; r_dico4_lsf[785] @ 12560
	.field	1108,16 		; r_dico4_lsf[786] @ 12576
	.field	367,16			; r_dico4_lsf[787] @ 12592
	.field	531,16			; r_dico4_lsf[788] @ 12608
	.field	466,16			; r_dico4_lsf[789] @ 12624
	.field	1028,16 		; r_dico4_lsf[790] @ 12640
	.field	649,16			; r_dico4_lsf[791] @ 12656
	.field	1053,16 		; r_dico4_lsf[792] @ 12672
	.field	615,16			; r_dico4_lsf[793] @ 12688
	.field	1034,16 		; r_dico4_lsf[794] @ 12704
	.field	553,16			; r_dico4_lsf[795] @ 12720
	.field	829,16			; r_dico4_lsf[796] @ 12736
	.field	602,16			; r_dico4_lsf[797] @ 12752
	.field	1021,16 		; r_dico4_lsf[798] @ 12768
	.field	799,16			; r_dico4_lsf[799] @ 12784
	.field	927,16			; r_dico4_lsf[800] @ 12800
	.field	803,16			; r_dico4_lsf[801] @ 12816
	.field	878,16			; r_dico4_lsf[802] @ 12832
	.field	763,16			; r_dico4_lsf[803] @ 12848
	.field	799,16			; r_dico4_lsf[804] @ 12864
	.field	496,16			; r_dico4_lsf[805] @ 12880
	.field	1373,16 		; r_dico4_lsf[806] @ 12896
	.field	773,16			; r_dico4_lsf[807] @ 12912
	.field	585,16			; r_dico4_lsf[808] @ 12928
	.field	770,16			; r_dico4_lsf[809] @ 12944
	.field	803,16			; r_dico4_lsf[810] @ 12960
	.field	930,16			; r_dico4_lsf[811] @ 12976
	.field	1099,16 		; r_dico4_lsf[812] @ 12992
	.field	793,16			; r_dico4_lsf[813] @ 13008
	.field	1222,16 		; r_dico4_lsf[814] @ 13024
	.field	862,16			; r_dico4_lsf[815] @ 13040
	.field	1209,16 		; r_dico4_lsf[816] @ 13056
	.field	895,16			; r_dico4_lsf[817] @ 13072
	.field	1025,16 		; r_dico4_lsf[818] @ 13088
	.field	727,16			; r_dico4_lsf[819] @ 13104
	.field	772,16			; r_dico4_lsf[820] @ 13120
	.field	845,16			; r_dico4_lsf[821] @ 13136
	.field	1172,16 		; r_dico4_lsf[822] @ 13152
	.field	1115,16 		; r_dico4_lsf[823] @ 13168
	.field	867,16			; r_dico4_lsf[824] @ 13184
	.field	1021,16 		; r_dico4_lsf[825] @ 13200
	.field	830,16			; r_dico4_lsf[826] @ 13216
	.field	1013,16 		; r_dico4_lsf[827] @ 13232
	.field	841,16			; r_dico4_lsf[828] @ 13248
	.field	910,16			; r_dico4_lsf[829] @ 13264
	.field	506,16			; r_dico4_lsf[830] @ 13280
	.field	703,16			; r_dico4_lsf[831] @ 13296
	.field	1239,16 		; r_dico4_lsf[832] @ 13312
	.field	1077,16 		; r_dico4_lsf[833] @ 13328
	.field	620,16			; r_dico4_lsf[834] @ 13344
	.field	819,16			; r_dico4_lsf[835] @ 13360
	.field	1196,16 		; r_dico4_lsf[836] @ 13376
	.field	1083,16 		; r_dico4_lsf[837] @ 13392
	.field	1155,16 		; r_dico4_lsf[838] @ 13408
	.field	1081,16 		; r_dico4_lsf[839] @ 13424
	.field	1142,16 		; r_dico4_lsf[840] @ 13440
	.field	907,16			; r_dico4_lsf[841] @ 13456
	.field	1547,16 		; r_dico4_lsf[842] @ 13472
	.field	1121,16 		; r_dico4_lsf[843] @ 13488
	.field	1309,16 		; r_dico4_lsf[844] @ 13504
	.field	648,16			; r_dico4_lsf[845] @ 13520
	.field	1343,16 		; r_dico4_lsf[846] @ 13536
	.field	612,16			; r_dico4_lsf[847] @ 13552
	.field	1484,16 		; r_dico4_lsf[848] @ 13568
	.field	988,16			; r_dico4_lsf[849] @ 13584
	.field	1479,16 		; r_dico4_lsf[850] @ 13600
	.field	937,16			; r_dico4_lsf[851] @ 13616
	.field	985,16			; r_dico4_lsf[852] @ 13632
	.field	1328,16 		; r_dico4_lsf[853] @ 13648
	.field	955,16			; r_dico4_lsf[854] @ 13664
	.field	1341,16 		; r_dico4_lsf[855] @ 13680
	.field	429,16			; r_dico4_lsf[856] @ 13696
	.field	910,16			; r_dico4_lsf[857] @ 13712
	.field	841,16			; r_dico4_lsf[858] @ 13728
	.field	1338,16 		; r_dico4_lsf[859] @ 13744
	.field	564,16			; r_dico4_lsf[860] @ 13760
	.field	1179,16 		; r_dico4_lsf[861] @ 13776
	.field	412,16			; r_dico4_lsf[862] @ 13792
	.field	1156,16 		; r_dico4_lsf[863] @ 13808
	.field	1427,16 		; r_dico4_lsf[864] @ 13824
	.field	1320,16 		; r_dico4_lsf[865] @ 13840
	.field	1434,16 		; r_dico4_lsf[866] @ 13856
	.field	1330,16 		; r_dico4_lsf[867] @ 13872
	.field	640,16			; r_dico4_lsf[868] @ 13888
	.field	760,16			; r_dico4_lsf[869] @ 13904
	.field	1726,16 		; r_dico4_lsf[870] @ 13920
	.field	1410,16 		; r_dico4_lsf[871] @ 13936
	.field	190,16			; r_dico4_lsf[872] @ 13952
	.field	555,16			; r_dico4_lsf[873] @ 13968
	.field	1073,16 		; r_dico4_lsf[874] @ 13984
	.field	1005,16 		; r_dico4_lsf[875] @ 14000
	.field	426,16			; r_dico4_lsf[876] @ 14016
	.field	257,16			; r_dico4_lsf[877] @ 14032
	.field	839,16			; r_dico4_lsf[878] @ 14048
	.field	980,16			; r_dico4_lsf[879] @ 14064
	.field	235,16			; r_dico4_lsf[880] @ 14080
	.field	231,16			; r_dico4_lsf[881] @ 14096
	.field	1520,16 		; r_dico4_lsf[882] @ 14112
	.field	1167,16 		; r_dico4_lsf[883] @ 14128
	.field	109,16			; r_dico4_lsf[884] @ 14144
	.field	293,16			; r_dico4_lsf[885] @ 14160
	.field	1014,16 		; r_dico4_lsf[886] @ 14176
	.field	1569,16 		; r_dico4_lsf[887] @ 14192
	.field	305,16			; r_dico4_lsf[888] @ 14208
	.field	142,16			; r_dico4_lsf[889] @ 14224
	.field	1148,16 		; r_dico4_lsf[890] @ 14240
	.field	539,16			; r_dico4_lsf[891] @ 14256
	.field	-291,16 		; r_dico4_lsf[892] @ 14272
	.field	-108,16 		; r_dico4_lsf[893] @ 14288
	.field	1213,16 		; r_dico4_lsf[894] @ 14304
	.field	972,16			; r_dico4_lsf[895] @ 14320
	.field	22,16			; r_dico4_lsf[896] @ 14336
	.field	-216,16 		; r_dico4_lsf[897] @ 14352
	.field	667,16			; r_dico4_lsf[898] @ 14368
	.field	828,16			; r_dico4_lsf[899] @ 14384
	.field	-482,16 		; r_dico4_lsf[900] @ 14400
	.field	438,16			; r_dico4_lsf[901] @ 14416
	.field	453,16			; r_dico4_lsf[902] @ 14432
	.field	1431,16 		; r_dico4_lsf[903] @ 14448
	.field	-581,16 		; r_dico4_lsf[904] @ 14464
	.field	-422,16 		; r_dico4_lsf[905] @ 14480
	.field	789,16			; r_dico4_lsf[906] @ 14496
	.field	387,16			; r_dico4_lsf[907] @ 14512
	.field	-358,16 		; r_dico4_lsf[908] @ 14528
	.field	-454,16 		; r_dico4_lsf[909] @ 14544
	.field	174,16			; r_dico4_lsf[910] @ 14560
	.field	780,16			; r_dico4_lsf[911] @ 14576
	.field	-36,16			; r_dico4_lsf[912] @ 14592
	.field	-372,16 		; r_dico4_lsf[913] @ 14608
	.field	390,16			; r_dico4_lsf[914] @ 14624
	.field	-134,16 		; r_dico4_lsf[915] @ 14640
	.field	-629,16 		; r_dico4_lsf[916] @ 14656
	.field	160,16			; r_dico4_lsf[917] @ 14672
	.field	-306,16 		; r_dico4_lsf[918] @ 14688
	.field	751,16			; r_dico4_lsf[919] @ 14704
	.field	-1258,16		; r_dico4_lsf[920] @ 14720
	.field	-331,16 		; r_dico4_lsf[921] @ 14736
	.field	177,16			; r_dico4_lsf[922] @ 14752
	.field	522,16			; r_dico4_lsf[923] @ 14768
	.field	-248,16 		; r_dico4_lsf[924] @ 14784
	.field	574,16			; r_dico4_lsf[925] @ 14800
	.field	-251,16 		; r_dico4_lsf[926] @ 14816
	.field	639,16			; r_dico4_lsf[927] @ 14832
	.field	-531,16 		; r_dico4_lsf[928] @ 14848
	.field	407,16			; r_dico4_lsf[929] @ 14864
	.field	-596,16 		; r_dico4_lsf[930] @ 14880
	.field	394,16			; r_dico4_lsf[931] @ 14896
	.field	-419,16 		; r_dico4_lsf[932] @ 14912
	.field	789,16			; r_dico4_lsf[933] @ 14928
	.field	-617,16 		; r_dico4_lsf[934] @ 14944
	.field	801,16			; r_dico4_lsf[935] @ 14960
	.field	-986,16 		; r_dico4_lsf[936] @ 14976
	.field	399,16			; r_dico4_lsf[937] @ 14992
	.field	-857,16 		; r_dico4_lsf[938] @ 15008
	.field	727,16			; r_dico4_lsf[939] @ 15024
	.field	-7,16			; r_dico4_lsf[940] @ 15040
	.field	518,16			; r_dico4_lsf[941] @ 15056
	.field	-703,16 		; r_dico4_lsf[942] @ 15072
	.field	310,16			; r_dico4_lsf[943] @ 15088
	.field	-1143,16		; r_dico4_lsf[944] @ 15104
	.field	-24,16			; r_dico4_lsf[945] @ 15120
	.field	-1002,16		; r_dico4_lsf[946] @ 15136
	.field	287,16			; r_dico4_lsf[947] @ 15152
	.field	-960,16 		; r_dico4_lsf[948] @ 15168
	.field	363,16			; r_dico4_lsf[949] @ 15184
	.field	-1299,16		; r_dico4_lsf[950] @ 15200
	.field	312,16			; r_dico4_lsf[951] @ 15216
	.field	-1534,16		; r_dico4_lsf[952] @ 15232
	.field	245,16			; r_dico4_lsf[953] @ 15248
	.field	-1557,16		; r_dico4_lsf[954] @ 15264
	.field	305,16			; r_dico4_lsf[955] @ 15280
	.field	28,16			; r_dico4_lsf[956] @ 15296
	.field	153,16			; r_dico4_lsf[957] @ 15312
	.field	-859,16 		; r_dico4_lsf[958] @ 15328
	.field	-175,16 		; r_dico4_lsf[959] @ 15344
	.field	-33,16			; r_dico4_lsf[960] @ 15360
	.field	332,16			; r_dico4_lsf[961] @ 15376
	.field	-1398,16		; r_dico4_lsf[962] @ 15392
	.field	-154,16 		; r_dico4_lsf[963] @ 15408
	.field	212,16			; r_dico4_lsf[964] @ 15424
	.field	410,16			; r_dico4_lsf[965] @ 15440
	.field	-593,16 		; r_dico4_lsf[966] @ 15456
	.field	-197,16 		; r_dico4_lsf[967] @ 15472
	.field	-1092,16		; r_dico4_lsf[968] @ 15488
	.field	-704,16 		; r_dico4_lsf[969] @ 15504
	.field	-904,16 		; r_dico4_lsf[970] @ 15520
	.field	-65,16			; r_dico4_lsf[971] @ 15536
	.field	282,16			; r_dico4_lsf[972] @ 15552
	.field	367,16			; r_dico4_lsf[973] @ 15568
	.field	-918,16 		; r_dico4_lsf[974] @ 15584
	.field	-686,16 		; r_dico4_lsf[975] @ 15600
	.field	345,16			; r_dico4_lsf[976] @ 15616
	.field	93,16			; r_dico4_lsf[977] @ 15632
	.field	-258,16 		; r_dico4_lsf[978] @ 15648
	.field	-357,16 		; r_dico4_lsf[979] @ 15664
	.field	696,16			; r_dico4_lsf[980] @ 15680
	.field	644,16			; r_dico4_lsf[981] @ 15696
	.field	-693,16 		; r_dico4_lsf[982] @ 15712
	.field	-28,16			; r_dico4_lsf[983] @ 15728
	.field	448,16			; r_dico4_lsf[984] @ 15744
	.field	493,16			; r_dico4_lsf[985] @ 15760
	.field	-273,16 		; r_dico4_lsf[986] @ 15776
	.field	193,16			; r_dico4_lsf[987] @ 15792
	.field	527,16			; r_dico4_lsf[988] @ 15808
	.field	546,16			; r_dico4_lsf[989] @ 15824
	.field	-243,16 		; r_dico4_lsf[990] @ 15840
	.field	-513,16 		; r_dico4_lsf[991] @ 15856
	.field	384,16			; r_dico4_lsf[992] @ 15872
	.field	-136,16 		; r_dico4_lsf[993] @ 15888
	.field	273,16			; r_dico4_lsf[994] @ 15904
	.field	-353,16 		; r_dico4_lsf[995] @ 15920
	.field	512,16			; r_dico4_lsf[996] @ 15936
	.field	-142,16 		; r_dico4_lsf[997] @ 15952
	.field	537,16			; r_dico4_lsf[998] @ 15968
	.field	-198,16 		; r_dico4_lsf[999] @ 15984
	.field	941,16			; r_dico4_lsf[1000] @ 16000
	.field	750,16			; r_dico4_lsf[1001] @ 16016
	.field	83,16			; r_dico4_lsf[1002] @ 16032
	.field	248,16			; r_dico4_lsf[1003] @ 16048
	.field	578,16			; r_dico4_lsf[1004] @ 16064
	.field	861,16			; r_dico4_lsf[1005] @ 16080
	.field	-56,16			; r_dico4_lsf[1006] @ 16096
	.field	592,16			; r_dico4_lsf[1007] @ 16112
	.field	842,16			; r_dico4_lsf[1008] @ 16128
	.field	44,16			; r_dico4_lsf[1009] @ 16144
	.field	892,16			; r_dico4_lsf[1010] @ 16160
	.field	24,16			; r_dico4_lsf[1011] @ 16176
	.field	33,16			; r_dico4_lsf[1012] @ 16192
	.field	890,16			; r_dico4_lsf[1013] @ 16208
	.field	-16,16			; r_dico4_lsf[1014] @ 16224
	.field	982,16			; r_dico4_lsf[1015] @ 16240
	.field	831,16			; r_dico4_lsf[1016] @ 16256
	.field	1398,16 		; r_dico4_lsf[1017] @ 16272
	.field	1535,16 		; r_dico4_lsf[1018] @ 16288
	.field	1898,16 		; r_dico4_lsf[1019] @ 16304
	.field	1716,16 		; r_dico4_lsf[1020] @ 16320
	.field	1376,16 		; r_dico4_lsf[1021] @ 16336
	.field	1948,16 		; r_dico4_lsf[1022] @ 16352
	.field	1465,16 		; r_dico4_lsf[1023] @ 16368


r_dico5_lsf:
	.field	-1002,16		; r_dico5_lsf[0] @ 0
	.field	-929,16 		; r_dico5_lsf[1] @ 16
	.field	-1096,16		; r_dico5_lsf[2] @ 32
	.field	-1203,16		; r_dico5_lsf[3] @ 48
	.field	-641,16 		; r_dico5_lsf[4] @ 64
	.field	-931,16 		; r_dico5_lsf[5] @ 80
	.field	-604,16 		; r_dico5_lsf[6] @ 96
	.field	-961,16 		; r_dico5_lsf[7] @ 112
	.field	-779,16 		; r_dico5_lsf[8] @ 128
	.field	-673,16 		; r_dico5_lsf[9] @ 144
	.field	-835,16 		; r_dico5_lsf[10] @ 160
	.field	-788,16 		; r_dico5_lsf[11] @ 176
	.field	-416,16 		; r_dico5_lsf[12] @ 192
	.field	-664,16 		; r_dico5_lsf[13] @ 208
	.field	-458,16 		; r_dico5_lsf[14] @ 224
	.field	-766,16 		; r_dico5_lsf[15] @ 240
	.field	-652,16 		; r_dico5_lsf[16] @ 256
	.field	-521,16 		; r_dico5_lsf[17] @ 272
	.field	-662,16 		; r_dico5_lsf[18] @ 288
	.field	-495,16 		; r_dico5_lsf[19] @ 304
	.field	-1023,16		; r_dico5_lsf[20] @ 320
	.field	-509,16 		; r_dico5_lsf[21] @ 336
	.field	-1023,16		; r_dico5_lsf[22] @ 352
	.field	-428,16 		; r_dico5_lsf[23] @ 368
	.field	-444,16 		; r_dico5_lsf[24] @ 384
	.field	-552,16 		; r_dico5_lsf[25] @ 400
	.field	-368,16 		; r_dico5_lsf[26] @ 416
	.field	-449,16 		; r_dico5_lsf[27] @ 432
	.field	-479,16 		; r_dico5_lsf[28] @ 448
	.field	-211,16 		; r_dico5_lsf[29] @ 464
	.field	-1054,16		; r_dico5_lsf[30] @ 480
	.field	-903,16 		; r_dico5_lsf[31] @ 496
	.field	-316,16 		; r_dico5_lsf[32] @ 512
	.field	-249,16 		; r_dico5_lsf[33] @ 528
	.field	-569,16 		; r_dico5_lsf[34] @ 544
	.field	-591,16 		; r_dico5_lsf[35] @ 560
	.field	-569,16 		; r_dico5_lsf[36] @ 576
	.field	-275,16 		; r_dico5_lsf[37] @ 592
	.field	-541,16 		; r_dico5_lsf[38] @ 608
	.field	-191,16 		; r_dico5_lsf[39] @ 624
	.field	-716,16 		; r_dico5_lsf[40] @ 640
	.field	-188,16 		; r_dico5_lsf[41] @ 656
	.field	-842,16 		; r_dico5_lsf[42] @ 672
	.field	-264,16 		; r_dico5_lsf[43] @ 688
	.field	-333,16 		; r_dico5_lsf[44] @ 704
	.field	-248,16 		; r_dico5_lsf[45] @ 720
	.field	-318,16 		; r_dico5_lsf[46] @ 736
	.field	-228,16 		; r_dico5_lsf[47] @ 752
	.field	-275,16 		; r_dico5_lsf[48] @ 768
	.field	1,16			; r_dico5_lsf[49] @ 784
	.field	-567,16 		; r_dico5_lsf[50] @ 800
	.field	-228,16 		; r_dico5_lsf[51] @ 816
	.field	-115,16 		; r_dico5_lsf[52] @ 832
	.field	-221,16 		; r_dico5_lsf[53] @ 848
	.field	-238,16 		; r_dico5_lsf[54] @ 864
	.field	-374,16 		; r_dico5_lsf[55] @ 880
	.field	-197,16 		; r_dico5_lsf[56] @ 896
	.field	-507,16 		; r_dico5_lsf[57] @ 912
	.field	-222,16 		; r_dico5_lsf[58] @ 928
	.field	-579,16 		; r_dico5_lsf[59] @ 944
	.field	-258,16 		; r_dico5_lsf[60] @ 960
	.field	-432,16 		; r_dico5_lsf[61] @ 976
	.field	-61,16			; r_dico5_lsf[62] @ 992
	.field	-244,16 		; r_dico5_lsf[63] @ 1008
	.field	-345,16 		; r_dico5_lsf[64] @ 1024
	.field	2,16			; r_dico5_lsf[65] @ 1040
	.field	-338,16 		; r_dico5_lsf[66] @ 1056
	.field	39,16			; r_dico5_lsf[67] @ 1072
	.field	-215,16 		; r_dico5_lsf[68] @ 1088
	.field	-169,16 		; r_dico5_lsf[69] @ 1104
	.field	-58,16			; r_dico5_lsf[70] @ 1120
	.field	0,16			; r_dico5_lsf[71] @ 1136
	.field	-56,16			; r_dico5_lsf[72] @ 1152
	.field	-6,16			; r_dico5_lsf[73] @ 1168
	.field	-203,16 		; r_dico5_lsf[74] @ 1184
	.field	-131,16 		; r_dico5_lsf[75] @ 1200
	.field	1,16			; r_dico5_lsf[76] @ 1216
	.field	-186,16 		; r_dico5_lsf[77] @ 1232
	.field	-5,16			; r_dico5_lsf[78] @ 1248
	.field	-211,16 		; r_dico5_lsf[79] @ 1264
	.field	6,16			; r_dico5_lsf[80] @ 1280
	.field	-380,16 		; r_dico5_lsf[81] @ 1296
	.field	11,16			; r_dico5_lsf[82] @ 1312
	.field	-418,16 		; r_dico5_lsf[83] @ 1328
	.field	-116,16 		; r_dico5_lsf[84] @ 1344
	.field	131,16			; r_dico5_lsf[85] @ 1360
	.field	-134,16 		; r_dico5_lsf[86] @ 1376
	.field	113,16			; r_dico5_lsf[87] @ 1392
	.field	89,16			; r_dico5_lsf[88] @ 1408
	.field	-4,16			; r_dico5_lsf[89] @ 1424
	.field	71,16			; r_dico5_lsf[90] @ 1440
	.field	-2,16			; r_dico5_lsf[91] @ 1456
	.field	-19,16			; r_dico5_lsf[92] @ 1472
	.field	-192,16 		; r_dico5_lsf[93] @ 1488
	.field	262,16			; r_dico5_lsf[94] @ 1504
	.field	24,16			; r_dico5_lsf[95] @ 1520
	.field	189,16			; r_dico5_lsf[96] @ 1536
	.field	151,16			; r_dico5_lsf[97] @ 1552
	.field	-133,16 		; r_dico5_lsf[98] @ 1568
	.field	-109,16 		; r_dico5_lsf[99] @ 1584
	.field	186,16			; r_dico5_lsf[100] @ 1600
	.field	-153,16 		; r_dico5_lsf[101] @ 1616
	.field	166,16			; r_dico5_lsf[102] @ 1632
	.field	-219,16 		; r_dico5_lsf[103] @ 1648
	.field	37,16			; r_dico5_lsf[104] @ 1664
	.field	139,16			; r_dico5_lsf[105] @ 1680
	.field	193,16			; r_dico5_lsf[106] @ 1696
	.field	171,16			; r_dico5_lsf[107] @ 1712
	.field	337,16			; r_dico5_lsf[108] @ 1728
	.field	124,16			; r_dico5_lsf[109] @ 1744
	.field	158,16			; r_dico5_lsf[110] @ 1760
	.field	-61,16			; r_dico5_lsf[111] @ 1776
	.field	141,16			; r_dico5_lsf[112] @ 1792
	.field	226,16			; r_dico5_lsf[113] @ 1808
	.field	-13,16			; r_dico5_lsf[114] @ 1824
	.field	190,16			; r_dico5_lsf[115] @ 1840
	.field	231,16			; r_dico5_lsf[116] @ 1856
	.field	34,16			; r_dico5_lsf[117] @ 1872
	.field	354,16			; r_dico5_lsf[118] @ 1888
	.field	109,16			; r_dico5_lsf[119] @ 1904
	.field	316,16			; r_dico5_lsf[120] @ 1920
	.field	201,16			; r_dico5_lsf[121] @ 1936
	.field	244,16			; r_dico5_lsf[122] @ 1952
	.field	164,16			; r_dico5_lsf[123] @ 1968
	.field	330,16			; r_dico5_lsf[124] @ 1984
	.field	-85,16			; r_dico5_lsf[125] @ 2000
	.field	390,16			; r_dico5_lsf[126] @ 2016
	.field	-84,16			; r_dico5_lsf[127] @ 2032
	.field	254,16			; r_dico5_lsf[128] @ 2048
	.field	327,16			; r_dico5_lsf[129] @ 2064
	.field	257,16			; r_dico5_lsf[130] @ 2080
	.field	335,16			; r_dico5_lsf[131] @ 2096
	.field	491,16			; r_dico5_lsf[132] @ 2112
	.field	147,16			; r_dico5_lsf[133] @ 2128
	.field	476,16			; r_dico5_lsf[134] @ 2144
	.field	105,16			; r_dico5_lsf[135] @ 2160
	.field	54,16			; r_dico5_lsf[136] @ 2176
	.field	77,16			; r_dico5_lsf[137] @ 2192
	.field	437,16			; r_dico5_lsf[138] @ 2208
	.field	370,16			; r_dico5_lsf[139] @ 2224
	.field	421,16			; r_dico5_lsf[140] @ 2240
	.field	314,16			; r_dico5_lsf[141] @ 2256
	.field	449,16			; r_dico5_lsf[142] @ 2272
	.field	342,16			; r_dico5_lsf[143] @ 2288
	.field	329,16			; r_dico5_lsf[144] @ 2304
	.field	126,16			; r_dico5_lsf[145] @ 2320
	.field	673,16			; r_dico5_lsf[146] @ 2336
	.field	292,16			; r_dico5_lsf[147] @ 2352
	.field	571,16			; r_dico5_lsf[148] @ 2368
	.field	388,16			; r_dico5_lsf[149] @ 2384
	.field	243,16			; r_dico5_lsf[150] @ 2400
	.field	193,16			; r_dico5_lsf[151] @ 2416
	.field	653,16			; r_dico5_lsf[152] @ 2432
	.field	320,16			; r_dico5_lsf[153] @ 2448
	.field	621,16			; r_dico5_lsf[154] @ 2464
	.field	280,16			; r_dico5_lsf[155] @ 2480
	.field	194,16			; r_dico5_lsf[156] @ 2496
	.field	380,16			; r_dico5_lsf[157] @ 2512
	.field	517,16			; r_dico5_lsf[158] @ 2528
	.field	581,16			; r_dico5_lsf[159] @ 2544
	.field	45,16			; r_dico5_lsf[160] @ 2560
	.field	323,16			; r_dico5_lsf[161] @ 2576
	.field	111,16			; r_dico5_lsf[162] @ 2592
	.field	422,16			; r_dico5_lsf[163] @ 2608
	.field	489,16			; r_dico5_lsf[164] @ 2624
	.field	395,16			; r_dico5_lsf[165] @ 2640
	.field	734,16			; r_dico5_lsf[166] @ 2656
	.field	534,16			; r_dico5_lsf[167] @ 2672
	.field	622,16			; r_dico5_lsf[168] @ 2688
	.field	546,16			; r_dico5_lsf[169] @ 2704
	.field	486,16			; r_dico5_lsf[170] @ 2720
	.field	502,16			; r_dico5_lsf[171] @ 2736
	.field	318,16			; r_dico5_lsf[172] @ 2752
	.field	572,16			; r_dico5_lsf[173] @ 2768
	.field	189,16			; r_dico5_lsf[174] @ 2784
	.field	550,16			; r_dico5_lsf[175] @ 2800
	.field	385,16			; r_dico5_lsf[176] @ 2816
	.field	422,16			; r_dico5_lsf[177] @ 2832
	.field	-157,16 		; r_dico5_lsf[178] @ 2848
	.field	153,16			; r_dico5_lsf[179] @ 2864
	.field	-125,16 		; r_dico5_lsf[180] @ 2880
	.field	382,16			; r_dico5_lsf[181] @ 2896
	.field	-197,16 		; r_dico5_lsf[182] @ 2912
	.field	386,16			; r_dico5_lsf[183] @ 2928
	.field	-263,16 		; r_dico5_lsf[184] @ 2944
	.field	334,16			; r_dico5_lsf[185] @ 2960
	.field	228,16			; r_dico5_lsf[186] @ 2976
	.field	697,16			; r_dico5_lsf[187] @ 2992
	.field	-188,16 		; r_dico5_lsf[188] @ 3008
	.field	1,16			; r_dico5_lsf[189] @ 3024
	.field	51,16			; r_dico5_lsf[190] @ 3040
	.field	297,16			; r_dico5_lsf[191] @ 3056
	.field	-507,16 		; r_dico5_lsf[192] @ 3072
	.field	213,16			; r_dico5_lsf[193] @ 3088
	.field	-376,16 		; r_dico5_lsf[194] @ 3104
	.field	397,16			; r_dico5_lsf[195] @ 3120
	.field	-24,16			; r_dico5_lsf[196] @ 3136
	.field	255,16			; r_dico5_lsf[197] @ 3152
	.field	-547,16 		; r_dico5_lsf[198] @ 3168
	.field	89,16			; r_dico5_lsf[199] @ 3184
	.field	-502,16 		; r_dico5_lsf[200] @ 3200
	.field	-94,16			; r_dico5_lsf[201] @ 3216
	.field	387,16			; r_dico5_lsf[202] @ 3232
	.field	179,16			; r_dico5_lsf[203] @ 3248
	.field	-620,16 		; r_dico5_lsf[204] @ 3264
	.field	68,16			; r_dico5_lsf[205] @ 3280
	.field	-684,16 		; r_dico5_lsf[206] @ 3296
	.field	112,16			; r_dico5_lsf[207] @ 3312
	.field	-642,16 		; r_dico5_lsf[208] @ 3328
	.field	-350,16 		; r_dico5_lsf[209] @ 3344
	.field	-260,16 		; r_dico5_lsf[210] @ 3360
	.field	172,16			; r_dico5_lsf[211] @ 3376
	.field	-438,16 		; r_dico5_lsf[212] @ 3392
	.field	-324,16 		; r_dico5_lsf[213] @ 3408
	.field	264,16			; r_dico5_lsf[214] @ 3424
	.field	648,16			; r_dico5_lsf[215] @ 3440
	.field	-964,16 		; r_dico5_lsf[216] @ 3456
	.field	-4,16			; r_dico5_lsf[217] @ 3472
	.field	-1121,16		; r_dico5_lsf[218] @ 3488
	.field	7,16			; r_dico5_lsf[219] @ 3504
	.field	-134,16 		; r_dico5_lsf[220] @ 3520
	.field	134,16			; r_dico5_lsf[221] @ 3536
	.field	-1133,16		; r_dico5_lsf[222] @ 3552
	.field	-306,16 		; r_dico5_lsf[223] @ 3568
	.field	143,16			; r_dico5_lsf[224] @ 3584
	.field	96,16			; r_dico5_lsf[225] @ 3600
	.field	-420,16 		; r_dico5_lsf[226] @ 3616
	.field	-497,16 		; r_dico5_lsf[227] @ 3632
	.field	-1221,16		; r_dico5_lsf[228] @ 3648
	.field	-350,16 		; r_dico5_lsf[229] @ 3664
	.field	-1527,16		; r_dico5_lsf[230] @ 3680
	.field	-685,16 		; r_dico5_lsf[231] @ 3696
	.field	-161,16 		; r_dico5_lsf[232] @ 3712
	.field	72,16			; r_dico5_lsf[233] @ 3728
	.field	873,16			; r_dico5_lsf[234] @ 3744
	.field	691,16			; r_dico5_lsf[235] @ 3760
	.field	732,16			; r_dico5_lsf[236] @ 3776
	.field	283,16			; r_dico5_lsf[237] @ 3792
	.field	921,16			; r_dico5_lsf[238] @ 3808
	.field	353,16			; r_dico5_lsf[239] @ 3824
	.field	334,16			; r_dico5_lsf[240] @ 3840
	.field	475,16			; r_dico5_lsf[241] @ 3856
	.field	1095,16 		; r_dico5_lsf[242] @ 3872
	.field	821,16			; r_dico5_lsf[243] @ 3888
	.field	864,16			; r_dico5_lsf[244] @ 3904
	.field	524,16			; r_dico5_lsf[245] @ 3920
	.field	843,16			; r_dico5_lsf[246] @ 3936
	.field	497,16			; r_dico5_lsf[247] @ 3952
	.field	714,16			; r_dico5_lsf[248] @ 3968
	.field	711,16			; r_dico5_lsf[249] @ 3984
	.field	788,16			; r_dico5_lsf[250] @ 4000
	.field	750,16			; r_dico5_lsf[251] @ 4016
	.field	1076,16 	 	; r_dico5_lsf[252] @ 4032
	.field	714,16			; r_dico5_lsf[253] @ 4048
	.field	1204,16 		; r_dico5_lsf[254] @ 4064
	.field	753,16			; r_dico5_lsf[255] @ 4080
 
r_window_232_8:
	.field	2621,16 		; r_window_232_8[0] @ 0
	.field	2623,16 		; r_window_232_8[1] @ 16
	.field	2627,16 		; r_window_232_8[2] @ 32
	.field	2634,16 		; r_window_232_8[3] @ 48
	.field	2644,16 		; r_window_232_8[4] @ 64
	.field	2656,16 		; r_window_232_8[5] @ 80
	.field	2671,16 		; r_window_232_8[6] @ 96
	.field	2689,16 		; r_window_232_8[7] @ 112
	.field	2710,16 		; r_window_232_8[8] @ 128
	.field	2734,16 		; r_window_232_8[9] @ 144
	.field	2760,16 		; r_window_232_8[10] @ 160
	.field	2789,16 		; r_window_232_8[11] @ 176
	.field	2821,16 		; r_window_232_8[12] @ 192
	.field	2855,16 		; r_window_232_8[13] @ 208
	.field	2893,16 		; r_window_232_8[14] @ 224
	.field	2933,16 		; r_window_232_8[15] @ 240
	.field	2975,16 		; r_window_232_8[16] @ 256
	.field	3021,16 		; r_window_232_8[17] @ 272
	.field	3069,16 		; r_window_232_8[18] @ 288
	.field	3120,16 		; r_window_232_8[19] @ 304
	.field	3173,16 		; r_window_232_8[20] @ 320
	.field	3229,16 		; r_window_232_8[21] @ 336
	.field	3288,16 		; r_window_232_8[22] @ 352
	.field	3350,16 		; r_window_232_8[23] @ 368
	.field	3414,16 		; r_window_232_8[24] @ 384
	.field	3481,16 		; r_window_232_8[25] @ 400
	.field	3550,16 		; r_window_232_8[26] @ 416
	.field	3622,16 		; r_window_232_8[27] @ 432
	.field	3697,16 		; r_window_232_8[28] @ 448
	.field	3774,16 		; r_window_232_8[29] @ 464
	.field	3853,16 		; r_window_232_8[30] @ 480
	.field	3936,16 		; r_window_232_8[31] @ 496
	.field	4021,16 		; r_window_232_8[32] @ 512
	.field	4108,16 		; r_window_232_8[33] @ 528
	.field	4198,16 		; r_window_232_8[34] @ 544
	.field	4290,16 		; r_window_232_8[35] @ 560
	.field	4385,16 		; r_window_232_8[36] @ 576
	.field	4482,16 		; r_window_232_8[37] @ 592
	.field	4582,16 		; r_window_232_8[38] @ 608
	.field	4684,16 		; r_window_232_8[39] @ 624
	.field	4788,16 		; r_window_232_8[40] @ 640
	.field	4895,16 		; r_window_232_8[41] @ 656
	.field	5004,16 		; r_window_232_8[42] @ 672
	.field	5116,16 		; r_window_232_8[43] @ 688
	.field	5230,16 		; r_window_232_8[44] @ 704
	.field	5346,16 		; r_window_232_8[45] @ 720
	.field	5464,16 		; r_window_232_8[46] @ 736
	.field	5585,16 		; r_window_232_8[47] @ 752
	.field	5708,16 		; r_window_232_8[48] @ 768
	.field	5833,16 		; r_window_232_8[49] @ 784
	.field	5960,16 		; r_window_232_8[50] @ 800
	.field	6090,16 		; r_window_232_8[51] @ 816
	.field	6221,16 		; r_window_232_8[52] @ 832
	.field	6355,16 		; r_window_232_8[53] @ 848
	.field	6491,16 		; r_window_232_8[54] @ 864
	.field	6629,16 		; r_window_232_8[55] @ 880
	.field	6769,16 		; r_window_232_8[56] @ 896
	.field	6910,16 		; r_window_232_8[57] @ 912
	.field	7054,16 		; r_window_232_8[58] @ 928
	.field	7200,16 		; r_window_232_8[59] @ 944
	.field	7348,16 		; r_window_232_8[60] @ 960
	.field	7498,16 		; r_window_232_8[61] @ 976
	.field	7649,16 		; r_window_232_8[62] @ 992
	.field	7803,16 		; r_window_232_8[63] @ 1008
	.field	7958,16 		; r_window_232_8[64] @ 1024
	.field	8115,16 		; r_window_232_8[65] @ 1040
	.field	8274,16 		; r_window_232_8[66] @ 1056
	.field	8434,16 		; r_window_232_8[67] @ 1072
	.field	8597,16 		; r_window_232_8[68] @ 1088
	.field	8761,16 		; r_window_232_8[69] @ 1104
	.field	8926,16 		; r_window_232_8[70] @ 1120
	.field	9093,16 		; r_window_232_8[71] @ 1136
	.field	9262,16 		; r_window_232_8[72] @ 1152
	.field	9432,16 		; r_window_232_8[73] @ 1168
	.field	9604,16 		; r_window_232_8[74] @ 1184
	.field	9778,16 		; r_window_232_8[75] @ 1200
	.field	9952,16 		; r_window_232_8[76] @ 1216
	.field	10129,16		; r_window_232_8[77] @ 1232
	.field	10306,16		; r_window_232_8[78] @ 1248
	.field	10485,16		; r_window_232_8[79] @ 1264
	.field	10665,16		; r_window_232_8[80] @ 1280
	.field	10847,16		; r_window_232_8[81] @ 1296
	.field	11030,16		; r_window_232_8[82] @ 1312
	.field	11214,16		; r_window_232_8[83] @ 1328
	.field	11399,16		; r_window_232_8[84] @ 1344
	.field	11586,16		; r_window_232_8[85] @ 1360
	.field	11773,16		; r_window_232_8[86] @ 1376
	.field	11962,16		; r_window_232_8[87] @ 1392
	.field	12152,16		; r_window_232_8[88] @ 1408
	.field	12342,16		; r_window_232_8[89] @ 1424
	.field	12534,16		; r_window_232_8[90] @ 1440
	.field	12727,16		; r_window_232_8[91] @ 1456
	.field	12920,16		; r_window_232_8[92] @ 1472
	.field	13115,16		; r_window_232_8[93] @ 1488
	.field	13310,16		; r_window_232_8[94] @ 1504
	.field	13506,16		; r_window_232_8[95] @ 1520
	.field	13703,16		; r_window_232_8[96] @ 1536
	.field	13901,16		; r_window_232_8[97] @ 1552
	.field	14099,16		; r_window_232_8[98] @ 1568
	.field	14298,16		; r_window_232_8[99] @ 1584
	.field	14497,16		; r_window_232_8[100] @ 1600
	.field	14698,16		; r_window_232_8[101] @ 1616
	.field	14898,16		; r_window_232_8[102] @ 1632
	.field	15100,16		; r_window_232_8[103] @ 1648
	.field	15301,16		; r_window_232_8[104] @ 1664
	.field	15504,16		; r_window_232_8[105] @ 1680
	.field	15706,16		; r_window_232_8[106] @ 1696
	.field	15909,16		; r_window_232_8[107] @ 1712
	.field	16112,16		; r_window_232_8[108] @ 1728
	.field	16316,16		; r_window_232_8[109] @ 1744
	.field	16520,16		; r_window_232_8[110] @ 1760
	.field	16724,16		; r_window_232_8[111] @ 1776
	.field	16928,16		; r_window_232_8[112] @ 1792
	.field	17132,16		; r_window_232_8[113] @ 1808
	.field	17337,16		; r_window_232_8[114] @ 1824
	.field	17541,16		; r_window_232_8[115] @ 1840
	.field	17746,16		; r_window_232_8[116] @ 1856
	.field	17950,16		; r_window_232_8[117] @ 1872
	.field	18155,16		; r_window_232_8[118] @ 1888
	.field	18359,16		; r_window_232_8[119] @ 1904
	.field	18564,16		; r_window_232_8[120] @ 1920
	.field	18768,16		; r_window_232_8[121] @ 1936
	.field	18972,16		; r_window_232_8[122] @ 1952
	.field	19175,16		; r_window_232_8[123] @ 1968
	.field	19379,16		; r_window_232_8[124] @ 1984
	.field	19582,16		; r_window_232_8[125] @ 2000
	.field	19785,16		; r_window_232_8[126] @ 2016
	.field	19987,16		; r_window_232_8[127] @ 2032
	.field	20189,16		; r_window_232_8[128] @ 2048
	.field	20390,16		; r_window_232_8[129] @ 2064
	.field	20591,16		; r_window_232_8[130] @ 2080
	.field	20792,16		; r_window_232_8[131] @ 2096
	.field	20992,16		; r_window_232_8[132] @ 2112
	.field	21191,16		; r_window_232_8[133] @ 2128
	.field	21390,16		; r_window_232_8[134] @ 2144
	.field	21588,16		; r_window_232_8[135] @ 2160
	.field	21785,16		; r_window_232_8[136] @ 2176
	.field	21981,16		; r_window_232_8[137] @ 2192
	.field	22177,16		; r_window_232_8[138] @ 2208
	.field	22372,16		; r_window_232_8[139] @ 2224
	.field	22566,16		; r_window_232_8[140] @ 2240
	.field	22759,16		; r_window_232_8[141] @ 2256
	.field	22951,16		; r_window_232_8[142] @ 2272
	.field	23143,16		; r_window_232_8[143] @ 2288
	.field	23333,16		; r_window_232_8[144] @ 2304
	.field	23522,16		; r_window_232_8[145] @ 2320
	.field	23710,16		; r_window_232_8[146] @ 2336
	.field	23897,16		; r_window_232_8[147] @ 2352
	.field	24083,16		; r_window_232_8[148] @ 2368
	.field	24268,16		; r_window_232_8[149] @ 2384
	.field	24451,16		; r_window_232_8[150] @ 2400
	.field	24633,16		; r_window_232_8[151] @ 2416
	.field	24814,16		; r_window_232_8[152] @ 2432
	.field	24994,16		; r_window_232_8[153] @ 2448
	.field	25172,16		; r_window_232_8[154] @ 2464
	.field	25349,16		; r_window_232_8[155] @ 2480
	.field	25525,16		; r_window_232_8[156] @ 2496
	.field	25699,16		; r_window_232_8[157] @ 2512
	.field	25871,16		; r_window_232_8[158] @ 2528
	.field	26042,16		; r_window_232_8[159] @ 2544
	.field	26212,16		; r_window_232_8[160] @ 2560
	.field	26380,16		; r_window_232_8[161] @ 2576
	.field	26546,16		; r_window_232_8[162] @ 2592
	.field	26711,16		; r_window_232_8[163] @ 2608
	.field	26874,16		; r_window_232_8[164] @ 2624
	.field	27035,16		; r_window_232_8[165] @ 2640
	.field	27195,16		; r_window_232_8[166] @ 2656
	.field	27353,16		; r_window_232_8[167] @ 2672
	.field	27509,16		; r_window_232_8[168] @ 2688
	.field	27664,16		; r_window_232_8[169] @ 2704
	.field	27816,16		; r_window_232_8[170] @ 2720
	.field	27967,16		; r_window_232_8[171] @ 2736
	.field	28115,16		; r_window_232_8[172] @ 2752
	.field	28262,16		; r_window_232_8[173] @ 2768
	.field	28407,16		; r_window_232_8[174] @ 2784
	.field	28550,16		; r_window_232_8[175] @ 2800
	.field	28691,16		; r_window_232_8[176] @ 2816
	.field	28830,16		; r_window_232_8[177] @ 2832
	.field	28967,16		; r_window_232_8[178] @ 2848
	.field	29102,16		; r_window_232_8[179] @ 2864
	.field	29234,16		; r_window_232_8[180] @ 2880
	.field	29365,16		; r_window_232_8[181] @ 2896
	.field	29493,16		; r_window_232_8[182] @ 2912
	.field	29619,16		; r_window_232_8[183] @ 2928
	.field	29743,16		; r_window_232_8[184] @ 2944
	.field	29865,16		; r_window_232_8[185] @ 2960
	.field	29985,16		; r_window_232_8[186] @ 2976
	.field	30102,16		; r_window_232_8[187] @ 2992
	.field	30217,16		; r_window_232_8[188] @ 3008
	.field	30330,16		; r_window_232_8[189] @ 3024
	.field	30440,16		; r_window_232_8[190] @ 3040
	.field	30548,16		; r_window_232_8[191] @ 3056
	.field	30654,16		; r_window_232_8[192] @ 3072
	.field	30757,16		; r_window_232_8[193] @ 3088
	.field	30858,16		; r_window_232_8[194] @ 3104
	.field	30956,16		; r_window_232_8[195] @ 3120
	.field	31052,16		; r_window_232_8[196] @ 3136
	.field	31146,16		; r_window_232_8[197] @ 3152
	.field	31237,16		; r_window_232_8[198] @ 3168
	.field	31326,16		; r_window_232_8[199] @ 3184
	.field	31412,16		; r_window_232_8[200] @ 3200
	.field	31495,16		; r_window_232_8[201] @ 3216
	.field	31576,16		; r_window_232_8[202] @ 3232
	.field	31655,16		; r_window_232_8[203] @ 3248
	.field	31730,16		; r_window_232_8[204] @ 3264
	.field	31804,16		; r_window_232_8[205] @ 3280
	.field	31874,16		; r_window_232_8[206] @ 3296
	.field	31942,16		; r_window_232_8[207] @ 3312
	.field	32008,16		; r_window_232_8[208] @ 3328
	.field	32071,16		; r_window_232_8[209] @ 3344
	.field	32131,16		; r_window_232_8[210] @ 3360
	.field	32188,16		; r_window_232_8[211] @ 3376
	.field	32243,16		; r_window_232_8[212] @ 3392
	.field	32295,16		; r_window_232_8[213] @ 3408
	.field	32345,16		; r_window_232_8[214] @ 3424
	.field	32392,16		; r_window_232_8[215] @ 3440
	.field	32436,16		; r_window_232_8[216] @ 3456
	.field	32477,16		; r_window_232_8[217] @ 3472
	.field	32516,16		; r_window_232_8[218] @ 3488
	.field	32552,16		; r_window_232_8[219] @ 3504
	.field	32585,16		; r_window_232_8[220] @ 3520
	.field	32615,16		; r_window_232_8[221] @ 3536
	.field	32643,16		; r_window_232_8[222] @ 3552
	.field	32668,16		; r_window_232_8[223] @ 3568
	.field	32690,16		; r_window_232_8[224] @ 3584
	.field	32709,16		; r_window_232_8[225] @ 3600
	.field	32726,16		; r_window_232_8[226] @ 3616
	.field	32740,16		; r_window_232_8[227] @ 3632
	.field	32751,16		; r_window_232_8[228] @ 3648
	.field	32759,16		; r_window_232_8[229] @ 3664
	.field	32765,16		; r_window_232_8[230] @ 3680
	.field	32767,16		; r_window_232_8[231] @ 3696
	.field	32767,16		; r_window_232_8[232] @ 3712
	.field	32097,16		; r_window_232_8[233] @ 3728
	.field	30112,16		; r_window_232_8[234] @ 3744
	.field	26895,16		; r_window_232_8[235] @ 3760
	.field	22576,16		; r_window_232_8[236] @ 3776
	.field	17333,16		; r_window_232_8[237] @ 3792
	.field	11380,16		; r_window_232_8[238] @ 3808
	.field	4962,16 		; r_window_232_8[239] @ 3824

r_window_160_80:
	.field	2621,16 		; r_window_160_80[0] @ 0
	.field	2624,16 		; r_window_160_80[1] @ 16
	.field	2633,16 		; r_window_160_80[2] @ 32
	.field	2648,16 		; r_window_160_80[3] @ 48
	.field	2668,16 		; r_window_160_80[4] @ 64
	.field	2695,16 		; r_window_160_80[5] @ 80
	.field	2727,16 		; r_window_160_80[6] @ 96
	.field	2765,16 		; r_window_160_80[7] @ 112
	.field	2809,16 		; r_window_160_80[8] @ 128
	.field	2859,16 		; r_window_160_80[9] @ 144
	.field	2915,16 		; r_window_160_80[10] @ 160
	.field	2976,16 		; r_window_160_80[11] @ 176
	.field	3043,16 		; r_window_160_80[12] @ 192
	.field	3116,16 		; r_window_160_80[13] @ 208
	.field	3194,16 		; r_window_160_80[14] @ 224
	.field	3279,16 		; r_window_160_80[15] @ 240
	.field	3368,16 		; r_window_160_80[16] @ 256
	.field	3464,16 		; r_window_160_80[17] @ 272
	.field	3565,16 		; r_window_160_80[18] @ 288
	.field	3671,16 		; r_window_160_80[19] @ 304
	.field	3783,16 		; r_window_160_80[20] @ 320
	.field	3900,16 		; r_window_160_80[21] @ 336
	.field	4023,16 		; r_window_160_80[22] @ 352
	.field	4151,16 		; r_window_160_80[23] @ 368
	.field	4285,16 		; r_window_160_80[24] @ 384
	.field	4423,16 		; r_window_160_80[25] @ 400
	.field	4567,16 		; r_window_160_80[26] @ 416
	.field	4716,16 		; r_window_160_80[27] @ 432
	.field	4870,16 		; r_window_160_80[28] @ 448
	.field	5029,16 		; r_window_160_80[29] @ 464
	.field	5193,16 		; r_window_160_80[30] @ 480
	.field	5362,16 		; r_window_160_80[31] @ 496
	.field	5535,16 		; r_window_160_80[32] @ 512
	.field	5714,16 		; r_window_160_80[33] @ 528
	.field	5897,16 		; r_window_160_80[34] @ 544
	.field	6084,16 		; r_window_160_80[35] @ 560
	.field	6277,16 		; r_window_160_80[36] @ 576
	.field	6473,16 		; r_window_160_80[37] @ 592
	.field	6674,16 		; r_window_160_80[38] @ 608
	.field	6880,16 		; r_window_160_80[39] @ 624
	.field	7089,16 		; r_window_160_80[40] @ 640
	.field	7303,16 		; r_window_160_80[41] @ 656
	.field	7521,16 		; r_window_160_80[42] @ 672
	.field	7742,16 		; r_window_160_80[43] @ 688
	.field	7968,16 		; r_window_160_80[44] @ 704
	.field	8197,16 		; r_window_160_80[45] @ 720
	.field	8430,16 		; r_window_160_80[46] @ 736
	.field	8667,16 		; r_window_160_80[47] @ 752
	.field	8907,16 		; r_window_160_80[48] @ 768
	.field	9151,16 		; r_window_160_80[49] @ 784
	.field	9398,16 		; r_window_160_80[50] @ 800
	.field	9648,16 		; r_window_160_80[51] @ 816
	.field	9902,16 		; r_window_160_80[52] @ 832
	.field	10158,16		; r_window_160_80[53] @ 848
	.field	10417,16		; r_window_160_80[54] @ 864
	.field	10680,16		; r_window_160_80[55] @ 880
	.field	10945,16		; r_window_160_80[56] @ 896
	.field	11212,16		; r_window_160_80[57] @ 912
	.field	11482,16		; r_window_160_80[58] @ 928
	.field	11755,16		; r_window_160_80[59] @ 944
	.field	12030,16		; r_window_160_80[60] @ 960
	.field	12307,16		; r_window_160_80[61] @ 976
	.field	12586,16		; r_window_160_80[62] @ 992
	.field	12867,16		; r_window_160_80[63] @ 1008
	.field	13150,16		; r_window_160_80[64] @ 1024
	.field	13435,16		; r_window_160_80[65] @ 1040
	.field	13722,16		; r_window_160_80[66] @ 1056
	.field	14010,16		; r_window_160_80[67] @ 1072
	.field	14299,16		; r_window_160_80[68] @ 1088
	.field	14590,16		; r_window_160_80[69] @ 1104
	.field	14882,16		; r_window_160_80[70] @ 1120
	.field	15175,16		; r_window_160_80[71] @ 1136
	.field	15469,16		; r_window_160_80[72] @ 1152
	.field	15764,16		; r_window_160_80[73] @ 1168
	.field	16060,16		; r_window_160_80[74] @ 1184
	.field	16356,16		; r_window_160_80[75] @ 1200
	.field	16653,16		; r_window_160_80[76] @ 1216
	.field	16950,16		; r_window_160_80[77] @ 1232
	.field	17248,16		; r_window_160_80[78] @ 1248
	.field	17546,16		; r_window_160_80[79] @ 1264
	.field	17844,16		; r_window_160_80[80] @ 1280
	.field	18141,16		; r_window_160_80[81] @ 1296
	.field	18439,16		; r_window_160_80[82] @ 1312
	.field	18736,16		; r_window_160_80[83] @ 1328
	.field	19033,16		; r_window_160_80[84] @ 1344
	.field	19330,16		; r_window_160_80[85] @ 1360
	.field	19625,16		; r_window_160_80[86] @ 1376
	.field	19920,16		; r_window_160_80[87] @ 1392
	.field	20214,16		; r_window_160_80[88] @ 1408
	.field	20507,16		; r_window_160_80[89] @ 1424
	.field	20799,16		; r_window_160_80[90] @ 1440
	.field	21090,16		; r_window_160_80[91] @ 1456
	.field	21380,16		; r_window_160_80[92] @ 1472
	.field	21668,16		; r_window_160_80[93] @ 1488
	.field	21954,16		; r_window_160_80[94] @ 1504
	.field	22239,16		; r_window_160_80[95] @ 1520
	.field	22522,16		; r_window_160_80[96] @ 1536
	.field	22803,16		; r_window_160_80[97] @ 1552
	.field	23083,16		; r_window_160_80[98] @ 1568
	.field	23360,16		; r_window_160_80[99] @ 1584
	.field	23635,16		; r_window_160_80[100] @ 1600
	.field	23907,16		; r_window_160_80[101] @ 1616
	.field	24177,16		; r_window_160_80[102] @ 1632
	.field	24445,16		; r_window_160_80[103] @ 1648
	.field	24710,16		; r_window_160_80[104] @ 1664
	.field	24972,16		; r_window_160_80[105] @ 1680
	.field	25231,16		; r_window_160_80[106] @ 1696
	.field	25488,16		; r_window_160_80[107] @ 1712
	.field	25741,16		; r_window_160_80[108] @ 1728
	.field	25991,16		; r_window_160_80[109] @ 1744
	.field	26238,16		; r_window_160_80[110] @ 1760
	.field	26482,16		; r_window_160_80[111] @ 1776
	.field	26722,16		; r_window_160_80[112] @ 1792
	.field	26959,16		; r_window_160_80[113] @ 1808
	.field	27192,16		; r_window_160_80[114] @ 1824
	.field	27422,16		; r_window_160_80[115] @ 1840
	.field	27647,16		; r_window_160_80[116] @ 1856
	.field	27869,16		; r_window_160_80[117] @ 1872
	.field	28087,16		; r_window_160_80[118] @ 1888
	.field	28300,16		; r_window_160_80[119] @ 1904
	.field	28510,16		; r_window_160_80[120] @ 1920
	.field	28715,16		; r_window_160_80[121] @ 1936
	.field	28916,16		; r_window_160_80[122] @ 1952
	.field	29113,16		; r_window_160_80[123] @ 1968
	.field	29305,16		; r_window_160_80[124] @ 1984
	.field	29493,16		; r_window_160_80[125] @ 2000
	.field	29676,16		; r_window_160_80[126] @ 2016
	.field	29854,16		; r_window_160_80[127] @ 2032
	.field	30028,16		; r_window_160_80[128] @ 2048
	.field	30197,16		; r_window_160_80[129] @ 2064
	.field	30361,16		; r_window_160_80[130] @ 2080
	.field	30519,16		; r_window_160_80[131] @ 2096
	.field	30673,16		; r_window_160_80[132] @ 2112
	.field	30822,16		; r_window_160_80[133] @ 2128
	.field	30966,16		; r_window_160_80[134] @ 2144
	.field	31105,16		; r_window_160_80[135] @ 2160
	.field	31238,16		; r_window_160_80[136] @ 2176
	.field	31366,16		; r_window_160_80[137] @ 2192
	.field	31489,16		; r_window_160_80[138] @ 2208
	.field	31606,16		; r_window_160_80[139] @ 2224
	.field	31718,16		; r_window_160_80[140] @ 2240
	.field	31825,16		; r_window_160_80[141] @ 2256
	.field	31926,16		; r_window_160_80[142] @ 2272
	.field	32021,16		; r_window_160_80[143] @ 2288
	.field	32111,16		; r_window_160_80[144] @ 2304
	.field	32195,16		; r_window_160_80[145] @ 2320
	.field	32273,16		; r_window_160_80[146] @ 2336
	.field	32346,16		; r_window_160_80[147] @ 2352
	.field	32413,16		; r_window_160_80[148] @ 2368
	.field	32475,16		; r_window_160_80[149] @ 2384
	.field	32530,16		; r_window_160_80[150] @ 2400
	.field	32580,16		; r_window_160_80[151] @ 2416
	.field	32624,16		; r_window_160_80[152] @ 2432
	.field	32662,16		; r_window_160_80[153] @ 2448
	.field	32695,16		; r_window_160_80[154] @ 2464
	.field	32721,16		; r_window_160_80[155] @ 2480
	.field	32742,16		; r_window_160_80[156] @ 2496
	.field	32756,16		; r_window_160_80[157] @ 2512
	.field	32765,16		; r_window_160_80[158] @ 2528
	.field	32767,16		; r_window_160_80[159] @ 2544
	.field	32767,16		; r_window_160_80[160] @ 2560
	.field	32756,16		; r_window_160_80[161] @ 2576
	.field	32720,16		; r_window_160_80[162] @ 2592
	.field	32661,16		; r_window_160_80[163] @ 2608
	.field	32578,16		; r_window_160_80[164] @ 2624
	.field	32471,16		; r_window_160_80[165] @ 2640
	.field	32341,16		; r_window_160_80[166] @ 2656
	.field	32188,16		; r_window_160_80[167] @ 2672
	.field	32012,16		; r_window_160_80[168] @ 2688
	.field	31813,16		; r_window_160_80[169] @ 2704
	.field	31592,16		; r_window_160_80[170] @ 2720
	.field	31349,16		; r_window_160_80[171] @ 2736
	.field	31084,16		; r_window_160_80[172] @ 2752
	.field	30798,16		; r_window_160_80[173] @ 2768
	.field	30492,16		; r_window_160_80[174] @ 2784
	.field	30165,16		; r_window_160_80[175] @ 2800
	.field	29818,16		; r_window_160_80[176] @ 2816
	.field	29453,16		; r_window_160_80[177] @ 2832
	.field	29068,16		; r_window_160_80[178] @ 2848
	.field	28666,16		; r_window_160_80[179] @ 2864
	.field	28247,16		; r_window_160_80[180] @ 2880
	.field	27810,16		; r_window_160_80[181] @ 2896
	.field	27358,16		; r_window_160_80[182] @ 2912
	.field	26891,16		; r_window_160_80[183] @ 2928
	.field	26408,16		; r_window_160_80[184] @ 2944
	.field	25913,16		; r_window_160_80[185] @ 2960
	.field	25404,16		; r_window_160_80[186] @ 2976
	.field	24883,16		; r_window_160_80[187] @ 2992
	.field	24350,16		; r_window_160_80[188] @ 3008
	.field	23807,16		; r_window_160_80[189] @ 3024
	.field	23255,16		; r_window_160_80[190] @ 3040
	.field	22693,16		; r_window_160_80[191] @ 3056
	.field	22124,16		; r_window_160_80[192] @ 3072
	.field	21548,16		; r_window_160_80[193] @ 3088
	.field	20965,16		; r_window_160_80[194] @ 3104
	.field	20378,16		; r_window_160_80[195] @ 3120
	.field	19786,16		; r_window_160_80[196] @ 3136
	.field	19191,16		; r_window_160_80[197] @ 3152
	.field	18593,16		; r_window_160_80[198] @ 3168
	.field	17994,16		; r_window_160_80[199] @ 3184
	.field	17395,16		; r_window_160_80[200] @ 3200
	.field	16796,16		; r_window_160_80[201] @ 3216
	.field	16199,16		; r_window_160_80[202] @ 3232
	.field	15604,16		; r_window_160_80[203] @ 3248
	.field	15012,16		; r_window_160_80[204] @ 3264
	.field	14424,16		; r_window_160_80[205] @ 3280
	.field	13842,16		; r_window_160_80[206] @ 3296
	.field	13265,16		; r_window_160_80[207] @ 3312
	.field	12696,16		; r_window_160_80[208] @ 3328
	.field	12135,16		; r_window_160_80[209] @ 3344
	.field	11582,16		; r_window_160_80[210] @ 3360
	.field	11039,16		; r_window_160_80[211] @ 3376
	.field	10507,16		; r_window_160_80[212] @ 3392
	.field	9986,16 		; r_window_160_80[213] @ 3408
	.field	9477,16 		; r_window_160_80[214] @ 3424
	.field	8981,16 		; r_window_160_80[215] @ 3440
	.field	8499,16 		; r_window_160_80[216] @ 3456
	.field	8031,16 		; r_window_160_80[217] @ 3472
	.field	7579,16 		; r_window_160_80[218] @ 3488
	.field	7143,16 		; r_window_160_80[219] @ 3504
	.field	6723,16 		; r_window_160_80[220] @ 3520
	.field	6321,16 		; r_window_160_80[221] @ 3536
	.field	5937,16 		; r_window_160_80[222] @ 3552
	.field	5571,16 		; r_window_160_80[223] @ 3568
	.field	5225,16 		; r_window_160_80[224] @ 3584
	.field	4898,16 		; r_window_160_80[225] @ 3600
	.field	4591,16 		; r_window_160_80[226] @ 3616
	.field	4305,16 		; r_window_160_80[227] @ 3632
	.field	4041,16 		; r_window_160_80[228] @ 3648
	.field	3798,16 		; r_window_160_80[229] @ 3664
	.field	3577,16 		; r_window_160_80[230] @ 3680
	.field	3378,16 		; r_window_160_80[231] @ 3696
	.field	3202,16 		; r_window_160_80[232] @ 3712
	.field	3048,16 		; r_window_160_80[233] @ 3728
	.field	2918,16 		; r_window_160_80[234] @ 3744
	.field	2812,16 		; r_window_160_80[235] @ 3760
	.field	2729,16 		; r_window_160_80[236] @ 3776
	.field	2669,16 		; r_window_160_80[237] @ 3792
	.field	2633,16 		; r_window_160_80[238] @ 3808
	.field	2621,16 		; r_window_160_80[239] @ 3824
r_f_gamma1:
	.word	29491, 26542, 23888, 21499, 19349
	.word	17414, 15672, 14105, 12694, 11425

r_f_gamma2:
	.word	19661, 11797, 7078, 4247, 2548
	.word	1529, 917, 550, 330, 198

r_pred_6:
	.word	29443
	.word	28346,	 25207,   20449,   14701,    8693,    3143
	.word	-1352,	 -4402,   -5865,   -5850,   -4673,   -2783
	.word	-672,	 1211,	  2536,    3130,    2991,    2259
	.word	1170,	    0,	 -1001,   -1652,   -1868,   -1666
	.word	-1147,	  -464,     218,     756,    1060,    1099
	.word	904,	 550,	  135,	  -245,    -514,    -634
	.word	-602,	 -451,	  -231,       0,     191,     308
	.word	340,	 296,	  198,	    78,     -36,    -120
	.word	-163,	 -165,	  -132,     -79,     -19,      34
	.word	73,	 91,	  89,	   70,	    38,       0


r_inter_6:
	.word	29519
	.word	28316, 24906, 19838, 13896, 7945, 2755
	.word	-1127, -3459, -4304, -3969, -2899, -1561
	.word	-336, 534, 970, 1023, 823, 516
	.word	220, 0, -131, -194, -215, 0
r_qua_gain_pitch:
	.word	0, 3277, 6556, 8192, 9830, 11469, 12288, 13107
	.word	13926, 14746, 15565, 16384, 17203, 18022, 18842, 19661
    
r_qua_gain_code:
	.word	159, 206, 268, 349, 419, 482, 554, 637
	.word	733, 842, 969, 1114, 1281, 1473, 1694, 1948
	.word	2241, 2577, 2963, 3408, 3919, 4507, 5183, 5960
	.word	6855, 7883, 9065, 10425, 12510, 16263, 21142, 27485

r_dgray
    .word   0, 1, 3, 2, 5, 6, 4, 7


r_lsp_old:
	.word   30000
        .word   26000
        .word   21000
        .word   15000
        .word    8000
        .word       0
        .word   -8000
        .word  -15000
        .word  -21000
        .word  -26000

r_dhf_mask:	
	        .word	0x0004
		.word	0x002f
		.word	0x00b4
		.word	0x0090
		.word	0x003e

		.word	0x0156
		.word	0x000b
		.word	0x0000
		.word	0x0001
		.word	0x000f
		.word	0x0001
		.word	0x000d
		.word	0x0000
		.word	0x0003
		.word	0x0000
		.word	0x0003
		.word	0x0000
		.word	0x0003

		.word	0x0036
		.word	0x0001
		.word	0x0008
		.word	0x0008
		.word	0x0005
		.word	0x0008
		.word	0x0001
		.word	0x0000
		.word	0x0000
		.word	0x0001
		.word	0x0001
		.word	0x0000
		.word	0x0000

		.word	0x0156
		.word	0x0000
		.word	0x0000
		.word	0x0000
		.word	0x0000
		.word	0x0000
		.word	0x0000
		.word	0x0000
		.word	0x0000
		.word	0x0000
		.word	0x0000
		.word	0x0000
		.word	0x0000

		.word	0x0036
		.word	0x000b
		.word	0x0000
		.word	0x0000
		.word	0x0000
		.word	0x0000
		.word	0x0000
		.word	0x0000
		.word	0x0000
		.word	0x0000
		.word	0x0000
		.word	0x0000
		.word	0x0000

r_pdown:	.word   32767
		.word   32112
		.word   32112
		.word   26214
		.word	 9830
		.word	 6553
		.word	 6553

r_f_gamma3:
	                .word   22938
	                .word   16057
	                .word   11240
	                .word   7868
	                .word   5508
	                .word   3856
	                .word   2699
	                .word   1889
	                .word   1322
	                .word   925
	 
r_f_gamma4:
	                .word   24576
	                .word   18432
	                .word   13824
	                .word   10368
	                .word   7776
	                .word   5832
	                .word   4374
		        .word   3281
	                .word   2461
	                .word   1846

r_cdown:
		.word	32767 
		.word	32112 
		.word	32112 
		.word	32112
		.word   32112 
		.word	32112 
		.word	22937

r_interp_factor:.word	0x0555, 0x0aaa, 0x1000, 0x1555, 0x1aaa, 0x2000
		.word	0x2555, 0x2aaa, 0x3000, 0x3555, 0x3aaa, 0x4000
		.word	0x4555, 0x4aaa, 0x5000, 0x5555, 0x5aaa, 0x6000
		.word	0x6555, 0x6aaa, 0x7000, 0x7555, 0x7aaa, 0x7fff


r_ab	.word	7807, -3733			; a[1], a[2]
	.word	1899, -3798, 1899		; b[0], b[1], b[2]

r_sid_codeword:	.word	0x00101, 0x0f800, 0x0c060, 0x00078, 0x07fff
		.word	0x0f878, 0x00fff, 0x0ffff, 0x0ff87, 0x087ff
		.word	0x0f000


r_b     .word   1899, -3798, 1899
r_a     .word   4096, 7807, -3733

r_bitno .word  7, 8, 9, 8, 6
        .word  9, 4, 4, 4, 4, 4, 4, 3, 3, 3, 3, 3, 5
        .word  6, 4, 4, 4, 4, 4, 4, 3, 3, 3, 3, 3, 5
        .word  9, 4, 4, 4, 4, 4, 4, 3, 3, 3, 3, 3, 5
        .word  6, 4, 4, 4, 4, 4, 4, 3, 3, 3, 3, 3, 5

r_sid_codeword_bit:
        .word  45,  46,  48,  49,  50,  51,  52,  53,  54,  55
        .word  56,  57,  58,  59,  60,  61,  62,  63,  64,  65
        .word  66,  67,  68,  94,  95,  96,  98,  99, 100, 101
        .word  102, 103, 104, 105, 106, 107, 108, 109, 110, 111
        .word  112, 113, 114, 115, 116, 117, 118, 148, 149, 150
        .word  151, 152, 153, 154, 155, 156, 157, 158, 159, 160
        .word  161, 162, 163, 164, 165, 166, 167, 168, 169, 170
        .word  171, 196, 197, 198, 199, 200, 201, 202, 203, 204
        .word  205, 206, 207, 208, 209, 212, 213, 214, 215, 216
        .word  217, 218, 219, 220, 221

r_lag_h: .word 32728,32619,32438,32187,31867,31480,31029,30517,29946,29321

r_lag_l: .word 11904,17280,30720,25856,24192,28992,24384,7360,19520,14784

.end
