;***************************************************************
;
; File :	hstabrom.asm
;
; Description : ROM-table for GSM Half Rate Speech Codec
;               Modified from the output of Lead C-compiler.
;		And adapted to fit the guidelines.
;***************************************************************


rom_compat  .set 1

	.def	r_gsp0
	.def	r_uvcodevec
	.def	r_vcdcodevec
	.def	r_quant1
	.def	r_quant2
	.def	r_quant3
	.def	r_preq1
	.def	r_preq2
	.def	r_preq3

	.if	rom_compat
	.def	r_quantsz
	.def	r_preqsz
	.endif

	.def	r_squant
	.def	r_vqindex
	.def	r_sqrtp0
	.def	r_cgintfilt

	.if	rom_compat
	.def	r_pvecintfilt
	.endif

	.def	r_lagtbl

	.if	rom_compat
	.def	r_r0dectbl
	.def	r_bitalloc
	.def	r_bitallocunvoiced
	.def	r_symtosimorder
	.def	r_symtosimorderuv
	.def	r_shiftright
	.def	r_hpfcoefs
	.endif

	.def	r_nwcoefs
	.def	r_flatsstcoefs

	.if	rom_compat
	.def	r_oldcont
	.def	r_newcont
	.endif

	.def	r_spfdenomwidencf
	.def	r_sst
	.def	r_submultfactor

	.def	r_conceal
	.def	r_r0repeatthreshold
	.def	r_r0mutethreshold
	.def	r_levelmaxincrease
	.def	r_updateindexv
	.def	r_bitindexv
	.def	r_updateindexun
	.def	r_bitindexun

	.if	rom_compat
	.def	r_modnextbituv
	.def	r_modnextbitv
	.def	r_pcoefe
	.endif

	.sect	"hstabrom"

	.align	1

r_gsp0
	.field	33,16		; r_gsp0[0] @ 0
	.field	34,16		; r_gsp0[1] @ 16
	.field	0,16		; r_gsp0[2] @ 32
	.field	0,16		; r_gsp0[3] @ 48
	.field	0,16		; r_gsp0[4] @ 64
	.field	58,16		; r_gsp0[5] @ 80
	.field	63,16		; r_gsp0[6] @ 96
	.field	0,16		; r_gsp0[7] @ 112
	.field	0,16		; r_gsp0[8] @ 128
	.field	0,16		; r_gsp0[9] @ 144
	.field	85,16		; r_gsp0[10] @ 160
	.field	89,16		; r_gsp0[11] @ 176
	.field	0,16		; r_gsp0[12] @ 192
	.field	0,16		; r_gsp0[13] @ 208
	.field	0,16		; r_gsp0[14] @ 224
	.field	139,16		; r_gsp0[15] @ 240
	.field	149,16		; r_gsp0[16] @ 256
	.field	-1,16		; r_gsp0[17] @ 272
	.field	-1,16		; r_gsp0[18] @ 288
	.field	-1,16		; r_gsp0[19] @ 304
	.field	233,16		; r_gsp0[20] @ 320
	.field	235,16		; r_gsp0[21] @ 336
	.field	-3,16		; r_gsp0[22] @ 352
	.field	-2,16		; r_gsp0[23] @ 368
	.field	-2,16		; r_gsp0[24] @ 384
	.field	313,16		; r_gsp0[25] @ 400
	.field	329,16		; r_gsp0[26] @ 416
	.field	-6,16		; r_gsp0[27] @ 432
	.field	-3,16		; r_gsp0[28] @ 448
	.field	-3,16		; r_gsp0[29] @ 464
	.field	440,16		; r_gsp0[30] @ 480
	.field	456,16		; r_gsp0[31] @ 496
	.field	-12,16		; r_gsp0[32] @ 512
	.field	-6,16		; r_gsp0[33] @ 528
	.field	-6,16		; r_gsp0[34] @ 544
	.field	703,16		; r_gsp0[35] @ 560
	.field	530,16		; r_gsp0[36] @ 576
	.field	-23,16		; r_gsp0[37] @ 592
	.field	-15,16		; r_gsp0[38] @ 608
	.field	-9,16		; r_gsp0[39] @ 624
	.field	892,16		; r_gsp0[40] @ 640
	.field	767,16		; r_gsp0[41] @ 656
	.field	-42,16		; r_gsp0[42] @ 672
	.field	-24,16		; r_gsp0[43] @ 688
	.field	-18,16		; r_gsp0[44] @ 704
	.field	963,16		; r_gsp0[45] @ 720
	.field	1329,16 	; r_gsp0[46] @ 736
	.field	-78,16		; r_gsp0[47] @ 752
	.field	-28,16		; r_gsp0[48] @ 768
	.field	-54,16		; r_gsp0[49] @ 784
	.field	1447,16 	; r_gsp0[50] @ 800
	.field	1165,16 	; r_gsp0[51] @ 816
	.field	-103,16 	; r_gsp0[52] @ 832
	.field	-64,16		; r_gsp0[53] @ 848
	.field	-41,16		; r_gsp0[54] @ 864
	.field	1894,16 	; r_gsp0[55] @ 880
	.field	1362,16 	; r_gsp0[56] @ 896
	.field	-157,16 	; r_gsp0[57] @ 912
	.field	-109,16 	; r_gsp0[58] @ 928
	.field	-57,16		; r_gsp0[59] @ 944
	.field	1639,16 	; r_gsp0[60] @ 960
	.field	2194,16 	; r_gsp0[61] @ 976
	.field	-219,16 	; r_gsp0[62] @ 992
	.field	-82,16		; r_gsp0[63] @ 1008
	.field	-147,16 	; r_gsp0[64] @ 1024
	.field	2120,16 	; r_gsp0[65] @ 1040
	.field	3211,16 	; r_gsp0[66] @ 1056
	.field	-415,16 	; r_gsp0[67] @ 1072
	.field	-137,16 	; r_gsp0[68] @ 1088
	.field	-315,16 	; r_gsp0[69] @ 1104
	.field	2994,16 	; r_gsp0[70] @ 1120
	.field	2147,16 	; r_gsp0[71] @ 1136
	.field	-392,16 	; r_gsp0[72] @ 1152
	.field	-274,16 	; r_gsp0[73] @ 1168
	.field	-141,16 	; r_gsp0[74] @ 1184
	.field	4132,16 	; r_gsp0[75] @ 1200
	.field	2566,16 	; r_gsp0[76] @ 1216
	.field	-647,16 	; r_gsp0[77] @ 1232
	.field	-521,16 	; r_gsp0[78] @ 1248
	.field	-201,16 	; r_gsp0[79] @ 1264
	.field	3040,16 	; r_gsp0[80] @ 1280
	.field	4009,16 	; r_gsp0[81] @ 1296
	.field	-744,16 	; r_gsp0[82] @ 1312
	.field	-282,16 	; r_gsp0[83] @ 1328
	.field	-490,16 	; r_gsp0[84] @ 1344
	.field	4012,16 	; r_gsp0[85] @ 1360
	.field	5316,16 	; r_gsp0[86] @ 1376
	.field	-1302,16	; r_gsp0[87] @ 1392
	.field	-491,16 	; r_gsp0[88] @ 1408
	.field	-862,16 	; r_gsp0[89] @ 1424
	.field	5356,16 	; r_gsp0[90] @ 1440
	.field	3752,16 	; r_gsp0[91] @ 1456
	.field	-1226,16	; r_gsp0[92] @ 1472
	.field	-875,16 	; r_gsp0[93] @ 1488
	.field	-430,16 	; r_gsp0[94] @ 1504
	.field	7068,16 	; r_gsp0[95] @ 1520
	.field	4287,16 	; r_gsp0[96] @ 1536
	.field	-1850,16	; r_gsp0[97] @ 1552
	.field	-1525,16	; r_gsp0[98] @ 1568
	.field	-561,16 	; r_gsp0[99] @ 1584
	.field	4927,16 	; r_gsp0[100] @ 1600
	.field	7072,16 	; r_gsp0[101] @ 1616
	.field	-2127,16	; r_gsp0[102] @ 1632
	.field	-741,16 	; r_gsp0[103] @ 1648
	.field	-1526,16	; r_gsp0[104] @ 1664
	.field	6996,16 	; r_gsp0[105] @ 1680
	.field	7304,16 	; r_gsp0[106] @ 1696
	.field	-3118,16	; r_gsp0[107] @ 1712
	.field	-1493,16	; r_gsp0[108] @ 1728
	.field	-1628,16	; r_gsp0[109] @ 1744
	.field	9047,16 	; r_gsp0[110] @ 1760
	.field	6154,16 	; r_gsp0[111] @ 1776
	.field	-3398,16	; r_gsp0[112] @ 1792
	.field	-2498,16	; r_gsp0[113] @ 1808
	.field	-1156,16	; r_gsp0[114] @ 1824
	.field	11747,16	; r_gsp0[115] @ 1840
	.field	6009,16 	; r_gsp0[116] @ 1856
	.field	-4309,16	; r_gsp0[117] @ 1872
	.field	-4211,16	; r_gsp0[118] @ 1888
	.field	-1102,16	; r_gsp0[119] @ 1904
	.field	5144,16 	; r_gsp0[120] @ 1920
	.field	10368,16	; r_gsp0[121] @ 1936
	.field	-3255,16	; r_gsp0[122] @ 1952
	.field	-808,16 	; r_gsp0[123] @ 1968
	.field	-3280,16	; r_gsp0[124] @ 1984
	.field	7677,16 	; r_gsp0[125] @ 2000
	.field	12151,16	; r_gsp0[126] @ 2016
	.field	-5693,16	; r_gsp0[127] @ 2032
	.field	-1798,16	; r_gsp0[128] @ 2048
	.field	-4506,16	; r_gsp0[129] @ 2064
	.field	8796,16 	; r_gsp0[130] @ 2080
	.field	9286,16 	; r_gsp0[131] @ 2096
	.field	-4986,16	; r_gsp0[132] @ 2112
	.field	-2361,16	; r_gsp0[133] @ 2128
	.field	-2632,16	; r_gsp0[134] @ 2144
	.field	11323,16	; r_gsp0[135] @ 2160
	.field	9802,16 	; r_gsp0[136] @ 2176
	.field	-6774,16	; r_gsp0[137] @ 2192
	.field	-3912,16	; r_gsp0[138] @ 2208
	.field	-2932,16	; r_gsp0[139] @ 2224
	.field	10555,16	; r_gsp0[140] @ 2240
	.field	15059,16	; r_gsp0[141] @ 2256
	.field	-9701,16	; r_gsp0[142] @ 2272
	.field	-3400,16	; r_gsp0[143] @ 2288
	.field	-6920,16	; r_gsp0[144] @ 2304
	.field	17566,16	; r_gsp0[145] @ 2320
	.field	15641,16	; r_gsp0[146] @ 2336
	.field	-16769,16	; r_gsp0[147] @ 2352
	.field	-9417,16	; r_gsp0[148] @ 2368
	.field	-7465,16	; r_gsp0[149] @ 2384
	.field	13934,16	; r_gsp0[150] @ 2400
	.field	9966,16 	; r_gsp0[151] @ 2416
	.field	-8476,16	; r_gsp0[152] @ 2432
	.field	-5925,16	; r_gsp0[153] @ 2448
	.field	-3031,16	; r_gsp0[154] @ 2464
	.field	17646,16	; r_gsp0[155] @ 2480
	.field	8051,16 	; r_gsp0[156] @ 2496
	.field	-8672,16	; r_gsp0[157] @ 2512
	.field	-9503,16	; r_gsp0[158] @ 2528
	.field	-1978,16	; r_gsp0[159] @ 2544
	.field	65,16		; r_gsp0[160] @ 2560
	.field	62,16		; r_gsp0[161] @ 2576
	.field	0,16		; r_gsp0[162] @ 2592
	.field	0,16		; r_gsp0[163] @ 2608
	.field	0,16		; r_gsp0[164] @ 2624
	.field	199,16		; r_gsp0[165] @ 2640
	.field	174,16		; r_gsp0[166] @ 2656
	.field	-2,16		; r_gsp0[167] @ 2672
	.field	-1,16		; r_gsp0[168] @ 2688
	.field	-1,16		; r_gsp0[169] @ 2704
	.field	526,16		; r_gsp0[170] @ 2720
	.field	613,16		; r_gsp0[171] @ 2736
	.field	-20,16		; r_gsp0[172] @ 2752
	.field	-8,16		; r_gsp0[173] @ 2768
	.field	-11,16		; r_gsp0[174] @ 2784
	.field	705,16		; r_gsp0[175] @ 2800
	.field	1191,16 	; r_gsp0[176] @ 2816
	.field	-51,16		; r_gsp0[177] @ 2832
	.field	-15,16		; r_gsp0[178] @ 2848
	.field	-43,16		; r_gsp0[179] @ 2864
	.field	1695,16 	; r_gsp0[180] @ 2880
	.field	1067,16 	; r_gsp0[181] @ 2896
	.field	-110,16 	; r_gsp0[182] @ 2912
	.field	-88,16		; r_gsp0[183] @ 2928
	.field	-35,16		; r_gsp0[184] @ 2944
	.field	2176,16 	; r_gsp0[185] @ 2960
	.field	1897,16 	; r_gsp0[186] @ 2976
	.field	-252,16 	; r_gsp0[187] @ 2992
	.field	-144,16 	; r_gsp0[188] @ 3008
	.field	-110,16 	; r_gsp0[189] @ 3024
	.field	848,16		; r_gsp0[190] @ 3040
	.field	3038,16 	; r_gsp0[191] @ 3056
	.field	-157,16 	; r_gsp0[192] @ 3072
	.field	-22,16		; r_gsp0[193] @ 3088
	.field	-282,16 	; r_gsp0[194] @ 3104
	.field	2105,16 	; r_gsp0[195] @ 3120
	.field	3693,16 	; r_gsp0[196] @ 3136
	.field	-474,16 	; r_gsp0[197] @ 3152
	.field	-135,16 	; r_gsp0[198] @ 3168
	.field	-416,16 	; r_gsp0[199] @ 3184
	.field	3483,16 	; r_gsp0[200] @ 3200
	.field	1605,16 	; r_gsp0[201] @ 3216
	.field	-341,16 	; r_gsp0[202] @ 3232
	.field	-370,16 	; r_gsp0[203] @ 3248
	.field	-79,16		; r_gsp0[204] @ 3264
	.field	3552,16 	; r_gsp0[205] @ 3280
	.field	3236,16 	; r_gsp0[206] @ 3296
	.field	-702,16 	; r_gsp0[207] @ 3312
	.field	-385,16 	; r_gsp0[208] @ 3328
	.field	-320,16 	; r_gsp0[209] @ 3344
	.field	4869,16 	; r_gsp0[210] @ 3360
	.field	2028,16 	; r_gsp0[211] @ 3376
	.field	-603,16 	; r_gsp0[212] @ 3392
	.field	-723,16 	; r_gsp0[213] @ 3408
	.field	-126,16 	; r_gsp0[214] @ 3424
	.field	6296,16 	; r_gsp0[215] @ 3440
	.field	2220,16 	; r_gsp0[216] @ 3456
	.field	-853,16 	; r_gsp0[217] @ 3472
	.field	-1210,16	; r_gsp0[218] @ 3488
	.field	-150,16 	; r_gsp0[219] @ 3504
	.field	1425,16 	; r_gsp0[220] @ 3520
	.field	5682,16 	; r_gsp0[221] @ 3536
	.field	-494,16 	; r_gsp0[222] @ 3552
	.field	-62,16		; r_gsp0[223] @ 3568
	.field	-985,16 	; r_gsp0[224] @ 3584
	.field	3538,16 	; r_gsp0[225] @ 3600
	.field	5556,16 	; r_gsp0[226] @ 3616
	.field	-1200,16	; r_gsp0[227] @ 3632
	.field	-382,16 	; r_gsp0[228] @ 3648
	.field	-942,16 	; r_gsp0[229] @ 3664
	.field	1468,16 	; r_gsp0[230] @ 3680
	.field	8528,16 	; r_gsp0[231] @ 3696
	.field	-764,16 	; r_gsp0[232] @ 3712
	.field	-66,16		; r_gsp0[233] @ 3728
	.field	-2219,16	; r_gsp0[234] @ 3744
	.field	4805,16 	; r_gsp0[235] @ 3760
	.field	8004,16 	; r_gsp0[236] @ 3776
	.field	-2347,16	; r_gsp0[237] @ 3792
	.field	-705,16 	; r_gsp0[238] @ 3808
	.field	-1955,16	; r_gsp0[239] @ 3824
	.field	5189,16 	; r_gsp0[240] @ 3840
	.field	4143,16 	; r_gsp0[241] @ 3856
	.field	-1312,16	; r_gsp0[242] @ 3872
	.field	-822,16 	; r_gsp0[243] @ 3888
	.field	-524,16 	; r_gsp0[244] @ 3904
	.field	6409,16 	; r_gsp0[245] @ 3920
	.field	5573,16 	; r_gsp0[246] @ 3936
	.field	-2180,16	; r_gsp0[247] @ 3952
	.field	-1254,16	; r_gsp0[248] @ 3968
	.field	-948,16 	; r_gsp0[249] @ 3984
	.field	7493,16 	; r_gsp0[250] @ 4000
	.field	2955,16 	; r_gsp0[251] @ 4016
	.field	-1351,16	; r_gsp0[252] @ 4032
	.field	-1713,16	; r_gsp0[253] @ 4048
	.field	-266,16 	; r_gsp0[254] @ 4064
	.field	8902,16 	; r_gsp0[255] @ 4080
	.field	2344,16 	; r_gsp0[256] @ 4096
	.field	-1274,16	; r_gsp0[257] @ 4112
	.field	-2418,16	; r_gsp0[258] @ 4128
	.field	-168,16 	; r_gsp0[259] @ 4144
	.field	8212,16 	; r_gsp0[260] @ 4160
	.field	5266,16 	; r_gsp0[261] @ 4176
	.field	-2639,16	; r_gsp0[262] @ 4192
	.field	-2058,16	; r_gsp0[263] @ 4208
	.field	-846,16 	; r_gsp0[264] @ 4224
	.field	10190,16	; r_gsp0[265] @ 4240
	.field	5396,16 	; r_gsp0[266] @ 4256
	.field	-3356,16	; r_gsp0[267] @ 4272
	.field	-3169,16	; r_gsp0[268] @ 4288
	.field	-889,16 	; r_gsp0[269] @ 4304
	.field	10556,16	; r_gsp0[270] @ 4320
	.field	3007,16 	; r_gsp0[271] @ 4336
	.field	-1938,16	; r_gsp0[272] @ 4352
	.field	-3401,16	; r_gsp0[273] @ 4368
	.field	-276,16 	; r_gsp0[274] @ 4384
	.field	12517,16	; r_gsp0[275] @ 4400
	.field	2934,16 	; r_gsp0[276] @ 4416
	.field	-2242,16	; r_gsp0[277] @ 4432
	.field	-4781,16	; r_gsp0[278] @ 4448
	.field	-263,16 	; r_gsp0[279] @ 4464
	.field	5383,16 	; r_gsp0[280] @ 4480
	.field	11357,16	; r_gsp0[281] @ 4496
	.field	-3731,16	; r_gsp0[282] @ 4512
	.field	-884,16 	; r_gsp0[283] @ 4528
	.field	-3936,16	; r_gsp0[284] @ 4544
	.field	9432,16 	; r_gsp0[285] @ 4560
	.field	9038,16 	; r_gsp0[286] @ 4576
	.field	-5203,16	; r_gsp0[287] @ 4592
	.field	-2715,16	; r_gsp0[288] @ 4608
	.field	-2493,16	; r_gsp0[289] @ 4624
	.field	7993,16 	; r_gsp0[290] @ 4640
	.field	17273,16	; r_gsp0[291] @ 4656
	.field	-8426,16	; r_gsp0[292] @ 4672
	.field	-1950,16	; r_gsp0[293] @ 4688
	.field	-9105,16	; r_gsp0[294] @ 4704
	.field	16236,16	; r_gsp0[295] @ 4720
	.field	12894,16	; r_gsp0[296] @ 4736
	.field	-12778,16	; r_gsp0[297] @ 4752
	.field	-8045,16	; r_gsp0[298] @ 4768
	.field	-5073,16	; r_gsp0[299] @ 4784
	.field	12832,16	; r_gsp0[300] @ 4800
	.field	6896,16 	; r_gsp0[301] @ 4816
	.field	-5401,16	; r_gsp0[302] @ 4832
	.field	-5025,16	; r_gsp0[303] @ 4848
	.field	-1451,16	; r_gsp0[304] @ 4864
	.field	14842,16	; r_gsp0[305] @ 4880
	.field	4024,16 	; r_gsp0[306] @ 4896
	.field	-3645,16	; r_gsp0[307] @ 4912
	.field	-6723,16	; r_gsp0[308] @ 4928
	.field	-494,16 	; r_gsp0[309] @ 4944
	.field	18013,16	; r_gsp0[310] @ 4960
	.field	7332,16 	; r_gsp0[311] @ 4976
	.field	-8062,16	; r_gsp0[312] @ 4992
	.field	-9902,16	; r_gsp0[313] @ 5008
	.field	-1641,16	; r_gsp0[314] @ 5024
	.field	19019,16	; r_gsp0[315] @ 5040
	.field	3737,16 	; r_gsp0[316] @ 5056
	.field	-4338,16	; r_gsp0[317] @ 5072
	.field	-11039,16	; r_gsp0[318] @ 5088
	.field	-426,16 	; r_gsp0[319] @ 5104
	.field	1004,16 	; r_gsp0[320] @ 5120
	.field	731,16		; r_gsp0[321] @ 5136
	.field	-45,16		; r_gsp0[322] @ 5152
	.field	-31,16		; r_gsp0[323] @ 5168
	.field	-16,16		; r_gsp0[324] @ 5184
	.field	1412,16 	; r_gsp0[325] @ 5200
	.field	1843,16 	; r_gsp0[326] @ 5216
	.field	-159,16 	; r_gsp0[327] @ 5232
	.field	-61,16		; r_gsp0[328] @ 5248
	.field	-104,16 	; r_gsp0[329] @ 5264
	.field	2700,16 	; r_gsp0[330] @ 5280
	.field	1489,16 	; r_gsp0[331] @ 5296
	.field	-245,16 	; r_gsp0[332] @ 5312
	.field	-222,16 	; r_gsp0[333] @ 5328
	.field	-68,16		; r_gsp0[334] @ 5344
	.field	2785,16 	; r_gsp0[335] @ 5360
	.field	2657,16 	; r_gsp0[336] @ 5376
	.field	-452,16 	; r_gsp0[337] @ 5392
	.field	-237,16 	; r_gsp0[338] @ 5408
	.field	-215,16 	; r_gsp0[339] @ 5424
	.field	4054,16 	; r_gsp0[340] @ 5440
	.field	1682,16 	; r_gsp0[341] @ 5456
	.field	-416,16 	; r_gsp0[342] @ 5472
	.field	-502,16 	; r_gsp0[343] @ 5488
	.field	-86,16		; r_gsp0[344] @ 5504
	.field	4499,16 	; r_gsp0[345] @ 5520
	.field	2664,16 	; r_gsp0[346] @ 5536
	.field	-732,16 	; r_gsp0[347] @ 5552
	.field	-618,16 	; r_gsp0[348] @ 5568
	.field	-217,16 	; r_gsp0[349] @ 5584
	.field	5155,16 	; r_gsp0[350] @ 5600
	.field	1429,16 	; r_gsp0[351] @ 5616
	.field	-450,16 	; r_gsp0[352] @ 5632
	.field	-811,16 	; r_gsp0[353] @ 5648
	.field	-62,16		; r_gsp0[354] @ 5664
	.field	6006,16 	; r_gsp0[355] @ 5680
	.field	1561,16 	; r_gsp0[356] @ 5696
	.field	-572,16 	; r_gsp0[357] @ 5712
	.field	-1101,16	; r_gsp0[358] @ 5728
	.field	-74,16		; r_gsp0[359] @ 5744
	.field	3421,16 	; r_gsp0[360] @ 5760
	.field	4218,16 	; r_gsp0[361] @ 5776
	.field	-881,16 	; r_gsp0[362] @ 5792
	.field	-357,16 	; r_gsp0[363] @ 5808
	.field	-543,16 	; r_gsp0[364] @ 5824
	.field	4313,16 	; r_gsp0[365] @ 5840
	.field	5518,16 	; r_gsp0[366] @ 5856
	.field	-1452,16	; r_gsp0[367] @ 5872
	.field	-568,16 	; r_gsp0[368] @ 5888
	.field	-929,16 	; r_gsp0[369] @ 5904
	.field	5540,16 	; r_gsp0[370] @ 5920
	.field	3384,16 	; r_gsp0[371] @ 5936
	.field	-1144,16	; r_gsp0[372] @ 5952
	.field	-937,16 	; r_gsp0[373] @ 5968
	.field	-350,16 	; r_gsp0[374] @ 5984
	.field	6832,16 	; r_gsp0[375] @ 6000
	.field	3531,16 	; r_gsp0[376] @ 6016
	.field	-1472,16	; r_gsp0[377] @ 6032
	.field	-1424,16	; r_gsp0[378] @ 6048
	.field	-381,16 	; r_gsp0[379] @ 6064
	.field	6382,16 	; r_gsp0[380] @ 6080
	.field	2333,16 	; r_gsp0[381] @ 6096
	.field	-909,16 	; r_gsp0[382] @ 6112
	.field	-1243,16	; r_gsp0[383] @ 6128
	.field	-166,16 	; r_gsp0[384] @ 6144
	.field	7417,16 	; r_gsp0[385] @ 6160
	.field	1574,16 	; r_gsp0[386] @ 6176
	.field	-713,16 	; r_gsp0[387] @ 6192
	.field	-1679,16	; r_gsp0[388] @ 6208
	.field	-76,16		; r_gsp0[389] @ 6224
	.field	8037,16 	; r_gsp0[390] @ 6240
	.field	2688,16 	; r_gsp0[391] @ 6256
	.field	-1319,16	; r_gsp0[392] @ 6272
	.field	-1971,16	; r_gsp0[393] @ 6288
	.field	-221,16 	; r_gsp0[394] @ 6304
	.field	9014,16 	; r_gsp0[395] @ 6320
	.field	1637,16 	; r_gsp0[396] @ 6336
	.field	-900,16 	; r_gsp0[397] @ 6352
	.field	-2479,16	; r_gsp0[398] @ 6368
	.field	-82,16		; r_gsp0[399] @ 6384
	.field	6141,16 	; r_gsp0[400] @ 6400
	.field	6173,16 	; r_gsp0[401] @ 6416
	.field	-2314,16	; r_gsp0[402] @ 6432
	.field	-1151,16	; r_gsp0[403] @ 6448
	.field	-1163,16	; r_gsp0[404] @ 6464
	.field	7883,16 	; r_gsp0[405] @ 6480
	.field	4573,16 	; r_gsp0[406] @ 6496
	.field	-2201,16	; r_gsp0[407] @ 6512
	.field	-1896,16	; r_gsp0[408] @ 6528
	.field	-638,16 	; r_gsp0[409] @ 6544
	.field	8608,16 	; r_gsp0[410] @ 6560
	.field	7132,16 	; r_gsp0[411] @ 6576
	.field	-3747,16	; r_gsp0[412] @ 6592
	.field	-2261,16	; r_gsp0[413] @ 6608
	.field	-1552,16	; r_gsp0[414] @ 6624
	.field	10098,16	; r_gsp0[415] @ 6640
	.field	4698,16 	; r_gsp0[416] @ 6656
	.field	-2896,16	; r_gsp0[417] @ 6672
	.field	-3112,16	; r_gsp0[418] @ 6688
	.field	-674,16 	; r_gsp0[419] @ 6704
	.field	9036,16 	; r_gsp0[420] @ 6720
	.field	3633,16 	; r_gsp0[421] @ 6736
	.field	-2004,16	; r_gsp0[422] @ 6752
	.field	-2492,16	; r_gsp0[423] @ 6768
	.field	-403,16 	; r_gsp0[424] @ 6784
	.field	9953,16 	; r_gsp0[425] @ 6800
	.field	2317,16 	; r_gsp0[426] @ 6816
	.field	-1408,16	; r_gsp0[427] @ 6832
	.field	-3023,16	; r_gsp0[428] @ 6848
	.field	-164,16 	; r_gsp0[429] @ 6864
	.field	11108,16	; r_gsp0[430] @ 6880
	.field	3228,16 	; r_gsp0[431] @ 6896
	.field	-2188,16	; r_gsp0[432] @ 6912
	.field	-3766,16	; r_gsp0[433] @ 6928
	.field	-318,16 	; r_gsp0[434] @ 6944
	.field	11570,16	; r_gsp0[435] @ 6960
	.field	1843,16 	; r_gsp0[436] @ 6976
	.field	-1302,16	; r_gsp0[437] @ 6992
	.field	-4085,16	; r_gsp0[438] @ 7008
	.field	-104,16 	; r_gsp0[439] @ 7024
	.field	11706,16	; r_gsp0[440] @ 7040
	.field	6610,16 	; r_gsp0[441] @ 7056
	.field	-4723,16	; r_gsp0[442] @ 7072
	.field	-4182,16	; r_gsp0[443] @ 7088
	.field	-1333,16	; r_gsp0[444] @ 7104
	.field	13128,16	; r_gsp0[445] @ 7120
	.field	4692,16 	; r_gsp0[446] @ 7136
	.field	-3760,16	; r_gsp0[447] @ 7152
	.field	-5260,16	; r_gsp0[448] @ 7168
	.field	-672,16 	; r_gsp0[449] @ 7184
	.field	12725,16	; r_gsp0[450] @ 7200
	.field	2951,16 	; r_gsp0[451] @ 7216
	.field	-2292,16	; r_gsp0[452] @ 7232
	.field	-4942,16	; r_gsp0[453] @ 7248
	.field	-266,16 	; r_gsp0[454] @ 7264
	.field	14028,16	; r_gsp0[455] @ 7280
	.field	2325,16 	; r_gsp0[456] @ 7296
	.field	-1990,16	; r_gsp0[457] @ 7312
	.field	-6005,16	; r_gsp0[458] @ 7328
	.field	-165,16 	; r_gsp0[459] @ 7344
	.field	16126,16	; r_gsp0[460] @ 7360
	.field	7702,16 	; r_gsp0[461] @ 7376
	.field	-7580,16	; r_gsp0[462] @ 7392
	.field	-7936,16	; r_gsp0[463] @ 7408
	.field	-1810,16	; r_gsp0[464] @ 7424
	.field	15583,16	; r_gsp0[465] @ 7440
	.field	4486,16 	; r_gsp0[466] @ 7456
	.field	-4267,16	; r_gsp0[467] @ 7472
	.field	-7411,16	; r_gsp0[468] @ 7488
	.field	-614,16 	; r_gsp0[469] @ 7504
	.field	16137,16	; r_gsp0[470] @ 7520
	.field	2609,16 	; r_gsp0[471] @ 7536
	.field	-2569,16	; r_gsp0[472] @ 7552
	.field	-7947,16	; r_gsp0[473] @ 7568
	.field	-208,16 	; r_gsp0[474] @ 7584
	.field	19264,16	; r_gsp0[475] @ 7600
	.field	3907,16 	; r_gsp0[476] @ 7616
	.field	-4593,16	; r_gsp0[477] @ 7632
	.field	-11325,16	; r_gsp0[478] @ 7648
	.field	-466,16 	; r_gsp0[479] @ 7664
	.field	1900,16 	; r_gsp0[480] @ 7680
	.field	1716,16 	; r_gsp0[481] @ 7696
	.field	-199,16 	; r_gsp0[482] @ 7712
	.field	-110,16 	; r_gsp0[483] @ 7728
	.field	-90,16		; r_gsp0[484] @ 7744
	.field	2946,16 	; r_gsp0[485] @ 7760
	.field	979,16		; r_gsp0[486] @ 7776
	.field	-176,16 	; r_gsp0[487] @ 7792
	.field	-265,16 	; r_gsp0[488] @ 7808
	.field	-29,16		; r_gsp0[489] @ 7824
	.field	3683,16 	; r_gsp0[490] @ 7840
	.field	842,16		; r_gsp0[491] @ 7856
	.field	-189,16 	; r_gsp0[492] @ 7872
	.field	-414,16 	; r_gsp0[493] @ 7888
	.field	-22,16		; r_gsp0[494] @ 7904
	.field	4395,16 	; r_gsp0[495] @ 7920
	.field	1025,16 	; r_gsp0[496] @ 7936
	.field	-275,16 	; r_gsp0[497] @ 7952
	.field	-589,16 	; r_gsp0[498] @ 7968
	.field	-32,16		; r_gsp0[499] @ 7984
	.field	3540,16 	; r_gsp0[500] @ 8000
	.field	2364,16 	; r_gsp0[501] @ 8016
	.field	-511,16 	; r_gsp0[502] @ 8032
	.field	-382,16 	; r_gsp0[503] @ 8048
	.field	-171,16 	; r_gsp0[504] @ 8064
	.field	5001,16 	; r_gsp0[505] @ 8080
	.field	1944,16 	; r_gsp0[506] @ 8096
	.field	-594,16 	; r_gsp0[507] @ 8112
	.field	-763,16 	; r_gsp0[508] @ 8128
	.field	-115,16 	; r_gsp0[509] @ 8144
	.field	5189,16 	; r_gsp0[510] @ 8160
	.field	852,16		; r_gsp0[511] @ 8176
	.field	-270,16 	; r_gsp0[512] @ 8192
	.field	-822,16 	; r_gsp0[513] @ 8208
	.field	-22,16		; r_gsp0[514] @ 8224
	.field	5862,16 	; r_gsp0[515] @ 8240
	.field	1050,16 	; r_gsp0[516] @ 8256
	.field	-376,16 	; r_gsp0[517] @ 8272
	.field	-1049,16	; r_gsp0[518] @ 8288
	.field	-34,16		; r_gsp0[519] @ 8304
	.field	5221,16 	; r_gsp0[520] @ 8320
	.field	2984,16 	; r_gsp0[521] @ 8336
	.field	-951,16 	; r_gsp0[522] @ 8352
	.field	-832,16 	; r_gsp0[523] @ 8368
	.field	-272,16 	; r_gsp0[524] @ 8384
	.field	6189,16 	; r_gsp0[525] @ 8400
	.field	3184,16 	; r_gsp0[526] @ 8416
	.field	-1203,16	; r_gsp0[527] @ 8432
	.field	-1169,16	; r_gsp0[528] @ 8448
	.field	-309,16 	; r_gsp0[529] @ 8464
	.field	6408,16 	; r_gsp0[530] @ 8480
	.field	1263,16 	; r_gsp0[531] @ 8496
	.field	-494,16 	; r_gsp0[532] @ 8512
	.field	-1253,16	; r_gsp0[533] @ 8528
	.field	-49,16		; r_gsp0[534] @ 8544
	.field	7032,16 	; r_gsp0[535] @ 8560
	.field	1044,16 	; r_gsp0[536] @ 8576
	.field	-448,16 	; r_gsp0[537] @ 8592
	.field	-1509,16	; r_gsp0[538] @ 8608
	.field	-33,16		; r_gsp0[539] @ 8624
	.field	6965,16 	; r_gsp0[540] @ 8640
	.field	2270,16 	; r_gsp0[541] @ 8656
	.field	-965,16 	; r_gsp0[542] @ 8672
	.field	-1481,16	; r_gsp0[543] @ 8688
	.field	-157,16 	; r_gsp0[544] @ 8704
	.field	7875,16 	; r_gsp0[545] @ 8720
	.field	2276,16 	; r_gsp0[546] @ 8736
	.field	-1094,16	; r_gsp0[547] @ 8752
	.field	-1893,16	; r_gsp0[548] @ 8768
	.field	-158,16 	; r_gsp0[549] @ 8784
	.field	7691,16 	; r_gsp0[550] @ 8800
	.field	1181,16 	; r_gsp0[551] @ 8816
	.field	-554,16 	; r_gsp0[552] @ 8832
	.field	-1805,16	; r_gsp0[553] @ 8848
	.field	-43,16		; r_gsp0[554] @ 8864
	.field	8365,16 	; r_gsp0[555] @ 8880
	.field	944,16		; r_gsp0[556] @ 8896
	.field	-482,16 	; r_gsp0[557] @ 8912
	.field	-2135,16	; r_gsp0[558] @ 8928
	.field	-27,16		; r_gsp0[559] @ 8944
	.field	7657,16 	; r_gsp0[560] @ 8960
	.field	4252,16 	; r_gsp0[561] @ 8976
	.field	-1987,16	; r_gsp0[562] @ 8992
	.field	-1789,16	; r_gsp0[563] @ 9008
	.field	-552,16 	; r_gsp0[564] @ 9024
	.field	8878,16 	; r_gsp0[565] @ 9040
	.field	2876,16 	; r_gsp0[566] @ 9056
	.field	-1559,16	; r_gsp0[567] @ 9072
	.field	-2405,16	; r_gsp0[568] @ 9088
	.field	-253,16 	; r_gsp0[569] @ 9104
	.field	8733,16 	; r_gsp0[570] @ 9120
	.field	1813,16 	; r_gsp0[571] @ 9136
	.field	-966,16 	; r_gsp0[572] @ 9152
	.field	-2328,16	; r_gsp0[573] @ 9168
	.field	-100,16 	; r_gsp0[574] @ 9184
	.field	9279,16 	; r_gsp0[575] @ 9200
	.field	1167,16 	; r_gsp0[576] @ 9216
	.field	-661,16 	; r_gsp0[577] @ 9232
	.field	-2628,16	; r_gsp0[578] @ 9248
	.field	-42,16		; r_gsp0[579] @ 9264
	.field	9894,16 	; r_gsp0[580] @ 9280
	.field	3465,16 	; r_gsp0[581] @ 9296
	.field	-2092,16	; r_gsp0[582] @ 9312
	.field	-2988,16	; r_gsp0[583] @ 9328
	.field	-366,16 	; r_gsp0[584] @ 9344
	.field	10615,16	; r_gsp0[585] @ 9360
	.field	2340,16 	; r_gsp0[586] @ 9376
	.field	-1516,16	; r_gsp0[587] @ 9392
	.field	-3439,16	; r_gsp0[588] @ 9408
	.field	-167,16 	; r_gsp0[589] @ 9424
	.field	10057,16	; r_gsp0[590] @ 9440
	.field	1444,16 	; r_gsp0[591] @ 9456
	.field	-886,16 	; r_gsp0[592] @ 9472
	.field	-3087,16	; r_gsp0[593] @ 9488
	.field	-64,16		; r_gsp0[594] @ 9504
	.field	10975,16	; r_gsp0[595] @ 9520
	.field	1209,16 	; r_gsp0[596] @ 9536
	.field	-810,16 	; r_gsp0[597] @ 9552
	.field	-3676,16	; r_gsp0[598] @ 9568
	.field	-45,16		; r_gsp0[599] @ 9584
	.field	11358,16	; r_gsp0[600] @ 9600
	.field	4510,16 	; r_gsp0[601] @ 9616
	.field	-3127,16	; r_gsp0[602] @ 9632
	.field	-3937,16	; r_gsp0[603] @ 9648
	.field	-621,16 	; r_gsp0[604] @ 9664
	.field	12248,16	; r_gsp0[605] @ 9680
	.field	2748,16 	; r_gsp0[606] @ 9696
	.field	-2054,16	; r_gsp0[607] @ 9712
	.field	-4578,16	; r_gsp0[608] @ 9728
	.field	-230,16 	; r_gsp0[609] @ 9744
	.field	11824,16	; r_gsp0[610] @ 9760
	.field	1559,16 	; r_gsp0[611] @ 9776
	.field	-1125,16	; r_gsp0[612] @ 9792
	.field	-4267,16	; r_gsp0[613] @ 9808
	.field	-74,16		; r_gsp0[614] @ 9824
	.field	12838,16	; r_gsp0[615] @ 9840
	.field	1441,16 	; r_gsp0[616] @ 9856
	.field	-1129,16	; r_gsp0[617] @ 9872
	.field	-5030,16	; r_gsp0[618] @ 9888
	.field	-63,16		; r_gsp0[619] @ 9904
	.field	13808,16	; r_gsp0[620] @ 9920
	.field	3978,16 	; r_gsp0[621] @ 9936
	.field	-3353,16	; r_gsp0[622] @ 9952
	.field	-5819,16	; r_gsp0[623] @ 9968
	.field	-483,16 	; r_gsp0[624] @ 9984
	.field	14250,16	; r_gsp0[625] @ 10000
	.field	1928,16 	; r_gsp0[626] @ 10016
	.field	-1677,16	; r_gsp0[627] @ 10032
	.field	-6197,16	; r_gsp0[628] @ 10048
	.field	-113,16 	; r_gsp0[629] @ 10064
	.field	16642,16	; r_gsp0[630] @ 10080
	.field	3962,16 	; r_gsp0[631] @ 10096
	.field	-4025,16	; r_gsp0[632] @ 10112
	.field	-8452,16	; r_gsp0[633] @ 10128
	.field	-479,16 	; r_gsp0[634] @ 10144
	.field	16641,16	; r_gsp0[635] @ 10160
	.field	1762,16 	; r_gsp0[636] @ 10176
	.field	-1790,16	; r_gsp0[637] @ 10192
	.field	-8451,16	; r_gsp0[638] @ 10208
	.field	-95,16		; r_gsp0[639] @ 10224


r_uvcodevec
	.field	12,16		; r_uvcodevec[0] @ 0				UvCodeVec[0] @ 0
	.field	11,16		; r_uvcodevec[1] @ 16
	.field	-49,16		; r_uvcodevec[2] @ 32
	.field	-53,16		; r_uvcodevec[3] @ 48
	.field	9,16		; r_uvcodevec[4] @ 64
	.field	-45,16		; r_uvcodevec[5] @ 80
	.field	-19,16		; r_uvcodevec[6] @ 96
	.field	-59,16		; r_uvcodevec[7] @ 112
	.field	-88,16		; r_uvcodevec[8] @ 128
	.field	43,16		; r_uvcodevec[9] @ 144
	.field	2,16		; r_uvcodevec[10] @ 160
	.field	-15,16		; r_uvcodevec[11] @ 176
	.field	17,16		; r_uvcodevec[12] @ 192
	.field	-18,16		; r_uvcodevec[13] @ 208
	.field	30,16		; r_uvcodevec[14] @ 224
	.field	71,16		; r_uvcodevec[15] @ 240
	.field	19,16		; r_uvcodevec[16] @ 256
	.field	22,16		; r_uvcodevec[17] @ 272
	.field	30,16		; r_uvcodevec[18] @ 288
	.field	1,16		; r_uvcodevec[19] @ 304
	.field	38,16		; r_uvcodevec[20] @ 320
	.field	1,16		; r_uvcodevec[21] @ 336
	.field	-17,16		; r_uvcodevec[22] @ 352
	.field	-22,16		; r_uvcodevec[23] @ 368
	.field	-34,16		; r_uvcodevec[24] @ 384
	.field	17,16		; r_uvcodevec[25] @ 400
	.field	-21,16		; r_uvcodevec[26] @ 416
	.field	-37,16		; r_uvcodevec[27] @ 432
	.field	-45,16		; r_uvcodevec[28] @ 448
	.field	-19,16		; r_uvcodevec[29] @ 464
	.field	23,16		; r_uvcodevec[30] @ 480
	.field	5,16		; r_uvcodevec[31] @ 496
	.field	40,16		; r_uvcodevec[32] @ 512
	.field	40,16		; r_uvcodevec[33] @ 528
	.field	14,16		; r_uvcodevec[34] @ 544
	.field	25,16		; r_uvcodevec[35] @ 560
	.field	21,16		; r_uvcodevec[36] @ 576
	.field	2,16		; r_uvcodevec[37] @ 592
	.field	-12,16		; r_uvcodevec[38] @ 608
	.field	24,16		; r_uvcodevec[39] @ 624
	.field	4,16		; r_uvcodevec[40] @ 640
	.field	-31,16		; r_uvcodevec[41] @ 656
	.field	50,16		; r_uvcodevec[42] @ 672
	.field	-3,16		; r_uvcodevec[43] @ 688
	.field	-36,16		; r_uvcodevec[44] @ 704
	.field	22,16		; r_uvcodevec[45] @ 720
	.field	28,16		; r_uvcodevec[46] @ 736
	.field	3,16		; r_uvcodevec[47] @ 752
	.field	-18,16		; r_uvcodevec[48] @ 768
	.field	-5,16		; r_uvcodevec[49] @ 784
	.field	0,16		; r_uvcodevec[50] @ 800
	.field	7,16		; r_uvcodevec[51] @ 816
	.field	77,16		; r_uvcodevec[52] @ 832
	.field	7,16		; r_uvcodevec[53] @ 848
	.field	-54,16		; r_uvcodevec[54] @ 864
	.field	42,16		; r_uvcodevec[55] @ 880
	.field	-29,16		; r_uvcodevec[56] @ 896
	.field	-48,16		; r_uvcodevec[57] @ 912
	.field	-11,16		; r_uvcodevec[58] @ 928
	.field	-3,16		; r_uvcodevec[59] @ 944
	.field	-18,16		; r_uvcodevec[60] @ 960
	.field	-34,16		; r_uvcodevec[61] @ 976
	.field	-4,16		; r_uvcodevec[62] @ 992
	.field	-47,16		; r_uvcodevec[63] @ 1008
	.field	-61,16		; r_uvcodevec[64] @ 1024
	.field	1,16		; r_uvcodevec[65] @ 1040
	.field	-26,16		; r_uvcodevec[66] @ 1056
	.field	-4,16		; r_uvcodevec[67] @ 1072
	.field	13,16		; r_uvcodevec[68] @ 1088
	.field	-46,16		; r_uvcodevec[69] @ 1104
	.field	7,16		; r_uvcodevec[70] @ 1120
	.field	-21,16		; r_uvcodevec[71] @ 1136
	.field	-24,16		; r_uvcodevec[72] @ 1152
	.field	36,16		; r_uvcodevec[73] @ 1168
	.field	22,16		; r_uvcodevec[74] @ 1184
	.field	59,16		; r_uvcodevec[75] @ 1200
	.field	38,16		; r_uvcodevec[76] @ 1216
	.field	34,16		; r_uvcodevec[77] @ 1232
	.field	62,16		; r_uvcodevec[78] @ 1248
	.field	12,16		; r_uvcodevec[79] @ 1264
	.field	-5,16		; r_uvcodevec[80] @ 1280
	.field	-17,16		; r_uvcodevec[81] @ 1296
	.field	-4,16		; r_uvcodevec[82] @ 1312
	.field	7,16		; r_uvcodevec[83] @ 1328
	.field	21,16		; r_uvcodevec[84] @ 1344
	.field	3,16		; r_uvcodevec[85] @ 1360
	.field	-60,16		; r_uvcodevec[86] @ 1376
	.field	-29,16		; r_uvcodevec[87] @ 1392
	.field	8,16		; r_uvcodevec[88] @ 1408
	.field	25,16		; r_uvcodevec[89] @ 1424
	.field	58,16		; r_uvcodevec[90] @ 1440
	.field	22,16		; r_uvcodevec[91] @ 1456
	.field	23,16		; r_uvcodevec[92] @ 1472
	.field	69,16		; r_uvcodevec[93] @ 1488
	.field	-25,16		; r_uvcodevec[94] @ 1504
	.field	-4,16		; r_uvcodevec[95] @ 1520
	.field	15,16		; r_uvcodevec[96] @ 1536
	.field	-43,16		; r_uvcodevec[97] @ 1552
	.field	-32,16		; r_uvcodevec[98] @ 1568
	.field	-20,16		; r_uvcodevec[99] @ 1584
	.field	26,16		; r_uvcodevec[100] @ 1600
	.field	-27,16		; r_uvcodevec[101] @ 1616
	.field	27,16		; r_uvcodevec[102] @ 1632
	.field	20,16		; r_uvcodevec[103] @ 1648
	.field	-5,16		; r_uvcodevec[104] @ 1664
	.field	-23,16		; r_uvcodevec[105] @ 1680
	.field	-31,16		; r_uvcodevec[106] @ 1696
	.field	20,16		; r_uvcodevec[107] @ 1712
	.field	39,16		; r_uvcodevec[108] @ 1728
	.field	-4,16		; r_uvcodevec[109] @ 1744
	.field	-69,16		; r_uvcodevec[110] @ 1760
	.field	46,16		; r_uvcodevec[111] @ 1776
	.field	52,16		; r_uvcodevec[112] @ 1792
	.field	-2,16		; r_uvcodevec[113] @ 1808
	.field	-12,16		; r_uvcodevec[114] @ 1824
	.field	17,16		; r_uvcodevec[115] @ 1840
	.field	24,16		; r_uvcodevec[116] @ 1856
	.field	-22,16		; r_uvcodevec[117] @ 1872
	.field	-14,16		; r_uvcodevec[118] @ 1888
	.field	-6,16		; r_uvcodevec[119] @ 1904
	.field	-28,16		; r_uvcodevec[120] @ 1920
	.field	28,16		; r_uvcodevec[121] @ 1936
	.field	51,16		; r_uvcodevec[122] @ 1952
	.field	24,16		; r_uvcodevec[123] @ 1968
	.field	-5,16		; r_uvcodevec[124] @ 1984
	.field	16,16		; r_uvcodevec[125] @ 2000
	.field	8,16		; r_uvcodevec[126] @ 2016
	.field	-27,16		; r_uvcodevec[127] @ 2032
	.field	24,16		; r_uvcodevec[128] @ 2048
	.field	19,16		; r_uvcodevec[129] @ 2064
	.field	-61,16		; r_uvcodevec[130] @ 2080
	.field	26,16		; r_uvcodevec[131] @ 2096
	.field	15,16		; r_uvcodevec[132] @ 2112
	.field	-46,16		; r_uvcodevec[133] @ 2128
	.field	17,16		; r_uvcodevec[134] @ 2144
	.field	-17,16		; r_uvcodevec[135] @ 2160
	.field	-22,16		; r_uvcodevec[136] @ 2176
	.field	22,16		; r_uvcodevec[137] @ 2192
	.field	48,16		; r_uvcodevec[138] @ 2208
	.field	31,16		; r_uvcodevec[139] @ 2224
	.field	36,16		; r_uvcodevec[140] @ 2240
	.field	13,16		; r_uvcodevec[141] @ 2256
	.field	20,16		; r_uvcodevec[142] @ 2272
	.field	53,16		; r_uvcodevec[143] @ 2288
	.field	-36,16		; r_uvcodevec[144] @ 2304
	.field	-43,16		; r_uvcodevec[145] @ 2320
	.field	-29,16		; r_uvcodevec[146] @ 2336
	.field	-20,16		; r_uvcodevec[147] @ 2352
	.field	3,16		; r_uvcodevec[148] @ 2368
	.field	-77,16		; r_uvcodevec[149] @ 2384
	.field	-40,16		; r_uvcodevec[150] @ 2400
	.field	30,16		; r_uvcodevec[151] @ 2416
	.field	-12,16		; r_uvcodevec[152] @ 2432
	.field	-3,16		; r_uvcodevec[153] @ 2448
	.field	-24,16		; r_uvcodevec[154] @ 2464
	.field	-15,16		; r_uvcodevec[155] @ 2480
	.field	45,16		; r_uvcodevec[156] @ 2496
	.field	-13,16		; r_uvcodevec[157] @ 2512
	.field	1,16		; r_uvcodevec[158] @ 2528
	.field	25,16		; r_uvcodevec[159] @ 2544
	.field	-29,16		; r_uvcodevec[160] @ 2560
	.field	-5,16		; r_uvcodevec[161] @ 2576
	.field	-47,16		; r_uvcodevec[162] @ 2592
	.field	-65,16		; r_uvcodevec[163] @ 2608
	.field	-6,16		; r_uvcodevec[164] @ 2624
	.field	81,16		; r_uvcodevec[165] @ 2640
	.field	-13,16		; r_uvcodevec[166] @ 2656
	.field	21,16		; r_uvcodevec[167] @ 2672
	.field	45,16		; r_uvcodevec[168] @ 2688
	.field	16,16		; r_uvcodevec[169] @ 2704
	.field	30,16		; r_uvcodevec[170] @ 2720
	.field	29,16		; r_uvcodevec[171] @ 2736
	.field	76,16		; r_uvcodevec[172] @ 2752
	.field	-12,16		; r_uvcodevec[173] @ 2768
	.field	-14,16		; r_uvcodevec[174] @ 2784
	.field	27,16		; r_uvcodevec[175] @ 2800
	.field	-24,16		; r_uvcodevec[176] @ 2816
	.field	-4,16		; r_uvcodevec[177] @ 2832
	.field	44,16		; r_uvcodevec[178] @ 2848
	.field	-14,16		; r_uvcodevec[179] @ 2864
	.field	-43,16		; r_uvcodevec[180] @ 2880
	.field	17,16		; r_uvcodevec[181] @ 2896
	.field	-39,16		; r_uvcodevec[182] @ 2912
	.field	-19,16		; r_uvcodevec[183] @ 2928
	.field	-9,16		; r_uvcodevec[184] @ 2944
	.field	-17,16		; r_uvcodevec[185] @ 2960
	.field	13,16		; r_uvcodevec[186] @ 2976
	.field	-9,16		; r_uvcodevec[187] @ 2992
	.field	35,16		; r_uvcodevec[188] @ 3008
	.field	30,16		; r_uvcodevec[189] @ 3024
	.field	-20,16		; r_uvcodevec[190] @ 3040
	.field	11,16		; r_uvcodevec[191] @ 3056
	.field	10,16		; r_uvcodevec[192] @ 3072
	.field	12,16		; r_uvcodevec[193] @ 3088
	.field	20,16		; r_uvcodevec[194] @ 3104
	.field	-53,16		; r_uvcodevec[195] @ 3120
	.field	-55,16		; r_uvcodevec[196] @ 3136
	.field	2,16		; r_uvcodevec[197] @ 3152
	.field	-21,16		; r_uvcodevec[198] @ 3168
	.field	6,16		; r_uvcodevec[199] @ 3184
	.field	37,16		; r_uvcodevec[200] @ 3200
	.field	-22,16		; r_uvcodevec[201] @ 3216
	.field	-30,16		; r_uvcodevec[202] @ 3232
	.field	35,16		; r_uvcodevec[203] @ 3248
	.field	-36,16		; r_uvcodevec[204] @ 3264
	.field	-17,16		; r_uvcodevec[205] @ 3280
	.field	-18,16		; r_uvcodevec[206] @ 3296
	.field	15,16		; r_uvcodevec[207] @ 3312
	.field	5,16		; r_uvcodevec[208] @ 3328
	.field	-53,16		; r_uvcodevec[209] @ 3344
	.field	-18,16		; r_uvcodevec[210] @ 3360
	.field	34,16		; r_uvcodevec[211] @ 3376
	.field	61,16		; r_uvcodevec[212] @ 3392
	.field	21,16		; r_uvcodevec[213] @ 3408
	.field	58,16		; r_uvcodevec[214] @ 3424
	.field	27,16		; r_uvcodevec[215] @ 3440
	.field	40,16		; r_uvcodevec[216] @ 3456
	.field	52,16		; r_uvcodevec[217] @ 3472
	.field	-5,16		; r_uvcodevec[218] @ 3488
	.field	-3,16		; r_uvcodevec[219] @ 3504
	.field	24,16		; r_uvcodevec[220] @ 3520
	.field	6,16		; r_uvcodevec[221] @ 3536
	.field	14,16		; r_uvcodevec[222] @ 3552
	.field	-8,16		; r_uvcodevec[223] @ 3568
	.field	-43,16		; r_uvcodevec[224] @ 3584
	.field	11,16		; r_uvcodevec[225] @ 3600
	.field	-48,16		; r_uvcodevec[226] @ 3616
	.field	-56,16		; r_uvcodevec[227] @ 3632
	.field	-8,16		; r_uvcodevec[228] @ 3648
	.field	26,16		; r_uvcodevec[229] @ 3664
	.field	-35,16		; r_uvcodevec[230] @ 3680
	.field	-27,16		; r_uvcodevec[231] @ 3696
	.field	21,16		; r_uvcodevec[232] @ 3712
	.field	-51,16		; r_uvcodevec[233] @ 3728
	.field	-65,16		; r_uvcodevec[234] @ 3744
	.field	7,16		; r_uvcodevec[235] @ 3760
	.field	11,16		; r_uvcodevec[236] @ 3776
	.field	5,16		; r_uvcodevec[237] @ 3792
	.field	3,16		; r_uvcodevec[238] @ 3808
	.field	-17,16		; r_uvcodevec[239] @ 3824
	.field	-135,16 	; r_uvcodevec[240] @ 3840
	.field	34,16		; r_uvcodevec[241] @ 3856
	.field	-2,16		; r_uvcodevec[242] @ 3872
	.field	-72,16		; r_uvcodevec[243] @ 3888
	.field	-42,16		; r_uvcodevec[244] @ 3904
	.field	21,16		; r_uvcodevec[245] @ 3920
	.field	40,16		; r_uvcodevec[246] @ 3936
	.field	7,16		; r_uvcodevec[247] @ 3952
	.field	26,16		; r_uvcodevec[248] @ 3968
	.field	-25,16		; r_uvcodevec[249] @ 3984
	.field	-11,16		; r_uvcodevec[250] @ 4000
	.field	3,16		; r_uvcodevec[251] @ 4016
	.field	8,16		; r_uvcodevec[252] @ 4032
	.field	22,16		; r_uvcodevec[253] @ 4048
	.field	11,16		; r_uvcodevec[254] @ 4064
	.field	24,16		; r_uvcodevec[255] @ 4080
	.field	22,16		; r_uvcodevec[256] @ 4096
	.field	22,16		; r_uvcodevec[257] @ 4112
	.field	-19,16		; r_uvcodevec[258] @ 4128
	.field	16,16		; r_uvcodevec[259] @ 4144
	.field	34,16		; r_uvcodevec[260] @ 4160
	.field	52,16		; r_uvcodevec[261] @ 4176
	.field	48,16		; r_uvcodevec[262] @ 4192
	.field	-27,16		; r_uvcodevec[263] @ 4208
	.field	21,16		; r_uvcodevec[264] @ 4224
	.field	38,16		; r_uvcodevec[265] @ 4240
	.field	-1,16		; r_uvcodevec[266] @ 4256
	.field	2,16		; r_uvcodevec[267] @ 4272
	.field	-5,16		; r_uvcodevec[268] @ 4288
	.field	-39,16		; r_uvcodevec[269] @ 4304
	.field	-12,16		; r_uvcodevec[270] @ 4320
	.field	8,16		; r_uvcodevec[271] @ 4336
	.field	10,16		; r_uvcodevec[272] @ 4352
	.field	-12,16		; r_uvcodevec[273] @ 4368
	.field	-14,16		; r_uvcodevec[274] @ 4384
	.field	16,16		; r_uvcodevec[275] @ 4400
	.field	-8,16		; r_uvcodevec[276] @ 4416
	.field	-20,16		; r_uvcodevec[277] @ 4432
	.field	-18,16		; r_uvcodevec[278] @ 4448
	.field	-25,16		; r_uvcodevec[279] @ 4464
	.field	-60,16		; r_uvcodevec[280] @ 4480
	.field	5,16		; r_uvcodevec[281] @ 4496
	.field	8,16		; r_uvcodevec[282] @ 4512
	.field	52,16		; r_uvcodevec[283] @ 4528
	.field	56,16		; r_uvcodevec[284] @ 4544
	.field	-8,16		; r_uvcodevec[285] @ 4560
	.field	-44,16		; r_uvcodevec[286] @ 4576
	.field	0,16		; r_uvcodevec[287] @ 4592
	.field	-28,16		; r_uvcodevec[288] @ 4608
	.field	-45,16		; r_uvcodevec[289] @ 4624
	.field	-36,16		; r_uvcodevec[290] @ 4640
	.field	-9,16		; r_uvcodevec[291] @ 4656
	.field	12,16		; r_uvcodevec[292] @ 4672
	.field	25,16		; r_uvcodevec[293] @ 4688
	.field	54,16		; r_uvcodevec[294] @ 4704
	.field	17,16		; r_uvcodevec[295] @ 4720
	.field	-59,16		; r_uvcodevec[296] @ 4736
	.field	7,16		; r_uvcodevec[297] @ 4752
	.field	35,16		; r_uvcodevec[298] @ 4768
	.field	-20,16		; r_uvcodevec[299] @ 4784
	.field	34,16		; r_uvcodevec[300] @ 4800
	.field	-11,16		; r_uvcodevec[301] @ 4816
	.field	-31,16		; r_uvcodevec[302] @ 4832
	.field	-36,16		; r_uvcodevec[303] @ 4848
	.field	14,16		; r_uvcodevec[304] @ 4864
	.field	-5,16		; r_uvcodevec[305] @ 4880
	.field	-46,16		; r_uvcodevec[306] @ 4896
	.field	60,16		; r_uvcodevec[307] @ 4912
	.field	27,16		; r_uvcodevec[308] @ 4928
	.field	-4,16		; r_uvcodevec[309] @ 4944
	.field	28,16		; r_uvcodevec[310] @ 4960
	.field	0,16		; r_uvcodevec[311] @ 4976
	.field	16,16		; r_uvcodevec[312] @ 4992
	.field	28,16		; r_uvcodevec[313] @ 5008
	.field	-8,16		; r_uvcodevec[314] @ 5024
	.field	-2,16		; r_uvcodevec[315] @ 5040
	.field	-54,16		; r_uvcodevec[316] @ 5056
	.field	1,16		; r_uvcodevec[317] @ 5072
	.field	16,16		; r_uvcodevec[318] @ 5088
	.field	-42,16		; r_uvcodevec[319] @ 5104
	.field	-25,16		; r_uvcodevec[320] @ 5120
	.field	-29,16		; r_uvcodevec[321] @ 5136
	.field	13,16		; r_uvcodevec[322] @ 5152
	.field	-18,16		; r_uvcodevec[323] @ 5168
	.field	37,16		; r_uvcodevec[324] @ 5184
	.field	-7,16		; r_uvcodevec[325] @ 5200
	.field	-60,16		; r_uvcodevec[326] @ 5216
	.field	-13,16		; r_uvcodevec[327] @ 5232
	.field	-3,16		; r_uvcodevec[328] @ 5248
	.field	-11,16		; r_uvcodevec[329] @ 5264
	.field	-24,16		; r_uvcodevec[330] @ 5280
	.field	20,16		; r_uvcodevec[331] @ 5296
	.field	8,16		; r_uvcodevec[332] @ 5312
	.field	-54,16		; r_uvcodevec[333] @ 5328
	.field	-18,16		; r_uvcodevec[334] @ 5344
	.field	4,16		; r_uvcodevec[335] @ 5360
	.field	-24,16		; r_uvcodevec[336] @ 5376
	.field	-21,16		; r_uvcodevec[337] @ 5392
	.field	14,16		; r_uvcodevec[338] @ 5408
	.field	67,16		; r_uvcodevec[339] @ 5424
	.field	52,16		; r_uvcodevec[340] @ 5440
	.field	-9,16		; r_uvcodevec[341] @ 5456
	.field	43,16		; r_uvcodevec[342] @ 5472
	.field	13,16		; r_uvcodevec[343] @ 5488
	.field	-9,16		; r_uvcodevec[344] @ 5504
	.field	52,16		; r_uvcodevec[345] @ 5520
	.field	5,16		; r_uvcodevec[346] @ 5536
	.field	-16,16		; r_uvcodevec[347] @ 5552
	.field	33,16		; r_uvcodevec[348] @ 5568
	.field	65,16		; r_uvcodevec[349] @ 5584
	.field	17,16		; r_uvcodevec[350] @ 5600
	.field	-14,16		; r_uvcodevec[351] @ 5616
	.field	-14,16		; r_uvcodevec[352] @ 5632
	.field	-55,16		; r_uvcodevec[353] @ 5648
	.field	66,16		; r_uvcodevec[354] @ 5664
	.field	46,16		; r_uvcodevec[355] @ 5680
	.field	-17,16		; r_uvcodevec[356] @ 5696
	.field	-13,16		; r_uvcodevec[357] @ 5712
	.field	-15,16		; r_uvcodevec[358] @ 5728
	.field	-11,16		; r_uvcodevec[359] @ 5744
	.field	-53,16		; r_uvcodevec[360] @ 5760
	.field	-22,16		; r_uvcodevec[361] @ 5776
	.field	-4,16		; r_uvcodevec[362] @ 5792
	.field	20,16		; r_uvcodevec[363] @ 5808
	.field	24,16		; r_uvcodevec[364] @ 5824
	.field	-60,16		; r_uvcodevec[365] @ 5840
	.field	18,16		; r_uvcodevec[366] @ 5856
	.field	75,16		; r_uvcodevec[367] @ 5872
	.field	-7,16		; r_uvcodevec[368] @ 5888
	.field	-2,16		; r_uvcodevec[369] @ 5904
	.field	22,16		; r_uvcodevec[370] @ 5920
	.field	-7,16		; r_uvcodevec[371] @ 5936
	.field	-30,16		; r_uvcodevec[372] @ 5952
	.field	-49,16		; r_uvcodevec[373] @ 5968
	.field	5,16		; r_uvcodevec[374] @ 5984
	.field	26,16		; r_uvcodevec[375] @ 6000
	.field	-6,16		; r_uvcodevec[376] @ 6016
	.field	-76,16		; r_uvcodevec[377] @ 6032
	.field	19,16		; r_uvcodevec[378] @ 6048
	.field	18,16		; r_uvcodevec[379] @ 6064
	.field	-13,16		; r_uvcodevec[380] @ 6080
	.field	23,16		; r_uvcodevec[381] @ 6096
	.field	-18,16		; r_uvcodevec[382] @ 6112
	.field	-13,16		; r_uvcodevec[383] @ 6128
	.field	7,16		; r_uvcodevec[384] @ 6144
	.field	-7,16		; r_uvcodevec[385] @ 6160
	.field	-35,16		; r_uvcodevec[386] @ 6176
	.field	-57,16		; r_uvcodevec[387] @ 6192
	.field	10,16		; r_uvcodevec[388] @ 6208
	.field	2,16		; r_uvcodevec[389] @ 6224
	.field	-41,16		; r_uvcodevec[390] @ 6240
	.field	38,16		; r_uvcodevec[391] @ 6256
	.field	32,16		; r_uvcodevec[392] @ 6272
	.field	-1,16		; r_uvcodevec[393] @ 6288
	.field	-4,16		; r_uvcodevec[394] @ 6304
	.field	-38,16		; r_uvcodevec[395] @ 6320
	.field	8,16		; r_uvcodevec[396] @ 6336
	.field	26,16		; r_uvcodevec[397] @ 6352
	.field	40,16		; r_uvcodevec[398] @ 6368
	.field	18,16		; r_uvcodevec[399] @ 6384
	.field	-9,16		; r_uvcodevec[400] @ 6400
	.field	5,16		; r_uvcodevec[401] @ 6416
	.field	1,16		; r_uvcodevec[402] @ 6432
	.field	24,16		; r_uvcodevec[403] @ 6448
	.field	46,16		; r_uvcodevec[404] @ 6464
	.field	-22,16		; r_uvcodevec[405] @ 6480
	.field	-21,16		; r_uvcodevec[406] @ 6496
	.field	22,16		; r_uvcodevec[407] @ 6512
	.field	69,16		; r_uvcodevec[408] @ 6528
	.field	60,16		; r_uvcodevec[409] @ 6544
	.field	-55,16		; r_uvcodevec[410] @ 6560
	.field	-42,16		; r_uvcodevec[411] @ 6576
	.field	27,16		; r_uvcodevec[412] @ 6592
	.field	-15,16		; r_uvcodevec[413] @ 6608
	.field	-17,16		; r_uvcodevec[414] @ 6624
	.field	-4,16		; r_uvcodevec[415] @ 6640
	.field	48,16		; r_uvcodevec[416] @ 6656
	.field	51,16		; r_uvcodevec[417] @ 6672
	.field	-12,16		; r_uvcodevec[418] @ 6688
	.field	12,16		; r_uvcodevec[419] @ 6704
	.field	-47,16		; r_uvcodevec[420] @ 6720
	.field	10,16		; r_uvcodevec[421] @ 6736
	.field	41,16		; r_uvcodevec[422] @ 6752
	.field	-67,16		; r_uvcodevec[423] @ 6768
	.field	-14,16		; r_uvcodevec[424] @ 6784
	.field	-41,16		; r_uvcodevec[425] @ 6800
	.field	-8,16		; r_uvcodevec[426] @ 6816
	.field	21,16		; r_uvcodevec[427] @ 6832
	.field	-25,16		; r_uvcodevec[428] @ 6848
	.field	14,16		; r_uvcodevec[429] @ 6864
	.field	1,16		; r_uvcodevec[430] @ 6880
	.field	-5,16		; r_uvcodevec[431] @ 6896
	.field	27,16		; r_uvcodevec[432] @ 6912
	.field	21,16		; r_uvcodevec[433] @ 6928
	.field	41,16		; r_uvcodevec[434] @ 6944
	.field	38,16		; r_uvcodevec[435] @ 6960
	.field	7,16		; r_uvcodevec[436] @ 6976
	.field	24,16		; r_uvcodevec[437] @ 6992
	.field	-4,16		; r_uvcodevec[438] @ 7008
	.field	-18,16		; r_uvcodevec[439] @ 7024
	.field	33,16		; r_uvcodevec[440] @ 7040
	.field	-39,16		; r_uvcodevec[441] @ 7056
	.field	51,16		; r_uvcodevec[442] @ 7072
	.field	-27,16		; r_uvcodevec[443] @ 7088
	.field	34,16		; r_uvcodevec[444] @ 7104
	.field	-26,16		; r_uvcodevec[445] @ 7120
	.field	-79,16		; r_uvcodevec[446] @ 7136
	.field	38,16		; r_uvcodevec[447] @ 7152
	.field	-23,16		; r_uvcodevec[448] @ 7168
	.field	-12,16		; r_uvcodevec[449] @ 7184
	.field	26,16		; r_uvcodevec[450] @ 7200
	.field	29,16		; r_uvcodevec[451] @ 7216
	.field	20,16		; r_uvcodevec[452] @ 7232
	.field	-19,16		; r_uvcodevec[453] @ 7248
	.field	-28,16		; r_uvcodevec[454] @ 7264
	.field	-26,16		; r_uvcodevec[455] @ 7280
	.field	2,16		; r_uvcodevec[456] @ 7296
	.field	59,16		; r_uvcodevec[457] @ 7312
	.field	5,16		; r_uvcodevec[458] @ 7328
	.field	-30,16		; r_uvcodevec[459] @ 7344
	.field	-6,16		; r_uvcodevec[460] @ 7360
	.field	44,16		; r_uvcodevec[461] @ 7376
	.field	29,16		; r_uvcodevec[462] @ 7392
	.field	-37,16		; r_uvcodevec[463] @ 7408
	.field	37,16		; r_uvcodevec[464] @ 7424
	.field	38,16		; r_uvcodevec[465] @ 7440
	.field	18,16		; r_uvcodevec[466] @ 7456
	.field	-2,16		; r_uvcodevec[467] @ 7472
	.field	-29,16		; r_uvcodevec[468] @ 7488
	.field	-61,16		; r_uvcodevec[469] @ 7504
	.field	-41,16		; r_uvcodevec[470] @ 7520
	.field	-20,16		; r_uvcodevec[471] @ 7536
	.field	-49,16		; r_uvcodevec[472] @ 7552
	.field	23,16		; r_uvcodevec[473] @ 7568
	.field	-14,16		; r_uvcodevec[474] @ 7584
	.field	-26,16		; r_uvcodevec[475] @ 7600
	.field	-8,16		; r_uvcodevec[476] @ 7616
	.field	-20,16		; r_uvcodevec[477] @ 7632
	.field	10,16		; r_uvcodevec[478] @ 7648
	.field	29,16		; r_uvcodevec[479] @ 7664
	.field	72,16		; r_uvcodevec[480] @ 7680
	.field	92,16		; r_uvcodevec[481] @ 7696
	.field	7,16		; r_uvcodevec[482] @ 7712
	.field	14,16		; r_uvcodevec[483] @ 7728
	.field	19,16		; r_uvcodevec[484] @ 7744
	.field	-11,16		; r_uvcodevec[485] @ 7760
	.field	34,16		; r_uvcodevec[486] @ 7776
	.field	23,16		; r_uvcodevec[487] @ 7792
	.field	-8,16		; r_uvcodevec[488] @ 7808
	.field	0,16		; r_uvcodevec[489] @ 7824
	.field	-27,16		; r_uvcodevec[490] @ 7840
	.field	-12,16		; r_uvcodevec[491] @ 7856
	.field	11,16		; r_uvcodevec[492] @ 7872
	.field	-15,16		; r_uvcodevec[493] @ 7888
	.field	-32,16		; r_uvcodevec[494] @ 7904
	.field	17,16		; r_uvcodevec[495] @ 7920
	.field	10,16		; r_uvcodevec[496] @ 7936
	.field	13,16		; r_uvcodevec[497] @ 7952
	.field	-64,16		; r_uvcodevec[498] @ 7968
	.field	-5,16		; r_uvcodevec[499] @ 7984
	.field	35,16		; r_uvcodevec[500] @ 8000
	.field	23,16		; r_uvcodevec[501] @ 8016
	.field	-21,16		; r_uvcodevec[502] @ 8032
	.field	-35,16		; r_uvcodevec[503] @ 8048
	.field	-21,16		; r_uvcodevec[504] @ 8064
	.field	-11,16		; r_uvcodevec[505] @ 8080
	.field	-15,16		; r_uvcodevec[506] @ 8096
	.field	-29,16		; r_uvcodevec[507] @ 8112
	.field	61,16		; r_uvcodevec[508] @ 8128
	.field	-21,16		; r_uvcodevec[509] @ 8144
	.field	-10,16		; r_uvcodevec[510] @ 8160
	.field	71,16		; r_uvcodevec[511] @ 8176
	.field	-20,16		; r_uvcodevec[512] @ 8192
	.field	2,16		; r_uvcodevec[513] @ 8208
	.field	36,16		; r_uvcodevec[514] @ 8224
	.field	-6,16		; r_uvcodevec[515] @ 8240
	.field	-52,16		; r_uvcodevec[516] @ 8256
	.field	-40,16		; r_uvcodevec[517] @ 8272
	.field	-11,16		; r_uvcodevec[518] @ 8288
	.field	-6,16		; r_uvcodevec[519] @ 8304
	.field	-43,16		; r_uvcodevec[520] @ 8320
	.field	-45,16		; r_uvcodevec[521] @ 8336
	.field	61,16		; r_uvcodevec[522] @ 8352
	.field	38,16		; r_uvcodevec[523] @ 8368
	.field	37,16		; r_uvcodevec[524] @ 8384
	.field	8,16		; r_uvcodevec[525] @ 8400
	.field	55,16		; r_uvcodevec[526] @ 8416
	.field	-4,16		; r_uvcodevec[527] @ 8432
	.field	-8,16		; r_uvcodevec[528] @ 8448
	.field	67,16		; r_uvcodevec[529] @ 8464
	.field	25,16		; r_uvcodevec[530] @ 8480
	.field	13,16		; r_uvcodevec[531] @ 8496
	.field	16,16		; r_uvcodevec[532] @ 8512
	.field	11,16		; r_uvcodevec[533] @ 8528
	.field	0,16		; r_uvcodevec[534] @ 8544
	.field	24,16		; r_uvcodevec[535] @ 8560
	.field	31,16		; r_uvcodevec[536] @ 8576
	.field	29,16		; r_uvcodevec[537] @ 8592
	.field	-1,16		; r_uvcodevec[538] @ 8608
	.field	-57,16		; r_uvcodevec[539] @ 8624
	.field	44,16		; r_uvcodevec[540] @ 8640
	.field	5,16		; r_uvcodevec[541] @ 8656
	.field	-66,16		; r_uvcodevec[542] @ 8672
	.field	3,16		; r_uvcodevec[543] @ 8688
	.field	-10,16		; r_uvcodevec[544] @ 8704
	.field	-24,16		; r_uvcodevec[545] @ 8720
	.field	24,16		; r_uvcodevec[546] @ 8736
	.field	-27,16		; r_uvcodevec[547] @ 8752
	.field	-24,16		; r_uvcodevec[548] @ 8768
	.field	3,16		; r_uvcodevec[549] @ 8784
	.field	-36,16		; r_uvcodevec[550] @ 8800
	.field	-3,16		; r_uvcodevec[551] @ 8816
	.field	-26,16		; r_uvcodevec[552] @ 8832
	.field	-55,16		; r_uvcodevec[553] @ 8848
	.field	24,16		; r_uvcodevec[554] @ 8864
	.field	24,16		; r_uvcodevec[555] @ 8880
	.field	-43,16		; r_uvcodevec[556] @ 8896
	.field	0,16		; r_uvcodevec[557] @ 8912
	.field	5,16		; r_uvcodevec[558] @ 8928
	.field	-35,16		; r_uvcodevec[559] @ 8944


r_vcdcodevec
       .field  24,16		; r_vcdcodevec[0] @ 0				VcdCodeVec[0] @ 0
	.field	13,16		; r_vcdcodevec[1] @ 16
	.field	-55,16		; r_vcdcodevec[2] @ 32
	.field	-51,16		; r_vcdcodevec[3] @ 48
	.field	-8,16		; r_vcdcodevec[4] @ 64
	.field	-58,16		; r_vcdcodevec[5] @ 80
	.field	2,16		; r_vcdcodevec[6] @ 96
	.field	-75,16		; r_vcdcodevec[7] @ 112
	.field	-70,16		; r_vcdcodevec[8] @ 128
	.field	22,16		; r_vcdcodevec[9] @ 144
	.field	-4,16		; r_vcdcodevec[10] @ 160
	.field	-21,16		; r_vcdcodevec[11] @ 176
	.field	19,16		; r_vcdcodevec[12] @ 192
	.field	-21,16		; r_vcdcodevec[13] @ 208
	.field	23,16		; r_vcdcodevec[14] @ 224
	.field	54,16		; r_vcdcodevec[15] @ 240
	.field	16,16		; r_vcdcodevec[16] @ 256
	.field	10,16		; r_vcdcodevec[17] @ 272
	.field	32,16		; r_vcdcodevec[18] @ 288
	.field	1,16		; r_vcdcodevec[19] @ 304
	.field	30,16		; r_vcdcodevec[20] @ 320
	.field	3,16		; r_vcdcodevec[21] @ 336
	.field	-15,16		; r_vcdcodevec[22] @ 352
	.field	-7,16		; r_vcdcodevec[23] @ 368
	.field	-42,16		; r_vcdcodevec[24] @ 384
	.field	-2,16		; r_vcdcodevec[25] @ 400
	.field	-22,16		; r_vcdcodevec[26] @ 416
	.field	-36,16		; r_vcdcodevec[27] @ 432
	.field	-20,16		; r_vcdcodevec[28] @ 448
	.field	-27,16		; r_vcdcodevec[29] @ 464
	.field	12,16		; r_vcdcodevec[30] @ 480
	.field	21,16		; r_vcdcodevec[31] @ 496
	.field	46,16		; r_vcdcodevec[32] @ 512
	.field	35,16		; r_vcdcodevec[33] @ 528
	.field	31,16		; r_vcdcodevec[34] @ 544
	.field	27,16		; r_vcdcodevec[35] @ 560
	.field	3,16		; r_vcdcodevec[36] @ 576
	.field	16,16		; r_vcdcodevec[37] @ 592
	.field	-9,16		; r_vcdcodevec[38] @ 608
	.field	4,16		; r_vcdcodevec[39] @ 624
	.field	-10,16		; r_vcdcodevec[40] @ 640
	.field	-53,16		; r_vcdcodevec[41] @ 656
	.field	46,16		; r_vcdcodevec[42] @ 672
	.field	10,16		; r_vcdcodevec[43] @ 688
	.field	-28,16		; r_vcdcodevec[44] @ 704
	.field	18,16		; r_vcdcodevec[45] @ 720
	.field	19,16		; r_vcdcodevec[46] @ 736
	.field	22,16		; r_vcdcodevec[47] @ 752
	.field	-17,16		; r_vcdcodevec[48] @ 768
	.field	-11,16		; r_vcdcodevec[49] @ 784
	.field	6,16		; r_vcdcodevec[50] @ 800
	.field	0,16		; r_vcdcodevec[51] @ 816
	.field	58,16		; r_vcdcodevec[52] @ 832
	.field	7,16		; r_vcdcodevec[53] @ 848
	.field	-37,16		; r_vcdcodevec[54] @ 864
	.field	32,16		; r_vcdcodevec[55] @ 880
	.field	-24,16		; r_vcdcodevec[56] @ 896
	.field	-49,16		; r_vcdcodevec[57] @ 912
	.field	-7,16		; r_vcdcodevec[58] @ 928
	.field	-10,16		; r_vcdcodevec[59] @ 944
	.field	-25,16		; r_vcdcodevec[60] @ 960
	.field	-32,16		; r_vcdcodevec[61] @ 976
	.field	-3,16		; r_vcdcodevec[62] @ 992
	.field	-48,16		; r_vcdcodevec[63] @ 1008
	.field	-41,16		; r_vcdcodevec[64] @ 1024
	.field	-6,16		; r_vcdcodevec[65] @ 1040
	.field	-24,16		; r_vcdcodevec[66] @ 1056
	.field	-18,16		; r_vcdcodevec[67] @ 1072
	.field	18,16		; r_vcdcodevec[68] @ 1088
	.field	-43,16		; r_vcdcodevec[69] @ 1104
	.field	9,16		; r_vcdcodevec[70] @ 1120
	.field	-18,16		; r_vcdcodevec[71] @ 1136
	.field	-15,16		; r_vcdcodevec[72] @ 1152
	.field	36,16		; r_vcdcodevec[73] @ 1168
	.field	28,16		; r_vcdcodevec[74] @ 1184
	.field	74,16		; r_vcdcodevec[75] @ 1200
	.field	58,16		; r_vcdcodevec[76] @ 1216
	.field	47,16		; r_vcdcodevec[77] @ 1232
	.field	49,16		; r_vcdcodevec[78] @ 1248
	.field	21,16		; r_vcdcodevec[79] @ 1264
	.field	-25,16		; r_vcdcodevec[80] @ 1280
	.field	-1,16		; r_vcdcodevec[81] @ 1296
	.field	8,16		; r_vcdcodevec[82] @ 1312
	.field	20,16		; r_vcdcodevec[83] @ 1328
	.field	13,16		; r_vcdcodevec[84] @ 1344
	.field	-34,16		; r_vcdcodevec[85] @ 1360
	.field	-52,16		; r_vcdcodevec[86] @ 1376
	.field	-35,16		; r_vcdcodevec[87] @ 1392
	.field	23,16		; r_vcdcodevec[88] @ 1408
	.field	18,16		; r_vcdcodevec[89] @ 1424
	.field	70,16		; r_vcdcodevec[90] @ 1440
	.field	44,16		; r_vcdcodevec[91] @ 1456
	.field	25,16		; r_vcdcodevec[92] @ 1472
	.field	76,16		; r_vcdcodevec[93] @ 1488
	.field	-20,16		; r_vcdcodevec[94] @ 1504
	.field	1,16		; r_vcdcodevec[95] @ 1520
	.field	6,16		; r_vcdcodevec[96] @ 1536
	.field	-49,16		; r_vcdcodevec[97] @ 1552
	.field	-18,16		; r_vcdcodevec[98] @ 1568
	.field	-43,16		; r_vcdcodevec[99] @ 1584
	.field	27,16		; r_vcdcodevec[100] @ 1600
	.field	-29,16		; r_vcdcodevec[101] @ 1616
	.field	32,16		; r_vcdcodevec[102] @ 1632
	.field	36,16		; r_vcdcodevec[103] @ 1648
	.field	3,16		; r_vcdcodevec[104] @ 1664
	.field	-6,16		; r_vcdcodevec[105] @ 1680
	.field	-34,16		; r_vcdcodevec[106] @ 1696
	.field	11,16		; r_vcdcodevec[107] @ 1712
	.field	37,16		; r_vcdcodevec[108] @ 1728
	.field	-13,16		; r_vcdcodevec[109] @ 1744
	.field	-50,16		; r_vcdcodevec[110] @ 1760
	.field	58,16		; r_vcdcodevec[111] @ 1776
	.field	32,16		; r_vcdcodevec[112] @ 1792
	.field	0,16		; r_vcdcodevec[113] @ 1808
	.field	12,16		; r_vcdcodevec[114] @ 1824
	.field	16,16		; r_vcdcodevec[115] @ 1840
	.field	16,16		; r_vcdcodevec[116] @ 1856
	.field	-6,16		; r_vcdcodevec[117] @ 1872
	.field	-20,16		; r_vcdcodevec[118] @ 1888
	.field	-3,16		; r_vcdcodevec[119] @ 1904
	.field	-50,16		; r_vcdcodevec[120] @ 1920
	.field	38,16		; r_vcdcodevec[121] @ 1936
	.field	47,16		; r_vcdcodevec[122] @ 1952
	.field	43,16		; r_vcdcodevec[123] @ 1968
	.field	9,16		; r_vcdcodevec[124] @ 1984
	.field	31,16		; r_vcdcodevec[125] @ 2000
	.field	1,16		; r_vcdcodevec[126] @ 2016
	.field	-23,16		; r_vcdcodevec[127] @ 2032
	.field	25,16		; r_vcdcodevec[128] @ 2048
	.field	21,16		; r_vcdcodevec[129] @ 2064
	.field	-38,16		; r_vcdcodevec[130] @ 2080
	.field	20,16		; r_vcdcodevec[131] @ 2096
	.field	7,16		; r_vcdcodevec[132] @ 2112
	.field	-55,16		; r_vcdcodevec[133] @ 2128
	.field	7,16		; r_vcdcodevec[134] @ 2144
	.field	-30,16		; r_vcdcodevec[135] @ 2160
	.field	-8,16		; r_vcdcodevec[136] @ 2176
	.field	23,16		; r_vcdcodevec[137] @ 2192
	.field	44,16		; r_vcdcodevec[138] @ 2208
	.field	28,16		; r_vcdcodevec[139] @ 2224
	.field	44,16		; r_vcdcodevec[140] @ 2240
	.field	19,16		; r_vcdcodevec[141] @ 2256
	.field	26,16		; r_vcdcodevec[142] @ 2272
	.field	49,16		; r_vcdcodevec[143] @ 2288
	.field	-32,16		; r_vcdcodevec[144] @ 2304
	.field	-28,16		; r_vcdcodevec[145] @ 2320
	.field	-51,16		; r_vcdcodevec[146] @ 2336
	.field	-30,16		; r_vcdcodevec[147] @ 2352
	.field	-11,16		; r_vcdcodevec[148] @ 2368
	.field	-65,16		; r_vcdcodevec[149] @ 2384
	.field	-44,16		; r_vcdcodevec[150] @ 2400
	.field	40,16		; r_vcdcodevec[151] @ 2416
	.field	-9,16		; r_vcdcodevec[152] @ 2432
	.field	22,16		; r_vcdcodevec[153] @ 2448
	.field	-1,16		; r_vcdcodevec[154] @ 2464
	.field	-6,16		; r_vcdcodevec[155] @ 2480
	.field	44,16		; r_vcdcodevec[156] @ 2496
	.field	-3,16		; r_vcdcodevec[157] @ 2512
	.field	7,16		; r_vcdcodevec[158] @ 2528
	.field	13,16		; r_vcdcodevec[159] @ 2544
	.field	-93,16		; r_vcdcodevec[160] @ 2560
	.field	-25,16		; r_vcdcodevec[161] @ 2576
	.field	-46,16		; r_vcdcodevec[162] @ 2592
	.field	-35,16		; r_vcdcodevec[163] @ 2608
	.field	11,16		; r_vcdcodevec[164] @ 2624
	.field	69,16		; r_vcdcodevec[165] @ 2640
	.field	-8,16		; r_vcdcodevec[166] @ 2656
	.field	37,16		; r_vcdcodevec[167] @ 2672
	.field	45,16		; r_vcdcodevec[168] @ 2688
	.field	21,16		; r_vcdcodevec[169] @ 2704
	.field	42,16		; r_vcdcodevec[170] @ 2720
	.field	23,16		; r_vcdcodevec[171] @ 2736
	.field	64,16		; r_vcdcodevec[172] @ 2752
	.field	-25,16		; r_vcdcodevec[173] @ 2768
	.field	-10,16		; r_vcdcodevec[174] @ 2784
	.field	16,16		; r_vcdcodevec[175] @ 2800
	.field	-19,16		; r_vcdcodevec[176] @ 2816
	.field	8,16		; r_vcdcodevec[177] @ 2832
	.field	41,16		; r_vcdcodevec[178] @ 2848
	.field	-7,16		; r_vcdcodevec[179] @ 2864
	.field	-32,16		; r_vcdcodevec[180] @ 2880
	.field	10,16		; r_vcdcodevec[181] @ 2896
	.field	-45,16		; r_vcdcodevec[182] @ 2912
	.field	-17,16		; r_vcdcodevec[183] @ 2928
	.field	-20,16		; r_vcdcodevec[184] @ 2944
	.field	-35,16		; r_vcdcodevec[185] @ 2960
	.field	25,16		; r_vcdcodevec[186] @ 2976
	.field	-6,16		; r_vcdcodevec[187] @ 2992
	.field	16,16		; r_vcdcodevec[188] @ 3008
	.field	46,16		; r_vcdcodevec[189] @ 3024
	.field	-1,16		; r_vcdcodevec[190] @ 3040
	.field	14,16		; r_vcdcodevec[191] @ 3056
	.field	10,16		; r_vcdcodevec[192] @ 3072
	.field	6,16		; r_vcdcodevec[193] @ 3088
	.field	4,16		; r_vcdcodevec[194] @ 3104
	.field	-43,16		; r_vcdcodevec[195] @ 3120
	.field	-29,16		; r_vcdcodevec[196] @ 3136
	.field	-9,16		; r_vcdcodevec[197] @ 3152
	.field	-14,16		; r_vcdcodevec[198] @ 3168
	.field	-7,16		; r_vcdcodevec[199] @ 3184
	.field	76,16		; r_vcdcodevec[200] @ 3200
	.field	-13,16		; r_vcdcodevec[201] @ 3216
	.field	-23,16		; r_vcdcodevec[202] @ 3232
	.field	33,16		; r_vcdcodevec[203] @ 3248
	.field	-35,16		; r_vcdcodevec[204] @ 3264
	.field	5,16		; r_vcdcodevec[205] @ 3280
	.field	-19,16		; r_vcdcodevec[206] @ 3296
	.field	7,16		; r_vcdcodevec[207] @ 3312
	.field	18,16		; r_vcdcodevec[208] @ 3328
	.field	-59,16		; r_vcdcodevec[209] @ 3344
	.field	-15,16		; r_vcdcodevec[210] @ 3360
	.field	40,16		; r_vcdcodevec[211] @ 3376
	.field	76,16		; r_vcdcodevec[212] @ 3392
	.field	36,16		; r_vcdcodevec[213] @ 3408
	.field	57,16		; r_vcdcodevec[214] @ 3424
	.field	29,16		; r_vcdcodevec[215] @ 3440
	.field	38,16		; r_vcdcodevec[216] @ 3456
	.field	58,16		; r_vcdcodevec[217] @ 3472
	.field	2,16		; r_vcdcodevec[218] @ 3488
	.field	0,16		; r_vcdcodevec[219] @ 3504
	.field	16,16		; r_vcdcodevec[220] @ 3520
	.field	6,16		; r_vcdcodevec[221] @ 3536
	.field	9,16		; r_vcdcodevec[222] @ 3552
	.field	-14,16		; r_vcdcodevec[223] @ 3568
	.field	-25,16		; r_vcdcodevec[224] @ 3584
	.field	9,16		; r_vcdcodevec[225] @ 3600
	.field	-49,16		; r_vcdcodevec[226] @ 3616
	.field	-39,16		; r_vcdcodevec[227] @ 3632
	.field	-5,16		; r_vcdcodevec[228] @ 3648
	.field	17,16		; r_vcdcodevec[229] @ 3664
	.field	-33,16		; r_vcdcodevec[230] @ 3680
	.field	-44,16		; r_vcdcodevec[231] @ 3696
	.field	9,16		; r_vcdcodevec[232] @ 3712
	.field	-43,16		; r_vcdcodevec[233] @ 3728
	.field	-32,16		; r_vcdcodevec[234] @ 3744
	.field	-1,16		; r_vcdcodevec[235] @ 3760
	.field	13,16		; r_vcdcodevec[236] @ 3776
	.field	1,16		; r_vcdcodevec[237] @ 3792
	.field	9,16		; r_vcdcodevec[238] @ 3808
	.field	-6,16		; r_vcdcodevec[239] @ 3824
	.field	-196,16 	; r_vcdcodevec[240] @ 3840
	.field	16,16		; r_vcdcodevec[241] @ 3856
	.field	-22,16		; r_vcdcodevec[242] @ 3872
	.field	-35,16		; r_vcdcodevec[243] @ 3888
	.field	-34,16		; r_vcdcodevec[244] @ 3904
	.field	20,16		; r_vcdcodevec[245] @ 3920
	.field	30,16		; r_vcdcodevec[246] @ 3936
	.field	10,16		; r_vcdcodevec[247] @ 3952
	.field	19,16		; r_vcdcodevec[248] @ 3968
	.field	-22,16		; r_vcdcodevec[249] @ 3984
	.field	2,16		; r_vcdcodevec[250] @ 4000
	.field	-13,16		; r_vcdcodevec[251] @ 4016
	.field	-4,16		; r_vcdcodevec[252] @ 4032
	.field	22,16		; r_vcdcodevec[253] @ 4048
	.field	14,16		; r_vcdcodevec[254] @ 4064
	.field	22,16		; r_vcdcodevec[255] @ 4080
	.field	20,16		; r_vcdcodevec[256] @ 4096
	.field	15,16		; r_vcdcodevec[257] @ 4112
	.field	-15,16		; r_vcdcodevec[258] @ 4128
	.field	22,16		; r_vcdcodevec[259] @ 4144
	.field	29,16		; r_vcdcodevec[260] @ 4160
	.field	40,16		; r_vcdcodevec[261] @ 4176
	.field	43,16		; r_vcdcodevec[262] @ 4192
	.field	-14,16		; r_vcdcodevec[263] @ 4208
	.field	30,16		; r_vcdcodevec[264] @ 4224
	.field	36,16		; r_vcdcodevec[265] @ 4240
	.field	-8,16		; r_vcdcodevec[266] @ 4256
	.field	-10,16		; r_vcdcodevec[267] @ 4272
	.field	-19,16		; r_vcdcodevec[268] @ 4288
	.field	-42,16		; r_vcdcodevec[269] @ 4304
	.field	-12,16		; r_vcdcodevec[270] @ 4320
	.field	-15,16		; r_vcdcodevec[271] @ 4336
	.field	-9,16		; r_vcdcodevec[272] @ 4352
	.field	-12,16		; r_vcdcodevec[273] @ 4368
	.field	-12,16		; r_vcdcodevec[274] @ 4384
	.field	0,16		; r_vcdcodevec[275] @ 4400
	.field	-9,16		; r_vcdcodevec[276] @ 4416
	.field	-5,16		; r_vcdcodevec[277] @ 4432
	.field	-11,16		; r_vcdcodevec[278] @ 4448
	.field	-7,16		; r_vcdcodevec[279] @ 4464
	.field	-77,16		; r_vcdcodevec[280] @ 4480
	.field	48,16		; r_vcdcodevec[281] @ 4496
	.field	24,16		; r_vcdcodevec[282] @ 4512
	.field	65,16		; r_vcdcodevec[283] @ 4528
	.field	45,16		; r_vcdcodevec[284] @ 4544
	.field	-3,16		; r_vcdcodevec[285] @ 4560
	.field	-38,16		; r_vcdcodevec[286] @ 4576
	.field	15,16		; r_vcdcodevec[287] @ 4592
	.field	-29,16		; r_vcdcodevec[288] @ 4608
	.field	-44,16		; r_vcdcodevec[289] @ 4624
	.field	-47,16		; r_vcdcodevec[290] @ 4640
	.field	6,16		; r_vcdcodevec[291] @ 4656
	.field	2,16		; r_vcdcodevec[292] @ 4672
	.field	4,16		; r_vcdcodevec[293] @ 4688
	.field	63,16		; r_vcdcodevec[294] @ 4704
	.field	27,16		; r_vcdcodevec[295] @ 4720
	.field	-26,16		; r_vcdcodevec[296] @ 4736
	.field	27,16		; r_vcdcodevec[297] @ 4752
	.field	47,16		; r_vcdcodevec[298] @ 4768
	.field	-13,16		; r_vcdcodevec[299] @ 4784
	.field	17,16		; r_vcdcodevec[300] @ 4800
	.field	-16,16		; r_vcdcodevec[301] @ 4816
	.field	-23,16		; r_vcdcodevec[302] @ 4832
	.field	-31,16		; r_vcdcodevec[303] @ 4848
	.field	-3,16		; r_vcdcodevec[304] @ 4864
	.field	-10,16		; r_vcdcodevec[305] @ 4880
	.field	-33,16		; r_vcdcodevec[306] @ 4896
	.field	46,16		; r_vcdcodevec[307] @ 4912
	.field	18,16		; r_vcdcodevec[308] @ 4928
	.field	15,16		; r_vcdcodevec[309] @ 4944
	.field	43,16		; r_vcdcodevec[310] @ 4960
	.field	9,16		; r_vcdcodevec[311] @ 4976
	.field	25,16		; r_vcdcodevec[312] @ 4992
	.field	24,16		; r_vcdcodevec[313] @ 5008
	.field	-26,16		; r_vcdcodevec[314] @ 5024
	.field	-10,16		; r_vcdcodevec[315] @ 5040
	.field	-46,16		; r_vcdcodevec[316] @ 5056
	.field	-27,16		; r_vcdcodevec[317] @ 5072
	.field	-13,16		; r_vcdcodevec[318] @ 5088
	.field	-37,16		; r_vcdcodevec[319] @ 5104
	.field	-24,16		; r_vcdcodevec[320] @ 5120
	.field	-56,16		; r_vcdcodevec[321] @ 5136
	.field	30,16		; r_vcdcodevec[322] @ 5152
	.field	-9,16		; r_vcdcodevec[323] @ 5168
	.field	27,16		; r_vcdcodevec[324] @ 5184
	.field	-13,16		; r_vcdcodevec[325] @ 5200
	.field	-56,16		; r_vcdcodevec[326] @ 5216
	.field	-1,16		; r_vcdcodevec[327] @ 5232
	.field	-24,16		; r_vcdcodevec[328] @ 5248
	.field	-24,16		; r_vcdcodevec[329] @ 5264
	.field	-38,16		; r_vcdcodevec[330] @ 5280
	.field	-1,16		; r_vcdcodevec[331] @ 5296
	.field	10,16		; r_vcdcodevec[332] @ 5312
	.field	-57,16		; r_vcdcodevec[333] @ 5328
	.field	-21,16		; r_vcdcodevec[334] @ 5344
	.field	-1,16		; r_vcdcodevec[335] @ 5360
	.field	-34,16		; r_vcdcodevec[336] @ 5376
	.field	-12,16		; r_vcdcodevec[337] @ 5392
	.field	29,16		; r_vcdcodevec[338] @ 5408
	.field	55,16		; r_vcdcodevec[339] @ 5424
	.field	42,16		; r_vcdcodevec[340] @ 5440
	.field	-1,16		; r_vcdcodevec[341] @ 5456
	.field	44,16		; r_vcdcodevec[342] @ 5472
	.field	33,16		; r_vcdcodevec[343] @ 5488
	.field	2,16		; r_vcdcodevec[344] @ 5504
	.field	54,16		; r_vcdcodevec[345] @ 5520
	.field	11,16		; r_vcdcodevec[346] @ 5536
	.field	-9,16		; r_vcdcodevec[347] @ 5552
	.field	55,16		; r_vcdcodevec[348] @ 5568
	.field	73,16		; r_vcdcodevec[349] @ 5584
	.field	13,16		; r_vcdcodevec[350] @ 5600
	.field	-2,16		; r_vcdcodevec[351] @ 5616
	.field	3,16		; r_vcdcodevec[352] @ 5632
	.field	-46,16		; r_vcdcodevec[353] @ 5648
	.field	52,16		; r_vcdcodevec[354] @ 5664
	.field	27,16		; r_vcdcodevec[355] @ 5680
	.field	1,16		; r_vcdcodevec[356] @ 5696
	.field	4,16		; r_vcdcodevec[357] @ 5712
	.field	-4,16		; r_vcdcodevec[358] @ 5728
	.field	-17,16		; r_vcdcodevec[359] @ 5744


r_quant1
	.field	-5980,16		; r_quant1[0] @ 0
	.field	25056,16		; r_quant1[1] @ 16
	.field	-22691,16		; r_quant1[2] @ 32
	.field	-7724,16		; r_quant1[3] @ 48
	.field	27102,16		; r_quant1[4] @ 64
	.field	-18323,16		; r_quant1[5] @ 80
	.field	-8275,16		; r_quant1[6] @ 96
	.field	18136,16		; r_quant1[7] @ 112
	.field	-13700,16		; r_quant1[8] @ 128
	.field	-11073,16		; r_quant1[9] @ 144
	.field	-27189,16		; r_quant1[10] @ 160
	.field	-21101,16		; r_quant1[11] @ 176
	.field	-15434,16		; r_quant1[12] @ 192
	.field	-31279,16		; r_quant1[13] @ 208
	.field	-22689,16		; r_quant1[14] @ 224
	.field	-12363,16		; r_quant1[15] @ 240
	.field	21448,16		; r_quant1[16] @ 256
	.field	-21397,16		; r_quant1[17] @ 272
	.field	-12572,16		; r_quant1[18] @ 288
	.field	-22070,16		; r_quant1[19] @ 304
	.field	-5974,16		; r_quant1[20] @ 320
	.field	-14112,16		; r_quant1[21] @ 336
	.field	-25915,16		; r_quant1[22] @ 352
	.field	-6003,16		; r_quant1[23] @ 368
	.field	-13613,16		; r_quant1[24] @ 384
	.field	-29240,16		; r_quant1[25] @ 400
	.field	-10112,16		; r_quant1[26] @ 416
	.field	-15142,16		; r_quant1[27] @ 432
	.field	31938,16		; r_quant1[28] @ 448
	.field	-12410,16		; r_quant1[29] @ 464
	.field	-13114,16		; r_quant1[30] @ 480
	.field	30406,16		; r_quant1[31] @ 496
	.field	-15487,16		; r_quant1[32] @ 512
	.field	-16186,16		; r_quant1[33] @ 528
	.field	-31809,16		; r_quant1[34] @ 544
	.field	-17285,16		; r_quant1[35] @ 560
	.field	-15419,16		; r_quant1[36] @ 576
	.field	28093,16		; r_quant1[37] @ 592
	.field	-19864,16		; r_quant1[38] @ 608
	.field	-15396,16		; r_quant1[39] @ 624
	.field	-24635,16		; r_quant1[40] @ 640
	.field	-12651,16		; r_quant1[41] @ 656
	.field	-16421,16		; r_quant1[42] @ 672
	.field	-21825,16		; r_quant1[43] @ 688
	.field	-7791,16		; r_quant1[44] @ 704
	.field	-16956,16		; r_quant1[45] @ 720
	.field	23237,16		; r_quant1[46] @ 736
	.field	-25725,16		; r_quant1[47] @ 752
	.field	-17473,16		; r_quant1[48] @ 768
	.field	29630,16		; r_quant1[49] @ 784
	.field	-9829,16		; r_quant1[50] @ 800
	.field	-16935,16		; r_quant1[51] @ 816
	.field	-29000,16		; r_quant1[52] @ 832
	.field	-7789,16		; r_quant1[53] @ 848
	.field	-18216,16		; r_quant1[54] @ 864
	.field	-27975,16		; r_quant1[55] @ 880
	.field	-5732,16		; r_quant1[56] @ 896
	.field	-18214,16		; r_quant1[57] @ 912
	.field	-24388,16		; r_quant1[58] @ 928
	.field	-12122,16		; r_quant1[59] @ 944
	.field	-17207,16		; r_quant1[60] @ 960
	.field	-25675,16		; r_quant1[61] @ 976
	.field	-9054,16		; r_quant1[62] @ 992
	.field	-19743,16		; r_quant1[63] @ 1008
	.field	-23118,16		; r_quant1[64] @ 1024
	.field	-8809,16		; r_quant1[65] @ 1040
	.field	-20512,16		; r_quant1[66] @ 1056
	.field	-24644,16		; r_quant1[67] @ 1072
	.field	-12400,16		; r_quant1[68] @ 1088
	.field	-17712,16		; r_quant1[69] @ 1104
	.field	-30792,16		; r_quant1[70] @ 1120
	.field	-15224,16		; r_quant1[71] @ 1136
	.field	-19258,16		; r_quant1[72] @ 1152
	.field	-31564,16		; r_quant1[73] @ 1168
	.field	-9845,16		; r_quant1[74] @ 1184
	.field	-20263,16		; r_quant1[75] @ 1200
	.field	-29518,16		; r_quant1[76] @ 1216
	.field	-12929,16		; r_quant1[77] @ 1232
	.field	-20531,16		; r_quant1[78] @ 1248
	.field	-31814,16		; r_quant1[79] @ 1264
	.field	-9355,16		; r_quant1[80] @ 1280
	.field	-18480,16		; r_quant1[81] @ 1296
	.field	30131,16		; r_quant1[82] @ 1312
	.field	-10383,16		; r_quant1[83] @ 1328
	.field	-17459,16		; r_quant1[84] @ 1344
	.field	-18246,16		; r_quant1[85] @ 1360
	.field	-14416,16		; r_quant1[86] @ 1376
	.field	-19502,16		; r_quant1[87] @ 1392
	.field	-21581,16		; r_quant1[88] @ 1408
	.field	-13909,16		; r_quant1[89] @ 1424
	.field	-18994,16		; r_quant1[90] @ 1440
	.field	-24905,16		; r_quant1[91] @ 1456
	.field	-14443,16		; r_quant1[92] @ 1472
	.field	-19515,16		; r_quant1[93] @ 1488
	.field	-26437,16		; r_quant1[94] @ 1504
	.field	-19835,16		; r_quant1[95] @ 1520
	.field	-20543,16		; r_quant1[96] @ 1536
	.field	30890,16		; r_quant1[97] @ 1552
	.field	-15250,16		; r_quant1[98] @ 1568
	.field	-20031,16		; r_quant1[99] @ 1584
	.field	-27219,16		; r_quant1[100] @ 1600
	.field	-9822,16		; r_quant1[101] @ 1616
	.field	-21295,16		; r_quant1[102] @ 1632
	.field	-23893,16		; r_quant1[103] @ 1648
	.field	-12373,16		; r_quant1[104] @ 1664
	.field	-22574,16		; r_quant1[105] @ 1680
	.field	-21337,16		; r_quant1[106] @ 1696
	.field	-12133,16		; r_quant1[107] @ 1712
	.field	-23855,16		; r_quant1[108] @ 1728
	.field	-19800,16		; r_quant1[109] @ 1744
	.field	-15203,16		; r_quant1[110] @ 1760
	.field	-23104,16		; r_quant1[111] @ 1776
	.field	-26452,16		; r_quant1[112] @ 1792
	.field	-11884,16		; r_quant1[113] @ 1808
	.field	-21560,16		; r_quant1[114] @ 1824
	.field	-28751,16		; r_quant1[115] @ 1840
	.field	-17781,16		; r_quant1[116] @ 1856
	.field	-21315,16		; r_quant1[117] @ 1872
	.field	-30038,16		; r_quant1[118] @ 1888
	.field	-12415,16		; r_quant1[119] @ 1904
	.field	-22588,16		; r_quant1[120] @ 1920
	.field	32420,16		; r_quant1[121] @ 1936
	.field	-13177,16		; r_quant1[122] @ 1952
	.field	-24123,16		; r_quant1[123] @ 1968
	.field	-31056,16		; r_quant1[124] @ 1984
	.field	-21620,16		; r_quant1[125] @ 2000
	.field	-22607,16		; r_quant1[126] @ 2016
	.field	-27221,16		; r_quant1[127] @ 2032
	.field	-23137,16		; r_quant1[128] @ 2048
	.field	-22092,16		; r_quant1[129] @ 2064
	.field	-30810,16		; r_quant1[130] @ 2080
	.field	-18816,16		; r_quant1[131] @ 2096
	.field	-19531,16		; r_quant1[132] @ 2112
	.field	-32602,16		; r_quant1[133] @ 2128
	.field	-8046,16		; r_quant1[134] @ 2144
	.field	-24094,16		; r_quant1[135] @ 2160
	.field	-28254,16		; r_quant1[136] @ 2176
	.field	-11878,16		; r_quant1[137] @ 2192
	.field	-24873,16		; r_quant1[138] @ 2208
	.field	-24931,16		; r_quant1[139] @ 2224
	.field	-8315,16		; r_quant1[140] @ 2240
	.field	-22318,16		; r_quant1[141] @ 2256
	.field	27555,16		; r_quant1[142] @ 2272
	.field	-13201,16		; r_quant1[143] @ 2288
	.field	-18764,16		; r_quant1[144] @ 2304
	.field	28848,16		; r_quant1[145] @ 2320
	.field	-13975,16		; r_quant1[146] @ 2336
	.field	-21579,16		; r_quant1[147] @ 2352
	.field	29348,16		; r_quant1[148] @ 2368
	.field	-20371,16		; r_quant1[149] @ 2384
	.field	-23379,16		; r_quant1[150] @ 2400
	.field	-31583,16		; r_quant1[151] @ 2416
	.field	-21381,16		; r_quant1[152] @ 2432
	.field	-18777,16		; r_quant1[153] @ 2448
	.field	-32080,16		; r_quant1[154] @ 2464
	.field	-21382,16		; r_quant1[155] @ 2480
	.field	-17754,16		; r_quant1[156] @ 2496
	.field	30898,16		; r_quant1[157] @ 2512
	.field	-23697,16		; r_quant1[158] @ 2528
	.field	-20839,16		; r_quant1[159] @ 2544
	.field	26034,16		; r_quant1[160] @ 2560
	.field	-22436,16		; r_quant1[161] @ 2576
	.field	-19020,16		; r_quant1[162] @ 2592
	.field	20657,16		; r_quant1[163] @ 2608
	.field	-19125,16		; r_quant1[164] @ 2624
	.field	-19525,16		; r_quant1[165] @ 2640
	.field	27311,16		; r_quant1[166] @ 2656
	.field	-20381,16		; r_quant1[167] @ 2672
	.field	-22618,16		; r_quant1[168] @ 2688
	.field	27812,16		; r_quant1[169] @ 2704
	.field	-25246,16		; r_quant1[170] @ 2720
	.field	-21598,16		; r_quant1[171] @ 2736
	.field	-30806,16		; r_quant1[172] @ 2752
	.field	-27260,16		; r_quant1[173] @ 2768
	.field	-22109,16		; r_quant1[174] @ 2784
	.field	31139,16		; r_quant1[175] @ 2800
	.field	-25736,16		; r_quant1[176] @ 2816
	.field	-24671,16		; r_quant1[177] @ 2832
	.field	-32356,16		; r_quant1[178] @ 2848
	.field	-24717,16		; r_quant1[179] @ 2864
	.field	-21870,16		; r_quant1[180] @ 2880
	.field	29597,16		; r_quant1[181] @ 2896
	.field	-28308,16		; r_quant1[182] @ 2912
	.field	-24695,16		; r_quant1[183] @ 2928
	.field	-31576,16		; r_quant1[184] @ 2944
	.field	-19364,16		; r_quant1[185] @ 2960
	.field	-25438,16		; r_quant1[186] @ 2976
	.field	25250,16		; r_quant1[187] @ 2992
	.field	-18316,16		; r_quant1[188] @ 3008
	.field	-25172,16		; r_quant1[189] @ 3024
	.field	28575,16		; r_quant1[190] @ 3040
	.field	-19868,16		; r_quant1[191] @ 3056
	.field	-9361,16		; r_quant1[192] @ 3072
	.field	16344,16		; r_quant1[193] @ 3088
	.field	-25510,16		; r_quant1[194] @ 3104
	.field	-11889,16		; r_quant1[195] @ 3120
	.field	20151,16		; r_quant1[196] @ 3136
	.field	-26768,16		; r_quant1[197] @ 3152
	.field	-23158,16		; r_quant1[198] @ 3168
	.field	26316,16		; r_quant1[199] @ 3184
	.field	32120,16		; r_quant1[200] @ 3200
	.field	-17047,16		; r_quant1[201] @ 3216
	.field	28596,16		; r_quant1[202] @ 3232
	.field	22908,16		; r_quant1[203] @ 3248
	.field	-18617,16		; r_quant1[204] @ 3264
	.field	30431,16		; r_quant1[205] @ 3280
	.field	29029,16		; r_quant1[206] @ 3296
	.field	-13988,16		; r_quant1[207] @ 3312
	.field	22966,16		; r_quant1[208] @ 3328
	.field	28514,16		; r_quant1[209] @ 3344
	.field	-20898,16		; r_quant1[210] @ 3360
	.field	23493,16		; r_quant1[211] @ 3376
	.field	-28552,16		; r_quant1[212] @ 3392
	.field	-14958,16		; r_quant1[213] @ 3408
	.field	25786,16		; r_quant1[214] @ 3424
	.field	-31898,16		; r_quant1[215] @ 3440
	.field	-14725,16		; r_quant1[216] @ 3456
	.field	23205,16		; r_quant1[217] @ 3472
	.field	-31843,16		; r_quant1[218] @ 3488
	.field	-21397,16		; r_quant1[219] @ 3504
	.field	-23115,16		; r_quant1[220] @ 3520
	.field	30855,16		; r_quant1[221] @ 3536
	.field	-24461,16		; r_quant1[222] @ 3552
	.field	-32612,16		; r_quant1[223] @ 3568
	.field	-32647,16		; r_quant1[224] @ 3584
	.field	-29316,16		; r_quant1[225] @ 3600
	.field	-31330,16		; r_quant1[226] @ 3616
	.field	25740,16		; r_quant1[227] @ 3632
	.field	-28069,16		; r_quant1[228] @ 3648
	.field	-31863,16		; r_quant1[229] @ 3664
	.field	27512,16		; r_quant1[230] @ 3680
	.field	-20354,16		; r_quant1[231] @ 3696
	.field	31142,16		; r_quant1[232] @ 3712
	.field	29296,16		; r_quant1[233] @ 3728
	.field	-20606,16		; r_quant1[234] @ 3744
	.field	25763,16		; r_quant1[235] @ 3760
	.field	29794,16		; r_quant1[236] @ 3776
	.field	-26781,16		; r_quant1[237] @ 3792
	.field	29340,16		; r_quant1[238] @ 3808
	.field	23144,16		; r_quant1[239] @ 3824
	.field	-16214,16		; r_quant1[240] @ 3840
	.field	27334,16		; r_quant1[241] @ 3856
	.field	-28846,16		; r_quant1[242] @ 3872
	.field	-16251,16		; r_quant1[243] @ 3888
	.field	18092,16		; r_quant1[244] @ 3904
	.field	27212,16		; r_quant1[245] @ 3920
	.field	31572,16		; r_quant1[246] @ 3936
	.field	28050,16		; r_quant1[247] @ 3952
	.field	25184,16		; r_quant1[248] @ 3968
	.field	-26783,16		; r_quant1[249] @ 3984
	.field	21102,16		; r_quant1[250] @ 4000
	.field	17765,16		; r_quant1[251] @ 4016
	.field	28473,16		; r_quant1[252] @ 4032
	.field	26502,16		; r_quant1[253] @ 4048
	.field	18264,16		; r_quant1[254] @ 4064
	.field	-31417,16		; r_quant1[255] @ 4080
	.field	17578,16		; r_quant1[256] @ 4096
	.field	20558,16		; r_quant1[257] @ 4112
	.field	-16280,16		; r_quant1[258] @ 4128
	.field	14727,16		; r_quant1[259] @ 4144
	.field	11105,16		; r_quant1[260] @ 4160
	.field	-25554,16		; r_quant1[261] @ 4176
	.field	17859,16		; r_quant1[262] @ 4192
	.field	-18870,16		; r_quant1[263] @ 4208
	.field	-17242,16		; r_quant1[264] @ 4224
	.field	21943,16		; r_quant1[265] @ 4240
	.field	-26531,16		; r_quant1[266] @ 4256
	.field	-20848,16		; r_quant1[267] @ 4272
	.field	21677,16		; r_quant1[268] @ 4288
	.field	32333,16		; r_quant1[269] @ 4304
	.field	-20610,16		; r_quant1[270] @ 4320
	.field	15288,16		; r_quant1[271] @ 4336
	.field	-24003,16		; r_quant1[272] @ 4352
	.field	-21876,16		; r_quant1[273] @ 4368
	.field	14235,16		; r_quant1[274] @ 4384
	.field	31579,16		; r_quant1[275] @ 4400
	.field	-24198,16		; r_quant1[276] @ 4416
	.field	20891,16		; r_quant1[277] @ 4432
	.field	30017,16		; r_quant1[278] @ 4448
	.field	-30876,16		; r_quant1[279] @ 4464
	.field	13949,16		; r_quant1[280] @ 4480
	.field	25416,16		; r_quant1[281] @ 4496
	.field	22097,16		; r_quant1[282] @ 4512
	.field	18554,16		; r_quant1[283] @ 4528
	.field	22866,16		; r_quant1[284] @ 4544
	.field	31829,16		; r_quant1[285] @ 4560
	.field	18009,16		; r_quant1[286] @ 4576
	.field	10361,16		; r_quant1[287] @ 4592
	.field	-31366,16		; r_quant1[288] @ 4608
	.field	30579,16		; r_quant1[289] @ 4624
	.field	21641,16		; r_quant1[290] @ 4640
	.field	31080,16		; r_quant1[291] @ 4656
	.field	28527,16		; r_quant1[292] @ 4672
	.field	22390,16		; r_quant1[293] @ 4688
	.field	25710,16		; r_quant1[294] @ 4704
	.field	-30132,16		; r_quant1[295] @ 4720
	.field	26486,16		; r_quant1[296] @ 4736
	.field	18280,16		; r_quant1[297] @ 4752
	.field	25914,16		; r_quant1[298] @ 4768
	.field	25195,16		; r_quant1[299] @ 4784
	.field	21862,16		; r_quant1[300] @ 4800
	.field	26705,16		; r_quant1[301] @ 4816
	.field	25186,16		; r_quant1[302] @ 4832
	.field	18018,16		; r_quant1[303] @ 4848
	.field	23104,16		; r_quant1[304] @ 4864
	.field	22366,16		; r_quant1[305] @ 4880
	.field	19808,16		; r_quant1[306] @ 4896
	.field	-31928,16		; r_quant1[307] @ 4912
	.field	21635,16		; r_quant1[308] @ 4928
	.field	15195,16		; r_quant1[309] @ 4944
	.field	30781,16		; r_quant1[310] @ 4960
	.field	20852,16		; r_quant1[311] @ 4976
	.field	22109,16		; r_quant1[312] @ 4992
	.field	28754,16		; r_quant1[313] @ 5008
	.field	22631,16		; r_quant1[314] @ 5024
	.field	18510,16		; r_quant1[315] @ 5040
	.field	26704,16		; r_quant1[316] @ 5056
	.field	19037,16		; r_quant1[317] @ 5072
	.field	-31637,16		; r_quant1[318] @ 5088
	.field	25971,16		; r_quant1[319] @ 5104
	.field	24156,16		; r_quant1[320] @ 5120
	.field	25180,16		; r_quant1[321] @ 5136
	.field	22104,16		; r_quant1[322] @ 5152
	.field	21587,16		; r_quant1[323] @ 5168
	.field	29812,16		; r_quant1[324] @ 5184
	.field	31338,16		; r_quant1[325] @ 5200
	.field	26998,16		; r_quant1[326] @ 5216
	.field	31609,16		; r_quant1[327] @ 5232
	.field	26732,16		; r_quant1[328] @ 5248
	.field	28006,16		; r_quant1[329] @ 5264
	.field	25192,16		; r_quant1[330] @ 5280
	.field	22624,16		; r_quant1[331] @ 5296
	.field	24669,16		; r_quant1[332] @ 5312
	.field	22109,16		; r_quant1[333] @ 5328
	.field	21064,16		; r_quant1[334] @ 5344
	.field	15988,16		; r_quant1[335] @ 5360
	.field	-26486,16		; r_quant1[336] @ 5376
	.field	24715,16		; r_quant1[337] @ 5392
	.field	-31895,16		; r_quant1[338] @ 5408
	.field	-28549,16		; r_quant1[339] @ 5424
	.field	25732,16		; r_quant1[340] @ 5440
	.field	30810,16		; r_quant1[341] @ 5456
	.field	-23917,16		; r_quant1[342] @ 5472
	.field	21395,16		; r_quant1[343] @ 5488
	.field	-32690,16		; r_quant1[344] @ 5504
	.field	-24437,16		; r_quant1[345] @ 5520
	.field	16777,16		; r_quant1[346] @ 5536
	.field	28733,16		; r_quant1[347] @ 5552
	.field	31610,16		; r_quant1[348] @ 5568
	.field	21354,16		; r_quant1[349] @ 5584
	.field	27217,16		; r_quant1[350] @ 5600
	.field	27500,16		; r_quant1[351] @ 5616
	.field	18562,16		; r_quant1[352] @ 5632
	.field	29517,16		; r_quant1[353] @ 5648
	.field	27748,16		; r_quant1[354] @ 5664
	.field	19572,16		; r_quant1[355] @ 5680
	.field	28226,16		; r_quant1[356] @ 5696
	.field	30824,16		; r_quant1[357] @ 5712
	.field	16812,16		; r_quant1[358] @ 5728
	.field	-20397,16		; r_quant1[359] @ 5744
	.field	-21056,16		; r_quant1[360] @ 5760
	.field	19107,16		; r_quant1[361] @ 5776
	.field	-20396,16		; r_quant1[362] @ 5792
	.field	-26473,16		; r_quant1[363] @ 5808
	.field	22428,16		; r_quant1[364] @ 5824
	.field	-26036,16		; r_quant1[365] @ 5840
	.field	-27243,16		; r_quant1[366] @ 5856
	.field	18583,16		; r_quant1[367] @ 5872
	.field	-30398,16		; r_quant1[368] @ 5888
	.field	-24418,16		; r_quant1[369] @ 5904
	.field	13967,16		; r_quant1[370] @ 5920
	.field	-31173,16		; r_quant1[371] @ 5936
	.field	-31366,16		; r_quant1[372] @ 5952
	.field	13472,16		; r_quant1[373] @ 5968
	.field	-22478,16		; r_quant1[374] @ 5984
	.field	-24400,16		; r_quant1[375] @ 6000
	.field	11155,16		; r_quant1[376] @ 6016
	.field	-26308,16		; r_quant1[377] @ 6032
	.field	-26977,16		; r_quant1[378] @ 6048
	.field	12937,16		; r_quant1[379] @ 6064
	.field	-29876,16		; r_quant1[380] @ 6080
	.field	-32644,16		; r_quant1[381] @ 6096
	.field	18051,16		; r_quant1[382] @ 6112
	.field	32567,16		; r_quant1[383] @ 6128
	.field	-23642,16		; r_quant1[384] @ 6144
	.field	-28516,16		; r_quant1[385] @ 6160
	.field	-11895,16		; r_quant1[386] @ 6176
	.field	-26147,16		; r_quant1[387] @ 6192
	.field	-29801,16		; r_quant1[388] @ 6208
	.field	-11645,16		; r_quant1[389] @ 6224
	.field	-24632,16		; r_quant1[390] @ 6240
	.field	-23393,16		; r_quant1[391] @ 6256
	.field	-14952,16		; r_quant1[392] @ 6272
	.field	-26161,16		; r_quant1[393] @ 6288
	.field	-25449,16		; r_quant1[394] @ 6304
	.field	-13672,16		; r_quant1[395] @ 6320
	.field	-24391,16		; r_quant1[396] @ 6336
	.field	-25445,16		; r_quant1[397] @ 6352
	.field	-16989,16		; r_quant1[398] @ 6368
	.field	-26692,16		; r_quant1[399] @ 6384
	.field	-25444,16		; r_quant1[400] @ 6400
	.field	-20575,16		; r_quant1[401] @ 6416
	.field	-23875,16		; r_quant1[402] @ 6432
	.field	-28512,16		; r_quant1[403] @ 6448
	.field	-18552,16		; r_quant1[404] @ 6464
	.field	-25661,16		; r_quant1[405] @ 6480
	.field	-29285,16		; r_quant1[406] @ 6496
	.field	-18043,16		; r_quant1[407] @ 6512
	.field	-25673,16		; r_quant1[408] @ 6528
	.field	-28518,16		; r_quant1[409] @ 6544
	.field	-21105,16		; r_quant1[410] @ 6560
	.field	-25682,16		; r_quant1[411] @ 6576
	.field	-31586,16		; r_quant1[412] @ 6592
	.field	-15491,16		; r_quant1[413] @ 6608
	.field	-25918,16		; r_quant1[414] @ 6624
	.field	31387,16		; r_quant1[415] @ 6640
	.field	-18569,16		; r_quant1[416] @ 6656
	.field	-27201,16		; r_quant1[417] @ 6672
	.field	30613,16		; r_quant1[418] @ 6688
	.field	-8817,16		; r_quant1[419] @ 6704
	.field	-27441,16		; r_quant1[420] @ 6720
	.field	-29549,16		; r_quant1[421] @ 6736
	.field	-13669,16		; r_quant1[422] @ 6752
	.field	-26941,16		; r_quant1[423] @ 6768
	.field	-29293,16		; r_quant1[424] @ 6784
	.field	-18543,16		; r_quant1[425] @ 6800
	.field	-27465,16		; r_quant1[426] @ 6816
	.field	-31080,16		; r_quant1[427] @ 6832
	.field	-24667,16		; r_quant1[428] @ 6848
	.field	-26156,16		; r_quant1[429] @ 6864
	.field	27796,16		; r_quant1[430] @ 6880
	.field	-14481,16		; r_quant1[431] @ 6896
	.field	-28202,16		; r_quant1[432] @ 6912
	.field	-29298,16		; r_quant1[433] @ 6928
	.field	-11636,16		; r_quant1[434] @ 6944
	.field	-28460,16		; r_quant1[435] @ 6960
	.field	-23409,16		; r_quant1[436] @ 6976
	.field	-10342,16		; r_quant1[437] @ 6992
	.field	-28472,16		; r_quant1[438] @ 7008
	.field	-27254,16		; r_quant1[439] @ 7024
	.field	-8540,16		; r_quant1[440] @ 7040
	.field	-29996,16		; r_quant1[441] @ 7056
	.field	-27514,16		; r_quant1[442] @ 7072
	.field	-9582,16		; r_quant1[443] @ 7088
	.field	-30774,16		; r_quant1[444] @ 7104
	.field	-29553,16		; r_quant1[445] @ 7120
	.field	-15458,16		; r_quant1[446] @ 7136
	.field	-29247,16		; r_quant1[447] @ 7152
	.field	-28278,16		; r_quant1[448] @ 7168
	.field	-16226,16		; r_quant1[449] @ 7184
	.field	-30789,16		; r_quant1[450] @ 7200
	.field	-26479,16		; r_quant1[451] @ 7216
	.field	-12675,16		; r_quant1[452] @ 7232
	.field	-28729,16		; r_quant1[453] @ 7248
	.field	32653,16		; r_quant1[454] @ 7264
	.field	-9353,16		; r_quant1[455] @ 7280
	.field	-29998,16		; r_quant1[456] @ 7296
	.field	31885,16		; r_quant1[457] @ 7312
	.field	-16766,16		; r_quant1[458] @ 7328
	.field	-29250,16		; r_quant1[459] @ 7344
	.field	29832,16		; r_quant1[460] @ 7360
	.field	-16776,16		; r_quant1[461] @ 7376
	.field	-30022,16		; r_quant1[462] @ 7392
	.field	-30331,16		; r_quant1[463] @ 7408
	.field	-18037,16		; r_quant1[464] @ 7424
	.field	-27969,16		; r_quant1[465] @ 7440
	.field	-30575,16		; r_quant1[466] @ 7456
	.field	-20333,16		; r_quant1[467] @ 7472
	.field	-28493,16		; r_quant1[468] @ 7488
	.field	-31599,16		; r_quant1[469] @ 7504
	.field	-9888,16		; r_quant1[470] @ 7520
	.field	-28727,16		; r_quant1[471] @ 7536
	.field	26753,16		; r_quant1[472] @ 7552
	.field	-9071,16		; r_quant1[473] @ 7568
	.field	-32052,16		; r_quant1[474] @ 7584
	.field	-29814,16		; r_quant1[475] @ 7600
	.field	-21334,16		; r_quant1[476] @ 7616
	.field	-30769,16		; r_quant1[477] @ 7632
	.field	30339,16		; r_quant1[478] @ 7648
	.field	-12935,16		; r_quant1[479] @ 7664
	.field	-26214,16		; r_quant1[480] @ 7680
	.field	-32620,16		; r_quant1[481] @ 7696
	.field	-26256,16		; r_quant1[482] @ 7712
	.field	-28025,16		; r_quant1[483] @ 7728
	.field	29334,16		; r_quant1[484] @ 7744
	.field	-21884,16		; r_quant1[485] @ 7760
	.field	-27981,16		; r_quant1[486] @ 7776
	.field	30596,16		; r_quant1[487] @ 7792
	.field	-19082,16		; r_quant1[488] @ 7808
	.field	-30804,16		; r_quant1[489] @ 7824
	.field	-28542,16		; r_quant1[490] @ 7840
	.field	-22133,16		; r_quant1[491] @ 7856
	.field	-32336,16		; r_quant1[492] @ 7872
	.field	-32112,16		; r_quant1[493] @ 7888
	.field	-21369,16		; r_quant1[494] @ 7904
	.field	-29781,16		; r_quant1[495] @ 7920
	.field	-31336,16		; r_quant1[496] @ 7936
	.field	-24432,16		; r_quant1[497] @ 7952
	.field	-28262,16		; r_quant1[498] @ 7968
	.field	-28533,16		; r_quant1[499] @ 7984
	.field	-25466,16		; r_quant1[500] @ 8000
	.field	-28277,16		; r_quant1[501] @ 8016
	.field	-28282,16		; r_quant1[502] @ 8032
	.field	-31086,16		; r_quant1[503] @ 8048
	.field	-32104,16		; r_quant1[504] @ 8064
	.field	-30313,16		; r_quant1[505] @ 8080
	.field	-21895,16		; r_quant1[506] @ 8096
	.field	-27739,16		; r_quant1[507] @ 8112
	.field	31118,16		; r_quant1[508] @ 8128
	.field	-23173,16		; r_quant1[509] @ 8144
	.field	-29533,16		; r_quant1[510] @ 8160
	.field	29073,16		; r_quant1[511] @ 8176
	.field	-27011,16		; r_quant1[512] @ 8192
	.field	-29806,16		; r_quant1[513] @ 8208
	.field	30603,16		; r_quant1[514] @ 8224
	.field	-20099,16		; r_quant1[515] @ 8240
	.field	-30548,16		; r_quant1[516] @ 8256
	.field	31110,16		; r_quant1[517] @ 8272
	.field	-23679,16		; r_quant1[518] @ 8288
	.field	-32084,16		; r_quant1[519] @ 8304
	.field	31868,16		; r_quant1[520] @ 8320
	.field	-22394,16		; r_quant1[521] @ 8336
	.field	-31067,16		; r_quant1[522] @ 8352
	.field	29063,16		; r_quant1[523] @ 8368
	.field	-19860,16		; r_quant1[524] @ 8384
	.field	-31068,16		; r_quant1[525] @ 8400
	.field	-23941,16		; r_quant1[526] @ 8416
	.field	-27734,16		; r_quant1[527] @ 8432
	.field	32175,16		; r_quant1[528] @ 8448
	.field	31357,16		; r_quant1[529] @ 8464
	.field	-27518,16		; r_quant1[530] @ 8480
	.field	-31593,16		; r_quant1[531] @ 8496
	.field	30592,16		; r_quant1[532] @ 8512
	.field	-27536,16		; r_quant1[533] @ 8528
	.field	32647,16		; r_quant1[534] @ 8544
	.field	32636,16		; r_quant1[535] @ 8560
	.field	-31627,16		; r_quant1[536] @ 8576
	.field	29315,16		; r_quant1[537] @ 8592
	.field	29057,16		; r_quant1[538] @ 8608
	.field	-25220,16		; r_quant1[539] @ 8624
	.field	-32341,16		; r_quant1[540] @ 8640
	.field	29566,16		; r_quant1[541] @ 8656
	.field	-24202,16		; r_quant1[542] @ 8672
	.field	31391,16		; r_quant1[543] @ 8688
	.field	29047,16		; r_quant1[544] @ 8704
	.field	-23934,16		; r_quant1[545] @ 8720
	.field	29856,16		; r_quant1[546] @ 8736
	.field	29807,16		; r_quant1[547] @ 8752
	.field	-24721,16		; r_quant1[548] @ 8768
	.field	28055,16		; r_quant1[549] @ 8784
	.field	30849,16		; r_quant1[550] @ 8800
	.field	-23959,16		; r_quant1[551] @ 8816
	.field	-32612,16		; r_quant1[552] @ 8832
	.field	24696,16		; r_quant1[553] @ 8848
	.field	-27016,16		; r_quant1[554] @ 8864
	.field	30607,16		; r_quant1[555] @ 8880
	.field	29301,16		; r_quant1[556] @ 8896
	.field	-26770,16		; r_quant1[557] @ 8912
	.field	29072,16		; r_quant1[558] @ 8928
	.field	27002,16		; r_quant1[559] @ 8944
	.field	-25242,16		; r_quant1[560] @ 8960
	.field	27536,16		; r_quant1[561] @ 8976
	.field	25980,16		; r_quant1[562] @ 8992
	.field	-22418,16		; r_quant1[563] @ 9008
	.field	29084,16		; r_quant1[564] @ 9024
	.field	25975,16		; r_quant1[565] @ 9040
	.field	-27246,16		; r_quant1[566] @ 9056
	.field	28818,16		; r_quant1[567] @ 9072
	.field	-29326,16		; r_quant1[568] @ 9088
	.field	-28032,16		; r_quant1[569] @ 9104
	.field	28299,16		; r_quant1[570] @ 9120
	.field	31855,16		; r_quant1[571] @ 9136
	.field	-32370,16		; r_quant1[572] @ 9152
	.field	-32117,16		; r_quant1[573] @ 9168
	.field	25978,16		; r_quant1[574] @ 9184
	.field	-29080,16		; r_quant1[575] @ 9200
	.field	27029,16		; r_quant1[576] @ 9216
	.field	29539,16		; r_quant1[577] @ 9232
	.field	-29600,16		; r_quant1[578] @ 9248
	.field	27813,16		; r_quant1[579] @ 9264
	.field	30313,16		; r_quant1[580] @ 9280
	.field	-23931,16		; r_quant1[581] @ 9296
	.field	25753,16		; r_quant1[582] @ 9312
	.field	32099,16		; r_quant1[583] @ 9328
	.field	-21640,16		; r_quant1[584] @ 9344
	.field	24739,16		; r_quant1[585] @ 9360
	.field	31066,16		; r_quant1[586] @ 9376
	.field	-25483,16		; r_quant1[587] @ 9392
	.field	25507,16		; r_quant1[588] @ 9408
	.field	28510,16		; r_quant1[589] @ 9424
	.field	-25492,16		; r_quant1[590] @ 9440
	.field	23194,16		; r_quant1[591] @ 9456
	.field	27240,16		; r_quant1[592] @ 9472
	.field	-24972,16		; r_quant1[593] @ 9488
	.field	26525,16		; r_quant1[594] @ 9504
	.field	27752,16		; r_quant1[595] @ 9520
	.field	-26520,16		; r_quant1[596] @ 9536
	.field	25234,16		; r_quant1[597] @ 9552
	.field	26465,16		; r_quant1[598] @ 9568
	.field	-27277,16		; r_quant1[599] @ 9584
	.field	23440,16		; r_quant1[600] @ 9600
	.field	28507,16		; r_quant1[601] @ 9616
	.field	-28569,16		; r_quant1[602] @ 9632
	.field	26529,16		; r_quant1[603] @ 9648
	.field	25695,16		; r_quant1[604] @ 9664
	.field	-25503,16		; r_quant1[605] @ 9680
	.field	25245,16		; r_quant1[606] @ 9696
	.field	22617,16		; r_quant1[607] @ 9712
	.field	-23698,16		; r_quant1[608] @ 9728
	.field	28322,16		; r_quant1[609] @ 9744
	.field	26474,16		; r_quant1[610] @ 9760
	.field	-24994,16		; r_quant1[611] @ 9776
	.field	26264,16		; r_quant1[612] @ 9792
	.field	22626,16		; r_quant1[613] @ 9808
	.field	-27810,16		; r_quant1[614] @ 9824
	.field	28073,16		; r_quant1[615] @ 9840
	.field	25450,16		; r_quant1[616] @ 9856
	.field	-22163,16		; r_quant1[617] @ 9872
	.field	26023,16		; r_quant1[618] @ 9888
	.field	25700,16		; r_quant1[619] @ 9904
	.field	-20887,16		; r_quant1[620] @ 9920
	.field	23959,16		; r_quant1[621] @ 9936
	.field	32341,16		; r_quant1[622] @ 9952
	.field	-28302,16		; r_quant1[623] @ 9968
	.field	21910,16		; r_quant1[624] @ 9984
	.field	26710,16		; r_quant1[625] @ 10000
	.field	-29597,16		; r_quant1[626] @ 10016
	.field	23189,16		; r_quant1[627] @ 10032
	.field	21591,16		; r_quant1[628] @ 10048
	.field	-27552,16		; r_quant1[629] @ 10064
	.field	21392,16		; r_quant1[630] @ 10080
	.field	23377,16		; r_quant1[631] @ 10096
	.field	-29612,16		; r_quant1[632] @ 10112
	.field	21143,16		; r_quant1[633] @ 10128
	.field	28748,16		; r_quant1[634] @ 10144
	.field	-27542,16		; r_quant1[635] @ 10160
	.field	19094,16		; r_quant1[636] @ 10176
	.field	25156,16		; r_quant1[637] @ 10192
	.field	-28322,16		; r_quant1[638] @ 10208
	.field	19088,16		; r_quant1[639] @ 10224
	.field	30278,16		; r_quant1[640] @ 10240
	.field	-28307,16		; r_quant1[641] @ 10256
	.field	16780,16		; r_quant1[642] @ 10272
	.field	28993,16		; r_quant1[643] @ 10288
	.field	-29338,16		; r_quant1[644] @ 10304
	.field	15752,16		; r_quant1[645] @ 10320
	.field	25164,16		; r_quant1[646] @ 10336
	.field	-28829,16		; r_quant1[647] @ 10352
	.field	18570,16		; r_quant1[648] @ 10368
	.field	23371,16		; r_quant1[649] @ 10384
	.field	-28073,16		; r_quant1[650] @ 10400
	.field	16779,16		; r_quant1[651] @ 10416
	.field	21308,16		; r_quant1[652] @ 10432
	.field	-31653,16		; r_quant1[653] @ 10448
	.field	15492,16		; r_quant1[654] @ 10464
	.field	21315,16		; r_quant1[655] @ 10480
	.field	-32431,16		; r_quant1[656] @ 10496
	.field	23695,16		; r_quant1[657] @ 10512
	.field	22614,16		; r_quant1[658] @ 10528
	.field	-30628,16		; r_quant1[659] @ 10544
	.field	20869,16		; r_quant1[660] @ 10560
	.field	22349,16		; r_quant1[661] @ 10576
	.field	-29841,16		; r_quant1[662] @ 10592
	.field	19846,16		; r_quant1[663] @ 10608
	.field	25670,16		; r_quant1[664] @ 10624
	.field	-31125,16		; r_quant1[665] @ 10640
	.field	17284,16		; r_quant1[666] @ 10656
	.field	25673,16		; r_quant1[667] @ 10672
	.field	-32416,16		; r_quant1[668] @ 10688
	.field	17789,16		; r_quant1[669] @ 10704
	.field	23353,16		; r_quant1[670] @ 10720
	.field	32090,16		; r_quant1[671] @ 10736
	.field	31131,16		; r_quant1[672] @ 10752
	.field	23923,16		; r_quant1[673] @ 10768
	.field	-26530,16		; r_quant1[674] @ 10784
	.field	28820,16		; r_quant1[675] @ 10800
	.field	22667,16		; r_quant1[676] @ 10816
	.field	-13724,16		; r_quant1[677] @ 10832
	.field	-30527,16		; r_quant1[678] @ 10848
	.field	24451,16		; r_quant1[679] @ 10864
	.field	-21399,16		; r_quant1[680] @ 10880
	.field	-31816,16		; r_quant1[681] @ 10896
	.field	26240,16		; r_quant1[682] @ 10912
	.field	-21408,16		; r_quant1[683] @ 10928
	.field	-30770,16		; r_quant1[684] @ 10944
	.field	23938,16		; r_quant1[685] @ 10960
	.field	-16805,16		; r_quant1[686] @ 10976
	.field	-30780,16		; r_quant1[687] @ 10992
	.field	19333,16		; r_quant1[688] @ 11008
	.field	-14522,16		; r_quant1[689] @ 11024
	.field	32705,16		; r_quant1[690] @ 11040
	.field	21879,16		; r_quant1[691] @ 11056
	.field	-20397,16		; r_quant1[692] @ 11072
	.field	31414,16		; r_quant1[693] @ 11088
	.field	18296,16		; r_quant1[694] @ 11104
	.field	-23705,16		; r_quant1[695] @ 11120
	.field	31664,16		; r_quant1[696] @ 11136
	.field	24952,16		; r_quant1[697] @ 11152
	.field	-22441,16		; r_quant1[698] @ 11168
	.field	28058,16		; r_quant1[699] @ 11184
	.field	24434,16		; r_quant1[700] @ 11200
	.field	-22690,16		; r_quant1[701] @ 11216
	.field	29096,16		; r_quant1[702] @ 11232
	.field	21869,16		; r_quant1[703] @ 11248
	.field	-26028,16		; r_quant1[704] @ 11264
	.field	-32339,16		; r_quant1[705] @ 11280
	.field	19328,16		; r_quant1[706] @ 11296
	.field	-17298,16		; r_quant1[707] @ 11312
	.field	31922,16		; r_quant1[708] @ 11328
	.field	28794,16		; r_quant1[709] @ 11344
	.field	-19094,16		; r_quant1[710] @ 11360
	.field	30384,16		; r_quant1[711] @ 11376
	.field	25473,16		; r_quant1[712] @ 11392
	.field	-12961,16		; r_quant1[713] @ 11408
	.field	-30286,16		; r_quant1[714] @ 11424
	.field	23174,16		; r_quant1[715] @ 11440
	.field	-19115,16		; r_quant1[716] @ 11456
	.field	32679,16		; r_quant1[717] @ 11472
	.field	22649,16		; r_quant1[718] @ 11488
	.field	-24493,16		; r_quant1[719] @ 11504
	.field	17023,16		; r_quant1[720] @ 11520
	.field	17465,16		; r_quant1[721] @ 11536
	.field	30533,16		; r_quant1[722] @ 11552
	.field	27029,16		; r_quant1[723] @ 11568
	.field	19550,16		; r_quant1[724] @ 11584
	.field	-28339,16		; r_quant1[725] @ 11600
	.field	22152,16		; r_quant1[726] @ 11616
	.field	19040,16		; r_quant1[727] @ 11632
	.field	-29868,16		; r_quant1[728] @ 11648
	.field	22916,16		; r_quant1[729] @ 11664
	.field	20550,16		; r_quant1[730] @ 11680
	.field	31821,16		; r_quant1[731] @ 11696
	.field	25481,16		; r_quant1[732] @ 11712
	.field	18772,16		; r_quant1[733] @ 11728
	.field	32327,16		; r_quant1[734] @ 11744
	.field	20866,16		; r_quant1[735] @ 11760
	.field	16727,16		; r_quant1[736] @ 11776
	.field	-31687,16		; r_quant1[737] @ 11792
	.field	27019,16		; r_quant1[738] @ 11808
	.field	16227,16		; r_quant1[739] @ 11824
	.field	-30664,16		; r_quant1[740] @ 11840
	.field	21370,16		; r_quant1[741] @ 11856
	.field	16220,16		; r_quant1[742] @ 11872
	.field	32307,16		; r_quant1[743] @ 11888
	.field	31126,16		; r_quant1[744] @ 11904
	.field	20338,16		; r_quant1[745] @ 11920
	.field	-27828,16		; r_quant1[746] @ 11936
	.field	28556,16		; r_quant1[747] @ 11952
	.field	17018,16		; r_quant1[748] @ 11968
	.field	-26311,16		; r_quant1[749] @ 11984
	.field	31896,16		; r_quant1[750] @ 12000
	.field	11387,16		; r_quant1[751] @ 12016
	.field	-22971,16		; r_quant1[752] @ 12032
	.field	28310,16		; r_quant1[753] @ 12048
	.field	18033,16		; r_quant1[754] @ 12064
	.field	-26820,16		; r_quant1[755] @ 12080
	.field	-29504,16		; r_quant1[756] @ 12096
	.field	16255,16		; r_quant1[757] @ 12112
	.field	-22736,16		; r_quant1[758] @ 12128
	.field	-29236,16		; r_quant1[759] @ 12144
	.field	14455,16		; r_quant1[760] @ 12160
	.field	-23758,16		; r_quant1[761] @ 12176
	.field	29346,16		; r_quant1[762] @ 12192
	.field	17762,16		; r_quant1[763] @ 12208
	.field	-28097,16		; r_quant1[764] @ 12224
	.field	25490,16		; r_quant1[765] @ 12240
	.field	13430,16		; r_quant1[766] @ 12256
	.field	-21968,16		; r_quant1[767] @ 12272
	.field	-31811,16		; r_quant1[768] @ 12288
	.field	-32385,16		; r_quant1[769] @ 12304
	.field	-17794,16		; r_quant1[770] @ 12320
	.field	32473,16		; r_quant1[771] @ 12336
	.field	-26494,16		; r_quant1[772] @ 12352
	.field	-13400,16		; r_quant1[773] @ 12368
	.field	32208,16		; r_quant1[774] @ 12384
	.field	-22914,16		; r_quant1[775] @ 12400
	.field	-13686,16		; r_quant1[776] @ 12416
	.field	31947,16		; r_quant1[777] @ 12432
	.field	-26754,16		; r_quant1[778] @ 12448
	.field	-17256,16		; r_quant1[779] @ 12464
	.field	31447,16		; r_quant1[780] @ 12480
	.field	-28297,16		; r_quant1[781] @ 12496
	.field	-10357,16		; r_quant1[782] @ 12512
	.field	30671,16		; r_quant1[783] @ 12528
	.field	-23178,16		; r_quant1[784] @ 12544
	.field	-13674,16		; r_quant1[785] @ 12560
	.field	31683,16		; r_quant1[786] @ 12576
	.field	-30857,16		; r_quant1[787] @ 12592
	.field	-14202,16		; r_quant1[788] @ 12608
	.field	30908,16		; r_quant1[789] @ 12624
	.field	-21898,16		; r_quant1[790] @ 12640
	.field	-19031,16		; r_quant1[791] @ 12656
	.field	31665,16		; r_quant1[792] @ 12672
	.field	-26243,16		; r_quant1[793] @ 12688
	.field	-23655,16		; r_quant1[794] @ 12704
	.field	30125,16		; r_quant1[795] @ 12720
	.field	-28288,16		; r_quant1[796] @ 12736
	.field	-18292,16		; r_quant1[797] @ 12752
	.field	31667,16		; r_quant1[798] @ 12768
	.field	-29830,16		; r_quant1[799] @ 12784
	.field	-18302,16		; r_quant1[800] @ 12800
	.field	29882,16		; r_quant1[801] @ 12816
	.field	-29568,16		; r_quant1[802] @ 12832
	.field	-9601,16		; r_quant1[803] @ 12848
	.field	32215,16		; r_quant1[804] @ 12864
	.field	30846,16		; r_quant1[805] @ 12880
	.field	-15244,16		; r_quant1[806] @ 12896
	.field	30676,16		; r_quant1[807] @ 12912
	.field	31095,16		; r_quant1[808] @ 12928
	.field	-9370,16		; r_quant1[809] @ 12944
	.field	29405,16		; r_quant1[810] @ 12960
	.field	-31632,16		; r_quant1[811] @ 12976
	.field	-10869,16		; r_quant1[812] @ 12992
	.field	29129,16		; r_quant1[813] @ 13008
	.field	-28304,16		; r_quant1[814] @ 13024
	.field	-15715,16		; r_quant1[815] @ 13040
	.field	30635,16		; r_quant1[816] @ 13056
	.field	30578,16		; r_quant1[817] @ 13072
	.field	-22917,16		; r_quant1[818] @ 13088
	.field	29364,16		; r_quant1[819] @ 13104
	.field	31600,16		; r_quant1[820] @ 13120
	.field	-20877,16		; r_quant1[821] @ 13136
	.field	27819,16		; r_quant1[822] @ 13152
	.field	31854,16		; r_quant1[823] @ 13168
	.field	-23672,16		; r_quant1[824] @ 13184
	.field	26288,16		; r_quant1[825] @ 13200
	.field	31860,16		; r_quant1[826] @ 13216
	.field	-22420,16		; r_quant1[827] @ 13232
	.field	29893,16		; r_quant1[828] @ 13248
	.field	32369,16		; r_quant1[829] @ 13264
	.field	-16253,16		; r_quant1[830] @ 13280
	.field	29350,16		; r_quant1[831] @ 13296
	.field	-28042,16		; r_quant1[832] @ 13312
	.field	-20095,16		; r_quant1[833] @ 13328
	.field	28854,16		; r_quant1[834] @ 13344
	.field	-29329,16		; r_quant1[835] @ 13360
	.field	-19324,16		; r_quant1[836] @ 13376
	.field	27571,16		; r_quant1[837] @ 13392
	.field	32379,16		; r_quant1[838] @ 13408
	.field	-14999,16		; r_quant1[839] @ 13424
	.field	31172,16		; r_quant1[840] @ 13440
	.field	30839,16		; r_quant1[841] @ 13456
	.field	-17801,16		; r_quant1[842] @ 13472
	.field	30650,16		; r_quant1[843] @ 13488
	.field	26739,16		; r_quant1[844] @ 13504
	.field	-18066,16		; r_quant1[845] @ 13520
	.field	28849,16		; r_quant1[846] @ 13536
	.field	26484,16		; r_quant1[847] @ 13552
	.field	-15510,16		; r_quant1[848] @ 13568
	.field	28861,16		; r_quant1[849] @ 13584
	.field	25200,16		; r_quant1[850] @ 13600
	.field	-14226,16		; r_quant1[851] @ 13616
	.field	28342,16		; r_quant1[852] @ 13632
	.field	28009,16		; r_quant1[853] @ 13648
	.field	-19604,16		; r_quant1[854] @ 13664
	.field	29111,16		; r_quant1[855] @ 13680
	.field	23406,16		; r_quant1[856] @ 13696
	.field	-16004,16		; r_quant1[857] @ 13712
	.field	27581,16		; r_quant1[858] @ 13728
	.field	30056,16		; r_quant1[859] @ 13744
	.field	-16512,16		; r_quant1[860] @ 13760
	.field	27847,16		; r_quant1[861] @ 13776
	.field	-28053,16		; r_quant1[862] @ 13792
	.field	-15987,16		; r_quant1[863] @ 13808
	.field	27844,16		; r_quant1[864] @ 13824
	.field	27243,16		; r_quant1[865] @ 13840
	.field	-16796,16		; r_quant1[866] @ 13856
	.field	29143,16		; r_quant1[867] @ 13872
	.field	29805,16		; r_quant1[868] @ 13888
	.field	-12174,16		; r_quant1[869] @ 13904
	.field	28127,16		; r_quant1[870] @ 13920
	.field	32106,16		; r_quant1[871] @ 13936
	.field	-7554,16		; r_quant1[872] @ 13952
	.field	27343,16		; r_quant1[873] @ 13968
	.field	-32666,16		; r_quant1[874] @ 13984
	.field	-10880,16		; r_quant1[875] @ 14000
	.field	27608,16		; r_quant1[876] @ 14016
	.field	28520,16		; r_quant1[877] @ 14032
	.field	-11418,16		; r_quant1[878] @ 14048
	.field	25817,16		; r_quant1[879] @ 14064
	.field	29794,16		; r_quant1[880] @ 14080
	.field	-13449,16		; r_quant1[881] @ 14096
	.field	26307,16		; r_quant1[882] @ 14112
	.field	29026,16		; r_quant1[883] @ 14128
	.field	-16018,16		; r_quant1[884] @ 14144
	.field	25037,16		; r_quant1[885] @ 14160
	.field	26464,16		; r_quant1[886] @ 14176
	.field	-13989,16		; r_quant1[887] @ 14192
	.field	26042,16		; r_quant1[888] @ 14208
	.field	31076,16		; r_quant1[889] @ 14224
	.field	-18831,16		; r_quant1[890] @ 14240
	.field	24752,16		; r_quant1[891] @ 14256
	.field	27997,16		; r_quant1[892] @ 14272
	.field	-19848,16		; r_quant1[893] @ 14288
	.field	24516,16		; r_quant1[894] @ 14304
	.field	30811,16		; r_quant1[895] @ 14320
	.field	-16780,16		; r_quant1[896] @ 14336
	.field	23489,16		; r_quant1[897] @ 14352
	.field	27227,16		; r_quant1[898] @ 14368
	.field	-20629,16		; r_quant1[899] @ 14384
	.field	25541,16		; r_quant1[900] @ 14400
	.field	22384,16		; r_quant1[901] @ 14416
	.field	-13481,16		; r_quant1[902] @ 14432
	.field	27338,16		; r_quant1[903] @ 14448
	.field	22632,16		; r_quant1[904] @ 14464
	.field	-15513,16		; r_quant1[905] @ 14480
	.field	25529,16		; r_quant1[906] @ 14496
	.field	24415,16		; r_quant1[907] @ 14512
	.field	-17561,16		; r_quant1[908] @ 14528
	.field	23990,16		; r_quant1[909] @ 14544
	.field	24679,16		; r_quant1[910] @ 14560
	.field	-11631,16		; r_quant1[911] @ 14576
	.field	23486,16		; r_quant1[912] @ 14592
	.field	22363,16		; r_quant1[913] @ 14608
	.field	-18859,16		; r_quant1[914] @ 14624
	.field	23222,16		; r_quant1[915] @ 14640
	.field	19798,16		; r_quant1[916] @ 14656
	.field	-18849,16		; r_quant1[917] @ 14672
	.field	20402,16		; r_quant1[918] @ 14688
	.field	24399,16		; r_quant1[919] @ 14704
	.field	-19625,16		; r_quant1[920] @ 14720
	.field	20145,16		; r_quant1[921] @ 14736
	.field	20303,16		; r_quant1[922] @ 14752
	.field	-21672,16		; r_quant1[923] @ 14768
	.field	18597,16		; r_quant1[924] @ 14784
	.field	21831,16		; r_quant1[925] @ 14800
	.field	-21677,16		; r_quant1[926] @ 14816
	.field	16806,16		; r_quant1[927] @ 14832
	.field	20033,16		; r_quant1[928] @ 14848
	.field	-23983,16		; r_quant1[929] @ 14864
	.field	16799,16		; r_quant1[930] @ 14880
	.field	19260,16		; r_quant1[931] @ 14896
	.field	-24252,16		; r_quant1[932] @ 14912
	.field	26822,16		; r_quant1[933] @ 14928
	.field	18537,16		; r_quant1[934] @ 14944
	.field	-16066,16		; r_quant1[935] @ 14960
	.field	25272,16		; r_quant1[936] @ 14976
	.field	13654,16		; r_quant1[937] @ 14992
	.field	-21694,16		; r_quant1[938] @ 15008
	.field	19876,16		; r_quant1[939] @ 15024
	.field	13925,16		; r_quant1[940] @ 15040
	.field	-12727,16		; r_quant1[941] @ 15056
	.field	25286,16		; r_quant1[942] @ 15072
	.field	15702,16		; r_quant1[943] @ 15088
	.field	-18368,16		; r_quant1[944] @ 15104
	.field	21431,16		; r_quant1[945] @ 15120
	.field	13649,16		; r_quant1[946] @ 15136
	.field	-20919,16		; r_quant1[947] @ 15152
	.field	19110,16		; r_quant1[948] @ 15168
	.field	17240,16		; r_quant1[949] @ 15184
	.field	-19397,16		; r_quant1[950] @ 15200
	.field	22452,16		; r_quant1[951] @ 15216
	.field	11853,16		; r_quant1[952] @ 15232
	.field	-23470,16		; r_quant1[953] @ 15248
	.field	17821,16		; r_quant1[954] @ 15264
	.field	20289,16		; r_quant1[955] @ 15280
	.field	-27070,16		; r_quant1[956] @ 15296
	.field	19357,16		; r_quant1[957] @ 15312
	.field	9303,16 		; r_quant1[958] @ 15328
	.field	-16823,16		; r_quant1[959] @ 15344
	.field	20395,16		; r_quant1[960] @ 15360
	.field	25164,16		; r_quant1[961] @ 15376
	.field	-19611,16		; r_quant1[962] @ 15392
	.field	18603,16		; r_quant1[963] @ 15408
	.field	25411,16		; r_quant1[964] @ 15424
	.field	-21667,16		; r_quant1[965] @ 15440
	.field	20646,16		; r_quant1[966] @ 15456
	.field	27466,16		; r_quant1[967] @ 15472
	.field	-24216,16		; r_quant1[968] @ 15488
	.field	19361,16		; r_quant1[969] @ 15504
	.field	24902,16		; r_quant1[970] @ 15520
	.field	-25252,16		; r_quant1[971] @ 15536
	.field	18340,16		; r_quant1[972] @ 15552
	.field	24896,16		; r_quant1[973] @ 15568
	.field	-24226,16		; r_quant1[974] @ 15584
	.field	15771,16		; r_quant1[975] @ 15600
	.field	24893,16		; r_quant1[976] @ 15616
	.field	-22427,16		; r_quant1[977] @ 15632
	.field	15778,16		; r_quant1[978] @ 15648
	.field	26680,16		; r_quant1[979] @ 15664
	.field	-24476,16		; r_quant1[980] @ 15680
	.field	13733,16		; r_quant1[981] @ 15696
	.field	25906,16		; r_quant1[982] @ 15712
	.field	-25499,16		; r_quant1[983] @ 15728
	.field	15266,16		; r_quant1[984] @ 15744
	.field	23348,16		; r_quant1[985] @ 15760
	.field	-25252,16		; r_quant1[986] @ 15776
	.field	13981,16		; r_quant1[987] @ 15792
	.field	21566,16		; r_quant1[988] @ 15808
	.field	-27789,16		; r_quant1[989] @ 15824
	.field	14997,16		; r_quant1[990] @ 15840
	.field	28485,16		; r_quant1[991] @ 15856
	.field	-26521,16		; r_quant1[992] @ 15872
	.field	16541,16		; r_quant1[993] @ 15888
	.field	22337,16		; r_quant1[994] @ 15904
	.field	-26250,16		; r_quant1[995] @ 15920
	.field	17820,16		; r_quant1[996] @ 15936
	.field	28482,16		; r_quant1[997] @ 15952
	.field	-24211,16		; r_quant1[998] @ 15968
	.field	16284,16		; r_quant1[999] @ 15984
	.field	26940,16		; r_quant1[1000] @ 16000
	.field	-24205,16		; r_quant1[1001] @ 16016
	.field	14239,16		; r_quant1[1002] @ 16032
	.field	28984,16		; r_quant1[1003] @ 16048
	.field	-25747,16		; r_quant1[1004] @ 16064
	.field	12697,16		; r_quant1[1005] @ 16080
	.field	28226,16		; r_quant1[1006] @ 16096
	.field	-22669,16		; r_quant1[1007] @ 16112
	.field	13704,16		; r_quant1[1008] @ 16128
	.field	25391,16		; r_quant1[1009] @ 16144
	.field	-31650,16		; r_quant1[1010] @ 16160
	.field	12160,16		; r_quant1[1011] @ 16176
	.field	22573,16		; r_quant1[1012] @ 16192
	.field	32082,16		; r_quant1[1013] @ 16208
	.field	12950,16		; r_quant1[1014] @ 16224
	.field	18229,16		; r_quant1[1015] @ 16240
	.field	-26530,16		; r_quant1[1016] @ 16256
	.field	11929,16		; r_quant1[1017] @ 16272
	.field	20777,16		; r_quant1[1018] @ 16288
	.field	-26531,16		; r_quant1[1019] @ 16304
	.field	10900,16		; r_quant1[1020] @ 16320
	.field	22559,16		; r_quant1[1021] @ 16336
	.field	-28589,16		; r_quant1[1022] @ 16352
	.field	14991,16		; r_quant1[1023] @ 16368
	.field	27442,16		; r_quant1[1024] @ 16384
	.field	-29848,16		; r_quant1[1025] @ 16400
	.field	13974,16		; r_quant1[1026] @ 16416
	.field	26670,16		; r_quant1[1027] @ 16432
	.field	-27547,16		; r_quant1[1028] @ 16448
	.field	10382,16		; r_quant1[1029] @ 16464
	.field	26942,16		; r_quant1[1030] @ 16480
	.field	-27546,16		; r_quant1[1031] @ 16496
	.field	16277,16		; r_quant1[1032] @ 16512
	.field	24380,16		; r_quant1[1033] @ 16528
	.field	-27560,16		; r_quant1[1034] @ 16544
	.field	13719,16		; r_quant1[1035] @ 16560
	.field	21564,16		; r_quant1[1036] @ 16576
	.field	-27314,16		; r_quant1[1037] @ 16592
	.field	12176,16		; r_quant1[1038] @ 16608
	.field	20274,16		; r_quant1[1039] @ 16624
	.field	-28832,16		; r_quant1[1040] @ 16640
	.field	10637,16		; r_quant1[1041] @ 16656
	.field	23336,16		; r_quant1[1042] @ 16672
	.field	-30620,16		; r_quant1[1043] @ 16688
	.field	9092,16 		; r_quant1[1044] @ 16704
	.field	23612,16		; r_quant1[1045] @ 16720
	.field	-28840,16		; r_quant1[1046] @ 16736
	.field	13193,16		; r_quant1[1047] @ 16752
	.field	22575,16		; r_quant1[1048] @ 16768
	.field	-29615,16		; r_quant1[1049] @ 16784
	.field	12425,16		; r_quant1[1050] @ 16800
	.field	18241,16		; r_quant1[1051] @ 16816
	.field	-28085,16		; r_quant1[1052] @ 16832
	.field	9620,16 		; r_quant1[1053] @ 16848
	.field	25888,16		; r_quant1[1054] @ 16864
	.field	-29084,16		; r_quant1[1055] @ 16880
	.field	21665,16		; r_quant1[1056] @ 16896
	.field	27983,16		; r_quant1[1057] @ 16912
	.field	-25753,16		; r_quant1[1058] @ 16928
	.field	20371,16		; r_quant1[1059] @ 16944
	.field	20585,16		; r_quant1[1060] @ 16960
	.field	-18849,16		; r_quant1[1061] @ 16976
	.field	26542,16		; r_quant1[1062] @ 16992
	.field	23399,16		; r_quant1[1063] @ 17008
	.field	-21419,16		; r_quant1[1064] @ 17024
	.field	22191,16		; r_quant1[1065] @ 17040
	.field	25194,16		; r_quant1[1066] @ 17056
	.field	-16561,16		; r_quant1[1067] @ 17072
	.field	23973,16		; r_quant1[1068] @ 17088
	.field	26209,16		; r_quant1[1069] @ 17104
	.field	-21666,16		; r_quant1[1070] @ 17120
	.field	23204,16		; r_quant1[1071] @ 17136
	.field	22619,16		; r_quant1[1072] @ 17152
	.field	-21151,16		; r_quant1[1073] @ 17168
	.field	21925,16		; r_quant1[1074] @ 17184
	.field	24917,16		; r_quant1[1075] @ 17200
	.field	-21670,16		; r_quant1[1076] @ 17216
	.field	21156,16		; r_quant1[1077] @ 17232
	.field	22357,16		; r_quant1[1078] @ 17248
	.field	-25503,16		; r_quant1[1079] @ 17264
	.field	21400,16		; r_quant1[1080] @ 17280
	.field	23628,16		; r_quant1[1081] @ 17296
	.field	-25509,16		; r_quant1[1082] @ 17312
	.field	18325,16		; r_quant1[1083] @ 17328
	.field	21855,16		; r_quant1[1084] @ 17344
	.field	-20394,16		; r_quant1[1085] @ 17360
	.field	23214,16		; r_quant1[1086] @ 17376
	.field	20566,16		; r_quant1[1087] @ 17392
	.field	-23472,16		; r_quant1[1088] @ 17408
	.field	21154,16		; r_quant1[1089] @ 17424
	.field	18250,16		; r_quant1[1090] @ 17440
	.field	-25014,16		; r_quant1[1091] @ 17456
	.field	19096,16		; r_quant1[1092] @ 17472
	.field	20063,16		; r_quant1[1093] @ 17488
	.field	-21696,16		; r_quant1[1094] @ 17504
	.field	22951,16		; r_quant1[1095] @ 17520
	.field	13416,16		; r_quant1[1096] @ 17536
	.field	-19376,16		; r_quant1[1097] @ 17552
	.field	26031,16		; r_quant1[1098] @ 17568
	.field	18016,16		; r_quant1[1099] @ 17584
	.field	-23469,16		; r_quant1[1100] @ 17600
	.field	22427,16		; r_quant1[1101] @ 17616
	.field	21846,16		; r_quant1[1102] @ 17632
	.field	-25010,16		; r_quant1[1103] @ 17648
	.field	20618,16		; r_quant1[1104] @ 17664
	.field	19531,16		; r_quant1[1105] @ 17680
	.field	-29111,16		; r_quant1[1106] @ 17696
	.field	16263,16		; r_quant1[1107] @ 17712
	.field	19262,16		; r_quant1[1108] @ 17728
	.field	-31168,16		; r_quant1[1109] @ 17744
	.field	16255,16		; r_quant1[1110] @ 17760
	.field	19316,16		; r_quant1[1111] @ 17776
	.field	-20925,16		; r_quant1[1112] @ 17792
	.field	27561,16		; r_quant1[1113] @ 17808
	.field	22598,16		; r_quant1[1114] @ 17824
	.field	-28348,16		; r_quant1[1115] @ 17840
	.field	16012,16		; r_quant1[1116] @ 17856
	.field	15188,16		; r_quant1[1117] @ 17872
	.field	-24771,16		; r_quant1[1118] @ 17888
	.field	31683,16		; r_quant1[1119] @ 17904
	.field	21876,16		; r_quant1[1120] @ 17920
	.field	-18865,16		; r_quant1[1121] @ 17936
	.field	29364,16		; r_quant1[1122] @ 17952
	.field	18294,16		; r_quant1[1123] @ 17968
	.field	-13998,16		; r_quant1[1124] @ 17984
	.field	29629,16		; r_quant1[1125] @ 18000
	.field	18004,16		; r_quant1[1126] @ 18016
	.field	-26040,16		; r_quant1[1127] @ 18032
	.field	25252,16		; r_quant1[1128] @ 18048
	.field	17491,16		; r_quant1[1129] @ 18064
	.field	-26818,16		; r_quant1[1130] @ 18080
	.field	26022,16		; r_quant1[1131] @ 18096
	.field	14432,16		; r_quant1[1132] @ 18112
	.field	-23246,16		; r_quant1[1133] @ 18128
	.field	26528,16		; r_quant1[1134] @ 18144
	.field	21095,16		; r_quant1[1135] @ 18160
	.field	-25781,16		; r_quant1[1136] @ 18176
	.field	26270,16		; r_quant1[1137] @ 18192
	.field	16743,16		; r_quant1[1138] @ 18208
	.field	-25543,16		; r_quant1[1139] @ 18224
	.field	24219,16		; r_quant1[1140] @ 18240
	.field	19543,16		; r_quant1[1141] @ 18256
	.field	-27836,16		; r_quant1[1142] @ 18272
	.field	20875,16		; r_quant1[1143] @ 18288
	.field	16718,16		; r_quant1[1144] @ 18304
	.field	-30154,16		; r_quant1[1145] @ 18320
	.field	30390,16		; r_quant1[1146] @ 18336
	.field	14443,16		; r_quant1[1147] @ 18352
	.field	-23761,16		; r_quant1[1148] @ 18368
	.field	21651,16		; r_quant1[1149] @ 18384
	.field	13423,16		; r_quant1[1150] @ 18400
	.field	-20949,16		; r_quant1[1151] @ 18416
	.field	18842,16		; r_quant1[1152] @ 18432
	.field	-24767,16		; r_quant1[1153] @ 18448
	.field	-24168,16		; r_quant1[1154] @ 18464
	.field	18065,16		; r_quant1[1155] @ 18480
	.field	-30909,16		; r_quant1[1156] @ 18496
	.field	-27738,16		; r_quant1[1157] @ 18512
	.field	15262,16		; r_quant1[1158] @ 18528
	.field	-24002,16		; r_quant1[1159] @ 18544
	.field	-30549,16		; r_quant1[1160] @ 18560
	.field	15494,16		; r_quant1[1161] @ 18576
	.field	-24513,16		; r_quant1[1162] @ 18592
	.field	-26988,16		; r_quant1[1163] @ 18608
	.field	15247,16		; r_quant1[1164] @ 18624
	.field	-27850,16		; r_quant1[1165] @ 18640
	.field	-26474,16		; r_quant1[1166] @ 18656
	.field	13459,16		; r_quant1[1167] @ 18672
	.field	-29375,16		; r_quant1[1168] @ 18688
	.field	-26235,16		; r_quant1[1169] @ 18704
	.field	15257,16		; r_quant1[1170] @ 18720
	.field	-30153,16		; r_quant1[1171] @ 18736
	.field	-26747,16		; r_quant1[1172] @ 18752
	.field	17042,16		; r_quant1[1173] @ 18768
	.field	32572,16		; r_quant1[1174] @ 18784
	.field	-28292,16		; r_quant1[1175] @ 18800
	.field	15497,16		; r_quant1[1176] @ 18816
	.field	31799,16		; r_quant1[1177] @ 18832
	.field	-30089,16		; r_quant1[1178] @ 18848
	.field	15755,16		; r_quant1[1179] @ 18864
	.field	-29896,16		; r_quant1[1180] @ 18880
	.field	-30074,16		; r_quant1[1181] @ 18896
	.field	13197,16		; r_quant1[1182] @ 18912
	.field	-31944,16		; r_quant1[1183] @ 18928
	.field	-24449,16		; r_quant1[1184] @ 18944
	.field	13978,16		; r_quant1[1185] @ 18960
	.field	31537,16		; r_quant1[1186] @ 18976
	.field	-25723,16		; r_quant1[1187] @ 18992
	.field	12170,16		; r_quant1[1188] @ 19008
	.field	-27319,16		; r_quant1[1189] @ 19024
	.field	-30326,16		; r_quant1[1190] @ 19040
	.field	17031,16		; r_quant1[1191] @ 19056
	.field	-32709,16		; r_quant1[1192] @ 19072
	.field	32645,16		; r_quant1[1193] @ 19088
	.field	15772,16		; r_quant1[1194] @ 19104
	.field	32055,16		; r_quant1[1195] @ 19120
	.field	-24178,16		; r_quant1[1196] @ 19136
	.field	12444,16		; r_quant1[1197] @ 19152
	.field	-28114,16		; r_quant1[1198] @ 19168
	.field	-27250,16		; r_quant1[1199] @ 19184
	.field	11664,16		; r_quant1[1200] @ 19200
	.field	28200,16		; r_quant1[1201] @ 19216
	.field	-30867,16		; r_quant1[1202] @ 19232
	.field	11659,16		; r_quant1[1203] @ 19248
	.field	-32203,16		; r_quant1[1204] @ 19264
	.field	-28038,16		; r_quant1[1205] @ 19280
	.field	12687,16		; r_quant1[1206] @ 19296
	.field	29998,16		; r_quant1[1207] @ 19312
	.field	-30598,16		; r_quant1[1208] @ 19328
	.field	10884,16		; r_quant1[1209] @ 19344
	.field	30253,16		; r_quant1[1210] @ 19360
	.field	-26495,16		; r_quant1[1211] @ 19376
	.field	11929,16		; r_quant1[1212] @ 19392
	.field	30501,16		; r_quant1[1213] @ 19408
	.field	-26251,16		; r_quant1[1214] @ 19424
	.field	10399,16		; r_quant1[1215] @ 19440
	.field	32290,16		; r_quant1[1216] @ 19456
	.field	-25730,16		; r_quant1[1217] @ 19472
	.field	7323,16 		; r_quant1[1218] @ 19488
	.field	32027,16		; r_quant1[1219] @ 19504
	.field	-25737,16		; r_quant1[1220] @ 19520
	.field	5525,16 		; r_quant1[1221] @ 19536
	.field	30503,16		; r_quant1[1222] @ 19552
	.field	-30327,16		; r_quant1[1223] @ 19568
	.field	9358,16 		; r_quant1[1224] @ 19584
	.field	-31969,16		; r_quant1[1225] @ 19600
	.field	-30586,16		; r_quant1[1226] @ 19616
	.field	6032,16 		; r_quant1[1227] @ 19632
	.field	-31211,16		; r_quant1[1228] @ 19648
	.field	-31357,16		; r_quant1[1229] @ 19664
	.field	10643,16		; r_quant1[1230] @ 19680
	.field	31782,16		; r_quant1[1231] @ 19696
	.field	-28300,16		; r_quant1[1232] @ 19712
	.field	8594,16 		; r_quant1[1233] @ 19728
	.field	31515,16		; r_quant1[1234] @ 19744
	.field	-28806,16		; r_quant1[1235] @ 19760
	.field	9352,16 		; r_quant1[1236] @ 19776
	.field	31004,16		; r_quant1[1237] @ 19792
	.field	-32135,16		; r_quant1[1238] @ 19808
	.field	8587,16 		; r_quant1[1239] @ 19824
	.field	28955,16		; r_quant1[1240] @ 19840
	.field	-29841,16		; r_quant1[1241] @ 19856
	.field	9622,16 		; r_quant1[1242] @ 19872
	.field	27930,16		; r_quant1[1243] @ 19888
	.field	-26001,16		; r_quant1[1244] @ 19904
	.field	7571,16 		; r_quant1[1245] @ 19920
	.field	28185,16		; r_quant1[1246] @ 19936
	.field	-27289,16		; r_quant1[1247] @ 19952
	.field	30040,16		; r_quant1[1248] @ 19968
	.field	-25811,16		; r_quant1[1249] @ 19984
	.field	-30325,16		; r_quant1[1250] @ 20000
	.field	13704,16		; r_quant1[1251] @ 20016
	.field	-25802,16		; r_quant1[1252] @ 20032
	.field	-32624,16		; r_quant1[1253] @ 20048
	.field	11898,16		; r_quant1[1254] @ 20064
	.field	-29142,16		; r_quant1[1255] @ 20080
	.field	-32105,16		; r_quant1[1256] @ 20096
	.field	8830,16 		; r_quant1[1257] @ 20112
	.field	-28640,16		; r_quant1[1258] @ 20128
	.field	31642,16		; r_quant1[1259] @ 20144
	.field	6017,16 		; r_quant1[1260] @ 20160
	.field	-28122,16		; r_quant1[1261] @ 20176
	.field	28819,16		; r_quant1[1262] @ 20192
	.field	8553,16 		; r_quant1[1263] @ 20208
	.field	-29403,16		; r_quant1[1264] @ 20224
	.field	29575,16		; r_quant1[1265] @ 20240
	.field	7031,16 		; r_quant1[1266] @ 20256
	.field	-31161,16		; r_quant1[1267] @ 20272
	.field	30613,16		; r_quant1[1268] @ 20288
	.field	16753,16		; r_quant1[1269] @ 20304
	.field	-29896,16		; r_quant1[1270] @ 20320
	.field	29330,16		; r_quant1[1271] @ 20336
	.field	12651,16		; r_quant1[1272] @ 20352
	.field	-29655,16		; r_quant1[1273] @ 20368
	.field	27520,16		; r_quant1[1274] @ 20384
	.field	12131,16		; r_quant1[1275] @ 20400
	.field	-31960,16		; r_quant1[1276] @ 20416
	.field	23935,16		; r_quant1[1277] @ 20432
	.field	16482,16		; r_quant1[1278] @ 20448
	.field	-23246,16		; r_quant1[1279] @ 20464
	.field	25238,16		; r_quant1[1280] @ 20480
	.field	11868,16		; r_quant1[1281] @ 20496
	.field	-29657,16		; r_quant1[1282] @ 20512
	.field	21392,16		; r_quant1[1283] @ 20528
	.field	15943,16		; r_quant1[1284] @ 20544
	.field	-30403,16		; r_quant1[1285] @ 20560
	.field	13715,16		; r_quant1[1286] @ 20576
	.field	10111,16		; r_quant1[1287] @ 20592
	.field	-30940,16		; r_quant1[1288] @ 20608
	.field	31872,16		; r_quant1[1289] @ 20624
	.field	10368,16		; r_quant1[1290] @ 20640
	.field	-24027,16		; r_quant1[1291] @ 20656
	.field	28322,16		; r_quant1[1292] @ 20672
	.field	7786,16 		; r_quant1[1293] @ 20688
	.field	-26076,16		; r_quant1[1294] @ 20704
	.field	22435,16		; r_quant1[1295] @ 20720
	.field	16750,16		; r_quant1[1296] @ 20736
	.field	27965,16		; r_quant1[1297] @ 20752
	.field	-31122,16		; r_quant1[1298] @ 20768
	.field	13449,16		; r_quant1[1299] @ 20784
	.field	28977,16		; r_quant1[1300] @ 20800
	.field	-31891,16		; r_quant1[1301] @ 20816
	.field	8576,16 		; r_quant1[1302] @ 20832
	.field	27437,16		; r_quant1[1303] @ 20848
	.field	32616,16		; r_quant1[1304] @ 20864
	.field	11133,16		; r_quant1[1305] @ 20880
	.field	24355,16		; r_quant1[1306] @ 20896
	.field	30310,16		; r_quant1[1307] @ 20912
	.field	9846,16 		; r_quant1[1308] @ 20928
	.field	23608,16		; r_quant1[1309] @ 20944
	.field	27263,16		; r_quant1[1310] @ 20960
	.field	15486,16		; r_quant1[1311] @ 20976
	.field	31288,16		; r_quant1[1312] @ 20992
	.field	31861,16		; r_quant1[1313] @ 21008
	.field	13440,16		; r_quant1[1314] @ 21024
	.field	-32721,16		; r_quant1[1315] @ 21040
	.field	31362,16		; r_quant1[1316] @ 21056
	.field	11123,16		; r_quant1[1317] @ 21072
	.field	32294,16		; r_quant1[1318] @ 21088
	.field	31605,16		; r_quant1[1319] @ 21104
	.field	8306,16 		; r_quant1[1320] @ 21120
	.field	29759,16		; r_quant1[1321] @ 21136
	.field	29820,16		; r_quant1[1322] @ 21152
	.field	14197,16		; r_quant1[1323] @ 21168
	.field	31023,16		; r_quant1[1324] @ 21184
	.field	31349,16		; r_quant1[1325] @ 21200
	.field	12663,16		; r_quant1[1326] @ 21216
	.field	27957,16		; r_quant1[1327] @ 21232
	.field	28020,16		; r_quant1[1328] @ 21248
	.field	11372,16		; r_quant1[1329] @ 21264
	.field	29239,16		; r_quant1[1330] @ 21280
	.field	25717,16		; r_quant1[1331] @ 21296
	.field	10083,16		; r_quant1[1332] @ 21312
	.field	29500,16		; r_quant1[1333] @ 21328
	.field	30061,16		; r_quant1[1334] @ 21344
	.field	13940,16		; r_quant1[1335] @ 21360
	.field	26417,16		; r_quant1[1336] @ 21376
	.field	27752,16		; r_quant1[1337] @ 21392
	.field	10090,16		; r_quant1[1338] @ 21408
	.field	25402,16		; r_quant1[1339] @ 21424
	.field	32618,16		; r_quant1[1340] @ 21440
	.field	14204,16		; r_quant1[1341] @ 21456
	.field	25411,16		; r_quant1[1342] @ 21472
	.field	31853,16		; r_quant1[1343] @ 21488
	.field	21613,16		; r_quant1[1344] @ 21504
	.field	-31144,16		; r_quant1[1345] @ 21520
	.field	28024,16		; r_quant1[1346] @ 21536
	.field	20343,16		; r_quant1[1347] @ 21552
	.field	30278,16		; r_quant1[1348] @ 21568
	.field	30321,16		; r_quant1[1349] @ 21584
	.field	17773,16		; r_quant1[1350] @ 21600
	.field	29804,16		; r_quant1[1351] @ 21616
	.field	31340,16		; r_quant1[1352] @ 21632
	.field	19579,16		; r_quant1[1353] @ 21648
	.field	-31932,16		; r_quant1[1354] @ 21664
	.field	31617,16		; r_quant1[1355] @ 21680
	.field	18823,16		; r_quant1[1356] @ 21696
	.field	30787,16		; r_quant1[1357] @ 21712
	.field	-32140,16		; r_quant1[1358] @ 21728
	.field	25981,16		; r_quant1[1359] @ 21744
	.field	-30359,16		; r_quant1[1360] @ 21760
	.field	32380,16		; r_quant1[1361] @ 21776
	.field	23933,16		; r_quant1[1362] @ 21792
	.field	31073,16		; r_quant1[1363] @ 21808
	.field	-28793,16		; r_quant1[1364] @ 21824
	.field	25228,16		; r_quant1[1365] @ 21840
	.field	31833,16		; r_quant1[1366] @ 21856
	.field	-30087,16		; r_quant1[1367] @ 21872
	.field	21648,16		; r_quant1[1368] @ 21888
	.field	32335,16		; r_quant1[1369] @ 21904
	.field	-30080,16		; r_quant1[1370] @ 21920
	.field	21635,16		; r_quant1[1371] @ 21936
	.field	32588,16		; r_quant1[1372] @ 21952
	.field	32631,16		; r_quant1[1373] @ 21968
	.field	20872,16		; r_quant1[1374] @ 21984
	.field	27468,16		; r_quant1[1375] @ 22000
	.field	-32658,16		; r_quant1[1376] @ 22016
	.field	19836,16		; r_quant1[1377] @ 22032
	.field	26728,16		; r_quant1[1378] @ 22048
	.field	-29580,16		; r_quant1[1379] @ 22064
	.field	25740,16		; r_quant1[1380] @ 22080
	.field	27752,16		; r_quant1[1381] @ 22096
	.field	-31636,16		; r_quant1[1382] @ 22112
	.field	23686,16		; r_quant1[1383] @ 22128
	.field	28759,16		; r_quant1[1384] @ 22144
	.field	-32659,16		; r_quant1[1385] @ 22160
	.field	22661,16		; r_quant1[1386] @ 22176
	.field	25693,16		; r_quant1[1387] @ 22192
	.field	30062,16		; r_quant1[1388] @ 22208
	.field	21620,16		; r_quant1[1389] @ 22224
	.field	27475,16		; r_quant1[1390] @ 22240
	.field	-29807,16		; r_quant1[1391] @ 22256
	.field	18543,16		; r_quant1[1392] @ 22272
	.field	26676,16		; r_quant1[1393] @ 22288
	.field	25953,16		; r_quant1[1394] @ 22304
	.field	25967,16		; r_quant1[1395] @ 22320
	.field	23656,16		; r_quant1[1396] @ 22336
	.field	-29606,16		; r_quant1[1397] @ 22352
	.field	26505,16		; r_quant1[1398] @ 22368
	.field	21581,16		; r_quant1[1399] @ 22384
	.field	32596,16		; r_quant1[1400] @ 22400
	.field	16756,16		; r_quant1[1401] @ 22416
	.field	24122,16		; r_quant1[1402] @ 22432
	.field	28762,16		; r_quant1[1403] @ 22448
	.field	11631,16		; r_quant1[1404] @ 22464
	.field	21046,16		; r_quant1[1405] @ 22480
	.field	26451,16		; r_quant1[1406] @ 22496
	.field	18297,16		; r_quant1[1407] @ 22512
	.field	25141,16		; r_quant1[1408] @ 22528
	.field	30294,16		; r_quant1[1409] @ 22544
	.field	25726,16		; r_quant1[1410] @ 22560
	.field	26194,16		; r_quant1[1411] @ 22576
	.field	32606,16		; r_quant1[1412] @ 22592
	.field	25476,16		; r_quant1[1413] @ 22608
	.field	24413,16		; r_quant1[1414] @ 22624
	.field	31837,16		; r_quant1[1415] @ 22640
	.field	20855,16		; r_quant1[1416] @ 22656
	.field	25167,16		; r_quant1[1417] @ 22672
	.field	29529,16		; r_quant1[1418] @ 22688
	.field	22654,16		; r_quant1[1419] @ 22704
	.field	22618,16		; r_quant1[1420] @ 22720
	.field	31824,16		; r_quant1[1421] @ 22736
	.field	19318,16		; r_quant1[1422] @ 22752
	.field	21059,16		; r_quant1[1423] @ 22768
	.field	29512,16		; r_quant1[1424] @ 22784
	.field	24434,16		; r_quant1[1425] @ 22800
	.field	25684,16		; r_quant1[1426] @ 22816
	.field	28000,16		; r_quant1[1427] @ 22832
	.field	19312,16		; r_quant1[1428] @ 22848
	.field	24908,16		; r_quant1[1429] @ 22864
	.field	27737,16		; r_quant1[1430] @ 22880
	.field	22381,16		; r_quant1[1431] @ 22896
	.field	22368,16		; r_quant1[1432] @ 22912
	.field	30551,16		; r_quant1[1433] @ 22928
	.field	22899,16		; r_quant1[1434] @ 22944
	.field	20849,16		; r_quant1[1435] @ 22960
	.field	-30367,16		; r_quant1[1436] @ 22976
	.field	27261,16		; r_quant1[1437] @ 22992
	.field	23401,16		; r_quant1[1438] @ 23008
	.field	-31918,16		; r_quant1[1439] @ 23024
	.field	-26696,16		; r_quant1[1440] @ 23040
	.field	28560,16		; r_quant1[1441] @ 23056
	.field	-18578,16		; r_quant1[1442] @ 23072
	.field	-29263,16		; r_quant1[1443] @ 23088
	.field	27285,16		; r_quant1[1444] @ 23104
	.field	-23188,16		; r_quant1[1445] @ 23120
	.field	-28516,16		; r_quant1[1446] @ 23136
	.field	26259,16		; r_quant1[1447] @ 23152
	.field	-21659,16		; r_quant1[1448] @ 23168
	.field	-29279,16		; r_quant1[1449] @ 23184
	.field	24198,16		; r_quant1[1450] @ 23200
	.field	-24981,16		; r_quant1[1451] @ 23216
	.field	-30036,16		; r_quant1[1452] @ 23232
	.field	17832,16		; r_quant1[1453] @ 23248
	.field	-11945,16		; r_quant1[1454] @ 23264
	.field	-24895,16		; r_quant1[1455] @ 23280
	.field	26522,16		; r_quant1[1456] @ 23296
	.field	-20130,16		; r_quant1[1457] @ 23312
	.field	-24913,16		; r_quant1[1458] @ 23328
	.field	19614,16		; r_quant1[1459] @ 23344
	.field	-17591,16		; r_quant1[1460] @ 23360
	.field	-27229,16		; r_quant1[1461] @ 23376
	.field	21392,16		; r_quant1[1462] @ 23392
	.field	-25527,16		; r_quant1[1463] @ 23408
	.field	-25151,16		; r_quant1[1464] @ 23424
	.field	18073,16		; r_quant1[1465] @ 23440
	.field	-16305,16		; r_quant1[1466] @ 23456
	.field	-28506,16		; r_quant1[1467] @ 23472
	.field	19087,16		; r_quant1[1468] @ 23488
	.field	-21432,16		; r_quant1[1469] @ 23504
	.field	-24877,16		; r_quant1[1470] @ 23520
	.field	27802,16		; r_quant1[1471] @ 23536
	.field	-14497,16		; r_quant1[1472] @ 23552
	.field	-27205,16		; r_quant1[1473] @ 23568
	.field	23954,16		; r_quant1[1474] @ 23584
	.field	-16543,16		; r_quant1[1475] @ 23600
	.field	-27966,16		; r_quant1[1476] @ 23616
	.field	21132,16		; r_quant1[1477] @ 23632
	.field	-18360,16		; r_quant1[1478] @ 23648
	.field	-29012,16		; r_quant1[1479] @ 23664
	.field	23689,16		; r_quant1[1480] @ 23680
	.field	-22954,16		; r_quant1[1481] @ 23696
	.field	-32355,16		; r_quant1[1482] @ 23712
	.field	21642,16		; r_quant1[1483] @ 23728
	.field	-27540,16		; r_quant1[1484] @ 23744
	.field	-31080,16		; r_quant1[1485] @ 23760
	.field	23694,16		; r_quant1[1486] @ 23776
	.field	-27555,16		; r_quant1[1487] @ 23792
	.field	28018,16		; r_quant1[1488] @ 23808
	.field	20080,16		; r_quant1[1489] @ 23824
	.field	-29880,16		; r_quant1[1490] @ 23840
	.field	-32615,16		; r_quant1[1491] @ 23856
	.field	15446,16		; r_quant1[1492] @ 23872
	.field	26962,16		; r_quant1[1493] @ 23888
	.field	24947,16		; r_quant1[1494] @ 23904
	.field	19797,16		; r_quant1[1495] @ 23920
	.field	27464,16		; r_quant1[1496] @ 23936
	.field	27769,16		; r_quant1[1497] @ 23952
	.field	18795,16		; r_quant1[1498] @ 23968
	.field	31040,16		; r_quant1[1499] @ 23984
	.field	25711,16		; r_quant1[1500] @ 24000
	.field	18028,16		; r_quant1[1501] @ 24016
	.field	28991,16		; r_quant1[1502] @ 24032
	.field	-32096,16		; r_quant1[1503] @ 24048
	.field	19580,16		; r_quant1[1504] @ 24064
	.field	-29351,16		; r_quant1[1505] @ 24080
	.field	29568,16		; r_quant1[1506] @ 24096
	.field	24696,16		; r_quant1[1507] @ 24112
	.field	-28071,16		; r_quant1[1508] @ 24128
	.field	29834,16		; r_quant1[1509] @ 24144
	.field	21871,16		; r_quant1[1510] @ 24160
	.field	-32181,16		; r_quant1[1511] @ 24176
	.field	23931,16		; r_quant1[1512] @ 24192
	.field	18782,16		; r_quant1[1513] @ 24208
	.field	30789,16		; r_quant1[1514] @ 24224
	.field	27266,16		; r_quant1[1515] @ 24240
	.field	15441,16		; r_quant1[1516] @ 24256
	.field	28216,16		; r_quant1[1517] @ 24272
	.field	-32124,16		; r_quant1[1518] @ 24288
	.field	23681,16		; r_quant1[1519] @ 24304
	.field	-30638,16		; r_quant1[1520] @ 24320
	.field	31363,16		; r_quant1[1521] @ 24336
	.field	19846,16		; r_quant1[1522] @ 24352
	.field	-30140,16		; r_quant1[1523] @ 24368
	.field	-32366,16		; r_quant1[1524] @ 24384
	.field	19322,16		; r_quant1[1525] @ 24400
	.field	-29117,16		; r_quant1[1526] @ 24416
	.field	-32626,16		; r_quant1[1527] @ 24432
	.field	15236,16		; r_quant1[1528] @ 24448
	.field	-26058,16		; r_quant1[1529] @ 24464
	.field	-30574,16		; r_quant1[1530] @ 24480
	.field	16251,16		; r_quant1[1531] @ 24496
	.field	-32712,16		; r_quant1[1532] @ 24512
	.field	-30057,16		; r_quant1[1533] @ 24528
	.field	13200,16		; r_quant1[1534] @ 24544
	.field	-25818,16		; r_quant1[1535] @ 24560
	.field	26266,16		; r_quant1[1536] @ 24576
	.field	-30353,16		; r_quant1[1537] @ 24592
	.field	-19040,16		; r_quant1[1538] @ 24608
	.field	26812,16		; r_quant1[1539] @ 24624
	.field	-25241,16		; r_quant1[1540] @ 24640
	.field	-17776,16		; r_quant1[1541] @ 24656
	.field	26291,16		; r_quant1[1542] @ 24672
	.field	-29854,16		; r_quant1[1543] @ 24688
	.field	-13175,16		; r_quant1[1544] @ 24704
	.field	25025,16		; r_quant1[1545] @ 24720
	.field	-24480,16		; r_quant1[1546] @ 24736
	.field	-17773,16		; r_quant1[1547] @ 24752
	.field	25277,16		; r_quant1[1548] @ 24768
	.field	-32161,16		; r_quant1[1549] @ 24784
	.field	-18302,16		; r_quant1[1550] @ 24800
	.field	23491,16		; r_quant1[1551] @ 24816
	.field	-30119,16		; r_quant1[1552] @ 24832
	.field	-18302,16		; r_quant1[1553] @ 24848
	.field	28319,16		; r_quant1[1554] @ 24864
	.field	-23961,16		; r_quant1[1555] @ 24880
	.field	-21862,16		; r_quant1[1556] @ 24896
	.field	25250,16		; r_quant1[1557] @ 24912
	.field	-26279,16		; r_quant1[1558] @ 24928
	.field	-15459,16		; r_quant1[1559] @ 24944
	.field	22711,16		; r_quant1[1560] @ 24960
	.field	-22446,16		; r_quant1[1561] @ 24976
	.field	-13414,16		; r_quant1[1562] @ 24992
	.field	21688,16		; r_quant1[1563] @ 25008
	.field	-26529,16		; r_quant1[1564] @ 25024
	.field	-24663,16		; r_quant1[1565] @ 25040
	.field	23450,16		; r_quant1[1566] @ 25056
	.field	-26276,16		; r_quant1[1567] @ 25072
	.field	-30558,16		; r_quant1[1568] @ 25088
	.field	20654,16		; r_quant1[1569] @ 25104
	.field	-25762,16		; r_quant1[1570] @ 25120
	.field	-21106,16		; r_quant1[1571] @ 25136
	.field	23204,16		; r_quant1[1572] @ 25152
	.field	-29093,16		; r_quant1[1573] @ 25168
	.field	-21374,16		; r_quant1[1574] @ 25184
	.field	21686,16		; r_quant1[1575] @ 25200
	.field	-30115,16		; r_quant1[1576] @ 25216
	.field	-11127,16		; r_quant1[1577] @ 25232
	.field	22746,16		; r_quant1[1578] @ 25248
	.field	-27814,16		; r_quant1[1579] @ 25264
	.field	-12679,16		; r_quant1[1580] @ 25280
	.field	22210,16		; r_quant1[1581] @ 25296
	.field	-32174,16		; r_quant1[1582] @ 25312
	.field	-13684,16		; r_quant1[1583] @ 25328
	.field	19354,16		; r_quant1[1584] @ 25344
	.field	28505,16		; r_quant1[1585] @ 25360
	.field	-21386,16		; r_quant1[1586] @ 25376
	.field	21933,16		; r_quant1[1587] @ 25392
	.field	27725,16		; r_quant1[1588] @ 25408
	.field	-19857,16		; r_quant1[1589] @ 25424
	.field	19627,16		; r_quant1[1590] @ 25440
	.field	31048,16		; r_quant1[1591] @ 25456
	.field	-21904,16		; r_quant1[1592] @ 25472
	.field	22164,16		; r_quant1[1593] @ 25488
	.field	-29361,16		; r_quant1[1594] @ 25504
	.field	-27771,16		; r_quant1[1595] @ 25520
	.field	18839,16		; r_quant1[1596] @ 25536
	.field	-30141,16		; r_quant1[1597] @ 25552
	.field	-24438,16		; r_quant1[1598] @ 25568
	.field	20133,16		; r_quant1[1599] @ 25584
	.field	-27055,16		; r_quant1[1600] @ 25600
	.field	-23414,16		; r_quant1[1601] @ 25616
	.field	19105,16		; r_quant1[1602] @ 25632
	.field	-29611,16		; r_quant1[1603] @ 25648
	.field	-22140,16		; r_quant1[1604] @ 25664
	.field	20658,16		; r_quant1[1605] @ 25680
	.field	-31661,16		; r_quant1[1606] @ 25696
	.field	-20873,16		; r_quant1[1607] @ 25712
	.field	20646,16		; r_quant1[1608] @ 25728
	.field	30297,16		; r_quant1[1609] @ 25744
	.field	-23938,16		; r_quant1[1610] @ 25760
	.field	21658,16		; r_quant1[1611] @ 25776
	.field	32595,16		; r_quant1[1612] @ 25792
	.field	-24714,16		; r_quant1[1613] @ 25808
	.field	19864,16		; r_quant1[1614] @ 25824
	.field	31054,16		; r_quant1[1615] @ 25840
	.field	-24191,16		; r_quant1[1616] @ 25856
	.field	18846,16		; r_quant1[1617] @ 25872
	.field	32070,16		; r_quant1[1618] @ 25888
	.field	-25988,16		; r_quant1[1619] @ 25904
	.field	19373,16		; r_quant1[1620] @ 25920
	.field	-29625,16		; r_quant1[1621] @ 25936
	.field	-19576,16		; r_quant1[1622] @ 25952
	.field	18346,16		; r_quant1[1623] @ 25968
	.field	-30651,16		; r_quant1[1624] @ 25984
	.field	-22911,16		; r_quant1[1625] @ 26000
	.field	16803,16		; r_quant1[1626] @ 26016
	.field	31563,16		; r_quant1[1627] @ 26032
	.field	-23951,16		; r_quant1[1628] @ 26048
	.field	19638,16		; r_quant1[1629] @ 26064
	.field	31812,16		; r_quant1[1630] @ 26080
	.field	-20615,16		; r_quant1[1631] @ 26096
	.field	19109,16		; r_quant1[1632] @ 26112
	.field	-21947,16		; r_quant1[1633] @ 26128
	.field	-22121,16		; r_quant1[1634] @ 26144
	.field	16559,16		; r_quant1[1635] @ 26160
	.field	-31929,16		; r_quant1[1636] @ 26176
	.field	-14436,16		; r_quant1[1637] @ 26192
	.field	18623,16		; r_quant1[1638] @ 26208
	.field	-28092,16		; r_quant1[1639] @ 26224
	.field	-12653,16		; r_quant1[1640] @ 26240
	.field	16842,16		; r_quant1[1641] @ 26256
	.field	-28606,16		; r_quant1[1642] @ 26272
	.field	-15724,16		; r_quant1[1643] @ 26288
	.field	16825,16		; r_quant1[1644] @ 26304
	.field	-27836,16		; r_quant1[1645] @ 26320
	.field	-18806,16		; r_quant1[1646] @ 26336
	.field	16563,16		; r_quant1[1647] @ 26352
	.field	-29889,16		; r_quant1[1648] @ 26368
	.field	-17274,16		; r_quant1[1649] @ 26384
	.field	15289,16		; r_quant1[1650] @ 26400
	.field	-32192,16		; r_quant1[1651] @ 26416
	.field	-15971,16		; r_quant1[1652] @ 26432
	.field	15814,16		; r_quant1[1653] @ 26448
	.field	-27330,16		; r_quant1[1654] @ 26464
	.field	-18793,16		; r_quant1[1655] @ 26480
	.field	15292,16		; r_quant1[1656] @ 26496
	.field	-28098,16		; r_quant1[1657] @ 26512
	.field	-17496,16		; r_quant1[1658] @ 26528
	.field	15030,16		; r_quant1[1659] @ 26544
	.field	-24008,16		; r_quant1[1660] @ 26560
	.field	-16485,16		; r_quant1[1661] @ 26576
	.field	14797,16		; r_quant1[1662] @ 26592
	.field	-28617,16		; r_quant1[1663] @ 26608
	.field	-13940,16		; r_quant1[1664] @ 26624
	.field	13780,16		; r_quant1[1665] @ 26640
	.field	-26829,16		; r_quant1[1666] @ 26656
	.field	-13677,16		; r_quant1[1667] @ 26672
	.field	14013,16		; r_quant1[1668] @ 26688
	.field	-29634,16		; r_quant1[1669] @ 26704
	.field	-20850,16		; r_quant1[1670] @ 26720
	.field	14771,16		; r_quant1[1671] @ 26736
	.field	-29641,16		; r_quant1[1672] @ 26752
	.field	-16720,16		; r_quant1[1673] @ 26768
	.field	13502,16		; r_quant1[1674] @ 26784
	.field	-23233,16		; r_quant1[1675] @ 26800
	.field	-13181,16		; r_quant1[1676] @ 26816
	.field	15559,16		; r_quant1[1677] @ 26832
	.field	-31175,16		; r_quant1[1678] @ 26848
	.field	-15743,16		; r_quant1[1679] @ 26864
	.field	12705,16		; r_quant1[1680] @ 26880
	.field	31286,16		; r_quant1[1681] @ 26896
	.field	-19045,16		; r_quant1[1682] @ 26912
	.field	13239,16		; r_quant1[1683] @ 26928
	.field	-28366,16		; r_quant1[1684] @ 26944
	.field	-15225,16		; r_quant1[1685] @ 26960
	.field	12476,16		; r_quant1[1686] @ 26976
	.field	-30662,16		; r_quant1[1687] @ 26992
	.field	-22902,16		; r_quant1[1688] @ 27008
	.field	15273,16		; r_quant1[1689] @ 27024
	.field	-31691,16		; r_quant1[1690] @ 27040
	.field	-22401,16		; r_quant1[1691] @ 27056
	.field	13481,16		; r_quant1[1692] @ 27072
	.field	-30672,16		; r_quant1[1693] @ 27088
	.field	-23414,16		; r_quant1[1694] @ 27104
	.field	13748,16		; r_quant1[1695] @ 27120
	.field	-31437,16		; r_quant1[1696] @ 27136
	.field	-18818,16		; r_quant1[1697] @ 27152
	.field	12465,16		; r_quant1[1698] @ 27168
	.field	-30930,16		; r_quant1[1699] @ 27184
	.field	-20349,16		; r_quant1[1700] @ 27200
	.field	12197,16		; r_quant1[1701] @ 27216
	.field	-32213,16		; r_quant1[1702] @ 27232
	.field	-23418,16		; r_quant1[1703] @ 27248
	.field	11432,16		; r_quant1[1704] @ 27264
	.field	32046,16		; r_quant1[1705] @ 27280
	.field	-15981,16		; r_quant1[1706] @ 27296
	.field	11448,16		; r_quant1[1707] @ 27312
	.field	-29142,16		; r_quant1[1708] @ 27328
	.field	-19828,16		; r_quant1[1709] @ 27344
	.field	10172,16		; r_quant1[1710] @ 27360
	.field	-30933,16		; r_quant1[1711] @ 27376
	.field	-18814,16		; r_quant1[1712] @ 27392
	.field	10163,16		; r_quant1[1713] @ 27408
	.field	-32472,16		; r_quant1[1714] @ 27424
	.field	-21628,16		; r_quant1[1715] @ 27440
	.field	12461,16		; r_quant1[1716] @ 27456
	.field	31529,16		; r_quant1[1717] @ 27472
	.field	-20105,16		; r_quant1[1718] @ 27488
	.field	13474,16		; r_quant1[1719] @ 27504
	.field	-25808,16		; r_quant1[1720] @ 27520
	.field	-21358,16		; r_quant1[1721] @ 27536
	.field	11692,16		; r_quant1[1722] @ 27552
	.field	-27082,16		; r_quant1[1723] @ 27568
	.field	-16258,16		; r_quant1[1724] @ 27584
	.field	12218,16		; r_quant1[1725] @ 27600
	.field	32299,16		; r_quant1[1726] @ 27616
	.field	-17284,16		; r_quant1[1727] @ 27632
	.field	22202,16		; r_quant1[1728] @ 27648
	.field	27217,16		; r_quant1[1729] @ 27664
	.field	-18574,16		; r_quant1[1730] @ 27680
	.field	19416,16		; r_quant1[1731] @ 27696
	.field	-24759,16		; r_quant1[1732] @ 27712
	.field	-11373,16		; r_quant1[1733] @ 27728
	.field	18638,16		; r_quant1[1734] @ 27744
	.field	32583,16		; r_quant1[1735] @ 27760
	.field	-14980,16		; r_quant1[1736] @ 27776
	.field	17613,16		; r_quant1[1737] @ 27792
	.field	-32169,16		; r_quant1[1738] @ 27808
	.field	-8332,16		; r_quant1[1739] @ 27824
	.field	21721,16		; r_quant1[1740] @ 27840
	.field	32088,16		; r_quant1[1741] @ 27856
	.field	-14221,16		; r_quant1[1742] @ 27872
	.field	21948,16		; r_quant1[1743] @ 27888
	.field	30805,16		; r_quant1[1744] @ 27904
	.field	-12927,16		; r_quant1[1745] @ 27920
	.field	20699,16		; r_quant1[1746] @ 27936
	.field	30797,16		; r_quant1[1747] @ 27952
	.field	-9855,16		; r_quant1[1748] @ 27968
	.field	20684,16		; r_quant1[1749] @ 27984
	.field	-31665,16		; r_quant1[1750] @ 28000
	.field	-14211,16		; r_quant1[1751] @ 28016
	.field	19653,16		; r_quant1[1752] @ 28032
	.field	-29878,16		; r_quant1[1753] @ 28048
	.field	-16762,16		; r_quant1[1754] @ 28064
	.field	21704,16		; r_quant1[1755] @ 28080
	.field	27472,16		; r_quant1[1756] @ 28096
	.field	-14486,16		; r_quant1[1757] @ 28112
	.field	20924,16		; r_quant1[1758] @ 28128
	.field	26958,16		; r_quant1[1759] @ 28144
	.field	-16797,16		; r_quant1[1760] @ 28160
	.field	20413,16		; r_quant1[1761] @ 28176
	.field	31816,16		; r_quant1[1762] @ 28192
	.field	-18569,16		; r_quant1[1763] @ 28208
	.field	19658,16		; r_quant1[1764] @ 28224
	.field	28744,16		; r_quant1[1765] @ 28240
	.field	-14228,16		; r_quant1[1766] @ 28256
	.field	18880,16		; r_quant1[1767] @ 28272
	.field	25932,16		; r_quant1[1768] @ 28288
	.field	-8341,16		; r_quant1[1769] @ 28304
	.field	19169,16		; r_quant1[1770] @ 28320
	.field	28999,16		; r_quant1[1771] @ 28336
	.field	-11416,16		; r_quant1[1772] @ 28352
	.field	20690,16		; r_quant1[1773] @ 28368
	.field	25418,16		; r_quant1[1774] @ 28384
	.field	-11428,16		; r_quant1[1775] @ 28400
	.field	18355,16		; r_quant1[1776] @ 28416
	.field	26689,16		; r_quant1[1777] @ 28432
	.field	-21398,16		; r_quant1[1778] @ 28448
	.field	16042,16		; r_quant1[1779] @ 28464
	.field	-32702,16		; r_quant1[1780] @ 28480
	.field	-14977,16		; r_quant1[1781] @ 28496
	.field	18360,16		; r_quant1[1782] @ 28512
	.field	28483,16		; r_quant1[1783] @ 28528
	.field	-17564,16		; r_quant1[1784] @ 28544
	.field	17089,16		; r_quant1[1785] @ 28560
	.field	26942,16		; r_quant1[1786] @ 28576
	.field	-17814,16		; r_quant1[1787] @ 28592
	.field	15803,16		; r_quant1[1788] @ 28608
	.field	24888,16		; r_quant1[1789] @ 28624
	.field	-19101,16		; r_quant1[1790] @ 28640
	.field	17595,16		; r_quant1[1791] @ 28656
	.field	-32447,16		; r_quant1[1792] @ 28672
	.field	-18308,16		; r_quant1[1793] @ 28688
	.field	17597,16		; r_quant1[1794] @ 28704
	.field	28992,16		; r_quant1[1795] @ 28720
	.field	-18318,16		; r_quant1[1796] @ 28736
	.field	16066,16		; r_quant1[1797] @ 28752
	.field	30780,16		; r_quant1[1798] @ 28768
	.field	-18055,16		; r_quant1[1799] @ 28784
	.field	14519,16		; r_quant1[1800] @ 28800
	.field	30270,16		; r_quant1[1801] @ 28816
	.field	-21388,16		; r_quant1[1802] @ 28832
	.field	14761,16		; r_quant1[1803] @ 28848
	.field	28221,16		; r_quant1[1804] @ 28864
	.field	-19861,16		; r_quant1[1805] @ 28880
	.field	14514,16		; r_quant1[1806] @ 28896
	.field	28214,16		; r_quant1[1807] @ 28912
	.field	-21398,16		; r_quant1[1808] @ 28928
	.field	16067,16		; r_quant1[1809] @ 28944
	.field	26681,16		; r_quant1[1810] @ 28960
	.field	-16528,16		; r_quant1[1811] @ 28976
	.field	13757,16		; r_quant1[1812] @ 28992
	.field	29748,16		; r_quant1[1813] @ 29008
	.field	-18833,16		; r_quant1[1814] @ 29024
	.field	14267,16		; r_quant1[1815] @ 29040
	.field	25923,16		; r_quant1[1816] @ 29056
	.field	-19360,16		; r_quant1[1817] @ 29072
	.field	14510,16		; r_quant1[1818] @ 29088
	.field	31028,16		; r_quant1[1819] @ 29104
	.field	-21132,16		; r_quant1[1820] @ 29120
	.field	17098,16		; r_quant1[1821] @ 29136
	.field	28995,16		; r_quant1[1822] @ 29152
	.field	-15014,16		; r_quant1[1823] @ 29168
	.field	13753,16		; r_quant1[1824] @ 29184
	.field	23857,16		; r_quant1[1825] @ 29200
	.field	-19615,16		; r_quant1[1826] @ 29216
	.field	11698,16		; r_quant1[1827] @ 29232
	.field	23616,16		; r_quant1[1828] @ 29248
	.field	-19366,16		; r_quant1[1829] @ 29264
	.field	17326,16		; r_quant1[1830] @ 29280
	.field	22334,16		; r_quant1[1831] @ 29296
	.field	-21677,16		; r_quant1[1832] @ 29312
	.field	15015,16		; r_quant1[1833] @ 29328
	.field	23092,16		; r_quant1[1834] @ 29344
	.field	-23210,16		; r_quant1[1835] @ 29360
	.field	18111,16		; r_quant1[1836] @ 29376
	.field	22591,16		; r_quant1[1837] @ 29392
	.field	-17835,16		; r_quant1[1838] @ 29408
	.field	14771,16		; r_quant1[1839] @ 29424
	.field	22836,16		; r_quant1[1840] @ 29440
	.field	-19882,16		; r_quant1[1841] @ 29456
	.field	15288,16		; r_quant1[1842] @ 29472
	.field	19765,16		; r_quant1[1843] @ 29488
	.field	-19896,16		; r_quant1[1844] @ 29504
	.field	11950,16		; r_quant1[1845] @ 29520
	.field	20778,16		; r_quant1[1846] @ 29536
	.field	-21178,16		; r_quant1[1847] @ 29552
	.field	15278,16		; r_quant1[1848] @ 29568
	.field	25142,16		; r_quant1[1849] @ 29584
	.field	-21669,16		; r_quant1[1850] @ 29600
	.field	12974,16		; r_quant1[1851] @ 29616
	.field	24877,16		; r_quant1[1852] @ 29632
	.field	-21413,16		; r_quant1[1853] @ 29648
	.field	12198,16		; r_quant1[1854] @ 29664
	.field	24107,16		; r_quant1[1855] @ 29680
	.field	-22953,16		; r_quant1[1856] @ 29696
	.field	10655,16		; r_quant1[1857] @ 29712
	.field	22561,16		; r_quant1[1858] @ 29728
	.field	-25259,16		; r_quant1[1859] @ 29744
	.field	15793,16		; r_quant1[1860] @ 29760
	.field	21294,16		; r_quant1[1861] @ 29776
	.field	-22708,16		; r_quant1[1862] @ 29792
	.field	14245,16		; r_quant1[1863] @ 29808
	.field	19500,16		; r_quant1[1864] @ 29824
	.field	-25016,16		; r_quant1[1865] @ 29840
	.field	9371,16 		; r_quant1[1866] @ 29856
	.field	15413,16		; r_quant1[1867] @ 29872
	.field	-18355,16		; r_quant1[1868] @ 29888
	.field	9644,16 		; r_quant1[1869] @ 29904
	.field	23844,16		; r_quant1[1870] @ 29920
	.field	-22704,16		; r_quant1[1871] @ 29936
	.field	20153,16		; r_quant1[1872] @ 29952
	.field	24137,16		; r_quant1[1873] @ 29968
	.field	-19111,16		; r_quant1[1874] @ 29984
	.field	15023,16		; r_quant1[1875] @ 30000
	.field	19247,16		; r_quant1[1876] @ 30016
	.field	-22463,16		; r_quant1[1877] @ 30032
	.field	14504,16		; r_quant1[1878] @ 30048
	.field	16224,16		; r_quant1[1879] @ 30064
	.field	-10406,16		; r_quant1[1880] @ 30080
	.field	23249,16		; r_quant1[1881] @ 30096
	.field	24920,16		; r_quant1[1882] @ 30112
	.field	-15266,16		; r_quant1[1883] @ 30128
	.field	21693,16		; r_quant1[1884] @ 30144
	.field	22613,16		; r_quant1[1885] @ 30160
	.field	-13738,16		; r_quant1[1886] @ 30176
	.field	20928,16		; r_quant1[1887] @ 30192
	.field	20299,16		; r_quant1[1888] @ 30208
	.field	-16815,16		; r_quant1[1889] @ 30224
	.field	17847,16		; r_quant1[1890] @ 30240
	.field	18767,16		; r_quant1[1891] @ 30256
	.field	-18620,16		; r_quant1[1892] @ 30272
	.field	18355,16		; r_quant1[1893] @ 30288
	.field	18754,16		; r_quant1[1894] @ 30304
	.field	-21951,16		; r_quant1[1895] @ 30320
	.field	24013,16		; r_quant1[1896] @ 30336
	.field	16213,16		; r_quant1[1897] @ 30352
	.field	-16331,16		; r_quant1[1898] @ 30368
	.field	18613,16		; r_quant1[1899] @ 30384
	.field	15171,16		; r_quant1[1900] @ 30400
	.field	-21203,16		; r_quant1[1901] @ 30416
	.field	20689,16		; r_quant1[1902] @ 30432
	.field	20039,16		; r_quant1[1903] @ 30448
	.field	-15285,16		; r_quant1[1904] @ 30464
	.field	19138,16		; r_quant1[1905] @ 30480
	.field	16963,16		; r_quant1[1906] @ 30496
	.field	-16831,16		; r_quant1[1907] @ 30512
	.field	20931,16		; r_quant1[1908] @ 30528
	.field	16465,16		; r_quant1[1909] @ 30544
	.field	-14536,16		; r_quant1[1910] @ 30560
	.field	16565,16		; r_quant1[1911] @ 30576
	.field	15932,16		; r_quant1[1912] @ 30592
	.field	-20174,16		; r_quant1[1913] @ 30608
	.field	13488,16		; r_quant1[1914] @ 30624
	.field	15680,16		; r_quant1[1915] @ 30640
	.field	-16845,16		; r_quant1[1916] @ 30656
	.field	11948,16		; r_quant1[1917] @ 30672
	.field	9558,16 		; r_quant1[1918] @ 30688
	.field	-9122,16		; r_quant1[1919] @ 30704
	.field	11206,16		; r_quant1[1920] @ 30720
	.field	-28366,16		; r_quant1[1921] @ 30736
	.field	-11909,16		; r_quant1[1922] @ 30752
	.field	12241,16		; r_quant1[1923] @ 30768
	.field	31276,16		; r_quant1[1924] @ 30784
	.field	-13965,16		; r_quant1[1925] @ 30800
	.field	12760,16		; r_quant1[1926] @ 30816
	.field	-29648,16		; r_quant1[1927] @ 30832
	.field	-12663,16		; r_quant1[1928] @ 30848
	.field	11992,16		; r_quant1[1929] @ 30864
	.field	-31188,16		; r_quant1[1930] @ 30880
	.field	-11896,16		; r_quant1[1931] @ 30896
	.field	11975,16		; r_quant1[1932] @ 30912
	.field	-32213,16		; r_quant1[1933] @ 30928
	.field	-15230,16		; r_quant1[1934] @ 30944
	.field	10958,16		; r_quant1[1935] @ 30960
	.field	-30680,16		; r_quant1[1936] @ 30976
	.field	-13181,16		; r_quant1[1937] @ 30992
	.field	12767,16		; r_quant1[1938] @ 31008
	.field	31279,16		; r_quant1[1939] @ 31024
	.field	-10122,16		; r_quant1[1940] @ 31040
	.field	11743,16		; r_quant1[1941] @ 31056
	.field	30508,16		; r_quant1[1942] @ 31072
	.field	-10377,16		; r_quant1[1943] @ 31088
	.field	10959,16		; r_quant1[1944] @ 31104
	.field	28457,16		; r_quant1[1945] @ 31120
	.field	-11148,16		; r_quant1[1946] @ 31136
	.field	10191,16		; r_quant1[1947] @ 31152
	.field	28715,16		; r_quant1[1948] @ 31168
	.field	-9600,16		; r_quant1[1949] @ 31184
	.field	10455,16		; r_quant1[1950] @ 31200
	.field	-32217,16		; r_quant1[1951] @ 31216
	.field	-7810,16		; r_quant1[1952] @ 31232
	.field	9949,16 		; r_quant1[1953] @ 31248
	.field	-31706,16		; r_quant1[1954] @ 31264
	.field	-10375,16		; r_quant1[1955] @ 31280
	.field	10698,16		; r_quant1[1956] @ 31296
	.field	31013,16		; r_quant1[1957] @ 31312
	.field	-13437,16		; r_quant1[1958] @ 31328
	.field	12493,16		; r_quant1[1959] @ 31344
	.field	-26579,16		; r_quant1[1960] @ 31360
	.field	-13157,16		; r_quant1[1961] @ 31376
	.field	10713,16		; r_quant1[1962] @ 31392
	.field	-27609,16		; r_quant1[1963] @ 31408
	.field	-10353,16		; r_quant1[1964] @ 31424
	.field	13518,16		; r_quant1[1965] @ 31440
	.field	-31959,16		; r_quant1[1966] @ 31456
	.field	-8337,16		; r_quant1[1967] @ 31472
	.field	9928,16 		; r_quant1[1968] @ 31488
	.field	30759,16		; r_quant1[1969] @ 31504
	.field	-16001,16		; r_quant1[1970] @ 31520
	.field	9153,16 		; r_quant1[1971] @ 31536
	.field	31522,16		; r_quant1[1972] @ 31552
	.field	-13181,16		; r_quant1[1973] @ 31568
	.field	9154,16 		; r_quant1[1974] @ 31584
	.field	-31457,16		; r_quant1[1975] @ 31600
	.field	-15741,16		; r_quant1[1976] @ 31616
	.field	9419,16 		; r_quant1[1977] @ 31632
	.field	31009,16		; r_quant1[1978] @ 31648
	.field	-13705,16		; r_quant1[1979] @ 31664
	.field	8388,16 		; r_quant1[1980] @ 31680
	.field	31261,16		; r_quant1[1981] @ 31696
	.field	-14468,16		; r_quant1[1982] @ 31712
	.field	8380,16 		; r_quant1[1983] @ 31728
	.field	31517,16		; r_quant1[1984] @ 31744
	.field	-17284,16		; r_quant1[1985] @ 31760
	.field	7105,16 		; r_quant1[1986] @ 31776
	.field	31524,16		; r_quant1[1987] @ 31792
	.field	-15509,16		; r_quant1[1988] @ 31808
	.field	9155,16 		; r_quant1[1989] @ 31824
	.field	29472,16		; r_quant1[1990] @ 31840
	.field	-16786,16		; r_quant1[1991] @ 31856
	.field	8387,16 		; r_quant1[1992] @ 31872
	.field	27420,16		; r_quant1[1993] @ 31888
	.field	-16280,16		; r_quant1[1994] @ 31904
	.field	7107,16 		; r_quant1[1995] @ 31920
	.field	28703,16		; r_quant1[1996] @ 31936
	.field	-18061,16		; r_quant1[1997] @ 31952
	.field	7354,16 		; r_quant1[1998] @ 31968
	.field	29221,16		; r_quant1[1999] @ 31984
	.field	-17794,16		; r_quant1[2000] @ 32000
	.field	9142,16 		; r_quant1[2001] @ 32016
	.field	32545,16		; r_quant1[2002] @ 32032
	.field	-19849,16		; r_quant1[2003] @ 32048
	.field	9914,16 		; r_quant1[2004] @ 32064
	.field	29731,16		; r_quant1[2005] @ 32080
	.field	-18061,16		; r_quant1[2006] @ 32096
	.field	8884,16 		; r_quant1[2007] @ 32112
	.field	27940,16		; r_quant1[2008] @ 32128
	.field	-14236,16		; r_quant1[2009] @ 32144
	.field	8900,16 		; r_quant1[2010] @ 32160
	.field	24869,16		; r_quant1[2011] @ 32176
	.field	-12951,16		; r_quant1[2012] @ 32192
	.field	8907,16 		; r_quant1[2013] @ 32208
	.field	27934,16		; r_quant1[2014] @ 32224
	.field	-13453,16		; r_quant1[2015] @ 32240
	.field	12450,16		; r_quant1[2016] @ 32256
	.field	25899,16		; r_quant1[2017] @ 32272
	.field	-24993,16		; r_quant1[2018] @ 32288
	.field	8343,16 		; r_quant1[2019] @ 32304
	.field	23594,16		; r_quant1[2020] @ 32320
	.field	-24970,16		; r_quant1[2021] @ 32336
	.field	9632,16 		; r_quant1[2022] @ 32352
	.field	30760,16		; r_quant1[2023] @ 32368
	.field	-22406,16		; r_quant1[2024] @ 32384
	.field	12969,16		; r_quant1[2025] @ 32400
	.field	26667,16		; r_quant1[2026] @ 32416
	.field	-20890,16		; r_quant1[2027] @ 32432
	.field	9646,16 		; r_quant1[2028] @ 32448
	.field	26157,16		; r_quant1[2029] @ 32464
	.field	-21644,16		; r_quant1[2030] @ 32480
	.field	13733,16		; r_quant1[2031] @ 32496
	.field	29232,16		; r_quant1[2032] @ 32512
	.field	-23952,16		; r_quant1[2033] @ 32528
	.field	11173,16		; r_quant1[2034] @ 32544
	.field	29222,16		; r_quant1[2035] @ 32560
	.field	-24210,16		; r_quant1[2036] @ 32576
	.field	12463,16		; r_quant1[2037] @ 32592
	.field	28197,16		; r_quant1[2038] @ 32608
	.field	-20619,16		; r_quant1[2039] @ 32624
	.field	10157,16		; r_quant1[2040] @ 32640
	.field	28450,16		; r_quant1[2041] @ 32656
	.field	-21394,16		; r_quant1[2042] @ 32672
	.field	9127,16 		; r_quant1[2043] @ 32688
	.field	27166,16		; r_quant1[2044] @ 32704
	.field	-22681,16		; r_quant1[2045] @ 32720
	.field	11688,16		; r_quant1[2046] @ 32736
	.field	26407,16		; r_quant1[2047] @ 32752
	.field	-22939,16		; r_quant1[2048] @ 32768
	.field	10399,16		; r_quant1[2049] @ 32784
	.field	26659,16		; r_quant1[2050] @ 32800
	.field	-24988,16		; r_quant1[2051] @ 32816
	.field	9382,16 		; r_quant1[2052] @ 32832
	.field	23835,16		; r_quant1[2053] @ 32848
	.field	-23458,16		; r_quant1[2054] @ 32864
	.field	7068,16 		; r_quant1[2055] @ 32880
	.field	26647,16		; r_quant1[2056] @ 32896
	.field	-25248,16		; r_quant1[2057] @ 32912
	.field	11162,16		; r_quant1[2058] @ 32928
	.field	27680,16		; r_quant1[2059] @ 32944
	.field	-25487,16		; r_quant1[2060] @ 32960
	.field	8869,16 		; r_quant1[2061] @ 32976
	.field	29470,16		; r_quant1[2062] @ 32992
	.field	-23440,16		; r_quant1[2063] @ 33008
	.field	8871,16 		; r_quant1[2064] @ 33024
	.field	31263,16		; r_quant1[2065] @ 33040
	.field	-23169,16		; r_quant1[2066] @ 33056
	.field	7861,16 		; r_quant1[2067] @ 33072
	.field	-31720,16		; r_quant1[2068] @ 33088
	.field	-16260,16		; r_quant1[2069] @ 33104
	.field	6836,16 		; r_quant1[2070] @ 33120
	.field	28181,16		; r_quant1[2071] @ 33136
	.field	-19346,16		; r_quant1[2072] @ 33152
	.field	6330,16 		; r_quant1[2073] @ 33168
	.field	29972,16		; r_quant1[2074] @ 33184
	.field	-17801,16		; r_quant1[2075] @ 33200
	.field	7855,16 		; r_quant1[2076] @ 33216
	.field	29728,16		; r_quant1[2077] @ 33232
	.field	-20609,16		; r_quant1[2078] @ 33248
	.field	7084,16 		; r_quant1[2079] @ 33264
	.field	32027,16		; r_quant1[2080] @ 33280
	.field	-19332,16		; r_quant1[2081] @ 33296
	.field	6321,16 		; r_quant1[2082] @ 33312
	.field	31513,16		; r_quant1[2083] @ 33328
	.field	-23950,16		; r_quant1[2084] @ 33344
	.field	5539,16 		; r_quant1[2085] @ 33360
	.field	27675,16		; r_quant1[2086] @ 33376
	.field	-22921,16		; r_quant1[2087] @ 33392
	.field	6051,16 		; r_quant1[2088] @ 33408
	.field	31254,16		; r_quant1[2089] @ 33424
	.field	-21386,16		; r_quant1[2090] @ 33440
	.field	5039,16 		; r_quant1[2091] @ 33456
	.field	30998,16		; r_quant1[2092] @ 33472
	.field	-20090,16		; r_quant1[2093] @ 33488
	.field	5289,16 		; r_quant1[2094] @ 33504
	.field	-31984,16		; r_quant1[2095] @ 33520
	.field	-22401,16		; r_quant1[2096] @ 33536
	.field	6585,16 		; r_quant1[2097] @ 33552
	.field	-31467,16		; r_quant1[2098] @ 33568
	.field	-18816,16		; r_quant1[2099] @ 33584
	.field	4792,16 		; r_quant1[2100] @ 33600
	.field	32020,16		; r_quant1[2101] @ 33616
	.field	-18037,16		; r_quant1[2102] @ 33632
	.field	4530,16 		; r_quant1[2103] @ 33648
	.field	-30952,16		; r_quant1[2104] @ 33664
	.field	-23677,16		; r_quant1[2105] @ 33680
	.field	5023,16 		; r_quant1[2106] @ 33696
	.field	-31980,16		; r_quant1[2107] @ 33712
	.field	-21617,16		; r_quant1[2108] @ 33728
	.field	7084,16 		; r_quant1[2109] @ 33744
	.field	28439,16		; r_quant1[2110] @ 33760
	.field	-21400,16		; r_quant1[2111] @ 33776
	.field	10690,16		; r_quant1[2112] @ 33792
	.field	-29402,16		; r_quant1[2113] @ 33808
	.field	-17518,16		; r_quant1[2114] @ 33824
	.field	9146,16 		; r_quant1[2115] @ 33840
	.field	-29904,16		; r_quant1[2116] @ 33856
	.field	-16988,16		; r_quant1[2117] @ 33872
	.field	12463,16		; r_quant1[2118] @ 33888
	.field	-24533,16		; r_quant1[2119] @ 33904
	.field	-13149,16		; r_quant1[2120] @ 33920
	.field	10447,16		; r_quant1[2121] @ 33936
	.field	-24018,16		; r_quant1[2122] @ 33952
	.field	-18509,16		; r_quant1[2123] @ 33968
	.field	11192,16		; r_quant1[2124] @ 33984
	.field	-21201,16		; r_quant1[2125] @ 34000
	.field	-24153,16		; r_quant1[2126] @ 34016
	.field	11424,16		; r_quant1[2127] @ 34032
	.field	-24021,16		; r_quant1[2128] @ 34048
	.field	-17766,16		; r_quant1[2129] @ 34064
	.field	10678,16		; r_quant1[2130] @ 34080
	.field	-25050,16		; r_quant1[2131] @ 34096
	.field	-18020,16		; r_quant1[2132] @ 34112
	.field	9142,16 		; r_quant1[2133] @ 34128
	.field	-25561,16		; r_quant1[2134] @ 34144
	.field	-13417,16		; r_quant1[2135] @ 34160
	.field	9673,16 		; r_quant1[2136] @ 34176
	.field	-27355,16		; r_quant1[2137] @ 34192
	.field	-9837,16		; r_quant1[2138] @ 34208
	.field	9175,16 		; r_quant1[2139] @ 34224
	.field	-26844,16		; r_quant1[2140] @ 34240
	.field	-12915,16		; r_quant1[2141] @ 34256
	.field	9929,16 		; r_quant1[2142] @ 34272
	.field	-23261,16		; r_quant1[2143] @ 34288
	.field	-15445,16		; r_quant1[2144] @ 34304
	.field	8910,16 		; r_quant1[2145] @ 34320
	.field	-23775,16		; r_quant1[2146] @ 34336
	.field	-13155,16		; r_quant1[2147] @ 34352
	.field	8378,16 		; r_quant1[2148] @ 34368
	.field	-24536,16		; r_quant1[2149] @ 34384
	.field	-21610,16		; r_quant1[2150] @ 34400
	.field	10149,16		; r_quant1[2151] @ 34416
	.field	-24277,16		; r_quant1[2152] @ 34432
	.field	-23363,16		; r_quant1[2153] @ 34448
	.field	10665,16		; r_quant1[2154] @ 34464
	.field	-21469,16		; r_quant1[2155] @ 34480
	.field	-17736,16		; r_quant1[2156] @ 34496
	.field	9134,16 		; r_quant1[2157] @ 34512
	.field	-21214,16		; r_quant1[2158] @ 34528
	.field	-16236,16		; r_quant1[2159] @ 34544
	.field	8593,16 		; r_quant1[2160] @ 34560
	.field	-29413,16		; r_quant1[2161] @ 34576
	.field	-29041,16		; r_quant1[2162] @ 34592
	.field	10645,16		; r_quant1[2163] @ 34608
	.field	-27099,16		; r_quant1[2164] @ 34624
	.field	-27237,16		; r_quant1[2165] @ 34640
	.field	8847,16 		; r_quant1[2166] @ 34656
	.field	-27100,16		; r_quant1[2167] @ 34672
	.field	-21632,16		; r_quant1[2168] @ 34688
	.field	9392,16 		; r_quant1[2169] @ 34704
	.field	-29151,16		; r_quant1[2170] @ 34720
	.field	-20336,16		; r_quant1[2171] @ 34736
	.field	8883,16 		; r_quant1[2172] @ 34752
	.field	-30947,16		; r_quant1[2173] @ 34768
	.field	-20847,16		; r_quant1[2174] @ 34784
	.field	7089,16 		; r_quant1[2175] @ 34800
	.field	-30182,16		; r_quant1[2176] @ 34816
	.field	-19055,16		; r_quant1[2177] @ 34832
	.field	6827,16 		; r_quant1[2178] @ 34848
	.field	-30946,16		; r_quant1[2179] @ 34864
	.field	-18274,16		; r_quant1[2180] @ 34880
	.field	11426,16		; r_quant1[2181] @ 34896
	.field	-27350,16		; r_quant1[2182] @ 34912
	.field	-25717,16		; r_quant1[2183] @ 34928
	.field	9881,16 		; r_quant1[2184] @ 34944
	.field	-30680,16		; r_quant1[2185] @ 34960
	.field	-22641,16		; r_quant1[2186] @ 34976
	.field	9638,16 		; r_quant1[2187] @ 34992
	.field	-26846,16		; r_quant1[2188] @ 35008
	.field	-24430,16		; r_quant1[2189] @ 35024
	.field	9123,16 		; r_quant1[2190] @ 35040
	.field	-24545,16		; r_quant1[2191] @ 35056
	.field	-23138,16		; r_quant1[2192] @ 35072
	.field	9635,16 		; r_quant1[2193] @ 35088
	.field	-31199,16		; r_quant1[2194] @ 35104
	.field	-23417,16		; r_quant1[2195] @ 35120
	.field	8346,16 		; r_quant1[2196] @ 35136
	.field	-30947,16		; r_quant1[2197] @ 35152
	.field	-27002,16		; r_quant1[2198] @ 35168
	.field	7842,16 		; r_quant1[2199] @ 35184
	.field	-28134,16		; r_quant1[2200] @ 35200
	.field	-23923,16		; r_quant1[2201] @ 35216
	.field	6811,16 		; r_quant1[2202] @ 35232
	.field	-27620,16		; r_quant1[2203] @ 35248
	.field	-23674,16		; r_quant1[2204] @ 35264
	.field	6042,16 		; r_quant1[2205] @ 35280
	.field	-31721,16		; r_quant1[2206] @ 35296
	.field	-22381,16		; r_quant1[2207] @ 35312
	.field	7821,16 		; r_quant1[2208] @ 35328
	.field	-27113,16		; r_quant1[2209] @ 35344
	.field	-19311,16		; r_quant1[2210] @ 35360
	.field	7332,16 		; r_quant1[2211] @ 35376
	.field	-25834,16		; r_quant1[2212] @ 35392
	.field	-26478,16		; r_quant1[2213] @ 35408
	.field	8359,16 		; r_quant1[2214] @ 35424
	.field	-17124,16		; r_quant1[2215] @ 35440
	.field	-19011,16		; r_quant1[2216] @ 35456
	.field	7852,16 		; r_quant1[2217] @ 35472
	.field	-21988,16		; r_quant1[2218] @ 35488
	.field	-22864,16		; r_quant1[2219] @ 35504
	.field	8598,16 		; r_quant1[2220] @ 35520
	.field	-23524,16		; r_quant1[2221] @ 35536
	.field	-26720,16		; r_quant1[2222] @ 35552
	.field	6811,16 		; r_quant1[2223] @ 35568
	.field	-21736,16		; r_quant1[2224] @ 35584
	.field	-25177,16		; r_quant1[2225] @ 35600
	.field	7052,16 		; r_quant1[2226] @ 35616
	.field	-25321,16		; r_quant1[2227] @ 35632
	.field	-29277,16		; r_quant1[2228] @ 35648
	.field	5793,16 		; r_quant1[2229] @ 35664
	.field	-24558,16		; r_quant1[2230] @ 35680
	.field	-23395,16		; r_quant1[2231] @ 35696
	.field	12167,16		; r_quant1[2232] @ 35712
	.field	-22748,16		; r_quant1[2233] @ 35728
	.field	-31313,16		; r_quant1[2234] @ 35744
	.field	7812,16 		; r_quant1[2235] @ 35760
	.field	-21474,16		; r_quant1[2236] @ 35776
	.field	25775,16		; r_quant1[2237] @ 35792
	.field	5806,16 		; r_quant1[2238] @ 35808
	.field	-18921,16		; r_quant1[2239] @ 35824
	.field	-29243,16		; r_quant1[2240] @ 35840
	.field	5251,16 		; r_quant1[2241] @ 35856
	.field	-14312,16		; r_quant1[2242] @ 35872
	.field	-29002,16		; r_quant1[2243] @ 35888
	.field	5761,16 		; r_quant1[2244] @ 35904
	.field	-21997,16		; r_quant1[2245] @ 35920
	.field	-23373,16		; r_quant1[2246] @ 35936
	.field	4260,16 		; r_quant1[2247] @ 35952
	.field	-20711,16		; r_quant1[2248] @ 35968
	.field	-19043,16		; r_quant1[2249] @ 35984
	.field	6574,16 		; r_quant1[2250] @ 36000
	.field	-24042,16		; r_quant1[2251] @ 36016
	.field	-20581,16		; r_quant1[2252] @ 36032
	.field	6077,16 		; r_quant1[2253] @ 36048
	.field	-19946,16		; r_quant1[2254] @ 36064
	.field	-19540,16		; r_quant1[2255] @ 36080
	.field	4516,16 		; r_quant1[2256] @ 36096
	.field	-28404,16		; r_quant1[2257] @ 36112
	.field	-22631,16		; r_quant1[2258] @ 36128
	.field	4796,16 		; r_quant1[2259] @ 36144
	.field	-16103,16		; r_quant1[2260] @ 36160
	.field	-14936,16		; r_quant1[2261] @ 36176
	.field	6088,16 		; r_quant1[2262] @ 36192
	.field	-23274,16		; r_quant1[2263] @ 36208
	.field	-16485,16		; r_quant1[2264] @ 36224
	.field	5307,16 		; r_quant1[2265] @ 36240
	.field	-27630,16		; r_quant1[2266] @ 36256
	.field	-15722,16		; r_quant1[2267] @ 36272
	.field	5307,16 		; r_quant1[2268] @ 36288
	.field	-24046,16		; r_quant1[2269] @ 36304
	.field	-19805,16		; r_quant1[2270] @ 36320
	.field	4537,16 		; r_quant1[2271] @ 36336
	.field	-26098,16		; r_quant1[2272] @ 36352
	.field	-17769,16		; r_quant1[2273] @ 36368
	.field	6342,16 		; r_quant1[2274] @ 36384
	.field	-19948,16		; r_quant1[2275] @ 36400
	.field	-17492,16		; r_quant1[2276] @ 36416
	.field	5582,16 		; r_quant1[2277] @ 36432
	.field	-22765,16		; r_quant1[2278] @ 36448
	.field	-13141,16		; r_quant1[2279] @ 36464
	.field	4818,16 		; r_quant1[2280] @ 36480
	.field	-23792,16		; r_quant1[2281] @ 36496
	.field	-12380,16		; r_quant1[2282] @ 36512
	.field	4820,16 		; r_quant1[2283] @ 36528
	.field	-19696,16		; r_quant1[2284] @ 36544
	.field	-10063,16		; r_quant1[2285] @ 36560
	.field	4038,16 		; r_quant1[2286] @ 36576
	.field	-16883,16		; r_quant1[2287] @ 36592
	.field	-19521,16		; r_quant1[2288] @ 36608
	.field	4288,16 		; r_quant1[2289] @ 36624
	.field	-21235,16		; r_quant1[2290] @ 36640
	.field	-18773,16		; r_quant1[2291] @ 36656
	.field	3277,16 		; r_quant1[2292] @ 36672
	.field	-23275,16		; r_quant1[2293] @ 36688
	.field	-13160,16		; r_quant1[2294] @ 36704
	.field	5071,16 		; r_quant1[2295] @ 36720
	.field	-27629,16		; r_quant1[2296] @ 36736
	.field	-9575,16		; r_quant1[2297] @ 36752
	.field	4830,16 		; r_quant1[2298] @ 36768
	.field	-25840,16		; r_quant1[2299] @ 36784
	.field	-11112,16		; r_quant1[2300] @ 36800
	.field	3800,16 		; r_quant1[2301] @ 36816
	.field	-24305,16		; r_quant1[2302] @ 36832
	.field	-7269,16		; r_quant1[2303] @ 36848
	.field	15302,16		; r_quant1[2304] @ 36864
	.field	30786,16		; r_quant1[2305] @ 36880
	.field	-13468,16		; r_quant1[2306] @ 36896
	.field	15302,16		; r_quant1[2307] @ 36912
	.field	27191,16		; r_quant1[2308] @ 36928
	.field	-8844,16		; r_quant1[2309] @ 36944
	.field	13782,16		; r_quant1[2310] @ 36960
	.field	28230,16		; r_quant1[2311] @ 36976
	.field	-10124,16		; r_quant1[2312] @ 36992
	.field	17364,16		; r_quant1[2313] @ 37008
	.field	29759,16		; r_quant1[2314] @ 37024
	.field	-13709,16		; r_quant1[2315] @ 37040
	.field	17114,16		; r_quant1[2316] @ 37056
	.field	23104,16		; r_quant1[2317] @ 37072
	.field	-9879,16		; r_quant1[2318] @ 37088
	.field	16084,16		; r_quant1[2319] @ 37104
	.field	26687,16		; r_quant1[2320] @ 37120
	.field	-12701,16		; r_quant1[2321] @ 37136
	.field	15056,16		; r_quant1[2322] @ 37152
	.field	24897,16		; r_quant1[2323] @ 37168
	.field	-11384,16		; r_quant1[2324] @ 37184
	.field	15574,16		; r_quant1[2325] @ 37200
	.field	-30401,16		; r_quant1[2326] @ 37216
	.field	-10376,16		; r_quant1[2327] @ 37232
	.field	15570,16		; r_quant1[2328] @ 37248
	.field	30267,16		; r_quant1[2329] @ 37264
	.field	-9095,16		; r_quant1[2330] @ 37280
	.field	14806,16		; r_quant1[2331] @ 37296
	.field	29242,16		; r_quant1[2332] @ 37312
	.field	-11392,16		; r_quant1[2333] @ 37328
	.field	14285,16		; r_quant1[2334] @ 37344
	.field	31798,16		; r_quant1[2335] @ 37360
	.field	-10879,16		; r_quant1[2336] @ 37376
	.field	15569,16		; r_quant1[2337] @ 37392
	.field	27705,16		; r_quant1[2338] @ 37408
	.field	-12693,16		; r_quant1[2339] @ 37424
	.field	14281,16		; r_quant1[2340] @ 37440
	.field	29751,16		; r_quant1[2341] @ 37456
	.field	-14488,16		; r_quant1[2342] @ 37472
	.field	16097,16		; r_quant1[2343] @ 37488
	.field	26684,16		; r_quant1[2344] @ 37504
	.field	-9372,16		; r_quant1[2345] @ 37520
	.field	15074,16		; r_quant1[2346] @ 37536
	.field	24888,16		; r_quant1[2347] @ 37552
	.field	-10654,16		; r_quant1[2348] @ 37568
	.field	16868,16		; r_quant1[2349] @ 37584
	.field	21053,16		; r_quant1[2350] @ 37600
	.field	-9900,16		; r_quant1[2351] @ 37616
	.field	14016,16		; r_quant1[2352] @ 37632
	.field	25650,16		; r_quant1[2353] @ 37648
	.field	-18839,16		; r_quant1[2354] @ 37664
	.field	11959,16		; r_quant1[2355] @ 37680
	.field	26408,16		; r_quant1[2356] @ 37696
	.field	-19352,16		; r_quant1[2357] @ 37712
	.field	12233,16		; r_quant1[2358] @ 37728
	.field	29480,16		; r_quant1[2359] @ 37744
	.field	-14740,16		; r_quant1[2360] @ 37760
	.field	11698,16		; r_quant1[2361] @ 37776
	.field	28214,16		; r_quant1[2362] @ 37792
	.field	-13220,16		; r_quant1[2363] @ 37808
	.field	13510,16		; r_quant1[2364] @ 37824
	.field	32049,16		; r_quant1[2365] @ 37840
	.field	-15748,16		; r_quant1[2366] @ 37856
	.field	13515,16		; r_quant1[2367] @ 37872
	.field	29235,16		; r_quant1[2368] @ 37888
	.field	-15004,16		; r_quant1[2369] @ 37904
	.field	12735,16		; r_quant1[2370] @ 37920
	.field	27950,16		; r_quant1[2371] @ 37936
	.field	-15767,16		; r_quant1[2372] @ 37952
	.field	13259,16		; r_quant1[2373] @ 37968
	.field	27183,16		; r_quant1[2374] @ 37984
	.field	-13979,16		; r_quant1[2375] @ 38000
	.field	12488,16		; r_quant1[2376] @ 38016
	.field	23851,16		; r_quant1[2377] @ 38032
	.field	-15266,16		; r_quant1[2378] @ 38048
	.field	12735,16		; r_quant1[2379] @ 38064
	.field	24877,16		; r_quant1[2380] @ 38080
	.field	-17057,16		; r_quant1[2381] @ 38096
	.field	11961,16		; r_quant1[2382] @ 38112
	.field	29738,16		; r_quant1[2383] @ 38128
	.field	-18574,16		; r_quant1[2384] @ 38144
	.field	11458,16		; r_quant1[2385] @ 38160
	.field	29992,16		; r_quant1[2386] @ 38176
	.field	-16013,16		; r_quant1[2387] @ 38192
	.field	11197,16		; r_quant1[2388] @ 38208
	.field	26919,16		; r_quant1[2389] @ 38224
	.field	-17046,16		; r_quant1[2390] @ 38240
	.field	14279,16		; r_quant1[2391] @ 38256
	.field	23089,16		; r_quant1[2392] @ 38272
	.field	-16039,16		; r_quant1[2393] @ 38288
	.field	13244,16		; r_quant1[2394] @ 38304
	.field	22575,16		; r_quant1[2395] @ 38320
	.field	-15020,16		; r_quant1[2396] @ 38336
	.field	11209,16		; r_quant1[2397] @ 38352
	.field	27175,16		; r_quant1[2398] @ 38368
	.field	-15521,16		; r_quant1[2399] @ 38384
	.field	17606,16		; r_quant1[2400] @ 38400
	.field	17467,16		; r_quant1[2401] @ 38416
	.field	-16828,16		; r_quant1[2402] @ 38432
	.field	17095,16		; r_quant1[2403] @ 38448
	.field	14911,16		; r_quant1[2404] @ 38464
	.field	-14802,16		; r_quant1[2405] @ 38480
	.field	14263,16		; r_quant1[2406] @ 38496
	.field	16201,16		; r_quant1[2407] @ 38512
	.field	-7320,16		; r_quant1[2408] @ 38528
	.field	17885,16		; r_quant1[2409] @ 38544
	.field	24893,16		; r_quant1[2410] @ 38560
	.field	-12965,16		; r_quant1[2411] @ 38576
	.field	20439,16		; r_quant1[2412] @ 38592
	.field	20810,16		; r_quant1[2413] @ 38608
	.field	-12465,16		; r_quant1[2414] @ 38624
	.field	17872,16		; r_quant1[2415] @ 38640
	.field	21825,16		; r_quant1[2416] @ 38656
	.field	-15281,16		; r_quant1[2417] @ 38672
	.field	16068,16		; r_quant1[2418] @ 38688
	.field	23097,16		; r_quant1[2419] @ 38704
	.field	-16040,16		; r_quant1[2420] @ 38720
	.field	15037,16		; r_quant1[2421] @ 38736
	.field	21307,16		; r_quant1[2422] @ 38752
	.field	-15285,16		; r_quant1[2423] @ 38768
	.field	14017,16		; r_quant1[2424] @ 38784
	.field	17459,16		; r_quant1[2425] @ 38800
	.field	-17853,16		; r_quant1[2426] @ 38816
	.field	10673,16		; r_quant1[2427] @ 38832
	.field	16712,16		; r_quant1[2428] @ 38848
	.field	-8362,16		; r_quant1[2429] @ 38864
	.field	17361,16		; r_quant1[2430] @ 38880
	.field	19775,16		; r_quant1[2431] @ 38896
	.field	-11955,16		; r_quant1[2432] @ 38912
	.field	14794,16		; r_quant1[2433] @ 38928
	.field	17729,16		; r_quant1[2434] @ 38944
	.field	-10174,16		; r_quant1[2435] @ 38960
	.field	15827,16		; r_quant1[2436] @ 38976
	.field	13371,16		; r_quant1[2437] @ 38992
	.field	-14280,16		; r_quant1[2438] @ 39008
	.field	13764,16		; r_quant1[2439] @ 39024
	.field	11315,16		; r_quant1[2440] @ 39040
	.field	-14270,16		; r_quant1[2441] @ 39056
	.field	10940,16		; r_quant1[2442] @ 39072
	.field	16182,16		; r_quant1[2443] @ 39088
	.field	-15281,16		; r_quant1[2444] @ 39104
	.field	12737,16		; r_quant1[2445] @ 39120
	.field	19768,16		; r_quant1[2446] @ 39136
	.field	-12209,16		; r_quant1[2447] @ 39152
	.field	10686,16		; r_quant1[2448] @ 39168
	.field	23844,16		; r_quant1[2449] @ 39184
	.field	-17575,16		; r_quant1[2450] @ 39200
	.field	9656,16 		; r_quant1[2451] @ 39216
	.field	26146,16		; r_quant1[2452] @ 39232
	.field	-19100,16		; r_quant1[2453] @ 39248
	.field	7859,16 		; r_quant1[2454] @ 39264
	.field	27177,16		; r_quant1[2455] @ 39280
	.field	-17335,16		; r_quant1[2456] @ 39296
	.field	8120,16 		; r_quant1[2457] @ 39312
	.field	17444,16		; r_quant1[2458] @ 39328
	.field	-19149,16		; r_quant1[2459] @ 39344
	.field	12218,16		; r_quant1[2460] @ 39360
	.field	20780,16		; r_quant1[2461] @ 39376
	.field	-19373,16		; r_quant1[2462] @ 39392
	.field	10163,16		; r_quant1[2463] @ 39408
	.field	19243,16		; r_quant1[2464] @ 39424
	.field	-16049,16		; r_quant1[2465] @ 39440
	.field	9149,16 		; r_quant1[2466] @ 39456
	.field	19753,16		; r_quant1[2467] @ 39472
	.field	-18089,16		; r_quant1[2468] @ 39488
	.field	9911,16 		; r_quant1[2469] @ 39504
	.field	21022,16		; r_quant1[2470] @ 39520
	.field	-18857,16		; r_quant1[2471] @ 39536
	.field	6322,16 		; r_quant1[2472] @ 39552
	.field	20266,16		; r_quant1[2473] @ 39568
	.field	-18593,16		; r_quant1[2474] @ 39584
	.field	9138,16 		; r_quant1[2475] @ 39600
	.field	24093,16		; r_quant1[2476] @ 39616
	.field	-20895,16		; r_quant1[2477] @ 39632
	.field	9646,16 		; r_quant1[2478] @ 39648
	.field	21789,16		; r_quant1[2479] @ 39664
	.field	-20652,16		; r_quant1[2480] @ 39680
	.field	7079,16 		; r_quant1[2481] @ 39696
	.field	19491,16		; r_quant1[2482] @ 39712
	.field	-16540,16		; r_quant1[2483] @ 39728
	.field	8125,16 		; r_quant1[2484] @ 39744
	.field	24863,16		; r_quant1[2485] @ 39760
	.field	-18592,16		; r_quant1[2486] @ 39776
	.field	7094,16 		; r_quant1[2487] @ 39792
	.field	25112,16		; r_quant1[2488] @ 39808
	.field	-17817,16		; r_quant1[2489] @ 39824
	.field	5812,16 		; r_quant1[2490] @ 39840
	.field	24082,16		; r_quant1[2491] @ 39856
	.field	-21413,16		; r_quant1[2492] @ 39872
	.field	8641,16 		; r_quant1[2493] @ 39888
	.field	22040,16		; r_quant1[2494] @ 39904
	.field	-17579,16		; r_quant1[2495] @ 39920
	.field	13530,16		; r_quant1[2496] @ 39936
	.field	31538,16		; r_quant1[2497] @ 39952
	.field	-10894,16		; r_quant1[2498] @ 39968
	.field	11734,16		; r_quant1[2499] @ 39984
	.field	27703,16		; r_quant1[2500] @ 40000
	.field	-8604,16		; r_quant1[2501] @ 40016
	.field	13777,16		; r_quant1[2502] @ 40032
	.field	24371,16		; r_quant1[2503] @ 40048
	.field	-10654,16		; r_quant1[2504] @ 40064
	.field	12496,16		; r_quant1[2505] @ 40080
	.field	24117,16		; r_quant1[2506] @ 40096
	.field	-7837,16		; r_quant1[2507] @ 40112
	.field	13027,16		; r_quant1[2508] @ 40128
	.field	23601,16		; r_quant1[2509] @ 40144
	.field	-9109,16		; r_quant1[2510] @ 40160
	.field	12248,16		; r_quant1[2511] @ 40176
	.field	25393,16		; r_quant1[2512] @ 40192
	.field	-9639,16		; r_quant1[2513] @ 40208
	.field	12251,16		; r_quant1[2514] @ 40224
	.field	22061,16		; r_quant1[2515] @ 40240
	.field	-11174,16		; r_quant1[2516] @ 40256
	.field	10959,16		; r_quant1[2517] @ 40272
	.field	23344,16		; r_quant1[2518] @ 40288
	.field	-11925,16		; r_quant1[2519] @ 40304
	.field	11726,16		; r_quant1[2520] @ 40320
	.field	26153,16		; r_quant1[2521] @ 40336
	.field	-13210,16		; r_quant1[2522] @ 40352
	.field	11222,16		; r_quant1[2523] @ 40368
	.field	25639,16		; r_quant1[2524] @ 40384
	.field	-11161,16		; r_quant1[2525] @ 40400
	.field	10192,16		; r_quant1[2526] @ 40416
	.field	24618,16		; r_quant1[2527] @ 40432
	.field	-13986,16		; r_quant1[2528] @ 40448
	.field	13269,16		; r_quant1[2529] @ 40464
	.field	21295,16		; r_quant1[2530] @ 40480
	.field	-12973,16		; r_quant1[2531] @ 40496
	.field	11466,16		; r_quant1[2532] @ 40512
	.field	22059,16		; r_quant1[2533] @ 40528
	.field	-12207,16		; r_quant1[2534] @ 40544
	.field	14819,16		; r_quant1[2535] @ 40560
	.field	21813,16		; r_quant1[2536] @ 40576
	.field	-8876,16		; r_quant1[2537] @ 40592
	.field	13794,16		; r_quant1[2538] @ 40608
	.field	18737,16		; r_quant1[2539] @ 40624
	.field	-9911,16		; r_quant1[2540] @ 40640
	.field	12003,16		; r_quant1[2541] @ 40656
	.field	25644,16		; r_quant1[2542] @ 40672
	.field	-8348,16		; r_quant1[2543] @ 40688
	.field	12229,16		; r_quant1[2544] @ 40704
	.field	14888,16		; r_quant1[2545] @ 40720
	.field	-15547,16		; r_quant1[2546] @ 40736
	.field	9150,16 		; r_quant1[2547] @ 40752
	.field	15656,16		; r_quant1[2548] @ 40768
	.field	-15281,16		; r_quant1[2549] @ 40784
	.field	9415,16 		; r_quant1[2550] @ 40800
	.field	22588,16		; r_quant1[2551] @ 40816
	.field	-7856,16		; r_quant1[2552] @ 40832
	.field	15064,16		; r_quant1[2553] @ 40848
	.field	18483,16		; r_quant1[2554] @ 40864
	.field	-13492,16		; r_quant1[2555] @ 40880
	.field	13520,16		; r_quant1[2556] @ 40896
	.field	17966,16		; r_quant1[2557] @ 40912
	.field	-14009,16		; r_quant1[2558] @ 40928
	.field	14558,16		; r_quant1[2559] @ 40944
	.field	18483,16		; r_quant1[2560] @ 40960
	.field	-10938,16		; r_quant1[2561] @ 40976
	.field	13274,16		; r_quant1[2562] @ 40992
	.field	15406,16		; r_quant1[2563] @ 41008
	.field	-11984,16		; r_quant1[2564] @ 41024
	.field	15062,16		; r_quant1[2565] @ 41040
	.field	14383,16		; r_quant1[2566] @ 41056
	.field	-13510,16		; r_quant1[2567] @ 41072
	.field	12754,16		; r_quant1[2568] @ 41088
	.field	13349,16		; r_quant1[2569] @ 41104
	.field	-15312,16		; r_quant1[2570] @ 41120
	.field	10440,16		; r_quant1[2571] @ 41136
	.field	20771,16		; r_quant1[2572] @ 41152
	.field	-14258,16		; r_quant1[2573] @ 41168
	.field	8135,16 		; r_quant1[2574] @ 41184
	.field	21038,16		; r_quant1[2575] @ 41200
	.field	-12218,16		; r_quant1[2576] @ 41216
	.field	10184,16		; r_quant1[2577] @ 41232
	.field	17706,16		; r_quant1[2578] @ 41248
	.field	-12993,16		; r_quant1[2579] @ 41264
	.field	8904,16 		; r_quant1[2580] @ 41280
	.field	15395,16		; r_quant1[2581] @ 41296
	.field	-12986,16		; r_quant1[2582] @ 41312
	.field	7873,16 		; r_quant1[2583] @ 41328
	.field	18196,16		; r_quant1[2584] @ 41344
	.field	-16565,16		; r_quant1[2585] @ 41360
	.field	11476,16		; r_quant1[2586] @ 41376
	.field	18474,16		; r_quant1[2587] @ 41392
	.field	-11199,16		; r_quant1[2588] @ 41408
	.field	11992,16		; r_quant1[2589] @ 41424
	.field	13605,16		; r_quant1[2590] @ 41440
	.field	-12487,16		; r_quant1[2591] @ 41456
	.field	9686,16 		; r_quant1[2592] @ 41472
	.field	29219,16		; r_quant1[2593] @ 41488
	.field	-11149,16		; r_quant1[2594] @ 41504
	.field	8401,16 		; r_quant1[2595] @ 41520
	.field	29219,16		; r_quant1[2596] @ 41536
	.field	-7824,16		; r_quant1[2597] @ 41552
	.field	8670,16 		; r_quant1[2598] @ 41568
	.field	27681,16		; r_quant1[2599] @ 41584
	.field	-8351,16		; r_quant1[2600] @ 41600
	.field	7900,16 		; r_quant1[2601] @ 41616
	.field	25636,16		; r_quant1[2602] @ 41632
	.field	-7297,16		; r_quant1[2603] @ 41648
	.field	9179,16 		; r_quant1[2604] @ 41664
	.field	32547,16		; r_quant1[2605] @ 41680
	.field	-11137,16		; r_quant1[2606] @ 41696
	.field	8408,16 		; r_quant1[2607] @ 41712
	.field	32545,16		; r_quant1[2608] @ 41728
	.field	-8841,16		; r_quant1[2609] @ 41744
	.field	8154,16 		; r_quant1[2610] @ 41760
	.field	28958,16		; r_quant1[2611] @ 41776
	.field	-10884,16		; r_quant1[2612] @ 41792
	.field	7378,16 		; r_quant1[2613] @ 41808
	.field	32033,16		; r_quant1[2614] @ 41824
	.field	-5775,16		; r_quant1[2615] @ 41840
	.field	8423,16 		; r_quant1[2616] @ 41856
	.field	29983,16		; r_quant1[2617] @ 41872
	.field	-4239,16		; r_quant1[2618] @ 41888
	.field	7658,16 		; r_quant1[2619] @ 41904
	.field	29470,16		; r_quant1[2620] @ 41920
	.field	-7065,16		; r_quant1[2621] @ 41936
	.field	7904,16 		; r_quant1[2622] @ 41952
	.field	30748,16		; r_quant1[2623] @ 41968
	.field	-8332,16		; r_quant1[2624] @ 41984
	.field	7136,16 		; r_quant1[2625] @ 42000
	.field	32025,16		; r_quant1[2626] @ 42016
	.field	-8584,16		; r_quant1[2627] @ 42032
	.field	6613,16 		; r_quant1[2628] @ 42048
	.field	31008,16		; r_quant1[2629] @ 42064
	.field	-11159,16		; r_quant1[2630] @ 42080
	.field	7893,16 		; r_quant1[2631] @ 42096
	.field	26657,16		; r_quant1[2632] @ 42112
	.field	-7282,16		; r_quant1[2633] @ 42128
	.field	8163,16 		; r_quant1[2634] @ 42144
	.field	-31200,16		; r_quant1[2635] @ 42160
	.field	-11129,16		; r_quant1[2636] @ 42176
	.field	7653,16 		; r_quant1[2637] @ 42192
	.field	-30949,16		; r_quant1[2638] @ 42208
	.field	-10130,16		; r_quant1[2639] @ 42224
	.field	6080,16 		; r_quant1[2640] @ 42240
	.field	27922,16		; r_quant1[2641] @ 42256
	.field	-17297,16		; r_quant1[2642] @ 42272
	.field	3769,16 		; r_quant1[2643] @ 42288
	.field	29202,16		; r_quant1[2644] @ 42304
	.field	-17822,16		; r_quant1[2645] @ 42320
	.field	7104,16 		; r_quant1[2646] @ 42336
	.field	23831,16		; r_quant1[2647] @ 42352
	.field	-10893,16		; r_quant1[2648] @ 42368
	.field	8396,16 		; r_quant1[2649] @ 42384
	.field	26653,16		; r_quant1[2650] @ 42400
	.field	-13977,16		; r_quant1[2651] @ 42416
	.field	7120,16 		; r_quant1[2652] @ 42432
	.field	26648,16		; r_quant1[2653] @ 42448
	.field	-13209,16		; r_quant1[2654] @ 42464
	.field	8652,16 		; r_quant1[2655] @ 42480
	.field	24350,16		; r_quant1[2656] @ 42496
	.field	-14244,16		; r_quant1[2657] @ 42512
	.field	7113,16 		; r_quant1[2658] @ 42528
	.field	22550,16		; r_quant1[2659] @ 42544
	.field	-15017,16		; r_quant1[2660] @ 42560
	.field	6854,16 		; r_quant1[2661] @ 42576
	.field	25365,16		; r_quant1[2662] @ 42592
	.field	-15520,16		; r_quant1[2663] @ 42608
	.field	5323,16 		; r_quant1[2664] @ 42624
	.field	24848,16		; r_quant1[2665] @ 42640
	.field	-15008,16		; r_quant1[2666] @ 42656
	.field	7113,16 		; r_quant1[2667] @ 42672
	.field	29211,16		; r_quant1[2668] @ 42688
	.field	-11917,16		; r_quant1[2669] @ 42704
	.field	6093,16 		; r_quant1[2670] @ 42720
	.field	29977,16		; r_quant1[2671] @ 42736
	.field	-14215,16		; r_quant1[2672] @ 42752
	.field	5570,16 		; r_quant1[2673] @ 42768
	.field	30225,16		; r_quant1[2674] @ 42784
	.field	-15753,16		; r_quant1[2675] @ 42800
	.field	6090,16 		; r_quant1[2676] @ 42816
	.field	28180,16		; r_quant1[2677] @ 42832
	.field	-14228,16		; r_quant1[2678] @ 42848
	.field	5072,16 		; r_quant1[2679] @ 42864
	.field	28187,16		; r_quant1[2680] @ 42880
	.field	-12452,16		; r_quant1[2681] @ 42896
	.field	6610,16 		; r_quant1[2682] @ 42912
	.field	23577,16		; r_quant1[2683] @ 42928
	.field	-10130,16		; r_quant1[2684] @ 42944
	.field	6102,16 		; r_quant1[2685] @ 42960
	.field	26133,16		; r_quant1[2686] @ 42976
	.field	-11160,16		; r_quant1[2687] @ 42992
	.field	9421,16 		; r_quant1[2688] @ 43008
	.field	24102,16		; r_quant1[2689] @ 43024
	.field	-12718,16		; r_quant1[2690] @ 43040
	.field	10205,16		; r_quant1[2691] @ 43056
	.field	27174,16		; r_quant1[2692] @ 43072
	.field	-6555,16		; r_quant1[2693] @ 43088
	.field	9442,16 		; r_quant1[2694] @ 43104
	.field	25648,16		; r_quant1[2695] @ 43120
	.field	-8116,16		; r_quant1[2696] @ 43136
	.field	11481,16		; r_quant1[2697] @ 43152
	.field	18736,16		; r_quant1[2698] @ 43168
	.field	-8387,16		; r_quant1[2699] @ 43184
	.field	11484,16		; r_quant1[2700] @ 43200
	.field	13350,16		; r_quant1[2701] @ 43216
	.field	-11201,16		; r_quant1[2702] @ 43232
	.field	11233,16		; r_quant1[2703] @ 43248
	.field	23081,16		; r_quant1[2704] @ 43264
	.field	-9633,16		; r_quant1[2705] @ 43280
	.field	11226,16		; r_quant1[2706] @ 43296
	.field	22312,16		; r_quant1[2707] @ 43312
	.field	-10925,16		; r_quant1[2708] @ 43328
	.field	9682,16 		; r_quant1[2709] @ 43344
	.field	22818,16		; r_quant1[2710] @ 43360
	.field	-12459,16		; r_quant1[2711] @ 43376
	.field	10207,16		; r_quant1[2712] @ 43392
	.field	23334,16		; r_quant1[2713] @ 43408
	.field	-9900,16		; r_quant1[2714] @ 43424
	.field	9179,16 		; r_quant1[2715] @ 43440
	.field	21796,16		; r_quant1[2716] @ 43456
	.field	-10653,16		; r_quant1[2717] @ 43472
	.field	8919,16 		; r_quant1[2718] @ 43488
	.field	24607,16		; r_quant1[2719] @ 43504
	.field	-11428,16		; r_quant1[2720] @ 43520
	.field	12003,16		; r_quant1[2721] @ 43536
	.field	21548,16		; r_quant1[2722] @ 43552
	.field	-8121,16		; r_quant1[2723] @ 43568
	.field	11236,16		; r_quant1[2724] @ 43584
	.field	20007,16		; r_quant1[2725] @ 43600
	.field	-8629,16		; r_quant1[2726] @ 43616
	.field	11233,16		; r_quant1[2727] @ 43632
	.field	15657,16		; r_quant1[2728] @ 43648
	.field	-8651,16		; r_quant1[2729] @ 43664
	.field	10458,16		; r_quant1[2730] @ 43680
	.field	18211,16		; r_quant1[2731] @ 43696
	.field	-10681,16		; r_quant1[2732] @ 43712
	.field	9171,16 		; r_quant1[2733] @ 43728
	.field	19495,16		; r_quant1[2734] @ 43744
	.field	-6829,16		; r_quant1[2735] @ 43760
	.field	7368,16 		; r_quant1[2736] @ 43776
	.field	17693,16		; r_quant1[2737] @ 43792
	.field	-12993,16		; r_quant1[2738] @ 43808
	.field	8915,16 		; r_quant1[2739] @ 43824
	.field	14109,16		; r_quant1[2740] @ 43840
	.field	-12503,16		; r_quant1[2741] @ 43856
	.field	8666,16 		; r_quant1[2742] @ 43872
	.field	22050,16		; r_quant1[2743] @ 43888
	.field	-10434,16		; r_quant1[2744] @ 43904
	.field	7636,16 		; r_quant1[2745] @ 43920
	.field	13864,16		; r_quant1[2746] @ 43936
	.field	-6847,16		; r_quant1[2747] @ 43952
	.field	9695,16 		; r_quant1[2748] @ 43968
	.field	15653,16		; r_quant1[2749] @ 43984
	.field	-7630,16		; r_quant1[2750] @ 44000
	.field	7900,16 		; r_quant1[2751] @ 44016
	.field	12321,16		; r_quant1[2752] @ 44032
	.field	-9915,16		; r_quant1[2753] @ 44048
	.field	7125,16 		; r_quant1[2754] @ 44064
	.field	17949,16		; r_quant1[2755] @ 44080
	.field	-9667,16		; r_quant1[2756] @ 44096
	.field	6101,16 		; r_quant1[2757] @ 44112
	.field	16159,16		; r_quant1[2758] @ 44128
	.field	-11959,16		; r_quant1[2759] @ 44144
	.field	8406,16 		; r_quant1[2760] @ 44160
	.field	19995,16		; r_quant1[2761] @ 44176
	.field	-11694,16		; r_quant1[2762] @ 44192
	.field	6860,16 		; r_quant1[2763] @ 44208
	.field	19988,16		; r_quant1[2764] @ 44224
	.field	-13492,16		; r_quant1[2765] @ 44240
	.field	7386,16 		; r_quant1[2766] @ 44256
	.field	23573,16		; r_quant1[2767] @ 44272
	.field	-11686,16		; r_quant1[2768] @ 44288
	.field	6357,16 		; r_quant1[2769] @ 44304
	.field	21014,16		; r_quant1[2770] @ 44320
	.field	-10675,16		; r_quant1[2771] @ 44336
	.field	4818,16 		; r_quant1[2772] @ 44352
	.field	21776,16		; r_quant1[2773] @ 44368
	.field	-11957,16		; r_quant1[2774] @ 44384
	.field	9442,16 		; r_quant1[2775] @ 44400
	.field	21796,16		; r_quant1[2776] @ 44416
	.field	-7861,16		; r_quant1[2777] @ 44432
	.field	8671,16 		; r_quant1[2778] @ 44448
	.field	18975,16		; r_quant1[2779] @ 44464
	.field	-8875,16		; r_quant1[2780] @ 44480
	.field	7387,16 		; r_quant1[2781] @ 44496
	.field	20005,16		; r_quant1[2782] @ 44512
	.field	-6590,16		; r_quant1[2783] @ 44528
	.field	7136,16 		; r_quant1[2784] @ 44544
	.field	25627,16		; r_quant1[2785] @ 44560
	.field	-6804,16		; r_quant1[2786] @ 44576
	.field	6616,16 		; r_quant1[2787] @ 44592
	.field	24355,16		; r_quant1[2788] @ 44608
	.field	-6311,16		; r_quant1[2789] @ 44624
	.field	8419,16 		; r_quant1[2790] @ 44640
	.field	21539,16		; r_quant1[2791] @ 44656
	.field	-6072,16		; r_quant1[2792] @ 44672
	.field	8417,16 		; r_quant1[2793] @ 44688
	.field	16924,16		; r_quant1[2794] @ 44704
	.field	-8129,16		; r_quant1[2795] @ 44720
	.field	8933,16 		; r_quant1[2796] @ 44736
	.field	14368,16		; r_quant1[2797] @ 44752
	.field	-7376,16		; r_quant1[2798] @ 44768
	.field	7133,16 		; r_quant1[2799] @ 44784
	.field	13334,16		; r_quant1[2800] @ 44800
	.field	-9418,16		; r_quant1[2801] @ 44816
	.field	8425,16 		; r_quant1[2802] @ 44832
	.field	23325,16		; r_quant1[2803] @ 44848
	.field	-7080,16		; r_quant1[2804] @ 44864
	.field	7917,16 		; r_quant1[2805] @ 44880
	.field	21788,16		; r_quant1[2806] @ 44896
	.field	-6051,16		; r_quant1[2807] @ 44912
	.field	6113,16 		; r_quant1[2808] @ 44928
	.field	24601,16		; r_quant1[2809] @ 44944
	.field	-8870,16		; r_quant1[2810] @ 44960
	.field	5849,16 		; r_quant1[2811] @ 44976
	.field	23318,16		; r_quant1[2812] @ 44992
	.field	-8366,16		; r_quant1[2813] @ 45008
	.field	8426,16 		; r_quant1[2814] @ 45024
	.field	19487,16		; r_quant1[2815] @ 45040
	.field	-6331,16		; r_quant1[2816] @ 45056
	.field	8425,16 		; r_quant1[2817] @ 45072
	.field	14619,16		; r_quant1[2818] @ 45088
	.field	-7372,16		; r_quant1[2819] @ 45104
	.field	7918,16 		; r_quant1[2820] @ 45120
	.field	15900,16		; r_quant1[2821] @ 45136
	.field	-6086,16		; r_quant1[2822] @ 45152
	.field	7139,16 		; r_quant1[2823] @ 45168
	.field	19736,16		; r_quant1[2824] @ 45184
	.field	-8627,16		; r_quant1[2825] @ 45200
	.field	6364,16 		; r_quant1[2826] @ 45216
	.field	17940,16		; r_quant1[2827] @ 45232
	.field	-9911,16		; r_quant1[2828] @ 45248
	.field	6882,16 		; r_quant1[2829] @ 45264
	.field	16408,16		; r_quant1[2830] @ 45280
	.field	-8342,16		; r_quant1[2831] @ 45296
	.field	6631,16 		; r_quant1[2832] @ 45312
	.field	28700,16		; r_quant1[2833] @ 45328
	.field	-5554,16		; r_quant1[2834] @ 45344
	.field	6631,16 		; r_quant1[2835] @ 45360
	.field	23061,16		; r_quant1[2836] @ 45376
	.field	-7846,16		; r_quant1[2837] @ 45392
	.field	5083,16 		; r_quant1[2838] @ 45408
	.field	22032,16		; r_quant1[2839] @ 45424
	.field	-9127,16		; r_quant1[2840] @ 45440
	.field	7147,16 		; r_quant1[2841] @ 45456
	.field	13082,16		; r_quant1[2842] @ 45472
	.field	-6099,16		; r_quant1[2843] @ 45488
	.field	5856,16 		; r_quant1[2844] @ 45504
	.field	15125,16		; r_quant1[2845] @ 45520
	.field	-8635,16		; r_quant1[2846] @ 45536
	.field	4313,16 		; r_quant1[2847] @ 45552
	.field	18713,16		; r_quant1[2848] @ 45568
	.field	-5049,16		; r_quant1[2849] @ 45584
	.field	6118,16 		; r_quant1[2850] @ 45600
	.field	20247,16		; r_quant1[2851] @ 45616
	.field	-5293,16		; r_quant1[2852] @ 45632
	.field	5610,16 		; r_quant1[2853] @ 45648
	.field	19734,16		; r_quant1[2854] @ 45664
	.field	-7352,16		; r_quant1[2855] @ 45680
	.field	5090,16 		; r_quant1[2856] @ 45696
	.field	19731,16		; r_quant1[2857] @ 45712
	.field	-6583,16		; r_quant1[2858] @ 45728
	.field	4321,16 		; r_quant1[2859] @ 45744
	.field	19483,16		; r_quant1[2860] @ 45760
	.field	-4552,16		; r_quant1[2861] @ 45776
	.field	6123,16 		; r_quant1[2862] @ 45792
	.field	12055,16		; r_quant1[2863] @ 45808
	.field	-6340,16		; r_quant1[2864] @ 45824
	.field	5093,16 		; r_quant1[2865] @ 45840
	.field	15381,16		; r_quant1[2866] @ 45856
	.field	-4543,16		; r_quant1[2867] @ 45872
	.field	4843,16 		; r_quant1[2868] @ 45888
	.field	16660,16		; r_quant1[2869] @ 45904
	.field	-5330,16		; r_quant1[2870] @ 45920
	.field	4846,16 		; r_quant1[2871] @ 45936
	.field	12567,16		; r_quant1[2872] @ 45952
	.field	-5537,16		; r_quant1[2873] @ 45968
	.field	5612,16 		; r_quant1[2874] @ 45984
	.field	25619,16		; r_quant1[2875] @ 46000
	.field	-6825,16		; r_quant1[2876] @ 46016
	.field	5361,16 		; r_quant1[2877] @ 46032
	.field	21519,16		; r_quant1[2878] @ 46048
	.field	-5565,16		; r_quant1[2879] @ 46064
	.field	8651,16 		; r_quant1[2880] @ 46080
	.field	-29153,16		; r_quant1[2881] @ 46096
	.field	-11866,16		; r_quant1[2882] @ 46112
	.field	7882,16 		; r_quant1[2883] @ 46128
	.field	-22501,16		; r_quant1[2884] @ 46144
	.field	-13394,16		; r_quant1[2885] @ 46160
	.field	6860,16 		; r_quant1[2886] @ 46176
	.field	-23525,16		; r_quant1[2887] @ 46192
	.field	-18023,16		; r_quant1[2888] @ 46208
	.field	6336,16 		; r_quant1[2889] @ 46224
	.field	-26337,16		; r_quant1[2890] @ 46240
	.field	-9323,16		; r_quant1[2891] @ 46256
	.field	7899,16 		; r_quant1[2892] @ 46272
	.field	-28386,16		; r_quant1[2893] @ 46288
	.field	-11385,16		; r_quant1[2894] @ 46304
	.field	7133,16 		; r_quant1[2895] @ 46320
	.field	-29154,16		; r_quant1[2896] @ 46336
	.field	-11881,16		; r_quant1[2897] @ 46352
	.field	7383,16 		; r_quant1[2898] @ 46368
	.field	-26596,16		; r_quant1[2899] @ 46384
	.field	-14184,16		; r_quant1[2900] @ 46400
	.field	6857,16 		; r_quant1[2901] @ 46416
	.field	-27110,16		; r_quant1[2902] @ 46432
	.field	-8553,16		; r_quant1[2903] @ 46448
	.field	6369,16 		; r_quant1[2904] @ 46464
	.field	-27625,16		; r_quant1[2905] @ 46480
	.field	-9825,16		; r_quant1[2906] @ 46496
	.field	5855,16 		; r_quant1[2907] @ 46512
	.field	-26849,16		; r_quant1[2908] @ 46528
	.field	-16491,16		; r_quant1[2909] @ 46544
	.field	8123,16 		; r_quant1[2910] @ 46560
	.field	-29412,16		; r_quant1[2911] @ 46576
	.field	-16758,16		; r_quant1[2912] @ 46592
	.field	7882,16 		; r_quant1[2913] @ 46608
	.field	-29156,16		; r_quant1[2914] @ 46624
	.field	-13945,16		; r_quant1[2915] @ 46640
	.field	6856,16 		; r_quant1[2916] @ 46656
	.field	-32233,16		; r_quant1[2917] @ 46672
	.field	-13438,16		; r_quant1[2918] @ 46688
	.field	6857,16 		; r_quant1[2919] @ 46704
	.field	-29160,16		; r_quant1[2920] @ 46720
	.field	-15730,16		; r_quant1[2921] @ 46736
	.field	6872,16 		; r_quant1[2922] @ 46752
	.field	-31719,16		; r_quant1[2923] @ 46768
	.field	-10869,16		; r_quant1[2924] @ 46784
	.field	6360,16 		; r_quant1[2925] @ 46800
	.field	-31210,16		; r_quant1[2926] @ 46816
	.field	-11122,16		; r_quant1[2927] @ 46832
	.field	5822,16 		; r_quant1[2928] @ 46848
	.field	-31727,16		; r_quant1[2929] @ 46864
	.field	-17269,16		; r_quant1[2930] @ 46880
	.field	3261,16 		; r_quant1[2931] @ 46896
	.field	-31735,16		; r_quant1[2932] @ 46912
	.field	-13401,16		; r_quant1[2933] @ 46928
	.field	5575,16 		; r_quant1[2934] @ 46944
	.field	31762,16		; r_quant1[2935] @ 46960
	.field	-13193,16		; r_quant1[2936] @ 46976
	.field	4041,16 		; r_quant1[2937] @ 46992
	.field	30742,16		; r_quant1[2938] @ 47008
	.field	-13430,16		; r_quant1[2939] @ 47024
	.field	5317,16 		; r_quant1[2940] @ 47040
	.field	-29164,16		; r_quant1[2941] @ 47056
	.field	-14715,16		; r_quant1[2942] @ 47072
	.field	4809,16 		; r_quant1[2943] @ 47088
	.field	-30191,16		; r_quant1[2944] @ 47104
	.field	-15743,16		; r_quant1[2945] @ 47120
	.field	4039,16 		; r_quant1[2946] @ 47136
	.field	-31980,16		; r_quant1[2947] @ 47152
	.field	-10615,16		; r_quant1[2948] @ 47168
	.field	5088,16 		; r_quant1[2949] @ 47184
	.field	-29167,16		; r_quant1[2950] @ 47200
	.field	-10100,16		; r_quant1[2951] @ 47216
	.field	5584,16 		; r_quant1[2952] @ 47232
	.field	-32237,16		; r_quant1[2953] @ 47248
	.field	-12419,16		; r_quant1[2954] @ 47264
	.field	4307,16 		; r_quant1[2955] @ 47280
	.field	31761,16		; r_quant1[2956] @ 47296
	.field	-11643,16		; r_quant1[2957] @ 47312
	.field	4311,16 		; r_quant1[2958] @ 47328
	.field	-31218,16		; r_quant1[2959] @ 47344
	.field	-10620,16		; r_quant1[2960] @ 47360
	.field	3023,16 		; r_quant1[2961] @ 47376
	.field	-32240,16		; r_quant1[2962] @ 47392
	.field	-13428,16		; r_quant1[2963] @ 47408
	.field	3786,16 		; r_quant1[2964] @ 47424
	.field	-29168,16		; r_quant1[2965] @ 47440
	.field	-7795,16		; r_quant1[2966] @ 47456
	.field	4058,16 		; r_quant1[2967] @ 47472
	.field	-29427,16		; r_quant1[2968] @ 47488
	.field	-7278,16		; r_quant1[2969] @ 47504
	.field	3536,16 		; r_quant1[2970] @ 47520
	.field	-26869,16		; r_quant1[2971] @ 47536
	.field	-11885,16		; r_quant1[2972] @ 47552
	.field	2783,16 		; r_quant1[2973] @ 47568
	.field	-28910,16		; r_quant1[2974] @ 47584
	.field	-8831,16		; r_quant1[2975] @ 47600
	.field	6103,16 		; r_quant1[2976] @ 47616
	.field	31252,16		; r_quant1[2977] @ 47632
	.field	-11148,16		; r_quant1[2978] @ 47648
	.field	4561,16 		; r_quant1[2979] @ 47664
	.field	28175,16		; r_quant1[2980] @ 47680
	.field	-12689,16		; r_quant1[2981] @ 47696
	.field	3276,16 		; r_quant1[2982] @ 47712
	.field	27670,16		; r_quant1[2983] @ 47728
	.field	-9086,16		; r_quant1[2984] @ 47744
	.field	4823,16 		; r_quant1[2985] @ 47760
	.field	31510,16		; r_quant1[2986] @ 47776
	.field	-9111,16		; r_quant1[2987] @ 47792
	.field	5078,16 		; r_quant1[2988] @ 47808
	.field	26128,16		; r_quant1[2989] @ 47824
	.field	-11165,16		; r_quant1[2990] @ 47840
	.field	5861,16 		; r_quant1[2991] @ 47856
	.field	30484,16		; r_quant1[2992] @ 47872
	.field	-8076,16		; r_quant1[2993] @ 47888
	.field	5081,16 		; r_quant1[2994] @ 47904
	.field	28945,16		; r_quant1[2995] @ 47920
	.field	-9357,16		; r_quant1[2996] @ 47936
	.field	4577,16 		; r_quant1[2997] @ 47952
	.field	27151,16		; r_quant1[2998] @ 47968
	.field	-7831,16		; r_quant1[2999] @ 47984
	.field	4311,16 		; r_quant1[3000] @ 48000
	.field	28685,16		; r_quant1[3001] @ 48016
	.field	-10381,16		; r_quant1[3002] @ 48032
	.field	5601,16 		; r_quant1[3003] @ 48048
	.field	32530,16		; r_quant1[3004] @ 48064
	.field	-5754,16		; r_quant1[3005] @ 48080
	.field	4323,16 		; r_quant1[3006] @ 48096
	.field	-31982,16		; r_quant1[3007] @ 48112
	.field	-7049,16		; r_quant1[3008] @ 48128
	.field	4325,16 		; r_quant1[3009] @ 48144
	.field	30480,16		; r_quant1[3010] @ 48160
	.field	-6533,16		; r_quant1[3011] @ 48176
	.field	4074,16 		; r_quant1[3012] @ 48192
	.field	30480,16		; r_quant1[3013] @ 48208
	.field	-9349,16		; r_quant1[3014] @ 48224
	.field	4064,16 		; r_quant1[3015] @ 48240
	.field	29710,16		; r_quant1[3016] @ 48256
	.field	-7294,16		; r_quant1[3017] @ 48272
	.field	3548,16 		; r_quant1[3018] @ 48288
	.field	31757,16		; r_quant1[3019] @ 48304
	.field	-6277,16		; r_quant1[3020] @ 48320
	.field	3301,16 		; r_quant1[3021] @ 48336
	.field	-32236,16		; r_quant1[3022] @ 48352
	.field	-7321,16		; r_quant1[3023] @ 48368
	.field	5341,16 		; r_quant1[3024] @ 48384
	.field	24849,16		; r_quant1[3025] @ 48400
	.field	-8609,16		; r_quant1[3026] @ 48416
	.field	3291,16 		; r_quant1[3027] @ 48432
	.field	24072,16		; r_quant1[3028] @ 48448
	.field	-9588,16		; r_quant1[3029] @ 48464
	.field	3304,16 		; r_quant1[3030] @ 48480
	.field	29706,16		; r_quant1[3031] @ 48496
	.field	-7809,16		; r_quant1[3032] @ 48512
	.field	5094,16 		; r_quant1[3033] @ 48528
	.field	24593,16		; r_quant1[3034] @ 48544
	.field	-6314,16		; r_quant1[3035] @ 48560
	.field	4586,16 		; r_quant1[3036] @ 48576
	.field	24079,16		; r_quant1[3037] @ 48592
	.field	-6561,16		; r_quant1[3038] @ 48608
	.field	5098,16 		; r_quant1[3039] @ 48624
	.field	27153,16		; r_quant1[3040] @ 48640
	.field	-5780,16		; r_quant1[3041] @ 48656
	.field	4593,16 		; r_quant1[3042] @ 48672
	.field	25360,16		; r_quant1[3043] @ 48688
	.field	-4506,16		; r_quant1[3044] @ 48704
	.field	4329,16 		; r_quant1[3045] @ 48720
	.field	28687,16		; r_quant1[3046] @ 48736
	.field	-5268,16		; r_quant1[3047] @ 48752
	.field	3562,16 		; r_quant1[3048] @ 48768
	.field	26891,16		; r_quant1[3049] @ 48784
	.field	-5524,16		; r_quant1[3050] @ 48800
	.field	4850,16 		; r_quant1[3051] @ 48816
	.field	18193,16		; r_quant1[3052] @ 48832
	.field	-5298,16		; r_quant1[3053] @ 48848
	.field	4594,16 		; r_quant1[3054] @ 48864
	.field	22032,16		; r_quant1[3055] @ 48880
	.field	-3252,16		; r_quant1[3056] @ 48896
	.field	4335,16 		; r_quant1[3057] @ 48912
	.field	23823,16		; r_quant1[3058] @ 48928
	.field	-4007,16		; r_quant1[3059] @ 48944
	.field	4337,16 		; r_quant1[3060] @ 48960
	.field	13839,16		; r_quant1[3061] @ 48976
	.field	-3268,16		; r_quant1[3062] @ 48992
	.field	3571,16 		; r_quant1[3063] @ 49008
	.field	15628,16		; r_quant1[3064] @ 49024
	.field	-3772,16		; r_quant1[3065] @ 49040
	.field	3821,16 		; r_quant1[3066] @ 49056
	.field	19981,16		; r_quant1[3067] @ 49072
	.field	-6058,16		; r_quant1[3068] @ 49088
	.field	3312,16 		; r_quant1[3069] @ 49104
	.field	21515,16		; r_quant1[3070] @ 49120
	.field	-4772,16		; r_quant1[3071] @ 49136


r_quant2
	.field	-15195,16		; r_quant2[0] @ 0
	.field	-24371,16		; r_quant2[1] @ 16
	.field	-26463,16		; r_quant2[2] @ 32
	.field	-15723,16		; r_quant2[3] @ 48
	.field	-24381,16		; r_quant2[4] @ 64
	.field	-28524,16		; r_quant2[5] @ 80
	.field	-12896,16		; r_quant2[6] @ 96
	.field	-28224,16		; r_quant2[7] @ 112
	.field	-25457,16		; r_quant2[8] @ 128
	.field	-15453,16		; r_quant2[9] @ 144
	.field	32712,16		; r_quant2[10] @ 160
	.field	-28494,16		; r_quant2[11] @ 176
	.field	-14965,16		; r_quant2[12] @ 192
	.field	-22574,16		; r_quant2[13] @ 208
	.field	-30310,16		; r_quant2[14] @ 224
	.field	-16503,16		; r_quant2[15] @ 240
	.field	-24111,16		; r_quant2[16] @ 256
	.field	-28027,16		; r_quant2[17] @ 272
	.field	-18030,16		; r_quant2[18] @ 288
	.field	-24905,16		; r_quant2[19] @ 304
	.field	-25189,16		; r_quant2[20] @ 320
	.field	-20583,16		; r_quant2[21] @ 336
	.field	-26445,16		; r_quant2[22] @ 352
	.field	-25209,16		; r_quant2[23] @ 368
	.field	-18032,16		; r_quant2[24] @ 384
	.field	-28992,16		; r_quant2[25] @ 400
	.field	-28289,16		; r_quant2[26] @ 416
	.field	-17020,16		; r_quant2[27] @ 432
	.field	-24646,16		; r_quant2[28] @ 448
	.field	-30058,16		; r_quant2[29] @ 464
	.field	-18301,16		; r_quant2[30] @ 480
	.field	-27961,16		; r_quant2[31] @ 496
	.field	-30070,16		; r_quant2[32] @ 512
	.field	-15487,16		; r_quant2[33] @ 528
	.field	-30278,16		; r_quant2[34] @ 544
	.field	-31354,16		; r_quant2[35] @ 560
	.field	-18563,16		; r_quant2[36] @ 576
	.field	-31821,16		; r_quant2[37] @ 592
	.field	-28543,16		; r_quant2[38] @ 608
	.field	-16771,16		; r_quant2[39] @ 624
	.field	-26695,16		; r_quant2[40] @ 640
	.field	31376,16		; r_quant2[41] @ 656
	.field	-20091,16		; r_quant2[42] @ 672
	.field	-28243,16		; r_quant2[43] @ 688
	.field	-32374,16		; r_quant2[44] @ 704
	.field	-19572,16		; r_quant2[45] @ 720
	.field	-24912,16		; r_quant2[46] @ 736
	.field	-28525,16		; r_quant2[47] @ 752
	.field	-14952,16		; r_quant2[48] @ 768
	.field	27829,16		; r_quant2[49] @ 784
	.field	-25753,16		; r_quant2[50] @ 800
	.field	-19319,16		; r_quant2[51] @ 816
	.field	27823,16		; r_quant2[52] @ 832
	.field	-31399,16		; r_quant2[53] @ 848
	.field	-16009,16		; r_quant2[54] @ 864
	.field	-32046,16		; r_quant2[55] @ 880
	.field	-32639,16		; r_quant2[56] @ 896
	.field	-13433,16		; r_quant2[57] @ 912
	.field	30656,16		; r_quant2[58] @ 928
	.field	-32394,16		; r_quant2[59] @ 944
	.field	-13710,16		; r_quant2[60] @ 960
	.field	31424,16		; r_quant2[61] @ 976
	.field	26745,16		; r_quant2[62] @ 992
	.field	-12160,16		; r_quant2[63] @ 1008
	.field	27075,16		; r_quant2[64] @ 1024
	.field	30562,16		; r_quant2[65] @ 1040
	.field	-12955,16		; r_quant2[66] @ 1056
	.field	28092,16		; r_quant2[67] @ 1072
	.field	25450,16		; r_quant2[68] @ 1088
	.field	-18057,16		; r_quant2[69] @ 1104
	.field	30385,16		; r_quant2[70] @ 1120
	.field	30572,16		; r_quant2[71] @ 1136
	.field	-21135,16		; r_quant2[72] @ 1152
	.field	31655,16		; r_quant2[73] @ 1168
	.field	26981,16		; r_quant2[74] @ 1184
	.field	-20609,16		; r_quant2[75] @ 1200
	.field	31652,16		; r_quant2[76] @ 1216
	.field	-30345,16		; r_quant2[77] @ 1232
	.field	-23169,16		; r_quant2[78] @ 1248
	.field	28819,16		; r_quant2[79] @ 1264
	.field	-30865,16		; r_quant2[80] @ 1280
	.field	-27781,16		; r_quant2[81] @ 1296
	.field	25765,16		; r_quant2[82] @ 1312
	.field	32129,16		; r_quant2[83] @ 1328
	.field	-23434,16		; r_quant2[84] @ 1344
	.field	31393,16		; r_quant2[85] @ 1360
	.field	29060,16		; r_quant2[86] @ 1376
	.field	-25747,16		; r_quant2[87] @ 1392
	.field	32408,16		; r_quant2[88] @ 1408
	.field	30582,16		; r_quant2[89] @ 1424
	.field	-24979,16		; r_quant2[90] @ 1440
	.field	29092,16		; r_quant2[91] @ 1456
	.field	31371,16		; r_quant2[92] @ 1472
	.field	-25735,16		; r_quant2[93] @ 1488
	.field	-32366,16		; r_quant2[94] @ 1504
	.field	32635,16		; r_quant2[95] @ 1520
	.field	-14206,16		; r_quant2[96] @ 1536
	.field	-27180,16		; r_quant2[97] @ 1552
	.field	28811,16		; r_quant2[98] @ 1568
	.field	-14463,16		; r_quant2[99] @ 1584
	.field	-23358,16		; r_quant2[100] @ 1600
	.field	31390,16		; r_quant2[101] @ 1616
	.field	-12167,16		; r_quant2[102] @ 1632
	.field	-23608,16		; r_quant2[103] @ 1648
	.field	29083,16		; r_quant2[104] @ 1664
	.field	-14217,16		; r_quant2[105] @ 1680
	.field	-28736,16		; r_quant2[106] @ 1696
	.field	29071,16		; r_quant2[107] @ 1712
	.field	-15497,16		; r_quant2[108] @ 1728
	.field	-19261,16		; r_quant2[109] @ 1744
	.field	29609,16		; r_quant2[110] @ 1760
	.field	-16020,16		; r_quant2[111] @ 1776
	.field	-18756,16		; r_quant2[112] @ 1792
	.field	29602,16		; r_quant2[113] @ 1808
	.field	-17556,16		; r_quant2[114] @ 1824
	.field	-25392,16		; r_quant2[115] @ 1840
	.field	25505,16		; r_quant2[116] @ 1856
	.field	-18571,16		; r_quant2[117] @ 1872
	.field	-26439,16		; r_quant2[118] @ 1888
	.field	31910,16		; r_quant2[119] @ 1904
	.field	-12448,16		; r_quant2[120] @ 1920
	.field	-31546,16		; r_quant2[121] @ 1936
	.field	24471,16		; r_quant2[122] @ 1952
	.field	-15771,16		; r_quant2[123] @ 1968
	.field	-22855,16		; r_quant2[124] @ 1984
	.field	25246,16		; r_quant2[125] @ 2000
	.field	-13235,16		; r_quant2[126] @ 2016
	.field	-24131,16		; r_quant2[127] @ 2032
	.field	20390,16		; r_quant2[128] @ 2048
	.field	-18857,16		; r_quant2[129] @ 2064
	.field	-25931,16		; r_quant2[130] @ 2080
	.field	18581,16		; r_quant2[131] @ 2096
	.field	-20397,16		; r_quant2[132] @ 2112
	.field	-20822,16		; r_quant2[133] @ 2128
	.field	20888,16		; r_quant2[134] @ 2144
	.field	-20128,16		; r_quant2[135] @ 2160
	.field	-26942,16		; r_quant2[136] @ 2176
	.field	26507,16		; r_quant2[137] @ 2192
	.field	-17826,16		; r_quant2[138] @ 2208
	.field	-30010,16		; r_quant2[139] @ 2224
	.field	21130,16		; r_quant2[140] @ 2240
	.field	-16299,16		; r_quant2[141] @ 2256
	.field	31665,16		; r_quant2[142] @ 2272
	.field	21382,16		; r_quant2[143] @ 2288
	.field	-18062,16		; r_quant2[144] @ 2304
	.field	-31053,16		; r_quant2[145] @ 2320
	.field	29057,16		; r_quant2[146] @ 2336
	.field	-21144,16		; r_quant2[147] @ 2352
	.field	-26191,16		; r_quant2[148] @ 2368
	.field	28818,16		; r_quant2[149] @ 2384
	.field	-18326,16		; r_quant2[150] @ 2400
	.field	-28496,16		; r_quant2[151] @ 2416
	.field	27020,16		; r_quant2[152] @ 2432
	.field	-21923,16		; r_quant2[153] @ 2448
	.field	-28758,16		; r_quant2[154] @ 2464
	.field	29331,16		; r_quant2[155] @ 2480
	.field	-23185,16		; r_quant2[156] @ 2496
	.field	-27741,16		; r_quant2[157] @ 2512
	.field	27789,16		; r_quant2[158] @ 2528
	.field	-21394,16		; r_quant2[159] @ 2544
	.field	-30039,16		; r_quant2[160] @ 2560
	.field	26756,16		; r_quant2[161] @ 2576
	.field	-18844,16		; r_quant2[162] @ 2592
	.field	32679,16		; r_quant2[163] @ 2608
	.field	25746,16		; r_quant2[164] @ 2624
	.field	-20359,16		; r_quant2[165] @ 2640
	.field	-29525,16		; r_quant2[166] @ 2656
	.field	30343,16		; r_quant2[167] @ 2672
	.field	-20632,16		; r_quant2[168] @ 2688
	.field	29353,16		; r_quant2[169] @ 2704
	.field	17301,16		; r_quant2[170] @ 2720
	.field	-24218,16		; r_quant2[171] @ 2736
	.field	-30562,16		; r_quant2[172] @ 2752
	.field	25218,16		; r_quant2[173] @ 2768
	.field	-20643,16		; r_quant2[174] @ 2784
	.field	32434,16		; r_quant2[175] @ 2800
	.field	20342,16		; r_quant2[176] @ 2816
	.field	-24228,16		; r_quant2[177] @ 2832
	.field	-28761,16		; r_quant2[178] @ 2848
	.field	22661,16		; r_quant2[179] @ 2864
	.field	-24497,16		; r_quant2[180] @ 2880
	.field	-30809,16		; r_quant2[181] @ 2896
	.field	26492,16		; r_quant2[182] @ 2912
	.field	-23199,16		; r_quant2[183] @ 2928
	.field	29859,16		; r_quant2[184] @ 2944
	.field	22652,16		; r_quant2[185] @ 2960
	.field	-24492,16		; r_quant2[186] @ 2976
	.field	28567,16		; r_quant2[187] @ 2992
	.field	23174,16		; r_quant2[188] @ 3008
	.field	-28086,16		; r_quant2[189] @ 3024
	.field	-31338,16		; r_quant2[190] @ 3040
	.field	22650,16		; r_quant2[191] @ 3056
	.field	-14973,16		; r_quant2[192] @ 3072
	.field	-18498,16		; r_quant2[193] @ 3088
	.field	31664,16		; r_quant2[194] @ 3104
	.field	-18291,16		; r_quant2[195] @ 3120
	.field	-19021,16		; r_quant2[196] @ 3136
	.field	-30281,16		; r_quant2[197] @ 3152
	.field	-17784,16		; r_quant2[198] @ 3168
	.field	-20557,16		; r_quant2[199] @ 3184
	.field	-31565,16		; r_quant2[200] @ 3200
	.field	-21116,16		; r_quant2[201] @ 3216
	.field	-20295,16		; r_quant2[202] @ 3232
	.field	-31041,16		; r_quant2[203] @ 3248
	.field	-19844,16		; r_quant2[204] @ 3264
	.field	-16454,16		; r_quant2[205] @ 3280
	.field	-32340,16		; r_quant2[206] @ 3296
	.field	-19334,16		; r_quant2[207] @ 3312
	.field	-20300,16		; r_quant2[208] @ 3328
	.field	-30808,16		; r_quant2[209] @ 3344
	.field	-21126,16		; r_quant2[210] @ 3360
	.field	-19276,16		; r_quant2[211] @ 3376
	.field	-29271,16		; r_quant2[212] @ 3392
	.field	-20861,16		; r_quant2[213] @ 3408
	.field	-14164,16		; r_quant2[214] @ 3424
	.field	32700,16		; r_quant2[215] @ 3440
	.field	-20872,16		; r_quant2[216] @ 3456
	.field	-26443,16		; r_quant2[217] @ 3472
	.field	31134,16		; r_quant2[218] @ 3488
	.field	-20877,16		; r_quant2[219] @ 3504
	.field	-24907,16		; r_quant2[220] @ 3520
	.field	-31585,16		; r_quant2[221] @ 3536
	.field	-21113,16		; r_quant2[222] @ 3552
	.field	-23381,16		; r_quant2[223] @ 3568
	.field	-32351,16		; r_quant2[224] @ 3584
	.field	-20096,16		; r_quant2[225] @ 3600
	.field	-25427,16		; r_quant2[226] @ 3616
	.field	32661,16		; r_quant2[227] @ 3632
	.field	-22405,16		; r_quant2[228] @ 3648
	.field	-25177,16		; r_quant2[229] @ 3664
	.field	30869,16		; r_quant2[230] @ 3680
	.field	-22912,16		; r_quant2[231] @ 3696
	.field	-28756,16		; r_quant2[232] @ 3712
	.field	32683,16		; r_quant2[233] @ 3728
	.field	-21895,16		; r_quant2[234] @ 3744
	.field	-22621,16		; r_quant2[235] @ 3760
	.field	32168,16		; r_quant2[236] @ 3776
	.field	-21879,16		; r_quant2[237] @ 3792
	.field	-25947,16		; r_quant2[238] @ 3808
	.field	-32103,16		; r_quant2[239] @ 3824
	.field	-18583,16		; r_quant2[240] @ 3840
	.field	-21325,16		; r_quant2[241] @ 3856
	.field	27554,16		; r_quant2[242] @ 3872
	.field	-18848,16		; r_quant2[243] @ 3888
	.field	-18511,16		; r_quant2[244] @ 3904
	.field	30631,16		; r_quant2[245] @ 3920
	.field	-18313,16		; r_quant2[246] @ 3936
	.field	-16207,16		; r_quant2[247] @ 3952
	.field	29887,16		; r_quant2[248] @ 3968
	.field	-18317,16		; r_quant2[249] @ 3984
	.field	-20047,16		; r_quant2[250] @ 4000
	.field	28590,16		; r_quant2[251] @ 4016
	.field	-18835,16		; r_quant2[252] @ 4032
	.field	-16209,16		; r_quant2[253] @ 4048
	.field	26818,16		; r_quant2[254] @ 4064
	.field	-21144,16		; r_quant2[255] @ 4080
	.field	-19796,16		; r_quant2[256] @ 4096
	.field	29617,16		; r_quant2[257] @ 4112
	.field	-21649,16		; r_quant2[258] @ 4128
	.field	-22614,16		; r_quant2[259] @ 4144
	.field	28098,16		; r_quant2[260] @ 4160
	.field	-23705,16		; r_quant2[261] @ 4176
	.field	-16471,16		; r_quant2[262] @ 4192
	.field	29372,16		; r_quant2[263] @ 4208
	.field	-20642,16		; r_quant2[264] @ 4224
	.field	-22105,16		; r_quant2[265] @ 4240
	.field	24249,16		; r_quant2[266] @ 4256
	.field	-23208,16		; r_quant2[267] @ 4272
	.field	-21594,16		; r_quant2[268] @ 4288
	.field	18602,16		; r_quant2[269] @ 4304
	.field	-22938,16		; r_quant2[270] @ 4320
	.field	-20322,16		; r_quant2[271] @ 4336
	.field	24510,16		; r_quant2[272] @ 4352
	.field	-24999,16		; r_quant2[273] @ 4368
	.field	-20317,16		; r_quant2[274] @ 4384
	.field	26797,16		; r_quant2[275] @ 4400
	.field	-25761,16		; r_quant2[276] @ 4416
	.field	-22615,16		; r_quant2[277] @ 4432
	.field	25764,16		; r_quant2[278] @ 4448
	.field	-23713,16		; r_quant2[279] @ 4464
	.field	-24408,16		; r_quant2[280] @ 4480
	.field	22941,16		; r_quant2[281] @ 4496
	.field	-24749,16		; r_quant2[282] @ 4512
	.field	-26463,16		; r_quant2[283] @ 4528
	.field	20407,16		; r_quant2[284] @ 4544
	.field	-25787,16		; r_quant2[285] @ 4560
	.field	-20325,16		; r_quant2[286] @ 4576
	.field	20643,16		; r_quant2[287] @ 4592
	.field	-23441,16		; r_quant2[288] @ 4608
	.field	-21848,16		; r_quant2[289] @ 4624
	.field	27808,16		; r_quant2[290] @ 4640
	.field	-23698,16		; r_quant2[291] @ 4656
	.field	-24925,16		; r_quant2[292] @ 4672
	.field	26779,16		; r_quant2[293] @ 4688
	.field	-25496,16		; r_quant2[294] @ 4704
	.field	-21602,16		; r_quant2[295] @ 4720
	.field	31139,16		; r_quant2[296] @ 4736
	.field	-22923,16		; r_quant2[297] @ 4752
	.field	-23902,16		; r_quant2[298] @ 4768
	.field	29851,16		; r_quant2[299] @ 4784
	.field	-24709,16		; r_quant2[300] @ 4800
	.field	-25188,16		; r_quant2[301] @ 4816
	.field	30361,16		; r_quant2[302] @ 4832
	.field	-24971,16		; r_quant2[303] @ 4848
	.field	-22115,16		; r_quant2[304] @ 4864
	.field	28579,16		; r_quant2[305] @ 4880
	.field	-26508,16		; r_quant2[306] @ 4896
	.field	-24425,16		; r_quant2[307] @ 4912
	.field	27555,16		; r_quant2[308] @ 4928
	.field	-25233,16		; r_quant2[309] @ 4944
	.field	-26724,16		; r_quant2[310] @ 4960
	.field	26525,16		; r_quant2[311] @ 4976
	.field	-27023,16		; r_quant2[312] @ 4992
	.field	-26223,16		; r_quant2[313] @ 5008
	.field	26785,16		; r_quant2[314] @ 5024
	.field	-27289,16		; r_quant2[315] @ 5040
	.field	-25971,16		; r_quant2[316] @ 5056
	.field	25238,16		; r_quant2[317] @ 5072
	.field	-24717,16		; r_quant2[318] @ 5088
	.field	-29033,16		; r_quant2[319] @ 5104
	.field	27795,16		; r_quant2[320] @ 5120
	.field	-26766,16		; r_quant2[321] @ 5136
	.field	-29797,16		; r_quant2[322] @ 5152
	.field	27531,16		; r_quant2[323] @ 5168
	.field	-27799,16		; r_quant2[324] @ 5184
	.field	-29281,16		; r_quant2[325] @ 5200
	.field	26259,16		; r_quant2[326] @ 5216
	.field	-25760,16		; r_quant2[327] @ 5232
	.field	-26475,16		; r_quant2[328] @ 5248
	.field	24467,16		; r_quant2[329] @ 5264
	.field	-26270,16		; r_quant2[330] @ 5280
	.field	-29804,16		; r_quant2[331] @ 5296
	.field	21905,16		; r_quant2[332] @ 5312
	.field	-28821,16		; r_quant2[333] @ 5328
	.field	-27246,16		; r_quant2[334] @ 5344
	.field	27525,16		; r_quant2[335] @ 5360
	.field	-27300,16		; r_quant2[336] @ 5376
	.field	-24174,16		; r_quant2[337] @ 5392
	.field	19357,16		; r_quant2[338] @ 5408
	.field	-26270,16		; r_quant2[339] @ 5424
	.field	-18542,16		; r_quant2[340] @ 5440
	.field	25534,16		; r_quant2[341] @ 5456
	.field	-27813,16		; r_quant2[342] @ 5472
	.field	-19562,16		; r_quant2[343] @ 5488
	.field	23236,16		; r_quant2[344] @ 5504
	.field	-27570,16		; r_quant2[345] @ 5520
	.field	-18031,16		; r_quant2[346] @ 5536
	.field	21168,16		; r_quant2[347] @ 5552
	.field	-30129,16		; r_quant2[348] @ 5568
	.field	-21102,16		; r_quant2[349] @ 5584
	.field	25514,16		; r_quant2[350] @ 5600
	.field	-29600,16		; r_quant2[351] @ 5616
	.field	-23410,16		; r_quant2[352] @ 5632
	.field	22941,16		; r_quant2[353] @ 5648
	.field	-30888,16		; r_quant2[354] @ 5664
	.field	-21376,16		; r_quant2[355] @ 5680
	.field	19109,16		; r_quant2[356] @ 5696
	.field	-29345,16		; r_quant2[357] @ 5712
	.field	-15739,16		; r_quant2[358] @ 5728
	.field	22463,16		; r_quant2[359] @ 5744
	.field	-28565,16		; r_quant2[360] @ 5760
	.field	30605,16		; r_quant2[361] @ 5776
	.field	25707,16		; r_quant2[362] @ 5792
	.field	-30123,16		; r_quant2[363] @ 5808
	.field	-27262,16		; r_quant2[364] @ 5824
	.field	21395,16		; r_quant2[365] @ 5840
	.field	-30611,16		; r_quant2[366] @ 5856
	.field	-28280,16		; r_quant2[367] @ 5872
	.field	25997,16		; r_quant2[368] @ 5888
	.field	-32671,16		; r_quant2[369] @ 5904
	.field	-28552,16		; r_quant2[370] @ 5920
	.field	23944,16		; r_quant2[371] @ 5936
	.field	-28317,16		; r_quant2[372] @ 5952
	.field	32647,16		; r_quant2[373] @ 5968
	.field	27523,16		; r_quant2[374] @ 5984
	.field	-32667,16		; r_quant2[375] @ 6000
	.field	31375,16		; r_quant2[376] @ 6016
	.field	24458,16		; r_quant2[377] @ 6032
	.field	-30374,16		; r_quant2[378] @ 6048
	.field	-31093,16		; r_quant2[379] @ 6064
	.field	21113,16		; r_quant2[380] @ 6080
	.field	32620,16		; r_quant2[381] @ 6096
	.field	-30609,16		; r_quant2[382] @ 6112
	.field	24182,16		; r_quant2[383] @ 6128
	.field	-14939,16		; r_quant2[384] @ 6144
	.field	-20545,16		; r_quant2[385] @ 6160
	.field	-25933,16		; r_quant2[386] @ 6176
	.field	-19049,16		; r_quant2[387] @ 6192
	.field	-22085,16		; r_quant2[388] @ 6208
	.field	-28481,16		; r_quant2[389] @ 6224
	.field	-19548,16		; r_quant2[390] @ 6240
	.field	-17488,16		; r_quant2[391] @ 6256
	.field	-25160,16		; r_quant2[392] @ 6272
	.field	-19560,16		; r_quant2[393] @ 6288
	.field	-15444,16		; r_quant2[394] @ 6304
	.field	-27207,16		; r_quant2[395] @ 6320
	.field	-20058,16		; r_quant2[396] @ 6336
	.field	-23120,16		; r_quant2[397] @ 6352
	.field	-25176,16		; r_quant2[398] @ 6368
	.field	-21864,16		; r_quant2[399] @ 6384
	.field	-20552,16		; r_quant2[400] @ 6400
	.field	-27986,16		; r_quant2[401] @ 6416
	.field	-20333,16		; r_quant2[402] @ 6432
	.field	-23378,16		; r_quant2[403] @ 6448
	.field	-29006,16		; r_quant2[404] @ 6464
	.field	-23902,16		; r_quant2[405] @ 6480
	.field	-16993,16		; r_quant2[406] @ 6496
	.field	-25166,16		; r_quant2[407] @ 6512
	.field	-19024,16		; r_quant2[408] @ 6528
	.field	-27987,16		; r_quant2[409] @ 6544
	.field	-22132,16		; r_quant2[410] @ 6560
	.field	-23624,16		; r_quant2[411] @ 6576
	.field	-27741,16		; r_quant2[412] @ 6592
	.field	-22898,16		; r_quant2[413] @ 6608
	.field	-19531,16		; r_quant2[414] @ 6624
	.field	32172,16		; r_quant2[415] @ 6640
	.field	-20306,16		; r_quant2[416] @ 6656
	.field	-23890,16		; r_quant2[417] @ 6672
	.field	-22375,16		; r_quant2[418] @ 6688
	.field	-19034,16		; r_quant2[419] @ 6704
	.field	-25945,16		; r_quant2[420] @ 6720
	.field	-23642,16		; r_quant2[421] @ 6736
	.field	-23393,16		; r_quant2[422] @ 6752
	.field	-23654,16		; r_quant2[423] @ 6768
	.field	-25703,16		; r_quant2[424] @ 6784
	.field	-23911,16		; r_quant2[425] @ 6800
	.field	-28749,16		; r_quant2[426] @ 6816
	.field	-26219,16		; r_quant2[427] @ 6832
	.field	-21116,16		; r_quant2[428] @ 6848
	.field	-26709,16		; r_quant2[429] @ 6864
	.field	-18027,16		; r_quant2[430] @ 6880
	.field	-22866,16		; r_quant2[431] @ 6896
	.field	-20340,16		; r_quant2[432] @ 6912
	.field	-15956,16		; r_quant2[433] @ 6928
	.field	-31045,16		; r_quant2[434] @ 6944
	.field	-22127,16		; r_quant2[435] @ 6960
	.field	-21336,16		; r_quant2[436] @ 6976
	.field	-27962,16		; r_quant2[437] @ 6992
	.field	-22642,16		; r_quant2[438] @ 7008
	.field	-17498,16		; r_quant2[439] @ 7024
	.field	-30268,16		; r_quant2[440] @ 7040
	.field	-24694,16		; r_quant2[441] @ 7056
	.field	-18009,16		; r_quant2[442] @ 7072
	.field	-30291,16		; r_quant2[443] @ 7088
	.field	-23420,16		; r_quant2[444] @ 7104
	.field	-19299,16		; r_quant2[445] @ 7120
	.field	-30775,16		; r_quant2[446] @ 7136
	.field	-26744,16		; r_quant2[447] @ 7152
	.field	-16988,16		; r_quant2[448] @ 7168
	.field	-31809,16		; r_quant2[449] @ 7184
	.field	-24683,16		; r_quant2[450] @ 7200
	.field	-15455,16		; r_quant2[451] @ 7216
	.field	-28231,16		; r_quant2[452] @ 7232
	.field	-25453,16		; r_quant2[453] @ 7248
	.field	-20078,16		; r_quant2[454] @ 7264
	.field	-31290,16		; r_quant2[455] @ 7280
	.field	-25463,16		; r_quant2[456] @ 7296
	.field	-20586,16		; r_quant2[457] @ 7312
	.field	-31830,16		; r_quant2[458] @ 7328
	.field	-28285,16		; r_quant2[459] @ 7344
	.field	-20082,16		; r_quant2[460] @ 7360
	.field	-31577,16		; r_quant2[461] @ 7376
	.field	-24426,16		; r_quant2[462] @ 7392
	.field	-22881,16		; r_quant2[463] @ 7408
	.field	-29274,16		; r_quant2[464] @ 7424
	.field	-25714,16		; r_quant2[465] @ 7440
	.field	-24669,16		; r_quant2[466] @ 7456
	.field	-30812,16		; r_quant2[467] @ 7472
	.field	-24702,16		; r_quant2[468] @ 7488
	.field	-23908,16		; r_quant2[469] @ 7504
	.field	-31331,16		; r_quant2[470] @ 7520
	.field	-28014,16		; r_quant2[471] @ 7536
	.field	-26220,16		; r_quant2[472] @ 7552
	.field	-30306,16		; r_quant2[473] @ 7568
	.field	-25984,16		; r_quant2[474] @ 7584
	.field	-22119,16		; r_quant2[475] @ 7600
	.field	32162,16		; r_quant2[476] @ 7616
	.field	-27776,16		; r_quant2[477] @ 7632
	.field	-24170,16		; r_quant2[478] @ 7648
	.field	-29266,16		; r_quant2[479] @ 7664
	.field	-20335,16		; r_quant2[480] @ 7680
	.field	30637,16		; r_quant2[481] @ 7696
	.field	-31102,16		; r_quant2[482] @ 7712
	.field	-22384,16		; r_quant2[483] @ 7728
	.field	-24670,16		; r_quant2[484] @ 7744
	.field	-30057,16		; r_quant2[485] @ 7760
	.field	-21848,16		; r_quant2[486] @ 7776
	.field	28832,16		; r_quant2[487] @ 7792
	.field	-25217,16		; r_quant2[488] @ 7808
	.field	-26471,16		; r_quant2[489] @ 7824
	.field	-27750,16		; r_quant2[490] @ 7840
	.field	-29290,16		; r_quant2[491] @ 7856
	.field	-22889,16		; r_quant2[492] @ 7872
	.field	-30804,16		; r_quant2[493] @ 7888
	.field	-29301,16		; r_quant2[494] @ 7904
	.field	-22904,16		; r_quant2[495] @ 7920
	.field	-28769,16		; r_quant2[496] @ 7936
	.field	-31350,16		; r_quant2[497] @ 7952
	.field	-23404,16		; r_quant2[498] @ 7968
	.field	-27745,16		; r_quant2[499] @ 7984
	.field	-28787,16		; r_quant2[500] @ 8000
	.field	-23669,16		; r_quant2[501] @ 8016
	.field	-32100,16		; r_quant2[502] @ 8032
	.field	-31613,16		; r_quant2[503] @ 8048
	.field	-25195,16		; r_quant2[504] @ 8064
	.field	29582,16		; r_quant2[505] @ 8080
	.field	-29803,16		; r_quant2[506] @ 8096
	.field	-26990,16		; r_quant2[507] @ 8112
	.field	-29034,16		; r_quant2[508] @ 8128
	.field	-28027,16		; r_quant2[509] @ 8144
	.field	-26742,16		; r_quant2[510] @ 8160
	.field	31880,16		; r_quant2[511] @ 8176
	.field	-22888,16		; r_quant2[512] @ 8192
	.field	-28257,16		; r_quant2[513] @ 8208
	.field	-29818,16		; r_quant2[514] @ 8224
	.field	-25212,16		; r_quant2[515] @ 8240
	.field	-30058,16		; r_quant2[516] @ 8256
	.field	-28022,16		; r_quant2[517] @ 8272
	.field	-29302,16		; r_quant2[518] @ 8288
	.field	-27998,16		; r_quant2[519] @ 8304
	.field	30856,16		; r_quant2[520] @ 8320
	.field	-22932,16		; r_quant2[521] @ 8336
	.field	32149,16		; r_quant2[522] @ 8352
	.field	29323,16		; r_quant2[523] @ 8368
	.field	-28546,16		; r_quant2[524] @ 8384
	.field	-30586,16		; r_quant2[525] @ 8400
	.field	32636,16		; r_quant2[526] @ 8416
	.field	-19824,16		; r_quant2[527] @ 8432
	.field	-24966,16		; r_quant2[528] @ 8448
	.field	-30560,16		; r_quant2[529] @ 8464
	.field	31123,16		; r_quant2[530] @ 8480
	.field	-26250,16		; r_quant2[531] @ 8496
	.field	-28265,16		; r_quant2[532] @ 8512
	.field	-32359,16		; r_quant2[533] @ 8528
	.field	-27515,16		; r_quant2[534] @ 8544
	.field	-27762,16		; r_quant2[535] @ 8560
	.field	-32104,16		; r_quant2[536] @ 8576
	.field	-24449,16		; r_quant2[537] @ 8592
	.field	-27237,16		; r_quant2[538] @ 8608
	.field	-31855,16		; r_quant2[539] @ 8624
	.field	-26755,16		; r_quant2[540] @ 8640
	.field	-29031,16		; r_quant2[541] @ 8656
	.field	31899,16		; r_quant2[542] @ 8672
	.field	-27526,16		; r_quant2[543] @ 8688
	.field	-26475,16		; r_quant2[544] @ 8704
	.field	-30323,16		; r_quant2[545] @ 8720
	.field	-28028,16		; r_quant2[546] @ 8736
	.field	-31092,16		; r_quant2[547] @ 8752
	.field	-31860,16		; r_quant2[548] @ 8768
	.field	-28037,16		; r_quant2[549] @ 8784
	.field	-30318,16		; r_quant2[550] @ 8800
	.field	30083,16		; r_quant2[551] @ 8816
	.field	-30081,16		; r_quant2[552] @ 8832
	.field	-27521,16		; r_quant2[553] @ 8848
	.field	-32391,16		; r_quant2[554] @ 8864
	.field	30072,16		; r_quant2[555] @ 8880
	.field	29582,16		; r_quant2[556] @ 8896
	.field	29583,16		; r_quant2[557] @ 8912
	.field	-31362,16		; r_quant2[558] @ 8928
	.field	-30837,16		; r_quant2[559] @ 8944
	.field	30851,16		; r_quant2[560] @ 8960
	.field	-31627,16		; r_quant2[561] @ 8976
	.field	31614,16		; r_quant2[562] @ 8992
	.field	32406,16		; r_quant2[563] @ 9008
	.field	-32122,16		; r_quant2[564] @ 9024
	.field	-29838,16		; r_quant2[565] @ 9040
	.field	-32380,16		; r_quant2[566] @ 9056
	.field	-30599,16		; r_quant2[567] @ 9072
	.field	-28026,16		; r_quant2[568] @ 9088
	.field	29837,16		; r_quant2[569] @ 9104
	.field	-32651,16		; r_quant2[570] @ 9120
	.field	-29576,16		; r_quant2[571] @ 9136
	.field	30858,16		; r_quant2[572] @ 9152
	.field	30063,16		; r_quant2[573] @ 9168
	.field	-32133,16		; r_quant2[574] @ 9184
	.field	29847,16		; r_quant2[575] @ 9200
	.field	-23180,16		; r_quant2[576] @ 9216
	.field	-20321,16		; r_quant2[577] @ 9232
	.field	-32337,16		; r_quant2[578] @ 9248
	.field	-25471,16		; r_quant2[579] @ 9264
	.field	-15210,16		; r_quant2[580] @ 9280
	.field	-32324,16		; r_quant2[581] @ 9296
	.field	-22917,16		; r_quant2[582] @ 9312
	.field	-15707,16		; r_quant2[583] @ 9328
	.field	31925,16		; r_quant2[584] @ 9344
	.field	-24194,16		; r_quant2[585] @ 9360
	.field	-17766,16		; r_quant2[586] @ 9376
	.field	31925,16		; r_quant2[587] @ 9392
	.field	-26249,16		; r_quant2[588] @ 9408
	.field	-20822,16		; r_quant2[589] @ 9424
	.field	30405,16		; r_quant2[590] @ 9440
	.field	-23697,16		; r_quant2[591] @ 9456
	.field	-15971,16		; r_quant2[592] @ 9472
	.field	27831,16		; r_quant2[593] @ 9488
	.field	-24203,16		; r_quant2[594] @ 9504
	.field	-17509,16		; r_quant2[595] @ 9520
	.field	29879,16		; r_quant2[596] @ 9536
	.field	-24455,16		; r_quant2[597] @ 9552
	.field	-14182,16		; r_quant2[598] @ 9568
	.field	31173,16		; r_quant2[599] @ 9584
	.field	-28561,16		; r_quant2[600] @ 9600
	.field	-25967,16		; r_quant2[601] @ 9616
	.field	30357,16		; r_quant2[602] @ 9632
	.field	-27271,16		; r_quant2[603] @ 9648
	.field	-22125,16		; r_quant2[604] @ 9664
	.field	30625,16		; r_quant2[605] @ 9680
	.field	-29570,16		; r_quant2[606] @ 9696
	.field	-24178,16		; r_quant2[607] @ 9712
	.field	30885,16		; r_quant2[608] @ 9728
	.field	-29578,16		; r_quant2[609] @ 9744
	.field	-25710,16		; r_quant2[610] @ 9760
	.field	28841,16		; r_quant2[611] @ 9776
	.field	-29073,16		; r_quant2[612] @ 9792
	.field	-24181,16		; r_quant2[613] @ 9808
	.field	27048,16		; r_quant2[614] @ 9824
	.field	-30613,16		; r_quant2[615] @ 9840
	.field	-24441,16		; r_quant2[616] @ 9856
	.field	29347,16		; r_quant2[617] @ 9872
	.field	-31626,16		; r_quant2[618] @ 9888
	.field	-26230,16		; r_quant2[619] @ 9904
	.field	28844,16		; r_quant2[620] @ 9920
	.field	-30083,16		; r_quant2[621] @ 9936
	.field	-21371,16		; r_quant2[622] @ 9952
	.field	31143,16		; r_quant2[623] @ 9968
	.field	-26007,16		; r_quant2[624] @ 9984
	.field	-15208,16		; r_quant2[625] @ 10000
	.field	28845,16		; r_quant2[626] @ 10016
	.field	-27287,16		; r_quant2[627] @ 10032
	.field	-20075,16		; r_quant2[628] @ 10048
	.field	30404,16		; r_quant2[629] @ 10064
	.field	-27532,16		; r_quant2[630] @ 10080
	.field	-18542,16		; r_quant2[631] @ 10096
	.field	31420,16		; r_quant2[632] @ 10112
	.field	-28548,16		; r_quant2[633] @ 10128
	.field	-19573,16		; r_quant2[634] @ 10144
	.field	30130,16		; r_quant2[635] @ 10160
	.field	-26255,16		; r_quant2[636] @ 10176
	.field	-14958,16		; r_quant2[637] @ 10192
	.field	27589,16		; r_quant2[638] @ 10208
	.field	-28562,16		; r_quant2[639] @ 10224
	.field	-17780,16		; r_quant2[640] @ 10240
	.field	26550,16		; r_quant2[641] @ 10256
	.field	-29068,16		; r_quant2[642] @ 10272
	.field	-14714,16		; r_quant2[643] @ 10288
	.field	29634,16		; r_quant2[644] @ 10304
	.field	-32152,16		; r_quant2[645] @ 10320
	.field	-15988,16		; r_quant2[646] @ 10336
	.field	32197,16		; r_quant2[647] @ 10352
	.field	30797,16		; r_quant2[648] @ 10368
	.field	-26745,16		; r_quant2[649] @ 10384
	.field	26011,16		; r_quant2[650] @ 10400
	.field	-32163,16		; r_quant2[651] @ 10416
	.field	-25213,16		; r_quant2[652] @ 10432
	.field	27804,16		; r_quant2[653] @ 10448
	.field	32362,16		; r_quant2[654] @ 10464
	.field	-27003,16		; r_quant2[655] @ 10480
	.field	24753,16		; r_quant2[656] @ 10496
	.field	32088,16		; r_quant2[657] @ 10512
	.field	-20860,16		; r_quant2[658] @ 10528
	.field	28595,16		; r_quant2[659] @ 10544
	.field	-32409,16		; r_quant2[660] @ 10560
	.field	-21638,16		; r_quant2[661] @ 10576
	.field	24508,16		; r_quant2[662] @ 10592
	.field	29539,16		; r_quant2[663] @ 10608
	.field	-17555,16		; r_quant2[664] @ 10624
	.field	21420,16		; r_quant2[665] @ 10640
	.field	31340,16		; r_quant2[666] @ 10656
	.field	-23689,16		; r_quant2[667] @ 10672
	.field	24997,16		; r_quant2[668] @ 10688
	.field	29792,16		; r_quant2[669] @ 10704
	.field	-25744,16		; r_quant2[670] @ 10720
	.field	22421,16		; r_quant2[671] @ 10736
	.field	-26472,16		; r_quant2[672] @ 10752
	.field	-23919,16		; r_quant2[673] @ 10768
	.field	-28252,16		; r_quant2[674] @ 10784
	.field	-30071,16		; r_quant2[675] @ 10800
	.field	-24689,16		; r_quant2[676] @ 10816
	.field	-24898,16		; r_quant2[677] @ 10832
	.field	-27750,16		; r_quant2[678] @ 10848
	.field	-20331,16		; r_quant2[679] @ 10864
	.field	-27456,16		; r_quant2[680] @ 10880
	.field	-29043,16		; r_quant2[681] @ 10896
	.field	-16498,16		; r_quant2[682] @ 10912
	.field	-28239,16		; r_quant2[683] @ 10928
	.field	-31347,16		; r_quant2[684] @ 10944
	.field	-20086,16		; r_quant2[685] @ 10960
	.field	-30294,16		; r_quant2[686] @ 10976
	.field	-31059,16		; r_quant2[687] @ 10992
	.field	-19070,16		; r_quant2[688] @ 11008
	.field	-24395,16		; r_quant2[689] @ 11024
	.field	-29540,16		; r_quant2[690] @ 11040
	.field	-23414,16		; r_quant2[691] @ 11056
	.field	-31816,16		; r_quant2[692] @ 11072
	.field	-30827,16		; r_quant2[693] @ 11088
	.field	-16001,16		; r_quant2[694] @ 11104
	.field	-29000,16		; r_quant2[695] @ 11120
	.field	32662,16		; r_quant2[696] @ 11136
	.field	-29323,16		; r_quant2[697] @ 11152
	.field	-28027,16		; r_quant2[698] @ 11168
	.field	-32376,16		; r_quant2[699] @ 11184
	.field	-25723,16		; r_quant2[700] @ 11200
	.field	-30061,16		; r_quant2[701] @ 11216
	.field	31108,16		; r_quant2[702] @ 11232
	.field	-28797,16		; r_quant2[703] @ 11248
	.field	-27742,16		; r_quant2[704] @ 11264
	.field	32412,16		; r_quant2[705] @ 11280
	.field	-25735,16		; r_quant2[706] @ 11296
	.field	-28523,16		; r_quant2[707] @ 11312
	.field	30366,16		; r_quant2[708] @ 11328
	.field	-19854,16		; r_quant2[709] @ 11344
	.field	-25181,16		; r_quant2[710] @ 11360
	.field	26774,16		; r_quant2[711] @ 11376
	.field	-20110,16		; r_quant2[712] @ 11392
	.field	-22133,16		; r_quant2[713] @ 11408
	.field	25759,16		; r_quant2[714] @ 11424
	.field	-29838,16		; r_quant2[715] @ 11440
	.field	-29256,16		; r_quant2[716] @ 11456
	.field	30091,16		; r_quant2[717] @ 11472
	.field	-24211,16		; r_quant2[718] @ 11488
	.field	-30824,16		; r_quant2[719] @ 11504
	.field	-31873,16		; r_quant2[720] @ 11520
	.field	-24962,16		; r_quant2[721] @ 11536
	.field	29104,16		; r_quant2[722] @ 11552
	.field	29806,16		; r_quant2[723] @ 11568
	.field	-21373,16		; r_quant2[724] @ 11584
	.field	-31831,16		; r_quant2[725] @ 11600
	.field	32136,16		; r_quant2[726] @ 11616
	.field	-22151,16		; r_quant2[727] @ 11632
	.field	-32093,16		; r_quant2[728] @ 11648
	.field	-31622,16		; r_quant2[729] @ 11664
	.field	-18299,16		; r_quant2[730] @ 11680
	.field	-31291,16		; r_quant2[731] @ 11696
	.field	31871,16		; r_quant2[732] @ 11712
	.field	-18049,16		; r_quant2[733] @ 11728
	.field	30402,16		; r_quant2[734] @ 11744
	.field	30066,16		; r_quant2[735] @ 11760
	.field	-16513,16		; r_quant2[736] @ 11776
	.field	31661,16		; r_quant2[737] @ 11792
	.field	32629,16		; r_quant2[738] @ 11808
	.field	-23943,16		; r_quant2[739] @ 11824
	.field	31401,16		; r_quant2[740] @ 11840
	.field	30328,16		; r_quant2[741] @ 11856
	.field	-24972,16		; r_quant2[742] @ 11872
	.field	32704,16		; r_quant2[743] @ 11888
	.field	25967,16		; r_quant2[744] @ 11904
	.field	-31891,16		; r_quant2[745] @ 11920
	.field	26786,16		; r_quant2[746] @ 11936
	.field	26459,16		; r_quant2[747] @ 11952
	.field	-29601,16		; r_quant2[748] @ 11968
	.field	-27230,16		; r_quant2[749] @ 11984
	.field	23943,16		; r_quant2[750] @ 12000
	.field	-29068,16		; r_quant2[751] @ 12016
	.field	27538,16		; r_quant2[752] @ 12032
	.field	28546,16		; r_quant2[753] @ 12048
	.field	-21908,16		; r_quant2[754] @ 12064
	.field	30132,16		; r_quant2[755] @ 12080
	.field	26727,16		; r_quant2[756] @ 12096
	.field	-18849,16		; r_quant2[757] @ 12112
	.field	26795,16		; r_quant2[758] @ 12128
	.field	28537,16		; r_quant2[759] @ 12144
	.field	-26007,16		; r_quant2[760] @ 12160
	.field	29329,16		; r_quant2[761] @ 12176
	.field	25984,16		; r_quant2[762] @ 12192
	.field	-19116,16		; r_quant2[763] @ 12208
	.field	-31577,16		; r_quant2[764] @ 12224
	.field	25463,16		; r_quant2[765] @ 12240
	.field	-24489,16		; r_quant2[766] @ 12256
	.field	27538,16		; r_quant2[767] @ 12272


r_quant3
	.field	-26192,16		; r_quant3[0] @ 0
	.field	-32358,16		; r_quant3[1] @ 16
	.field	-27991,16		; r_quant3[2] @ 32
	.field	31890,16		; r_quant3[3] @ 48
	.field	-27731,16		; r_quant3[4] @ 64
	.field	30625,16		; r_quant3[5] @ 80
	.field	-28246,16		; r_quant3[6] @ 96
	.field	29078,16		; r_quant3[7] @ 112
	.field	-28501,16		; r_quant3[8] @ 128
	.field	-31610,16		; r_quant3[9] @ 144
	.field	-30302,16		; r_quant3[10] @ 160
	.field	30347,16		; r_quant3[11] @ 176
	.field	-25161,16		; r_quant3[12] @ 192
	.field	29326,16		; r_quant3[13] @ 208
	.field	-26959,16		; r_quant3[14] @ 224
	.field	27784,16		; r_quant3[15] @ 240
	.field	-27468,16		; r_quant3[16] @ 256
	.field	26514,16		; r_quant3[17] @ 272
	.field	-30561,16		; r_quant3[18] @ 288
	.field	29088,16		; r_quant3[19] @ 304
	.field	-28484,16		; r_quant3[20] @ 320
	.field	31120,16		; r_quant3[21] @ 336
	.field	-29789,16		; r_quant3[22] @ 352
	.field	-30559,16		; r_quant3[23] @ 368
	.field	-30302,16		; r_quant3[24] @ 384
	.field	-32361,16		; r_quant3[25] @ 400
	.field	-30548,16		; r_quant3[26] @ 416
	.field	31646,16		; r_quant3[27] @ 432
	.field	-25687,16		; r_quant3[28] @ 448
	.field	29589,16		; r_quant3[29] @ 464
	.field	-29286,16		; r_quant3[30] @ 480
	.field	30359,16		; r_quant3[31] @ 496
	.field	-31069,16		; r_quant3[32] @ 512
	.field	-32127,16		; r_quant3[33] @ 528
	.field	-31074,16		; r_quant3[34] @ 544
	.field	29819,16		; r_quant3[35] @ 560
	.field	-29016,16		; r_quant3[36] @ 576
	.field	23178,16		; r_quant3[37] @ 592
	.field	-30027,16		; r_quant3[38] @ 608
	.field	30600,16		; r_quant3[39] @ 624
	.field	-28995,16		; r_quant3[40] @ 640
	.field	27787,16		; r_quant3[41] @ 656
	.field	-31305,16		; r_quant3[42] @ 672
	.field	27527,16		; r_quant3[43] @ 688
	.field	-31049,16		; r_quant3[44] @ 704
	.field	29808,16		; r_quant3[45] @ 720
	.field	32171,16		; r_quant3[46] @ 736
	.field	26486,16		; r_quant3[47] @ 752
	.field	-30295,16		; r_quant3[48] @ 768
	.field	27026,16		; r_quant3[49] @ 784
	.field	-32096,16		; r_quant3[50] @ 800
	.field	27014,16		; r_quant3[51] @ 816
	.field	32677,16		; r_quant3[52] @ 832
	.field	24203,16		; r_quant3[53] @ 848
	.field	31132,16		; r_quant3[54] @ 864
	.field	22399,16		; r_quant3[55] @ 880
	.field	-26968,16		; r_quant3[56] @ 896
	.field	26231,16		; r_quant3[57] @ 912
	.field	-30302,16		; r_quant3[58] @ 928
	.field	24437,16		; r_quant3[59] @ 944
	.field	31391,16		; r_quant3[60] @ 960
	.field	28304,16		; r_quant3[61] @ 976
	.field	31400,16		; r_quant3[62] @ 992
	.field	30599,16		; r_quant3[63] @ 1008
	.field	-31076,16		; r_quant3[64] @ 1024
	.field	27796,16		; r_quant3[65] @ 1040
	.field	-31335,16		; r_quant3[66] @ 1056
	.field	32672,16		; r_quant3[67] @ 1072
	.field	32153,16		; r_quant3[68] @ 1088
	.field	31896,16		; r_quant3[69] @ 1104
	.field	-31853,16		; r_quant3[70] @ 1120
	.field	30613,16		; r_quant3[71] @ 1136
	.field	31892,16		; r_quant3[72] @ 1152
	.field	29840,16		; r_quant3[73] @ 1168
	.field	-32100,16		; r_quant3[74] @ 1184
	.field	32654,16		; r_quant3[75] @ 1200
	.field	-32616,16		; r_quant3[76] @ 1216
	.field	29576,16		; r_quant3[77] @ 1232
	.field	32140,16		; r_quant3[78] @ 1248
	.field	31375,16		; r_quant3[79] @ 1264
	.field	32408,16		; r_quant3[80] @ 1280
	.field	30369,16		; r_quant3[81] @ 1296
	.field	31890,16		; r_quant3[82] @ 1312
	.field	28062,16		; r_quant3[83] @ 1328
	.field	31373,16		; r_quant3[84] @ 1344
	.field	30619,16		; r_quant3[85] @ 1360
	.field	31129,16		; r_quant3[86] @ 1376
	.field	28826,16		; r_quant3[87] @ 1392
	.field	32390,16		; r_quant3[88] @ 1408
	.field	27555,16		; r_quant3[89] @ 1424
	.field	32159,16		; r_quant3[90] @ 1440
	.field	30099,16		; r_quant3[91] @ 1456
	.field	30362,16		; r_quant3[92] @ 1472
	.field	32674,16		; r_quant3[93] @ 1488
	.field	-32103,16		; r_quant3[94] @ 1504
	.field	-28774,16		; r_quant3[95] @ 1520
	.field	32660,16		; r_quant3[96] @ 1536
	.field	22937,16		; r_quant3[97] @ 1552
	.field	30599,16		; r_quant3[98] @ 1568
	.field	22164,16		; r_quant3[99] @ 1584
	.field	29847,16		; r_quant3[100] @ 1600
	.field	24465,16		; r_quant3[101] @ 1616
	.field	27534,16		; r_quant3[102] @ 1632
	.field	21905,16		; r_quant3[103] @ 1648
	.field	30859,16		; r_quant3[104] @ 1664
	.field	27788,16		; r_quant3[105] @ 1680
	.field	28803,16		; r_quant3[106] @ 1696
	.field	26763,16		; r_quant3[107] @ 1712
	.field	30092,16		; r_quant3[108] @ 1728
	.field	29333,16		; r_quant3[109] @ 1744
	.field	28295,16		; r_quant3[110] @ 1760
	.field	29081,16		; r_quant3[111] @ 1776
	.field	28545,16		; r_quant3[112] @ 1792
	.field	26786,16		; r_quant3[113] @ 1808
	.field	29843,16		; r_quant3[114] @ 1824
	.field	27283,16		; r_quant3[115] @ 1840
	.field	26249,16		; r_quant3[116] @ 1856
	.field	26261,16		; r_quant3[117] @ 1872
	.field	24707,16		; r_quant3[118] @ 1888
	.field	29600,16		; r_quant3[119] @ 1904
	.field	31618,16		; r_quant3[120] @ 1920
	.field	26772,16		; r_quant3[121] @ 1936
	.field	27790,16		; r_quant3[122] @ 1952
	.field	27778,16		; r_quant3[123] @ 1968
	.field	31880,16		; r_quant3[124] @ 1984
	.field	27518,16		; r_quant3[125] @ 2000
	.field	27022,16		; r_quant3[126] @ 2016
	.field	29840,16		; r_quant3[127] @ 2032
	.field	-23384,16		; r_quant3[128] @ 2048
	.field	31896,16		; r_quant3[129] @ 2064
	.field	-25701,16		; r_quant3[130] @ 2080
	.field	31373,16		; r_quant3[131] @ 2096
	.field	-27495,16		; r_quant3[132] @ 2112
	.field	29317,16		; r_quant3[133] @ 2128
	.field	-23127,16		; r_quant3[134] @ 2144
	.field	27534,16		; r_quant3[135] @ 2160
	.field	-25176,16		; r_quant3[136] @ 2176
	.field	24974,16		; r_quant3[137] @ 2192
	.field	-27231,16		; r_quant3[138] @ 2208
	.field	27285,16		; r_quant3[139] @ 2224
	.field	-23917,16		; r_quant3[140] @ 2240
	.field	22157,16		; r_quant3[141] @ 2256
	.field	-26979,16		; r_quant3[142] @ 2272
	.field	30625,16		; r_quant3[143] @ 2288
	.field	-27245,16		; r_quant3[144] @ 2304
	.field	28569,16		; r_quant3[145] @ 2320
	.field	-30062,16		; r_quant3[146] @ 2336
	.field	29580,16		; r_quant3[147] @ 2352
	.field	-22890,16		; r_quant3[148] @ 2368
	.field	28565,16		; r_quant3[149] @ 2384
	.field	-24436,16		; r_quant3[150] @ 2400
	.field	27277,16		; r_quant3[151] @ 2416
	.field	-27509,16		; r_quant3[152] @ 2432
	.field	28814,16		; r_quant3[153] @ 2448
	.field	-26725,16		; r_quant3[154] @ 2464
	.field	-30573,16		; r_quant3[155] @ 2480
	.field	-25961,16		; r_quant3[156] @ 2496
	.field	-31877,16		; r_quant3[157] @ 2512
	.field	-26739,16		; r_quant3[158] @ 2528
	.field	30071,16		; r_quant3[159] @ 2544
	.field	-30829,16		; r_quant3[160] @ 2560
	.field	26777,16		; r_quant3[161] @ 2576
	.field	-32626,16		; r_quant3[162] @ 2592
	.field	25999,16		; r_quant3[163] @ 2608
	.field	-28775,16		; r_quant3[164] @ 2624
	.field	25992,16		; r_quant3[165] @ 2640
	.field	-26988,16		; r_quant3[166] @ 2656
	.field	22913,16		; r_quant3[167] @ 2672
	.field	-28007,16		; r_quant3[168] @ 2688
	.field	21903,16		; r_quant3[169] @ 2704
	.field	-30575,16		; r_quant3[170] @ 2720
	.field	21132,16		; r_quant3[171] @ 2736
	.field	-31594,16		; r_quant3[172] @ 2752
	.field	24707,16		; r_quant3[173] @ 2768
	.field	-31851,16		; r_quant3[174] @ 2784
	.field	21629,16		; r_quant3[175] @ 2800
	.field	-30068,16		; r_quant3[176] @ 2816
	.field	27542,16		; r_quant3[177] @ 2832
	.field	-31604,16		; r_quant3[178] @ 2848
	.field	28807,16		; r_quant3[179] @ 2864
	.field	-31358,16		; r_quant3[180] @ 2880
	.field	24708,16		; r_quant3[181] @ 2896
	.field	-27509,16		; r_quant3[182] @ 2912
	.field	25240,16		; r_quant3[183] @ 2928
	.field	-28542,16		; r_quant3[184] @ 2944
	.field	21907,16		; r_quant3[185] @ 2960
	.field	-30328,16		; r_quant3[186] @ 2976
	.field	21915,16		; r_quant3[187] @ 2992
	.field	-31872,16		; r_quant3[188] @ 3008
	.field	21907,16		; r_quant3[189] @ 3024
	.field	-31092,16		; r_quant3[190] @ 3040
	.field	28271,16		; r_quant3[191] @ 3056
	.field	-30846,16		; r_quant3[192] @ 3072
	.field	27787,16		; r_quant3[193] @ 3088
	.field	-28028,16		; r_quant3[194] @ 3104
	.field	27522,16		; r_quant3[195] @ 3120
	.field	-26494,16		; r_quant3[196] @ 3136
	.field	32399,16		; r_quant3[197] @ 3152
	.field	-28809,16		; r_quant3[198] @ 3168
	.field	30350,16		; r_quant3[199] @ 3184
	.field	-28047,16		; r_quant3[200] @ 3200
	.field	32382,16		; r_quant3[201] @ 3216
	.field	-30860,16		; r_quant3[202] @ 3232
	.field	28546,16		; r_quant3[203] @ 3248
	.field	-24456,16		; r_quant3[204] @ 3264
	.field	25747,16		; r_quant3[205] @ 3280
	.field	-27019,16		; r_quant3[206] @ 3296
	.field	22680,16		; r_quant3[207] @ 3312
	.field	-29831,16		; r_quant3[208] @ 3328
	.field	26776,16		; r_quant3[209] @ 3344
	.field	-31633,16		; r_quant3[210] @ 3360
	.field	23964,16		; r_quant3[211] @ 3376
	.field	-28818,16		; r_quant3[212] @ 3392
	.field	31384,16		; r_quant3[213] @ 3408
	.field	-28829,16		; r_quant3[214] @ 3424
	.field	28053,16		; r_quant3[215] @ 3440
	.field	-30841,16		; r_quant3[216] @ 3456
	.field	30365,16		; r_quant3[217] @ 3472
	.field	-32382,16		; r_quant3[218] @ 3488
	.field	29587,16		; r_quant3[219] @ 3504
	.field	-31875,16		; r_quant3[220] @ 3520
	.field	32660,16		; r_quant3[221] @ 3536
	.field	32628,16		; r_quant3[222] @ 3552
	.field	30862,16		; r_quant3[223] @ 3568
	.field	27002,16		; r_quant3[224] @ 3584
	.field	25753,16		; r_quant3[225] @ 3600
	.field	31356,16		; r_quant3[226] @ 3616
	.field	23711,16		; r_quant3[227] @ 3632
	.field	31606,16		; r_quant3[228] @ 3648
	.field	24978,16		; r_quant3[229] @ 3664
	.field	32361,16		; r_quant3[230] @ 3680
	.field	30369,16		; r_quant3[231] @ 3696
	.field	31844,16		; r_quant3[232] @ 3712
	.field	29333,16		; r_quant3[233] @ 3728
	.field	30588,16		; r_quant3[234] @ 3744
	.field	29838,16		; r_quant3[235] @ 3760
	.field	30324,16		; r_quant3[236] @ 3776
	.field	28294,16		; r_quant3[237] @ 3792
	.field	30081,16		; r_quant3[238] @ 3808
	.field	30870,16		; r_quant3[239] @ 3824
	.field	32121,16		; r_quant3[240] @ 3840
	.field	29598,16		; r_quant3[241] @ 3856
	.field	29297,16		; r_quant3[242] @ 3872
	.field	26785,16		; r_quant3[243] @ 3888
	.field	28029,16		; r_quant3[244] @ 3904
	.field	32672,16		; r_quant3[245] @ 3920
	.field	25720,16		; r_quant3[246] @ 3936
	.field	30616,16		; r_quant3[247] @ 3952
	.field	28784,16		; r_quant3[248] @ 3968
	.field	30359,16		; r_quant3[249] @ 3984
	.field	26733,16		; r_quant3[250] @ 4000
	.field	28305,16		; r_quant3[251] @ 4016
	.field	26988,16		; r_quant3[252] @ 4032
	.field	-31083,16		; r_quant3[253] @ 4048
	.field	27774,16		; r_quant3[254] @ 4064
	.field	31370,16		; r_quant3[255] @ 4080
	.field	-32092,16		; r_quant3[256] @ 4096
	.field	31128,16		; r_quant3[257] @ 4112
	.field	-30794,16		; r_quant3[258] @ 4128
	.field	-31079,16		; r_quant3[259] @ 4144
	.field	-32336,16		; r_quant3[260] @ 4160
	.field	-32370,16		; r_quant3[261] @ 4176
	.field	-32575,16		; r_quant3[262] @ 4192
	.field	-32631,16		; r_quant3[263] @ 4208
	.field	31932,16		; r_quant3[264] @ 4224
	.field	29069,16		; r_quant3[265] @ 4240
	.field	-31561,16		; r_quant3[266] @ 4256
	.field	30364,16		; r_quant3[267] @ 4272
	.field	32427,16		; r_quant3[268] @ 4288
	.field	29590,16		; r_quant3[269] @ 4304
	.field	30141,16		; r_quant3[270] @ 4320
	.field	-31342,16		; r_quant3[271] @ 4336
	.field	29874,16		; r_quant3[272] @ 4352
	.field	32406,16		; r_quant3[273] @ 4368
	.field	27327,16		; r_quant3[274] @ 4384
	.field	-31858,16		; r_quant3[275] @ 4400
	.field	29877,16		; r_quant3[276] @ 4416
	.field	31872,16		; r_quant3[277] @ 4432
	.field	31654,16		; r_quant3[278] @ 4448
	.field	-29297,16		; r_quant3[279] @ 4464
	.field	31654,16		; r_quant3[280] @ 4480
	.field	-30813,16		; r_quant3[281] @ 4496
	.field	30369,16		; r_quant3[282] @ 4512
	.field	-31077,16		; r_quant3[283] @ 4528
	.field	30881,16		; r_quant3[284] @ 4544
	.field	32147,16		; r_quant3[285] @ 4560
	.field	27820,16		; r_quant3[286] @ 4576
	.field	-29032,16		; r_quant3[287] @ 4592
	.field	32159,16		; r_quant3[288] @ 4608
	.field	-31889,16		; r_quant3[289] @ 4624
	.field	29849,16		; r_quant3[290] @ 4640
	.field	28785,16		; r_quant3[291] @ 4656
	.field	31896,16		; r_quant3[292] @ 4672
	.field	32135,16		; r_quant3[293] @ 4688
	.field	31892,16		; r_quant3[294] @ 4704
	.field	27775,16		; r_quant3[295] @ 4720
	.field	27821,16		; r_quant3[296] @ 4736
	.field	29557,16		; r_quant3[297] @ 4752
	.field	28840,16		; r_quant3[298] @ 4768
	.field	27017,16		; r_quant3[299] @ 4784
	.field	26270,16		; r_quant3[300] @ 4800
	.field	25731,16		; r_quant3[301] @ 4816
	.field	30623,16		; r_quant3[302] @ 4832
	.field	-31352,16		; r_quant3[303] @ 4848
	.field	28582,16		; r_quant3[304] @ 4864
	.field	-30079,16		; r_quant3[305] @ 4880
	.field	27801,16		; r_quant3[306] @ 4896
	.field	-31622,16		; r_quant3[307] @ 4912
	.field	29327,16		; r_quant3[308] @ 4928
	.field	-28299,16		; r_quant3[309] @ 4944
	.field	29600,16		; r_quant3[310] @ 4960
	.field	30337,16		; r_quant3[311] @ 4976
	.field	29848,16		; r_quant3[312] @ 4992
	.field	28552,16		; r_quant3[313] @ 5008
	.field	27291,16		; r_quant3[314] @ 5024
	.field	32392,16		; r_quant3[315] @ 5040
	.field	30864,16		; r_quant3[316] @ 5056
	.field	31871,16		; r_quant3[317] @ 5072
	.field	29574,16		; r_quant3[318] @ 5088
	.field	30331,16		; r_quant3[319] @ 5104
	.field	29326,16		; r_quant3[320] @ 5120
	.field	30373,16		; r_quant3[321] @ 5136
	.field	27538,16		; r_quant3[322] @ 5152
	.field	27553,16		; r_quant3[323] @ 5168
	.field	27566,16		; r_quant3[324] @ 5184
	.field	31119,16		; r_quant3[325] @ 5200
	.field	29336,16		; r_quant3[326] @ 5216
	.field	31388,16		; r_quant3[327] @ 5232
	.field	29342,16		; r_quant3[328] @ 5248
	.field	31632,16		; r_quant3[329] @ 5264
	.field	29845,16		; r_quant3[330] @ 5280
	.field	31379,16		; r_quant3[331] @ 5296
	.field	30630,16		; r_quant3[332] @ 5312
	.field	31391,16		; r_quant3[333] @ 5328
	.field	29859,16		; r_quant3[334] @ 5344
	.field	28314,16		; r_quant3[335] @ 5360
	.field	28058,16		; r_quant3[336] @ 5376
	.field	30359,16		; r_quant3[337] @ 5392
	.field	27288,16		; r_quant3[338] @ 5408
	.field	28560,16		; r_quant3[339] @ 5424
	.field	26788,16		; r_quant3[340] @ 5440
	.field	31388,16		; r_quant3[341] @ 5456
	.field	25249,16		; r_quant3[342] @ 5472
	.field	29074,16		; r_quant3[343] @ 5488
	.field	25511,16		; r_quant3[344] @ 5504
	.field	-29540,16		; r_quant3[345] @ 5520
	.field	26782,16		; r_quant3[346] @ 5536
	.field	-31088,16		; r_quant3[347] @ 5552
	.field	26777,16		; r_quant3[348] @ 5568
	.field	-32093,16		; r_quant3[349] @ 5584
	.field	27538,16		; r_quant3[350] @ 5600
	.field	31126,16		; r_quant3[351] @ 5616
	.field	25242,16		; r_quant3[352] @ 5632
	.field	30850,16		; r_quant3[353] @ 5648
	.field	23434,16		; r_quant3[354] @ 5664
	.field	30335,16		; r_quant3[355] @ 5680
	.field	24982,16		; r_quant3[356] @ 5696
	.field	28572,16		; r_quant3[357] @ 5712
	.field	23183,16		; r_quant3[358] @ 5728
	.field	27791,16		; r_quant3[359] @ 5744
	.field	24728,16		; r_quant3[360] @ 5760
	.field	-32115,16		; r_quant3[361] @ 5776
	.field	25009,16		; r_quant3[362] @ 5792
	.field	-30841,16		; r_quant3[363] @ 5808
	.field	24230,16		; r_quant3[364] @ 5824
	.field	-32389,16		; r_quant3[365] @ 5840
	.field	23720,16		; r_quant3[366] @ 5856
	.field	31885,16		; r_quant3[367] @ 5872
	.field	21663,16		; r_quant3[368] @ 5888
	.field	30090,16		; r_quant3[369] @ 5904
	.field	24978,16		; r_quant3[370] @ 5920
	.field	32668,16		; r_quant3[371] @ 5936
	.field	23450,16		; r_quant3[372] @ 5952
	.field	32153,16		; r_quant3[373] @ 5968
	.field	22926,16		; r_quant3[374] @ 5984
	.field	31126,16		; r_quant3[375] @ 6000
	.field	22432,16		; r_quant3[376] @ 6016
	.field	-29809,16		; r_quant3[377] @ 6032
	.field	21143,16		; r_quant3[378] @ 6048
	.field	-30078,16		; r_quant3[379] @ 6064
	.field	20885,16		; r_quant3[380] @ 6080
	.field	-31343,16		; r_quant3[381] @ 6096
	.field	19344,16		; r_quant3[382] @ 6112
	.field	32394,16		; r_quant3[383] @ 6128
	.field	-29301,16		; r_quant3[384] @ 6144
	.field	-32102,16		; r_quant3[385] @ 6160
	.field	-30839,16		; r_quant3[386] @ 6176
	.field	32145,16		; r_quant3[387] @ 6192
	.field	32663,16		; r_quant3[388] @ 6208
	.field	-29057,16		; r_quant3[389] @ 6224
	.field	-32631,16		; r_quant3[390] @ 6240
	.field	-30602,16		; r_quant3[391] @ 6256
	.field	-29292,16		; r_quant3[392] @ 6272
	.field	-30074,16		; r_quant3[393] @ 6288
	.field	-29803,16		; r_quant3[394] @ 6304
	.field	-32627,16		; r_quant3[395] @ 6320
	.field	-30064,16		; r_quant3[396] @ 6336
	.field	32131,16		; r_quant3[397] @ 6352
	.field	-30834,16		; r_quant3[398] @ 6368
	.field	31608,16		; r_quant3[399] @ 6384
	.field	-32370,16		; r_quant3[400] @ 6400
	.field	-31863,16		; r_quant3[401] @ 6416
	.field	-32631,16		; r_quant3[402] @ 6432
	.field	32132,16		; r_quant3[403] @ 6448
	.field	-30078,16		; r_quant3[404] @ 6464
	.field	31877,16		; r_quant3[405] @ 6480
	.field	-32642,16		; r_quant3[406] @ 6496
	.field	31103,16		; r_quant3[407] @ 6512
	.field	31101,16		; r_quant3[408] @ 6528
	.field	27507,16		; r_quant3[409] @ 6544
	.field	-29816,16		; r_quant3[410] @ 6560
	.field	-27509,16		; r_quant3[411] @ 6576
	.field	-29563,16		; r_quant3[412] @ 6592
	.field	-30592,16		; r_quant3[413] @ 6608
	.field	32657,16		; r_quant3[414] @ 6624
	.field	-30061,16		; r_quant3[415] @ 6640
	.field	-32126,16		; r_quant3[416] @ 6656
	.field	-30070,16		; r_quant3[417] @ 6672
	.field	-32645,16		; r_quant3[418] @ 6688
	.field	-31611,16		; r_quant3[419] @ 6704
	.field	-30600,16		; r_quant3[420] @ 6720
	.field	-26506,16		; r_quant3[421] @ 6736
	.field	30310,16		; r_quant3[422] @ 6752
	.field	-25216,16		; r_quant3[423] @ 6768
	.field	30328,16		; r_quant3[424] @ 6784
	.field	-29310,16		; r_quant3[425] @ 6800
	.field	29550,16		; r_quant3[426] @ 6816
	.field	-31618,16		; r_quant3[427] @ 6832
	.field	-30603,16		; r_quant3[428] @ 6848
	.field	-27501,16		; r_quant3[429] @ 6864
	.field	-32401,16		; r_quant3[430] @ 6880
	.field	-30834,16		; r_quant3[431] @ 6896
	.field	-30881,16		; r_quant3[432] @ 6912
	.field	-29045,16		; r_quant3[433] @ 6928
	.field	32096,16		; r_quant3[434] @ 6944
	.field	-32632,16		; r_quant3[435] @ 6960
	.field	30064,16		; r_quant3[436] @ 6976
	.field	-29031,16		; r_quant3[437] @ 6992
	.field	29539,16		; r_quant3[438] @ 7008
	.field	-31852,16		; r_quant3[439] @ 7024
	.field	29567,16		; r_quant3[440] @ 7040
	.field	-32636,16		; r_quant3[441] @ 7056
	.field	29314,16		; r_quant3[442] @ 7072
	.field	-25726,16		; r_quant3[443] @ 7088
	.field	27512,16		; r_quant3[444] @ 7104
	.field	-24714,16		; r_quant3[445] @ 7120
	.field	29053,16		; r_quant3[446] @ 7136
	.field	-31088,16		; r_quant3[447] @ 7152
	.field	30598,16		; r_quant3[448] @ 7168
	.field	30346,16		; r_quant3[449] @ 7184
	.field	25993,16		; r_quant3[450] @ 7200
	.field	32159,16		; r_quant3[451] @ 7216
	.field	25221,16		; r_quant3[452] @ 7232
	.field	29841,16		; r_quant3[453] @ 7248
	.field	31623,16		; r_quant3[454] @ 7264
	.field	32672,16		; r_quant3[455] @ 7280
	.field	29072,16		; r_quant3[456] @ 7296
	.field	30857,16		; r_quant3[457] @ 7312
	.field	30869,16		; r_quant3[458] @ 7328
	.field	-31854,16		; r_quant3[459] @ 7344
	.field	29841,16		; r_quant3[460] @ 7360
	.field	-31862,16		; r_quant3[461] @ 7376
	.field	32137,16		; r_quant3[462] @ 7392
	.field	-30318,16		; r_quant3[463] @ 7408
	.field	31365,16		; r_quant3[464] @ 7424
	.field	-32369,16		; r_quant3[465] @ 7440
	.field	30344,16		; r_quant3[466] @ 7456
	.field	-30844,16		; r_quant3[467] @ 7472
	.field	29330,16		; r_quant3[468] @ 7488
	.field	-30563,16		; r_quant3[469] @ 7504
	.field	28556,16		; r_quant3[470] @ 7520
	.field	32665,16		; r_quant3[471] @ 7536
	.field	28554,16		; r_quant3[472] @ 7552
	.field	-32368,16		; r_quant3[473] @ 7568
	.field	26759,16		; r_quant3[474] @ 7584
	.field	32141,16		; r_quant3[475] @ 7600
	.field	29076,16		; r_quant3[476] @ 7616
	.field	-27763,16		; r_quant3[477] @ 7632
	.field	29570,16		; r_quant3[478] @ 7648
	.field	-28777,16		; r_quant3[479] @ 7664
	.field	22143,16		; r_quant3[480] @ 7680
	.field	29588,16		; r_quant3[481] @ 7696
	.field	28038,16		; r_quant3[482] @ 7712
	.field	-31625,16		; r_quant3[483] @ 7728
	.field	24717,16		; r_quant3[484] @ 7744
	.field	-32634,16		; r_quant3[485] @ 7760
	.field	25447,16		; r_quant3[486] @ 7776
	.field	-31349,16		; r_quant3[487] @ 7792
	.field	25979,16		; r_quant3[488] @ 7808
	.field	30084,16		; r_quant3[489] @ 7824
	.field	27275,16		; r_quant3[490] @ 7840
	.field	-29559,16		; r_quant3[491] @ 7856
	.field	24724,16		; r_quant3[492] @ 7872
	.field	-28027,16		; r_quant3[493] @ 7888
	.field	24202,16		; r_quant3[494] @ 7904
	.field	-29063,16		; r_quant3[495] @ 7920
	.field	23929,16		; r_quant3[496] @ 7936
	.field	-26230,16		; r_quant3[497] @ 7952
	.field	24437,16		; r_quant3[498] @ 7968
	.field	-29059,16		; r_quant3[499] @ 7984
	.field	26490,16		; r_quant3[500] @ 8000
	.field	-28786,16		; r_quant3[501] @ 8016
	.field	24693,16		; r_quant3[502] @ 8032
	.field	-31602,16		; r_quant3[503] @ 8048
	.field	24971,16		; r_quant3[504] @ 8064
	.field	-29802,16		; r_quant3[505] @ 8080
	.field	22405,16		; r_quant3[506] @ 8096
	.field	-31337,16		; r_quant3[507] @ 8112
	.field	22917,16		; r_quant3[508] @ 8128
	.field	-30072,16		; r_quant3[509] @ 8144
	.field	20861,16		; r_quant3[510] @ 8160
	.field	-30842,16		; r_quant3[511] @ 8176


r_preq1
	.field	-13624,16		; r_preq1[0] @ 0
	.field	-31561,16		; r_preq1[1] @ 16
	.field	-11886,16		; r_preq1[2] @ 32
	.field	-22329,16		; r_preq1[3] @ 48
	.field	-28759,16		; r_preq1[4] @ 64
	.field	-22416,16		; r_preq1[5] @ 80
	.field	-20112,16		; r_preq1[6] @ 96
	.field	28822,16		; r_preq1[7] @ 112
	.field	24392,16		; r_preq1[8] @ 128
	.field	21340,16		; r_preq1[9] @ 144
	.field	26761,16		; r_preq1[10] @ 160
	.field	32323,16		; r_preq1[11] @ 176
	.field	-25919,16		; r_preq1[12] @ 192
	.field	-29300,16		; r_preq1[13] @ 208
	.field	-14455,16		; r_preq1[14] @ 224
	.field	-29788,16		; r_preq1[15] @ 240
	.field	-32648,16		; r_preq1[16] @ 256
	.field	-26510,16		; r_preq1[17] @ 272
	.field	25500,16		; r_preq1[18] @ 288
	.field	27209,16		; r_preq1[19] @ 304
	.field	-30113,16		; r_preq1[20] @ 320
	.field	31917,16		; r_preq1[21] @ 336
	.field	22884,16		; r_preq1[22] @ 352
	.field	-29633,16		; r_preq1[23] @ 368
	.field	31429,16		; r_preq1[24] @ 384
	.field	-29072,16		; r_preq1[25] @ 400
	.field	-18827,16		; r_preq1[26] @ 416
	.field	26052,16		; r_preq1[27] @ 432
	.field	26961,16		; r_preq1[28] @ 448
	.field	-21177,16		; r_preq1[29] @ 464
	.field	16031,16		; r_preq1[30] @ 480
	.field	25903,16		; r_preq1[31] @ 496
	.field	-29092,16		; r_preq1[32] @ 512
	.field	22691,16		; r_preq1[33] @ 528
	.field	21594,16		; r_preq1[34] @ 544
	.field	-26817,16		; r_preq1[35] @ 560
	.field	14738,16		; r_preq1[36] @ 576
	.field	-30686,16		; r_preq1[37] @ 592
	.field	-28552,16		; r_preq1[38] @ 608
	.field	10352,16		; r_preq1[39] @ 624
	.field	-28111,16		; r_preq1[40] @ 640
	.field	30576,16		; r_preq1[41] @ 656
	.field	21631,16		; r_preq1[42] @ 672
	.field	29521,16		; r_preq1[43] @ 688
	.field	30041,16		; r_preq1[44] @ 704
	.field	-27988,16		; r_preq1[45] @ 720
	.field	22897,16		; r_preq1[46] @ 736
	.field	32583,16		; r_preq1[47] @ 752
	.field	23991,16		; r_preq1[48] @ 768
	.field	-28340,16		; r_preq1[49] @ 784
	.field	-23428,16		; r_preq1[50] @ 800
	.field	15550,16		; r_preq1[51] @ 816
	.field	-28626,16		; r_preq1[52] @ 832
	.field	-20091,16		; r_preq1[53] @ 848
	.field	19913,16		; r_preq1[54] @ 864
	.field	29757,16		; r_preq1[55] @ 880
	.field	-18579,16		; r_preq1[56] @ 896
	.field	13228,16		; r_preq1[57] @ 912
	.field	21831,16		; r_preq1[58] @ 928
	.field	-18366,16		; r_preq1[59] @ 944
	.field	11219,16		; r_preq1[60] @ 960
	.field	32289,16		; r_preq1[61] @ 976
	.field	-16012,16		; r_preq1[62] @ 992
	.field	9892,16 		; r_preq1[63] @ 1008
	.field	27415,16		; r_preq1[64] @ 1024
	.field	-20612,16		; r_preq1[65] @ 1040
	.field	9919,16 		; r_preq1[66] @ 1056
	.field	-24801,16		; r_preq1[67] @ 1072
	.field	-23921,16		; r_preq1[68] @ 1088
	.field	6302,16 		; r_preq1[69] @ 1104
	.field	-22510,16		; r_preq1[70] @ 1120
	.field	-14174,16		; r_preq1[71] @ 1136
	.field	15572,16		; r_preq1[72] @ 1152
	.field	27438,16		; r_preq1[73] @ 1168
	.field	-16281,16		; r_preq1[74] @ 1184
	.field	15046,16		; r_preq1[75] @ 1200
	.field	17698,16		; r_preq1[76] @ 1216
	.field	-18601,16		; r_preq1[77] @ 1232
	.field	12246,16		; r_preq1[78] @ 1248
	.field	23595,16		; r_preq1[79] @ 1264
	.field	-13248,16		; r_preq1[80] @ 1280
	.field	8157,16 		; r_preq1[81] @ 1296
	.field	29463,16		; r_preq1[82] @ 1312
	.field	-13721,16		; r_preq1[83] @ 1328
	.field	10458,16		; r_preq1[84] @ 1344
	.field	19998,16		; r_preq1[85] @ 1360
	.field	-10173,16		; r_preq1[86] @ 1376
	.field	7395,16 		; r_preq1[87] @ 1392
	.field	18453,16		; r_preq1[88] @ 1408
	.field	-6332,16		; r_preq1[89] @ 1424
	.field	6862,16 		; r_preq1[90] @ 1440
	.field	-28399,16		; r_preq1[91] @ 1456
	.field	-12154,16		; r_preq1[92] @ 1472
	.field	4575,16 		; r_preq1[93] @ 1488
	.field	29455,16		; r_preq1[94] @ 1504
	.field	-5029,16		; r_preq1[95] @ 1520


r_preq2
	.field	-14954,16		; r_preq2[0] @ 0
	.field	-26695,16		; r_preq2[1] @ 16
	.field	-31091,16		; r_preq2[2] @ 32
	.field	-15239,16		; r_preq2[3] @ 48
	.field	29089,16		; r_preq2[4] @ 64
	.field	31099,16		; r_preq2[5] @ 80
	.field	-14987,16		; r_preq2[6] @ 96
	.field	-25155,16		; r_preq2[7] @ 112
	.field	23445,16		; r_preq2[8] @ 128
	.field	-20883,16		; r_preq2[9] @ 144
	.field	-29788,16		; r_preq2[10] @ 160
	.field	23424,16		; r_preq2[11] @ 176
	.field	-18813,16		; r_preq2[12] @ 192
	.field	-19541,16		; r_preq2[13] @ 208
	.field	32412,16		; r_preq2[14] @ 224
	.field	-20114,16		; r_preq2[15] @ 240
	.field	-19805,16		; r_preq2[16] @ 256
	.field	23464,16		; r_preq2[17] @ 272
	.field	-24719,16		; r_preq2[18] @ 288
	.field	-24682,16		; r_preq2[19] @ 304
	.field	27026,16		; r_preq2[20] @ 320
	.field	-28839,16		; r_preq2[21] @ 336
	.field	-20857,16		; r_preq2[22] @ 352
	.field	25479,16		; r_preq2[23] @ 368
	.field	-19558,16		; r_preq2[24] @ 384
	.field	-20062,16		; r_preq2[25] @ 400
	.field	-22120,16		; r_preq2[26] @ 416
	.field	-23669,16		; r_preq2[27] @ 432
	.field	-18023,16		; r_preq2[28] @ 448
	.field	-30813,16		; r_preq2[29] @ 464
	.field	-23666,16		; r_preq2[30] @ 480
	.field	-29810,16		; r_preq2[31] @ 496
	.field	-27514,16		; r_preq2[32] @ 512
	.field	-27010,16		; r_preq2[33] @ 528
	.field	-28797,16		; r_preq2[34] @ 544
	.field	31371,16		; r_preq2[35] @ 560
	.field	-24711,16		; r_preq2[36] @ 576
	.field	-18292,16		; r_preq2[37] @ 592
	.field	29857,16		; r_preq2[38] @ 608
	.field	-28558,16		; r_preq2[39] @ 624
	.field	-18051,16		; r_preq2[40] @ 640
	.field	25508,16		; r_preq2[41] @ 656
	.field	-29550,16		; r_preq2[42] @ 672
	.field	-20871,16		; r_preq2[43] @ 688
	.field	-28262,16		; r_preq2[44] @ 704
	.field	32123,16		; r_preq2[45] @ 720
	.field	-21144,16		; r_preq2[46] @ 736
	.field	30111,16		; r_preq2[47] @ 752


r_preq3
	.field	-28246,16		; r_preq3[0] @ 0
	.field	30356,16		; r_preq3[1] @ 16
	.field	-31320,16		; r_preq3[2] @ 32
	.field	27523,16		; r_preq3[3] @ 48
	.field	32405,16		; r_preq3[4] @ 64
	.field	30613,16		; r_preq3[5] @ 80
	.field	29066,16		; r_preq3[6] @ 96
	.field	27281,16		; r_preq3[7] @ 112
	.field	-26216,16		; r_preq3[8] @ 128
	.field	28557,16		; r_preq3[9] @ 144
	.field	-30322,16		; r_preq3[10] @ 160
	.field	24972,16		; r_preq3[11] @ 176
	.field	-29576,16		; r_preq3[12] @ 192
	.field	29072,16		; r_preq3[13] @ 208
	.field	29301,16		; r_preq3[14] @ 224
	.field	29589,16		; r_preq3[15] @ 240
	.field	31407,16		; r_preq3[16] @ 256
	.field	-32622,16		; r_preq3[17] @ 272
	.field	29594,16		; r_preq3[18] @ 288
	.field	31359,16		; r_preq3[19] @ 304
	.field	28060,16		; r_preq3[20] @ 320
	.field	30870,16		; r_preq3[21] @ 336
	.field	23193,16		; r_preq3[22] @ 352
	.field	32141,16		; r_preq3[23] @ 368
	.field	-31349,16		; r_preq3[24] @ 384
	.field	-32379,16		; r_preq3[25] @ 400
	.field	31093,16		; r_preq3[26] @ 416
	.field	-29817,16		; r_preq3[27] @ 432
	.field	29323,16		; r_preq3[28] @ 448
	.field	-32369,16		; r_preq3[29] @ 464
	.field	24450,16		; r_preq3[30] @ 480
	.field	-30584,16		; r_preq3[31] @ 496


	.if	rom_compat
r_quantsz
	.field	32,16		; r_quantsz[0] @ 0
	.field	16,16		; r_quantsz[1] @ 16
	.field	16,16		; r_quantsz[2] @ 32
	.endif


	.if	rom_compat
r_preqsz
	.field	64,16		; r_preqsz[0] @ 0
	.field	32,16		; r_preqsz[1] @ 16
	.field	16,16		; r_preqsz[2] @ 32
	.endif

r_squant
	.field	-32766,16		; r_squant[0] @ 0
	.field	-32758,16		; r_squant[1] @ 16
	.field	-32746,16		; r_squant[2] @ 32
	.field	-32729,16		; r_squant[3] @ 48
	.field	-32707,16		; r_squant[4] @ 64
	.field	-32680,16		; r_squant[5] @ 80
	.field	-32648,16		; r_squant[6] @ 96
	.field	-32611,16		; r_squant[7] @ 112
	.field	-32570,16		; r_squant[8] @ 128
	.field	-32523,16		; r_squant[9] @ 144
	.field	-32472,16		; r_squant[10] @ 160
	.field	-32416,16		; r_squant[11] @ 176
	.field	-32355,16		; r_squant[12] @ 192
	.field	-32289,16		; r_squant[13] @ 208
	.field	-32219,16		; r_squant[14] @ 224
	.field	-32143,16		; r_squant[15] @ 240
	.field	-32063,16		; r_squant[16] @ 256
	.field	-31978,16		; r_squant[17] @ 272
	.field	-31888,16		; r_squant[18] @ 288
	.field	-31794,16		; r_squant[19] @ 304
	.field	-31694,16		; r_squant[20] @ 320
	.field	-31590,16		; r_squant[21] @ 336
	.field	-31481,16		; r_squant[22] @ 352
	.field	-31368,16		; r_squant[23] @ 368
	.field	-31250,16		; r_squant[24] @ 384
	.field	-31127,16		; r_squant[25] @ 400
	.field	-30999,16		; r_squant[26] @ 416
	.field	-30867,16		; r_squant[27] @ 432
	.field	-30731,16		; r_squant[28] @ 448
	.field	-30589,16		; r_squant[29] @ 464
	.field	-30443,16		; r_squant[30] @ 480
	.field	-30293,16		; r_squant[31] @ 496
	.field	-30138,16		; r_squant[32] @ 512
	.field	-29978,16		; r_squant[33] @ 528
	.field	-29814,16		; r_squant[34] @ 544
	.field	-29646,16		; r_squant[35] @ 560
	.field	-29473,16		; r_squant[36] @ 576
	.field	-29296,16		; r_squant[37] @ 592
	.field	-29114,16		; r_squant[38] @ 608
	.field	-28928,16		; r_squant[39] @ 624
	.field	-28738,16		; r_squant[40] @ 640
	.field	-28543,16		; r_squant[41] @ 656
	.field	-28344,16		; r_squant[42] @ 672
	.field	-28141,16		; r_squant[43] @ 688
	.field	-27934,16		; r_squant[44] @ 704
	.field	-27723,16		; r_squant[45] @ 720
	.field	-27507,16		; r_squant[46] @ 736
	.field	-27287,16		; r_squant[47] @ 752
	.field	-27063,16		; r_squant[48] @ 768
	.field	-26836,16		; r_squant[49] @ 784
	.field	-26604,16		; r_squant[50] @ 800
	.field	-26368,16		; r_squant[51] @ 816
	.field	-26128,16		; r_squant[52] @ 832
	.field	-25884,16		; r_squant[53] @ 848
	.field	-25637,16		; r_squant[54] @ 864
	.field	-25386,16		; r_squant[55] @ 880
	.field	-25130,16		; r_squant[56] @ 896
	.field	-24871,16		; r_squant[57] @ 912
	.field	-24609,16		; r_squant[58] @ 928
	.field	-24342,16		; r_squant[59] @ 944
	.field	-24072,16		; r_squant[60] @ 960
	.field	-23799,16		; r_squant[61] @ 976
	.field	-23522,16		; r_squant[62] @ 992
	.field	-23241,16		; r_squant[63] @ 1008
	.field	-22957,16		; r_squant[64] @ 1024
	.field	-22670,16		; r_squant[65] @ 1040
	.field	-22379,16		; r_squant[66] @ 1056
	.field	-22084,16		; r_squant[67] @ 1072
	.field	-21787,16		; r_squant[68] @ 1088
	.field	-21486,16		; r_squant[69] @ 1104
	.field	-21182,16		; r_squant[70] @ 1120
	.field	-20875,16		; r_squant[71] @ 1136
	.field	-20564,16		; r_squant[72] @ 1152
	.field	-20251,16		; r_squant[73] @ 1168
	.field	-19935,16		; r_squant[74] @ 1184
	.field	-19615,16		; r_squant[75] @ 1200
	.field	-19293,16		; r_squant[76] @ 1216
	.field	-18968,16		; r_squant[77] @ 1232
	.field	-18640,16		; r_squant[78] @ 1248
	.field	-18309,16		; r_squant[79] @ 1264
	.field	-17975,16		; r_squant[80] @ 1280
	.field	-17639,16		; r_squant[81] @ 1296
	.field	-17300,16		; r_squant[82] @ 1312
	.field	-16959,16		; r_squant[83] @ 1328
	.field	-16615,16		; r_squant[84] @ 1344
	.field	-16268,16		; r_squant[85] @ 1360
	.field	-15919,16		; r_squant[86] @ 1376
	.field	-15568,16		; r_squant[87] @ 1392
	.field	-15214,16		; r_squant[88] @ 1408
	.field	-14859,16		; r_squant[89] @ 1424
	.field	-14500,16		; r_squant[90] @ 1440
	.field	-14140,16		; r_squant[91] @ 1456
	.field	-13778,16		; r_squant[92] @ 1472
	.field	-13413,16		; r_squant[93] @ 1488
	.field	-13047,16		; r_squant[94] @ 1504
	.field	-12678,16		; r_squant[95] @ 1520
	.field	-12308,16		; r_squant[96] @ 1536
	.field	-11936,16		; r_squant[97] @ 1552
	.field	-11562,16		; r_squant[98] @ 1568
	.field	-11186,16		; r_squant[99] @ 1584
	.field	-10809,16		; r_squant[100] @ 1600
	.field	-10430,16		; r_squant[101] @ 1616
	.field	-10050,16		; r_squant[102] @ 1632
	.field	-9668,16		; r_squant[103] @ 1648
	.field	-9284,16		; r_squant[104] @ 1664
	.field	-8899,16		; r_squant[105] @ 1680
	.field	-8513,16		; r_squant[106] @ 1696
	.field	-8126,16		; r_squant[107] @ 1712
	.field	-7737,16		; r_squant[108] @ 1728
	.field	-7347,16		; r_squant[109] @ 1744
	.field	-6956,16		; r_squant[110] @ 1760
	.field	-6565,16		; r_squant[111] @ 1776
	.field	-6172,16		; r_squant[112] @ 1792
	.field	-5778,16		; r_squant[113] @ 1808
	.field	-5383,16		; r_squant[114] @ 1824
	.field	-4988,16		; r_squant[115] @ 1840
	.field	-4591,16		; r_squant[116] @ 1856
	.field	-4194,16		; r_squant[117] @ 1872
	.field	-3797,16		; r_squant[118] @ 1888
	.field	-3399,16		; r_squant[119] @ 1904
	.field	-3000,16		; r_squant[120] @ 1920
	.field	-2601,16		; r_squant[121] @ 1936
	.field	-2201,16		; r_squant[122] @ 1952
	.field	-1802,16		; r_squant[123] @ 1968
	.field	-1402,16		; r_squant[124] @ 1984
	.field	-1001,16		; r_squant[125] @ 2000
	.field	-601,16 		; r_squant[126] @ 2016
	.field	-200,16 		; r_squant[127] @ 2032
	.field	200,16			; r_squant[128] @ 2048
	.field	601,16			; r_squant[129] @ 2064
	.field	1001,16 		; r_squant[130] @ 2080
	.field	1402,16 		; r_squant[131] @ 2096
	.field	1802,16 		; r_squant[132] @ 2112
	.field	2201,16 		; r_squant[133] @ 2128
	.field	2601,16 		; r_squant[134] @ 2144
	.field	3000,16 		; r_squant[135] @ 2160
	.field	3399,16 		; r_squant[136] @ 2176
	.field	3797,16 		; r_squant[137] @ 2192
	.field	4194,16 		; r_squant[138] @ 2208
	.field	4591,16 		; r_squant[139] @ 2224
	.field	4988,16 		; r_squant[140] @ 2240
	.field	5383,16 		; r_squant[141] @ 2256
	.field	5778,16 		; r_squant[142] @ 2272
	.field	6172,16 		; r_squant[143] @ 2288
	.field	6565,16 		; r_squant[144] @ 2304
	.field	6956,16 		; r_squant[145] @ 2320
	.field	7347,16 		; r_squant[146] @ 2336
	.field	7737,16 		; r_squant[147] @ 2352
	.field	8126,16 		; r_ quant[148] @ 2368
	.field	8513,16 		; r_squant[149] @ 2384
	.field	8899,16 		; r_squant[150] @ 2400
	.field	9284,16 		; r_squant[151] @ 2416
	.field	9668,16 		; r_squant[152] @ 2432
	.field	10050,16		; r_squant[153] @ 2448
	.field	10430,16		; r_squant[154] @ 2464
	.field	10809,16		; r_squant[155] @ 2480
	.field	11186,16		; r_squant[156] @ 2496
	.field	11562,16		; r_squant[157] @ 2512
	.field	11936,16		; r_squant[158] @ 2528
	.field	12308,16		; r_squant[159] @ 2544
	.field	12678,16		; r_squant[160] @ 2560
	.field	13047,16		; r_squant[161] @ 2576
	.field	13413,16		; r_squant[162] @ 2592
	.field	13778,16		; r_squant[163] @ 2608
	.field	14140,16		; r_squant[164] @ 2624
	.field	14500,16		; r_squant[165] @ 2640
	.field	14859,16		; r_squant[166] @ 2656
	.field	15214,16		; r_squant[167] @ 2672
	.field	15568,16		; r_squant[168] @ 2688
	.field	15919,16		; r_squant[169] @ 2704
	.field	16268,16		; r_squant[170] @ 2720
	.field	16615,16		; r_squant[171] @ 2736
	.field	16959,16		; r_squant[172] @ 2752
	.field	17300,16		; r_squant[173] @ 2768
	.field	17639,16		; r_squant[174] @ 2784
	.field	17975,16		; r_squant[175] @ 2800
	.field	18309,16		; r_squant[176] @ 2816
	.field	18640,16		; r_squant[177] @ 2832
	.field	18968,16		; r_squant[178] @ 2848
	.field	19293,16		; r_squant[179] @ 2864
	.field	19615,16		; r_squant[180] @ 2880
	.field	19935,16		; r_squant[181] @ 2896
	.field	20251,16		; r_squant[182] @ 2912
	.field	20564,16		; r_squant[183] @ 2928
	.field	20875,16		; r_squant[184] @ 2944
	.field	21182,16		; r_squant[185] @ 2960
	.field	21486,16		; r_squant[186] @ 2976
	.field	21787,16		; r_squant[187] @ 2992
	.field	22084,16		; r_squant[188] @ 3008
	.field	22379,16		; r_squant[189] @ 3024
	.field	22670,16		; r_squant[190] @ 3040
	.field	22957,16		; r_squant[191] @ 3056
	.field	23241,16		; r_squant[192] @ 3072
	.field	23522,16		; r_squant[193] @ 3088
	.field	23799,16		; r_squant[194] @ 3104
	.field	24072,16		; r_squant[195] @ 3120
	.field	24342,16		; r_squant[196] @ 3136
	.field	24609,16		; r_squant[197] @ 3152
	.field	24871,16		; r_squant[198] @ 3168
	.field	25130,16		; r_squant[199] @ 3184
	.field	25386,16		; r_squant[200] @ 3200
	.field	25637,16		; r_squant[201] @ 3216
	.field	25884,16		; r_squant[202] @ 3232
	.field	26128,16		; r_squant[203] @ 3248
	.field	26368,16		; r_squant[204] @ 3264
	.field	26604,16		; r_squant[205] @ 3280
	.field	26836,16		; r_squant[206] @ 3296
	.field	27063,16		; r_squant[207] @ 3312
	.field	27287,16		; r_squant[208] @ 3328
	.field	27507,16		; r_squant[209] @ 3344
	.field	27723,16		; r_squant[210] @ 3360
	.field	27934,16		; r_squant[211] @ 3376
	.field	28141,16		; r_squant[212] @ 3392
	.field	28344,16		; r_squant[213] @ 3408
	.field	28543,16		; r_squant[214] @ 3424
	.field	28738,16		; r_squant[215] @ 3440
	.field	28928,16		; r_squant[216] @ 3456
	.field	29114,16		; r_squant[217] @ 3472
	.field	29296,16		; r_squant[218] @ 3488
	.field	29473,16		; r_squant[219] @ 3504
	.field	29646,16		; r_squant[220] @ 3520
	.field	29814,16		; r_squant[221] @ 3536
	.field	29978,16		; r_squant[222] @ 3552
	.field	30138,16		; r_squant[223] @ 3568
	.field	30293,16		; r_squant[224] @ 3584
	.field	30443,16		; r_squant[225] @ 3600
	.field	30589,16		; r_squant[226] @ 3616
	.field	30731,16		; r_squant[227] @ 3632
	.field	30867,16		; r_squant[228] @ 3648
	.field	30999,16		; r_squant[229] @ 3664
	.field	31127,16		; r_squant[230] @ 3680
	.field	31250,16		; r_squant[231] @ 3696
	.field	31368,16		; r_squant[232] @ 3712
	.field	31481,16		; r_squant[233] @ 3728
	.field	31590,16		; r_squant[234] @ 3744
	.field	31694,16		; r_squant[235] @ 3760
	.field	31794,16		; r_squant[236] @ 3776
	.field	31888,16		; r_squant[237] @ 3792
	.field	31978,16		; r_squant[238] @ 3808
	.field	32063,16		; r_squant[239] @ 3824
	.field	32143,16		; r_squant[240] @ 3840
	.field	32219,16		; r_squant[241] @ 3856
	.field	32289,16		; r_squant[242] @ 3872
	.field	32355,16		; r_squant[243] @ 3888
	.field	32416,16		; r_squant[244] @ 3904
	.field	32472,16		; r_squant[245] @ 3920
	.field	32523,16		; r_squant[246] @ 3936
	.field	32570,16		; r_squant[247] @ 3952
	.field	32611,16		; r_squant[248] @ 3968
	.field	32648,16		; r_squant[249] @ 3984
	.field	32680,16		; r_squant[250] @ 4000
	.field	32707,16		; r_squant[251] @ 4016
	.field	32729,16		; r_squant[252] @ 4032
	.field	32746,16		; r_squant[253] @ 4048
	.field	32758,16		; r_squant[254] @ 4064
	.field	32766,16		; r_squant[255] @ 4080


r_vqindex
	.field	1,16		; r_vqindex[0]._l @ 0
	.field	3,16		; r_vqindex[0]._h @ 16
	.field	3,16		; r_vqindex[0]._len @ 32
***JSu	.space	16
	.field	4,16		; r_vqindex[1]._l @ 64
	.field	6,16		; r_vqindex[1]._h @ 80
	.field	3,16		; r_vqindex[1]._len @ 96
***JSu	.space	16
	.field	7,16		; r_vqindex[2]._l @ 128
	.field	10,16		; r_vqindex[2]._h @ 144
	.field	4,16		; r_vqindex[2]._len @ 160


r_sqrtp0
	.field	23853,16		; r_sqrtp0[0] @ 0
	.field	24682,16		; r_sqrtp0[1] @ 16
	.field	21337,16		; r_sqrtp0[2] @ 32
	.field	16698,16		; r_sqrtp0[3] @ 48
	.field	27731,16		; r_sqrtp0[4] @ 64
	.field	24699,16		; r_sqrtp0[5] @ 80
	.field	8804,16 		; r_sqrtp0[6] @ 96
	.field	16227,16		; r_sqrtp0[7] @ 112
	.field	29760,16		; r_sqrtp0[8] @ 128
	.field	24223,16		; r_sqrtp0[9] @ 144
	.field	30248,16		; r_sqrtp0[10] @ 160
	.field	30903,16		; r_sqrtp0[11] @ 176
	.field	7969,16 		; r_sqrtp0[12] @ 192
	.field	17600,16		; r_sqrtp0[13] @ 208
	.field	5559,16 		; r_sqrtp0[14] @ 224
	.field	16866,16		; r_sqrtp0[15] @ 240
	.field	25609,16		; r_sqrtp0[16] @ 256
	.field	24727,16		; r_sqrtp0[17] @ 272
	.field	30483,16		; r_sqrtp0[18] @ 288
	.field	31688,16		; r_sqrtp0[19] @ 304
	.field	27583,16		; r_sqrtp0[20] @ 320
	.field	28959,16		; r_sqrtp0[21] @ 336
	.field	31514,16		; r_sqrtp0[22] @ 352
	.field	31903,16		; r_sqrtp0[23] @ 368
	.field	14035,16		; r_sqrtp0[24] @ 384
	.field	23660,16		; r_sqrtp0[25] @ 400
	.field	13761,16		; r_sqrtp0[26] @ 416
	.field	25661,16		; r_sqrtp0[27] @ 432
	.field	28863,16		; r_sqrtp0[28] @ 448
	.field	31627,16		; r_sqrtp0[29] @ 464
	.field	30350,16		; r_sqrtp0[30] @ 480
	.field	32153,16		; r_sqrtp0[31] @ 496
	.field	26490,16		; r_sqrtp0[32] @ 512
	.field	19929,16		; r_sqrtp0[33] @ 528
	.field	28693,16		; r_sqrtp0[34] @ 544
	.field	23708,16		; r_sqrtp0[35] @ 560
	.field	30266,16		; r_sqrtp0[36] @ 576
	.field	28196,16		; r_sqrtp0[37] @ 592
	.field	31577,16		; r_sqrtp0[38] @ 608
	.field	31714,16		; r_sqrtp0[39] @ 624
	.field	20642,16		; r_sqrtp0[40] @ 640
	.field	20179,16		; r_sqrtp0[41] @ 656
	.field	27963,16		; r_sqrtp0[42] @ 672
	.field	29109,16		; r_sqrtp0[43] @ 688
	.field	30776,16		; r_sqrtp0[44] @ 704
	.field	32054,16		; r_sqrtp0[45] @ 720
	.field	31076,16		; r_sqrtp0[46] @ 736
	.field	32241,16		; r_sqrtp0[47] @ 752
	.field	23111,16		; r_sqrtp0[48] @ 768
	.field	28343,16		; r_sqrtp0[49] @ 784
	.field	25233,16		; r_sqrtp0[50] @ 800
	.field	29710,16		; r_sqrtp0[51] @ 816
	.field	30403,16		; r_sqrtp0[52] @ 832
	.field	31915,16		; r_sqrtp0[53] @ 848
	.field	31466,16		; r_sqrtp0[54] @ 864
	.field	32360,16		; r_sqrtp0[55] @ 880
	.field	28533,16		; r_sqrtp0[56] @ 896
	.field	30856,16		; r_sqrtp0[57] @ 912
	.field	31921,16		; r_sqrtp0[58] @ 928
	.field	32327,16		; r_sqrtp0[59] @ 944
	.field	29569,16		; r_sqrtp0[60] @ 960
	.field	31489,16		; r_sqrtp0[61] @ 976
	.field	32348,16		; r_sqrtp0[62] @ 992
	.field	32114,16		; r_sqrtp0[63] @ 1008
	.field	24318,16		; r_sqrtp0[64] @ 1024
	.field	31095,16		; r_sqrtp0[65] @ 1040
	.field	31943,16		; r_sqrtp0[66] @ 1056
	.field	31912,16		; r_sqrtp0[67] @ 1072
	.field	27251,16		; r_sqrtp0[68] @ 1088
	.field	30541,16		; r_sqrtp0[69] @ 1104
	.field	32336,16		; r_sqrtp0[70] @ 1120
	.field	32254,16		; r_sqrtp0[71] @ 1136
	.field	28448,16		; r_sqrtp0[72] @ 1152
	.field	29139,16		; r_sqrtp0[73] @ 1168
	.field	32149,16		; r_sqrtp0[74] @ 1184
	.field	32413,16		; r_sqrtp0[75] @ 1200
	.field	31155,16		; r_sqrtp0[76] @ 1216
	.field	31480,16		; r_sqrtp0[77] @ 1232
	.field	32388,16		; r_sqrtp0[78] @ 1248
	.field	32561,16		; r_sqrtp0[79] @ 1264
	.field	28647,16		; r_sqrtp0[80] @ 1280
	.field	31172,16		; r_sqrtp0[81] @ 1296
	.field	32084,16		; r_sqrtp0[82] @ 1312
	.field	32512,16		; r_sqrtp0[83] @ 1328
	.field	30927,16		; r_sqrtp0[84] @ 1344
	.field	32000,16		; r_sqrtp0[85] @ 1360
	.field	32435,16		; r_sqrtp0[86] @ 1376
	.field	32571,16		; r_sqrtp0[87] @ 1392
	.field	30455,16		; r_sqrtp0[88] @ 1408
	.field	31973,16		; r_sqrtp0[89] @ 1424
	.field	32487,16		; r_sqrtp0[90] @ 1440
	.field	32564,16		; r_sqrtp0[91] @ 1456
	.field	31487,16		; r_sqrtp0[92] @ 1472
	.field	32472,16		; r_sqrtp0[93] @ 1488
	.field	31877,16		; r_sqrtp0[94] @ 1504
	.field	32586,16		; r_sqrtp0[95] @ 1520



r_cgintfilt
	.field	0,16		; r_cgintfilt[0] @ 0
	.field	126,16		; r_cgintfilt[1] @ 16
	.field	0,16		; r_cgintfilt[2] @ 32
	.field	-299,16 	; r_cgintfilt[3] @ 48
	.field	-778,16 	; r_cgintfilt[4] @ 64
	.field	-1381,16	; r_cgintfilt[5] @ 80
	.field	-1980,16	; r_cgintfilt[6] @ 96
	.field	-2375,16	; r_cgintfilt[7] @ 112
	.field	-2326,16	; r_cgintfilt[8] @ 128
	.field	-1596,16	; r_cgintfilt[9] @ 144
	.field	0,16		; r_cgintfilt[10] @ 160
	.field	2535,16 	; r_cgintfilt[11] @ 176
	.field	5936,16 	; r_cgintfilt[12] @ 192
	.field	9968,16 	; r_cgintfilt[13] @ 208
	.field	14254,16	; r_cgintfilt[14] @ 224
	.field	18322,16	; r_cgintfilt[15] @ 240
	.field	21678,16	; r_cgintfilt[16] @ 256
	.field	23889,16	; r_cgintfilt[17] @ 272
	.field	24661,16	; r_cgintfilt[18] @ 288
	.field	23889,16	; r_cgintfilt[19] @ 304
	.field	21678,16	; r_cgintfilt[20] @ 320
	.field	18322,16	; r_cgintfilt[21] @ 336
	.field	14254,16	; r_cgintfilt[22] @ 352
	.field	9968,16 	; r_cgintfilt[23] @ 368
	.field	5936,16 	; r_cgintfilt[24] @ 384
	.field	2535,16 	; r_cgintfilt[25] @ 400
	.field	0,16		; r_cgintfilt[26] @ 416
	.field	-1596,16	; r_cgintfilt[27] @ 432
	.field	-2326,16	; r_cgintfilt[28] @ 448
	.field	-2375,16	; r_cgintfilt[29] @ 464
	.field	-1980,16	; r_cgintfilt[30] @ 480
	.field	-1381,16	; r_cgintfilt[31] @ 496
	.field	-778,16 	; r_cgintfilt[32] @ 512
	.field	-299,16 	; r_cgintfilt[33] @ 528
	.field	0,16		; r_cgintfilt[34] @ 544
	.field	126,16		; r_cgintfilt[35] @ 560


	.if	rom_compat
r_pvecintfilt
	.field	0,16		; r_pvecintfilt[0] @ 0
	.field	183,16		; r_pvecintfilt[1] @ 16
	.field	249,16		; r_pvecintfilt[2] @ 32
	.field	251,16		; r_pvecintfilt[3] @ 48
	.field	149,16		; r_pvecintfilt[4] @ 64
	.field	-67,16		; r_pvecintfilt[5] @ 80
	.field	-368,16 	; r_pvecintfilt[6] @ 96
	.field	-681,16 	; r_pvecintfilt[7] @ 112
	.field	-897,16 	; r_pvecintfilt[8] @ 128
	.field	-904,16 	; r_pvecintfilt[9] @ 144
	.field	-622,16 	; r_pvecintfilt[10] @ 160
	.field	-38,16		; r_pvecintfilt[11] @ 176
	.field	762,16		; r_pvecintfilt[12] @ 192
	.field	1595,16 	; r_pvecintfilt[13] @ 208
	.field	2214,16 	; r_pvecintfilt[14] @ 224
	.field	2360,16 	; r_pvecintfilt[15] @ 240
	.field	1842,16 	; r_pvecintfilt[16] @ 256
	.field	611,16		; r_pvecintfilt[17] @ 272
	.field	-1186,16	; r_pvecintfilt[18] @ 288
	.field	-3195,16	; r_pvecintfilt[19] @ 304
	.field	-4898,16	; r_pvecintfilt[20] @ 320
	.field	-5708,16	; r_pvecintfilt[21] @ 336
	.field	-5089,16	; r_pvecintfilt[22] @ 352
	.field	-2696,16	; r_pvecintfilt[23] @ 368
	.field	1515,16 	; r_pvecintfilt[24] @ 384
	.field	7239,16 	; r_pvecintfilt[25] @ 400
	.field	13835,16	; r_pvecintfilt[26] @ 416
	.field	20424,16	; r_pvecintfilt[27] @ 432
	.field	26040,16	; r_pvecintfilt[28] @ 448
	.field	29814,16	; r_pvecintfilt[29] @ 464
	.field	31144,16	; r_pvecintfilt[30] @ 480
	.field	29814,16	; r_pvecintfilt[31] @ 496
	.field	26040,16	; r_pvecintfilt[32] @ 512
	.field	20424,16	; r_pvecintfilt[33] @ 528
	.field	13835,16	; r_pvecintfilt[34] @ 544
	.field	7239,16 	; r_pvecintfilt[35] @ 560
	.field	1515,16 	; r_pvecintfilt[36] @ 576
	.field	-2696,16	; r_pvecintfilt[37] @ 592
	.field	-5089,16	; r_pvecintfilt[38] @ 608
	.field	-5708,16	; r_pvecintfilt[39] @ 624
	.field	-4898,16	; r_pvecintfilt[40] @ 640
	.field	-3195,16	; r_pvecintfilt[41] @ 656
	.field	-1186,16	; r_pvecintfilt[42] @ 672
	.field	611,16		; r_pvecintfilt[43] @ 688
	.field	1842,16 	; r_pvecintfilt[44] @ 704
	.field	2360,16 	; r_pvecintfilt[45] @ 720
	.field	2214,16 	; r_pvecintfilt[46] @ 736
	.field	1595,16 	; r_pvecintfilt[47] @ 752
	.field	762,16		; r_pvecintfilt[48] @ 768
	.field	-38,16		; r_pvecintfilt[49] @ 784
	.field	-622,16 	; r_pvecintfilt[50] @ 800
	.field	-904,16 	; r_pvecintfilt[51] @ 816
	.field	-897,16 	; r_pvecintfilt[52] @ 832
	.field	-681,16 	; r_pvecintfilt[53] @ 848
	.field	-368,16 	; r_pvecintfilt[54] @ 864
	.field	-67,16		; r_pvecintfilt[55] @ 880
	.field	149,16		; r_pvecintfilt[56] @ 896
	.field	251,16		; r_pvecintfilt[57] @ 912
	.field	249,16		; r_pvecintfilt[58] @ 928
	.field	183,16		; r_pvecintfilt[59] @ 944
	.endif
       
       
r_lagtbl
	.field	126,16		; r_lagtbl[0] @ 0
	.field	128,16		; r_lagtbl[1] @ 16
	.field	130,16		; r_lagtbl[2] @ 32
	.field	132,16		; r_lagtbl[3] @ 48
	.field	134,16		; r_lagtbl[4] @ 64
	.field	136,16		; r_lagtbl[5] @ 80
	.field	138,16		; r_lagtbl[6] @ 96
	.field	139,16		; r_lagtbl[7] @ 112
	.field	140,16		; r_lagtbl[8] @ 128
	.field	141,16		; r_lagtbl[9] @ 144
	.field	142,16		; r_lagtbl[10] @ 160
	.field	143,16		; r_lagtbl[11] @ 176
	.field	144,16		; r_lagtbl[12] @ 192
	.field	145,16		; r_lagtbl[13] @ 208
	.field	146,16		; r_lagtbl[14] @ 224
	.field	147,16		; r_lagtbl[15] @ 240
	.field	148,16		; r_lagtbl[16] @ 256
	.field	149,16		; r_lagtbl[17] @ 272
	.field	150,16		; r_lagtbl[18] @ 288
	.field	151,16		; r_lagtbl[19] @ 304
	.field	152,16		; r_lagtbl[20] @ 320
	.field	153,16		; r_lagtbl[21] @ 336
	.field	154,16		; r_lagtbl[22] @ 352
	.field	155,16		; r_lagtbl[23] @ 368
	.field	156,16		; r_lagtbl[24] @ 384
	.field	157,16		; r_lagtbl[25] @ 400
	.field	158,16		; r_lagtbl[26] @ 416
	.field	159,16		; r_lagtbl[27] @ 432
	.field	160,16		; r_lagtbl[28] @ 448
	.field	161,16		; r_lagtbl[29] @ 464
	.field	162,16		; r_lagtbl[30] @ 480
	.field	163,16		; r_lagtbl[31] @ 496
	.field	164,16		; r_lagtbl[32] @ 512
	.field	165,16		; r_lagtbl[33] @ 528
	.field	166,16		; r_lagtbl[34] @ 544
	.field	167,16		; r_lagtbl[35] @ 560
	.field	168,16		; r_lagtbl[36] @ 576
	.field	169,16		; r_lagtbl[37] @ 592
	.field	170,16		; r_lagtbl[38] @ 608
	.field	171,16		; r_lagtbl[39] @ 624
	.field	172,16		; r_lagtbl[40] @ 640
	.field	173,16		; r_lagtbl[41] @ 656
	.field	174,16		; r_lagtbl[42] @ 672
	.field	175,16		; r_lagtbl[43] @ 688
	.field	176,16		; r_lagtbl[44] @ 704
	.field	177,16		; r_lagtbl[45] @ 720
	.field	178,16		; r_lagtbl[46] @ 736
	.field	179,16		; r_lagtbl[47] @ 752
	.field	180,16		; r_lagtbl[48] @ 768
	.field	181,16		; r_lagtbl[49] @ 784
	.field	182,16		; r_lagtbl[50] @ 800
	.field	183,16		; r_lagtbl[51] @ 816
	.field	184,16		; r_lagtbl[52] @ 832
	.field	185,16		; r_lagtbl[53] @ 848
	.field	186,16		; r_lagtbl[54] @ 864
	.field	187,16		; r_lagtbl[55] @ 880
	.field	188,16		; r_lagtbl[56] @ 896
	.field	189,16		; r_lagtbl[57] @ 912
	.field	190,16		; r_lagtbl[58] @ 928
	.field	191,16		; r_lagtbl[59] @ 944
	.field	192,16		; r_lagtbl[60] @ 960
	.field	193,16		; r_lagtbl[61] @ 976
	.field	194,16		; r_lagtbl[62] @ 992
	.field	195,16		; r_lagtbl[63] @ 1008
	.field	196,16		; r_lagtbl[64] @ 1024
	.field	197,16		; r_lagtbl[65] @ 1040
	.field	198,16		; r_lagtbl[66] @ 1056
	.field	199,16		; r_lagtbl[67] @ 1072
	.field	200,16		; r_lagtbl[68] @ 1088
	.field	201,16		; r_lagtbl[69] @ 1104
	.field	202,16		; r_lagtbl[70] @ 1120
	.field	203,16		; r_lagtbl[71] @ 1136
	.field	204,16		; r_lagtbl[72] @ 1152
	.field	205,16		; r_lagtbl[73] @ 1168
	.field	206,16		; r_lagtbl[74] @ 1184
	.field	207,16		; r_lagtbl[75] @ 1200
	.field	208,16		; r_lagtbl[76] @ 1216
	.field	209,16		; r_lagtbl[77] @ 1232
	.field	210,16		; r_lagtbl[78] @ 1248
	.field	212,16		; r_lagtbl[79] @ 1264
	.field	214,16		; r_lagtbl[80] @ 1280
	.field	216,16		; r_lagtbl[81] @ 1296
	.field	218,16		; r_lagtbl[82] @ 1312
	.field	220,16		; r_lagtbl[83] @ 1328
	.field	222,16		; r_lagtbl[84] @ 1344
	.field	224,16		; r_lagtbl[85] @ 1360
	.field	226,16		; r_lagtbl[86] @ 1376
	.field	228,16		; r_lagtbl[87] @ 1392
	.field	230,16		; r_lagtbl[88] @ 1408
	.field	232,16		; r_lagtbl[89] @ 1424
	.field	234,16		; r_lagtbl[90] @ 1440
	.field	236,16		; r_lagtbl[91] @ 1456
	.field	238,16		; r_lagtbl[92] @ 1472
	.field	240,16		; r_lagtbl[93] @ 1488
	.field	242,16		; r_lagtbl[94] @ 1504
	.field	244,16		; r_lagtbl[95] @ 1520
	.field	246,16		; r_lagtbl[96] @ 1536
	.field	248,16		; r_lagtbl[97] @ 1552
	.field	250,16		; r_lagtbl[98] @ 1568
	.field	252,16		; r_lagtbl[99] @ 1584
	.field	254,16		; r_lagtbl[100] @ 1600
	.field	256,16		; r_lagtbl[101] @ 1616
	.field	258,16		; r_lagtbl[102] @ 1632
	.field	260,16		; r_lagtbl[103] @ 1648
	.field	262,16		; r_lagtbl[104] @ 1664
	.field	264,16		; r_lagtbl[105] @ 1680
	.field	266,16		; r_lagtbl[106] @ 1696
	.field	268,16		; r_lagtbl[107] @ 1712
	.field	270,16		; r_lagtbl[108] @ 1728
	.field	272,16		; r_lagtbl[109] @ 1744
	.field	274,16		; r_lagtbl[110] @ 1760
	.field	276,16		; r_lagtbl[111] @ 1776
	.field	278,16		; r_lagtbl[112] @ 1792
	.field	280,16		; r_lagtbl[113] @ 1808
	.field	282,16		; r_lagtbl[114] @ 1824
	.field	284,16		; r_lagtbl[115] @ 1840
	.field	286,16		; r_lagtbl[116] @ 1856
	.field	288,16		; r_lagtbl[117] @ 1872
	.field	290,16		; r_lagtbl[118] @ 1888
	.field	292,16		; r_lagtbl[119] @ 1904
	.field	294,16		; r_lagtbl[120] @ 1920
	.field	296,16		; r_lagtbl[121] @ 1936
	.field	298,16		; r_lagtbl[122] @ 1952
	.field	300,16		; r_lagtbl[123] @ 1968
	.field	303,16		; r_lagtbl[124] @ 1984
	.field	306,16		; r_lagtbl[125] @ 2000
	.field	309,16		; r_lagtbl[126] @ 2016
	.field	312,16		; r_lagtbl[127] @ 2032
	.field	315,16		; r_lagtbl[128] @ 2048
	.field	318,16		; r_lagtbl[129] @ 2064
	.field	321,16		; r_lagtbl[130] @ 2080
	.field	324,16		; r_lagtbl[131] @ 2096
	.field	327,16		; r_lagtbl[132] @ 2112
	.field	330,16		; r_lagtbl[133] @ 2128
	.field	333,16		; r_lagtbl[134] @ 2144
	.field	336,16		; r_lagtbl[135] @ 2160
	.field	339,16		; r_lagtbl[136] @ 2176
	.field	342,16		; r_lagtbl[137] @ 2192
	.field	345,16		; r_lagtbl[138] @ 2208
	.field	348,16		; r_lagtbl[139] @ 2224
	.field	351,16		; r_lagtbl[140] @ 2240
	.field	354,16		; r_lagtbl[141] @ 2256
	.field	357,16		; r_lagtbl[142] @ 2272
	.field	360,16		; r_lagtbl[143] @ 2288
	.field	363,16		; r_lagtbl[144] @ 2304
	.field	366,16		; r_lagtbl[145] @ 2320
	.field	369,16		; r_lagtbl[146] @ 2336
	.field	372,16		; r_lagtbl[147] @ 2352
	.field	375,16		; r_lagtbl[148] @ 2368
	.field	378,16		; r_lagtbl[149] @ 2384
	.field	381,16		; r_lagtbl[150] @ 2400
	.field	384,16		; r_lagtbl[151] @ 2416
	.field	387,16		; r_lagtbl[152] @ 2432
	.field	390,16		; r_lagtbl[153] @ 2448
	.field	393,16		; r_lagtbl[154] @ 2464
	.field	396,16		; r_lagtbl[155] @ 2480
	.field	399,16		; r_lagtbl[156] @ 2496
	.field	402,16		; r_lagtbl[157] @ 2512
	.field	405,16		; r_lagtbl[158] @ 2528
	.field	408,16		; r_lagtbl[159] @ 2544
	.field	411,16		; r_lagtbl[160] @ 2560
	.field	414,16		; r_lagtbl[161] @ 2576
	.field	417,16		; r_lagtbl[162] @ 2592
	.field	420,16		; r_lagtbl[163] @ 2608
	.field	423,16		; r_lagtbl[164] @ 2624
	.field	426,16		; r_lagtbl[165] @ 2640
	.field	429,16		; r_lagtbl[166] @ 2656
	.field	432,16		; r_lagtbl[167] @ 2672
	.field	435,16		; r_lagtbl[168] @ 2688
	.field	438,16		; r_lagtbl[169] @ 2704
	.field	441,16		; r_lagtbl[170] @ 2720
	.field	444,16		; r_lagtbl[171] @ 2736
	.field	447,16		; r_lagtbl[172] @ 2752
	.field	450,16		; r_lagtbl[173] @ 2768
	.field	453,16		; r_lagtbl[174] @ 2784
	.field	456,16		; r_lagtbl[175] @ 2800
	.field	459,16		; r_lagtbl[176] @ 2816
	.field	462,16		; r_lagtbl[177] @ 2832
	.field	465,16		; r_lagtbl[178] @ 2848
	.field	468,16		; r_lagtbl[179] @ 2864
	.field	471,16		; r_lagtbl[180] @ 2880
	.field	474,16		; r_lagtbl[181] @ 2896
	.field	477,16		; r_lagtbl[182] @ 2912
	.field	480,16		; r_lagtbl[183] @ 2928
	.field	483,16		; r_lagtbl[184] @ 2944
	.field	486,16		; r_lagtbl[185] @ 2960
	.field	489,16		; r_lagtbl[186] @ 2976
	.field	492,16		; r_lagtbl[187] @ 2992
	.field	495,16		; r_lagtbl[188] @ 3008
	.field	498,16		; r_lagtbl[189] @ 3024
	.field	501,16		; r_lagtbl[190] @ 3040
	.field	504,16		; r_lagtbl[191] @ 3056
	.field	507,16		; r_lagtbl[192] @ 3072
	.field	510,16		; r_lagtbl[193] @ 3088
	.field	513,16		; r_lagtbl[194] @ 3104
	.field	516,16		; r_lagtbl[195] @ 3120
	.field	519,16		; r_lagtbl[196] @ 3136
	.field	522,16		; r_lagtbl[197] @ 3152
	.field	525,16		; r_lagtbl[198] @ 3168
	.field	528,16		; r_lagtbl[199] @ 3184
	.field	531,16		; r_lagtbl[200] @ 3200
	.field	534,16		; r_lagtbl[201] @ 3216
	.field	537,16		; r_lagtbl[202] @ 3232
	.field	540,16		; r_lagtbl[203] @ 3248
	.field	546,16		; r_lagtbl[204] @ 3264
	.field	552,16		; r_lagtbl[205] @ 3280
	.field	558,16		; r_lagtbl[206] @ 3296
	.field	564,16		; r_lagtbl[207] @ 3312
	.field	570,16		; r_lagtbl[208] @ 3328
	.field	576,16		; r_lagtbl[209] @ 3344
	.field	582,16		; r_lagtbl[210] @ 3360
	.field	588,16		; r_lagtbl[211] @ 3376
	.field	594,16		; r_lagtbl[212] @ 3392
	.field	600,16		; r_lagtbl[213] @ 3408
	.field	606,16		; r_lagtbl[214] @ 3424
	.field	612,16		; r_lagtbl[215] @ 3440
	.field	618,16		; r_lagtbl[216] @ 3456
	.field	624,16		; r_lagtbl[217] @ 3472
	.field	630,16		; r_lagtbl[218] @ 3488
	.field	636,16		; r_lagtbl[219] @ 3504
	.field	642,16		; r_lagtbl[220] @ 3520
	.field	648,16		; r_lagtbl[221] @ 3536
	.field	654,16		; r_lagtbl[222] @ 3552
	.field	660,16		; r_lagtbl[223] @ 3568
	.field	666,16		; r_lagtbl[224] @ 3584
	.field	672,16		; r_lagtbl[225] @ 3600
	.field	678,16		; r_lagtbl[226] @ 3616
	.field	684,16		; r_lagtbl[227] @ 3632
	.field	690,16		; r_lagtbl[228] @ 3648
	.field	696,16		; r_lagtbl[229] @ 3664
	.field	702,16		; r_lagtbl[230] @ 3680
	.field	708,16		; r_lagtbl[231] @ 3696
	.field	714,16		; r_lagtbl[232] @ 3712
	.field	720,16		; r_lagtbl[233] @ 3728
	.field	726,16		; r_lagtbl[234] @ 3744
	.field	732,16		; r_lagtbl[235] @ 3760
	.field	738,16		; r_lagtbl[236] @ 3776
	.field	744,16		; r_lagtbl[237] @ 3792
	.field	750,16		; r_lagtbl[238] @ 3808
	.field	756,16		; r_lagtbl[239] @ 3824
	.field	762,16		; r_lagtbl[240] @ 3840
	.field	768,16		; r_lagtbl[241] @ 3856
	.field	774,16		; r_lagtbl[242] @ 3872
	.field	780,16		; r_lagtbl[243] @ 3888
	.field	786,16		; r_lagtbl[244] @ 3904
	.field	792,16		; r_lagtbl[245] @ 3920
	.field	798,16		; r_lagtbl[246] @ 3936
	.field	804,16		; r_lagtbl[247] @ 3952
	.field	810,16		; r_lagtbl[248] @ 3968
	.field	816,16		; r_lagtbl[249] @ 3984
	.field	822,16		; r_lagtbl[250] @ 4000
	.field	828,16		; r_lagtbl[251] @ 4016
	.field	834,16		; r_lagtbl[252] @ 4032
	.field	840,16		; r_lagtbl[253] @ 4048
	.field	846,16		; r_lagtbl[254] @ 4064
	.field	852,16		; r_lagtbl[255] @ 4080


	.if	rom_compat
r_r0dectbl
	.field	6,16		; r_r0dectbl[0] @ 0
	.field	7,16		; r_r0dectbl[1] @ 16
	.field	8,16		; r_r0dectbl[2] @ 32
	.field	9,16		; r_r0dectbl[3] @ 48
	.field	10,16		; r_r0dectbl[4] @ 64
	.field	12,16		; r_r0dectbl[5] @ 80
	.field	13,16		; r_r0dectbl[6] @ 96
	.field	15,16		; r_r0dectbl[7] @ 112
	.field	16,16		; r_r0dectbl[8] @ 128
	.field	18,16		; r_r0dectbl[9] @ 144
	.field	21,16		; r_r0dectbl[10] @ 160
	.field	23,16		; r_r0dectbl[11] @ 176
	.field	26,16		; r_r0dectbl[12] @ 192
	.field	29,16		; r_r0dectbl[13] @ 208
	.field	33,16		; r_r0dectbl[14] @ 224
	.field	37,16		; r_r0dectbl[15] @ 240
	.field	41,16		; r_r0dectbl[16] @ 256
	.field	46,16		; r_r0dectbl[17] @ 272
	.field	52,16		; r_r0dectbl[18] @ 288
	.field	58,16		; r_r0dectbl[19] @ 304
	.field	65,16		; r_r0dectbl[20] @ 320
	.field	73,16		; r_r0dectbl[21] @ 336
	.field	82,16		; r_r0dectbl[22] @ 352
	.field	92,16		; r_r0dectbl[23] @ 368
	.field	103,16		; r_r0dectbl[24] @ 384
	.field	115,16		; r_r0dectbl[25] @ 400
	.field	130,16		; r_r0dectbl[26] @ 416
	.field	145,16		; r_r0dectbl[27] @ 432
	.field	163,16		; r_r0dectbl[28] @ 448
	.field	183,16		; r_r0dectbl[29] @ 464
	.field	205,16		; r_r0dectbl[30] @ 480
	.field	230,16		; r_r0dectbl[31] @ 496
	.field	258,16		; r_r0dectbl[32] @ 512
	.field	290,16		; r_r0dectbl[33] @ 528
	.field	325,16		; r_r0dectbl[34] @ 544
	.field	365,16		; r_r0dectbl[35] @ 560
	.field	410,16		; r_r0dectbl[36] @ 576
	.field	460,16		; r_r0dectbl[37] @ 592
	.field	516,16		; r_r0dectbl[38] @ 608
	.field	579,16		; r_r0dectbl[39] @ 624
	.field	649,16		; r_r0dectbl[40] @ 640
	.field	728,16		; r_r0dectbl[41] @ 656
	.field	817,16		; r_r0dectbl[42] @ 672
	.field	917,16		; r_r0dectbl[43] @ 688
	.field	1029,16 	; r_r0dectbl[44] @ 704
	.field	1154,16 	; r_r0dectbl[45] @ 720
	.field	1295,16 	; r_r0dectbl[46] @ 736
	.field	1453,16 	; r_r0dectbl[47] @ 752
	.field	1631,16 	; r_r0dectbl[48] @ 768
	.field	1830,16 	; r_r0dectbl[49] @ 784
	.field	2053,16 	; r_r0dectbl[50] @ 800
	.field	2303,16 	; r_r0dectbl[51] @ 816
	.field	2584,16 	; r_r0dectbl[52] @ 832
	.field	2900,16 	; r_r0dectbl[53] @ 848
	.field	3254,16 	; r_r0dectbl[54] @ 864
	.field	3651,16 	; r_r0dectbl[55] @ 880
	.field	4096,16 	; r_r0dectbl[56] @ 896
	.field	4596,16 	; r_r0dectbl[57] @ 912
	.field	5157,16 	; r_r0dectbl[58] @ 928
	.field	5786,16 	; r_r0dectbl[59] @ 944
	.field	6492,16 	; r_r0dectbl[60] @ 960
	.field	7284,16 	; r_r0dectbl[61] @ 976
	.field	8173,16 	; r_r0dectbl[62] @ 992
	.endif

	.if	rom_compat
r_bitalloc
	.field	18,16		; r_bitalloc[0] @ 0
	.field	2,16		; r_bitalloc[1] @ 16
	.field	5,16		; r_bitalloc[2] @ 32
	.field	11,16		; r_bitalloc[3] @ 48
	.field	9,16		; r_bitalloc[4] @ 64
	.field	8,16		; r_bitalloc[5] @ 80
	.field	1,16		; r_bitalloc[6] @ 96
	.field	8,16		; r_bitalloc[7] @ 112
	.field	4,16		; r_bitalloc[8] @ 128
	.field	4,16		; r_bitalloc[9] @ 144
	.field	4,16		; r_bitalloc[10] @ 160
	.field	9,16		; r_bitalloc[11] @ 176
	.field	5,16		; r_bitalloc[12] @ 192
	.field	9,16		; r_bitalloc[13] @ 208
	.field	5,16		; r_bitalloc[14] @ 224
	.field	9,16		; r_bitalloc[15] @ 240
	.field	5,16		; r_bitalloc[16] @ 256
	.field	9,16		; r_bitalloc[17] @ 272
	.field	5,16		; r_bitalloc[18] @ 288
	.endif


	.if	rom_compat
r_bitallocunvoiced
       .field  18,16		; r_bitallocunvoiced[0] @ 0
	.field	2,16		; r_bitallocunvoiced[1] @ 16
	.field	5,16		; r_bitallocunvoiced[2] @ 32
	.field	11,16		; r_bitallocunvoiced[3] @ 48
	.field	9,16		; r_bitallocunvoiced[4] @ 64
	.field	8,16		; r_bitallocunvoiced[5] @ 80
	.field	1,16		; r_bitallocunvoiced[6] @ 96
	.field	7,16		; r_bitallocunvoiced[7] @ 112
	.field	7,16		; r_bitallocunvoiced[8] @ 128
	.field	5,16		; r_bitallocunvoiced[9] @ 144
	.field	7,16		; r_bitallocunvoiced[10] @ 160
	.field	7,16		; r_bitallocunvoiced[11] @ 176
	.field	5,16		; r_bitallocunvoiced[12] @ 192
	.field	7,16		; r_bitallocunvoiced[13] @ 208
	.field	7,16		; r_bitallocunvoiced[14] @ 224
	.field	5,16		; r_bitallocunvoiced[15] @ 240
	.field	7,16		; r_bitallocunvoiced[16] @ 256
	.field	7,16		; r_bitallocunvoiced[17] @ 272
	.field	5,16		; r_bitallocunvoiced[18] @ 288
	.endif


	.if	rom_compat
r_symtosimorder
	.field	0,16		; r_symtosimorder[0] @ 0
	.field	1,16		; r_symtosimorder[1] @ 16
	.field	2,16		; r_symtosimorder[2] @ 32
	.field	4,16		; r_symtosimorder[3] @ 48
	.field	6,16		; r_symtosimorder[4] @ 64
	.field	7,16		; r_symtosimorder[5] @ 80
	.field	8,16		; r_symtosimorder[6] @ 96
	.field	13,16		; r_symtosimorder[7] @ 112
	.field	17,16		; r_symtosimorder[8] @ 128
	.field	21,16		; r_symtosimorder[9] @ 144
	.field	10,16		; r_symtosimorder[10] @ 160
	.field	12,16		; r_symtosimorder[11] @ 176
	.field	14,16		; r_symtosimorder[12] @ 192
	.field	16,16		; r_symtosimorder[13] @ 208
	.field	18,16		; r_symtosimorder[14] @ 224
	.field	20,16		; r_symtosimorder[15] @ 240
	.field	22,16		; r_symtosimorder[16] @ 256
	.field	24,16		; r_symtosimorder[17] @ 272
	.endif


	.if	rom_compat
r_symtosimorderuv
	.field	0,16		; r_symtosimorderuv[0] @ 0
	.field	1,16		; r_symtosimorderuv[1] @ 16
	.field	2,16		; r_symtosimorderuv[2] @ 32
	.field	4,16		; r_symtosimorderuv[3] @ 48
	.field	6,16		; r_symtosimorderuv[4] @ 64
	.field	7,16		; r_symtosimorderuv[5] @ 80
	.field	10,16		; r_symtosimorderuv[6] @ 96
	.field	11,16		; r_symtosimorderuv[7] @ 112
	.field	12,16		; r_symtosimorderuv[8] @ 128
	.field	14,16		; r_symtosimorderuv[9] @ 144
	.field	15,16		; r_symtosimorderuv[10] @ 160
	.field	16,16		; r_symtosimorderuv[11] @ 176
	.field	18,16		; r_symtosimorderuv[12] @ 192
	.field	19,16		; r_symtosimorderuv[13] @ 208
	.field	20,16		; r_symtosimorderuv[14] @ 224
	.field	22,16		; r_symtosimorderuv[15] @ 240
	.field	23,16		; r_symtosimorderuv[16] @ 256
	.field	24,16		; r_symtosimorderuv[17] @ 272
	.endif



	.if	rom_compat
r_shiftright
	.field	32767,16	; r_shiftright[0] @ 0
	.field	16384,16	; r_shiftright[1] @ 16
	.field	8192,16 	; r_shiftright[2] @ 32
	.field	4096,16 	; r_shiftright[3] @ 48
	.field	2048,16 	; r_shiftright[4] @ 64
	.field	1024,16 	; r_shiftright[5] @ 80
	.field	512,16		; r_shiftright[6] @ 96
	.field	256,16		; r_shiftright[7] @ 112
	.field	128,16		; r_shiftright[8] @ 128
	.field	64,16		; r_shiftright[9] @ 144
	.field	32,16		; r_shiftright[10] @ 160
	.field	16,16		; r_shiftright[11] @ 176
	.field	8,16		; r_shiftright[12] @ 192
	.field	4,16		; r_shiftright[13] @ 208
	.field	2,16		; r_shiftright[14] @ 224
	.field	1,16		; r_shiftright[15] @ 240
	.field	0,16		; r_shiftright[16] @ 256
	.endif


	.if	rom_compat
r_hpfcoefs
	.field	10979,16		; r_hpfcoefs[0] @ 0
	.field	-21954,16		; r_hpfcoefs[1] @ 16
	.field	10979,16		; r_hpfcoefs[2] @ 32
	.field	-14071,16		; r_hpfcoefs[3] @ 48
	.field	30347,16		; r_hpfcoefs[4] @ 64
	.field	10979,16		; r_hpfcoefs[5] @ 80
	.field	-21936,16		; r_hpfcoefs[6] @ 96
	.field	10979,16		; r_hpfcoefs[7] @ 112
	.field	-15385,16		; r_hpfcoefs[8] @ 128
	.field	31632,16		; r_hpfcoefs[9] @ 144
	.endif

r_nwcoefs
	.field	30474,16		; r_nwcoefs[0] @ 0
	.field	28341,16		; r_nwcoefs[1] @ 16
	.field	26357,16		; r_nwcoefs[2] @ 32
	.field	24512,16		; r_nwcoefs[3] @ 48
	.field	22796,16		; r_nwcoefs[4] @ 64
	.field	21201,16		; r_nwcoefs[5] @ 80
	.field	19717,16		; r_nwcoefs[6] @ 96
	.field	18336,16		; r_nwcoefs[7] @ 112
	.field	17053,16		; r_nwcoefs[8] @ 128
	.field	15859,16		; r_nwcoefs[9] @ 144
	.field	22938,16		; r_nwcoefs[10] @ 160
	.field	16056,16		; r_nwcoefs[11] @ 176
	.field	11239,16		; r_nwcoefs[12] @ 192
	.field	7868,16 		; r_nwcoefs[13] @ 208
	.field	5507,16 		; r_nwcoefs[14] @ 224
	.field	3855,16 		; r_nwcoefs[15] @ 240
	.field	2699,16 		; r_nwcoefs[16] @ 256
	.field	1889,16 		; r_nwcoefs[17] @ 272
	.field	1322,16 		; r_nwcoefs[18] @ 288
	.field	926,16			; r_nwcoefs[19] @ 304


	.align	2
r_flatsstcoefs
	.field	2145262551,32		; r_flatsstcoefs[0] @ 0
	.field	2138972761,32		; r_flatsstcoefs[1] @ 32
	.field	2129579484,32		; r_flatsstcoefs[2] @ 64
	.field	2118274784,32		; r_flatsstcoefs[3] @ 96
	.field	2106083684,32		; r_flatsstcoefs[4] @ 128
	.field	2093615080,32		; r_flatsstcoefs[5] @ 160
	.field	2081026796,32		; r_flatsstcoefs[6] @ 192
	.field	2068156528,32		; r_flatsstcoefs[7] @ 224
	.field	2054704628,32		; r_flatsstcoefs[8] @ 256
	.field	2040382328,32		; r_flatsstcoefs[9] @ 288


	.if	rom_compat
r_oldcont
	.field	22938,16	; r_oldcont[0] @ 0
	.field	12452,16	; r_oldcont[1] @ 16
	.field	2621,16 	; r_oldcont[2] @ 32
	.field	0,16		; r_oldcont[3] @ 48


r_newcont
	.field	9830,16 		; r_newcont[0] @ 0
	.field	20316,16		; r_newcont[1] @ 16
	.field	30147,16		; r_newcont[2] @ 32
	.field	32767,16		; r_newcont[3] @ 48
	.endif

r_spfdenomwidencf
	.field	24576,16	; r_spfdenomwidencf[0] @ 0
	.field	18432,16	; r_spfdenomwidencf[1] @ 16
	.field	13824,16	; r_spfdenomwidencf[2] @ 32
	.field	10368,16	; r_spfdenomwidencf[3] @ 48
	.field	7776,16 	; r_spfdenomwidencf[4] @ 64
	.field	5832,16 	; r_spfdenomwidencf[5] @ 80
	.field	4374,16 	; r_spfdenomwidencf[6] @ 96
	.field	3280,16 	; r_spfdenomwidencf[7] @ 112
	.field	2460,16 	; r_spfdenomwidencf[8] @ 128
	.field	1845,16 	; r_spfdenomwidencf[9] @ 144


r_sst	.field	32767,16		; r_sst[0] @ 0
	.field	32604,16		; r_sst[1] @ 16
	.field	32118,16		; r_sst[2] @ 32
	.field	31323,16		; r_sst[3] @ 48
	.field	30242,16		; r_sst[4] @ 64
	.field	28908,16		; r_sst[5] @ 80
	.field	27357,16		; r_sst[6] @ 96
	.field	25631,16		; r_sst[7] @ 112
	.field	23773,16		; r_sst[8] @ 128
	.field	21830,16		; r_sst[9] @ 144
	.field	19846,16		; r_sst[10] @ 160


r_submultfactor
	.field	2731,16 	; r_submultfactor[0] @ 0
	.field	1820,16 	; r_submultfactor[1] @ 16
	.field	1365,16 	; r_submultfactor[2] @ 32
	.field	1092,16 	; r_submultfactor[3] @ 48
	.field	910,16		; r_submultfactor[4] @ 64


r_r0repeatthreshold
	.field	15,16		; r_r0repeatthreshold[0] @ 0
	.field	15,16		; r_r0repeatthreshold[1] @ 16
	.field	15,16		; r_r0repeatthreshold[2] @ 32
	.field	12,16		; r_r0repeatthreshold[3] @ 48
	.field	12,16		; r_r0repeatthreshold[4] @ 64
	.field	12,16		; r_r0repeatthreshold[5] @ 80
	.field	12,16		; r_r0repeatthreshold[6] @ 96
	.field	11,16		; r_r0repeatthreshold[7] @ 112
	.field	10,16		; r_r0repeatthreshold[8] @ 128
	.field	10,16		; r_r0repeatthreshold[9] @ 144
	.field	9,16		; r_r0repeatthreshold[10] @ 160
	.field	9,16		; r_r0repeatthreshold[11] @ 176
	.field	9,16		; r_r0repeatthreshold[12] @ 192
	.field	9,16		; r_r0repeatthreshold[13] @ 208
	.field	8,16		; r_r0repeatthreshold[14] @ 224
	.field	8,16		; r_r0repeatthreshold[15] @ 240
	.field	7,16		; r_r0repeatthreshold[16] @ 256
	.field	6,16		; r_r0repeatthreshold[17] @ 272
	.field	5,16		; r_r0repeatthreshold[18] @ 288
	.field	5,16		; r_r0repeatthreshold[19] @ 304
	.field	5,16		; r_r0repeatthreshold[20] @ 320
	.field	4,16		; r_r0repeatthreshold[21] @ 336
	.field	4,16		; r_r0repeatthreshold[22] @ 352
	.field	3,16		; r_r0repeatthreshold[23] @ 368
	.field	2,16		; r_r0repeatthreshold[24] @ 384
	.field	2,16		; r_r0repeatthreshold[25] @ 400
	.field	2,16		; r_r0repeatthreshold[26] @ 416
	.field	2,16		; r_r0repeatthreshold[27] @ 432
	.field	2,16		; r_r0repeatthreshold[28] @ 448
	.field	2,16		; r_r0repeatthreshold[29] @ 464
	.field	10,16		; r_r0repeatthreshold[30] @ 480
	.field	10,16		; r_r0repeatthreshold[31] @ 496


r_r0mutethreshold
	.field	14,16		; r_r0mutethreshold[0] @ 0
	.field	12,16		; r_r0mutethreshold[1] @ 16
	.field	11,16		; r_r0mutethreshold[2] @ 32
	.field	9,16		; r_r0mutethreshold[3] @ 48
	.field	9,16		; r_r0mutethreshold[4] @ 64
	.field	9,16		; r_r0mutethreshold[5] @ 80
	.field	9,16		; r_r0mutethreshold[6] @ 96
	.field	7,16		; r_r0mutethreshold[7] @ 112
	.field	7,16		; r_r0mutethreshold[8] @ 128
	.field	7,16		; r_r0mutethreshold[9] @ 144
	.field	7,16		; r_r0mutethreshold[10] @ 160
	.field	7,16		; r_r0mutethreshold[11] @ 176
	.field	6,16		; r_r0mutethreshold[12] @ 192
	.field	6,16		; r_r0mutethreshold[13] @ 208
	.field	6,16		; r_r0mutethreshold[14] @ 224
	.field	5,16		; r_r0mutethreshold[15] @ 240
	.field	5,16		; r_r0mutethreshold[16] @ 256
	.field	4,16		; r_r0mutethreshold[17] @ 272
	.field	3,16		; r_r0mutethreshold[18] @ 288
	.field	3,16		; r_r0mutethreshold[19] @ 304
	.field	3,16		; r_r0mutethreshold[20] @ 320
	.field	3,16		; r_r0mutethreshold[21] @ 336
	.field	3,16		; r_r0mutethreshold[22] @ 352
	.field	2,16		; r_r0mutethreshold[23] @ 368
	.field	1,16		; r_r0mutethreshold[24] @ 384
	.field	1,16		; r_r0mutethreshold[25] @ 400
	.field	1,16		; r_r0mutethreshold[26] @ 416
	.field	1,16		; r_r0mutethreshold[27] @ 432
	.field	1,16		; r_r0mutethreshold[28] @ 448
	.field	1,16		; r_r0mutethreshold[29] @ 464
	.field	10,16		; r_r0mutethreshold[30] @ 480
	.field	10,16		; r_r0mutethreshold[31] @ 496


r_conceal
	.field	29205,16		; r_conceal[0] @ 0
	.field	27571,16		; r_conceal[1] @ 16
	.field	24573,16		; r_conceal[2] @ 32
	.field	21900,16		; r_conceal[3] @ 48
	.field	19519,16		; r_conceal[4] @ 64
	.field	17396,16		; r_conceal[5] @ 80
	.field	15504,16		; r_conceal[6] @ 96
	.field	13818,16		; r_conceal[7] @ 112
	.field	12315,16		; r_conceal[8] @ 128
	.field	10976,16		; r_conceal[9] @ 144
	.field	9783,16 		; r_conceal[10] @ 160
	.field	8719,16 		; r_conceal[11] @ 176
	.field	7771,16 		; r_conceal[12] @ 192
	.field	6925,16 		; r_conceal[13] @ 208
	.field	6172,16 		; r_conceal[14] @ 224


r_levelmaxincrease
	.field	0,16		; r_levelmaxincrease[0] @ 0
	.field	0,16		; r_levelmaxincrease[1] @ 16
	.field	1,16		; r_levelmaxincrease[2] @ 32
	.field	1,16		; r_levelmaxincrease[3] @ 48
	.field	2,16		; r_levelmaxincrease[4] @ 64
	.field	3,16		; r_levelmaxincrease[5] @ 80
	.field	4,16		; r_levelmaxincrease[6] @ 96
	.field	5,16		; r_levelmaxincrease[7] @ 112
	.field	6,16		; r_levelmaxincrease[8] @ 128
	.field	7,16		; r_levelmaxincrease[9] @ 144
	.field	8,16		; r_levelmaxincrease[10] @ 160
	.field	9,16		; r_levelmaxincrease[11] @ 176
	.field	10,16		; r_levelmaxincrease[12] @ 192
	.field	12,16		; r_levelmaxincrease[13] @ 208
	.field	14,16		; r_levelmaxincrease[14] @ 224
	.field	16,16		; r_levelmaxincrease[15] @ 240


r_updateindexv
	.field	0,16		; r_updateindexv[0] @ 0
	.field	9,16		; r_updateindexv[1] @ 16
	.field	72,16		; r_updateindexv[2] @ 32
	.field	18,16		; r_updateindexv[3] @ 48
	.field	0,16		; r_updateindexv[4] @ 64
	.field	81,16		; r_updateindexv[5] @ 80
	.field	72,16		; r_updateindexv[6] @ 96
	.field	27,16		; r_updateindexv[7] @ 112
	.field	0,16		; r_updateindexv[8] @ 128
	.field	9,16		; r_updateindexv[9] @ 144
	.field	72,16		; r_updateindexv[10] @ 160
	.field	90,16		; r_updateindexv[11] @ 176
	.field	0,16		; r_updateindexv[12] @ 192
	.field	81,16		; r_updateindexv[13] @ 208
	.field	72,16		; r_updateindexv[14] @ 224
	.field	36,16		; r_updateindexv[15] @ 240
	.field	0,16		; r_updateindexv[16] @ 256
	.field	9,16		; r_updateindexv[17] @ 272
	.field	72,16		; r_updateindexv[18] @ 288
	.field	18,16		; r_updateindexv[19] @ 304
	.field	0,16		; r_updateindexv[20] @ 320
	.field	81,16		; r_updateindexv[21] @ 336
	.field	72,16		; r_updateindexv[22] @ 352
	.field	99,16		; r_updateindexv[23] @ 368
	.field	0,16		; r_updateindexv[24] @ 384
	.field	9,16		; r_updateindexv[25] @ 400
	.field	72,16		; r_updateindexv[26] @ 416
	.field	90,16		; r_updateindexv[27] @ 432
	.field	0,16		; r_updateindexv[28] @ 448
	.field	81,16		; r_updateindexv[29] @ 464
	.field	72,16		; r_updateindexv[30] @ 480
	.field	45,16		; r_updateindexv[31] @ 496
	.field	0,16		; r_updateindexv[32] @ 512
	.field	9,16		; r_updateindexv[33] @ 528
	.field	72,16		; r_updateindexv[34] @ 544
	.field	18,16		; r_updateindexv[35] @ 560
	.field	0,16		; r_updateindexv[36] @ 576
	.field	81,16		; r_updateindexv[37] @ 592
	.field	72,16		; r_updateindexv[38] @ 608
	.field	27,16		; r_updateindexv[39] @ 624
	.field	0,16		; r_updateindexv[40] @ 640
	.field	9,16		; r_updateindexv[41] @ 656
	.field	72,16		; r_updateindexv[42] @ 672
	.field	90,16		; r_updateindexv[43] @ 688
	.field	0,16		; r_updateindexv[44] @ 704
	.field	81,16		; r_updateindexv[45] @ 720
	.field	72,16		; r_updateindexv[46] @ 736
	.field	108,16		; r_updateindexv[47] @ 752
	.field	0,16		; r_updateindexv[48] @ 768
	.field	9,16		; r_updateindexv[49] @ 784
	.field	72,16		; r_updateindexv[50] @ 800
	.field	18,16		; r_updateindexv[51] @ 816
	.field	0,16		; r_updateindexv[52] @ 832
	.field	81,16		; r_updateindexv[53] @ 848
	.field	72,16		; r_updateindexv[54] @ 864
	.field	99,16		; r_updateindexv[55] @ 880
	.field	0,16		; r_updateindexv[56] @ 896
	.field	9,16		; r_updateindexv[57] @ 912
	.field	72,16		; r_updateindexv[58] @ 928
	.field	90,16		; r_updateindexv[59] @ 944
	.field	0,16		; r_updateindexv[60] @ 960
	.field	81,16		; r_updateindexv[61] @ 976
	.field	72,16		; r_updateindexv[62] @ 992
	.field	54,16		; r_updateindexv[63] @ 1008
	.field	0,16		; r_updateindexv[64] @ 1024
	.field	9,16		; r_updateindexv[65] @ 1040
	.field	72,16		; r_updateindexv[66] @ 1056
	.field	18,16		; r_updateindexv[67] @ 1072
	.field	0,16		; r_updateindexv[68] @ 1088
	.field	81,16		; r_updateindexv[69] @ 1104
	.field	72,16		; r_updateindexv[70] @ 1120
	.field	27,16		; r_updateindexv[71] @ 1136
	.field	0,16		; r_updateindexv[72] @ 1152
	.field	9,16		; r_updateindexv[73] @ 1168
	.field	72,16		; r_updateindexv[74] @ 1184
	.field	90,16		; r_updateindexv[75] @ 1200
	.field	0,16		; r_updateindexv[76] @ 1216
	.field	81,16		; r_updateindexv[77] @ 1232
	.field	72,16		; r_updateindexv[78] @ 1248
	.field	36,16		; r_updateindexv[79] @ 1264
	.field	0,16		; r_updateindexv[80] @ 1280
	.field	9,16		; r_updateindexv[81] @ 1296
	.field	72,16		; r_updateindexv[82] @ 1312
	.field	18,16		; r_updateindexv[83] @ 1328
	.field	0,16		; r_updateindexv[84] @ 1344
	.field	81,16		; r_updateindexv[85] @ 1360
	.field	72,16		; r_updateindexv[86] @ 1376
	.field	99,16		; r_updateindexv[87] @ 1392
	.field	0,16		; r_updateindexv[88] @ 1408
	.field	9,16		; r_updateindexv[89] @ 1424
	.field	72,16		; r_updateindexv[90] @ 1440
	.field	90,16		; r_updateindexv[91] @ 1456
	.field	0,16		; r_updateindexv[92] @ 1472
	.field	81,16		; r_updateindexv[93] @ 1488
	.field	72,16		; r_updateindexv[94] @ 1504
	.field	117,16		; r_updateindexv[95] @ 1520
	.field	0,16		; r_updateindexv[96] @ 1536
	.field	9,16		; r_updateindexv[97] @ 1552
	.field	72,16		; r_updateindexv[98] @ 1568
	.field	18,16		; r_updateindexv[99] @ 1584
	.field	0,16		; r_updateindexv[100] @ 1600
	.field	81,16		; r_updateindexv[101] @ 1616
	.field	72,16		; r_updateindexv[102] @ 1632
	.field	27,16		; r_updateindexv[103] @ 1648
	.field	0,16		; r_updateindexv[104] @ 1664
	.field	9,16		; r_updateindexv[105] @ 1680
	.field	72,16		; r_updateindexv[106] @ 1696
	.field	90,16		; r_updateindexv[107] @ 1712
	.field	0,16		; r_updateindexv[108] @ 1728
	.field	81,16		; r_updateindexv[109] @ 1744
	.field	72,16		; r_updateindexv[110] @ 1760
	.field	108,16		; r_updateindexv[111] @ 1776
	.field	0,16		; r_updateindexv[112] @ 1792
	.field	9,16		; r_updateindexv[113] @ 1808
	.field	72,16		; r_updateindexv[114] @ 1824
	.field	18,16		; r_updateindexv[115] @ 1840
	.field	0,16		; r_updateindexv[116] @ 1856
	.field	81,16		; r_updateindexv[117] @ 1872
	.field	72,16		; r_updateindexv[118] @ 1888
	.field	99,16		; r_updateindexv[119] @ 1904
	.field	0,16		; r_updateindexv[120] @ 1920
	.field	9,16		; r_updateindexv[121] @ 1936
	.field	72,16		; r_updateindexv[122] @ 1952
	.field	90,16		; r_updateindexv[123] @ 1968
	.field	0,16		; r_updateindexv[124] @ 1984
	.field	81,16		; r_updateindexv[125] @ 2000
	.field	72,16		; r_updateindexv[126] @ 2016
	.field	63,16		; r_updateindexv[127] @ 2032
	.field	0,16		; r_updateindexv[128] @ 2048
	.field	9,16		; r_updateindexv[129] @ 2064
	.field	72,16		; r_updateindexv[130] @ 2080
	.field	18,16		; r_updateindexv[131] @ 2096
	.field	0,16		; r_updateindexv[132] @ 2112
	.field	81,16		; r_updateindexv[133] @ 2128
	.field	72,16		; r_updateindexv[134] @ 2144
	.field	27,16		; r_updateindexv[135] @ 2160
	.field	0,16		; r_updateindexv[136] @ 2176
	.field	9,16		; r_updateindexv[137] @ 2192
	.field	72,16		; r_updateindexv[138] @ 2208
	.field	90,16		; r_updateindexv[139] @ 2224
	.field	0,16		; r_updateindexv[140] @ 2240
	.field	81,16		; r_updateindexv[141] @ 2256
	.field	72,16		; r_updateindexv[142] @ 2272
	.field	36,16		; r_updateindexv[143] @ 2288
	.field	0,16		; r_updateindexv[144] @ 2304
	.field	9,16		; r_updateindexv[145] @ 2320
	.field	72,16		; r_updateindexv[146] @ 2336
	.field	18,16		; r_updateindexv[147] @ 2352
	.field	0,16		; r_updateindexv[148] @ 2368
	.field	81,16		; r_updateindexv[149] @ 2384
	.field	72,16		; r_updateindexv[150] @ 2400
	.field	99,16		; r_updateindexv[151] @ 2416
	.field	0,16		; r_updateindexv[152] @ 2432
	.field	9,16		; r_updateindexv[153] @ 2448
	.field	72,16		; r_updateindexv[154] @ 2464
	.field	90,16		; r_updateindexv[155] @ 2480
	.field	0,16		; r_updateindexv[156] @ 2496
	.field	81,16		; r_updateindexv[157] @ 2512
	.field	72,16		; r_updateindexv[158] @ 2528
	.field	45,16		; r_updateindexv[159] @ 2544
	.field	0,16		; r_updateindexv[160] @ 2560
	.field	9,16		; r_updateindexv[161] @ 2576
	.field	72,16		; r_updateindexv[162] @ 2592
	.field	18,16		; r_updateindexv[163] @ 2608
	.field	0,16		; r_updateindexv[164] @ 2624
	.field	81,16		; r_updateindexv[165] @ 2640
	.field	72,16		; r_updateindexv[166] @ 2656
	.field	27,16		; r_updateindexv[167] @ 2672
	.field	0,16		; r_updateindexv[168] @ 2688
	.field	9,16		; r_updateindexv[169] @ 2704
	.field	72,16		; r_updateindexv[170] @ 2720
	.field	90,16		; r_updateindexv[171] @ 2736
	.field	0,16		; r_updateindexv[172] @ 2752
	.field	81,16		; r_updateindexv[173] @ 2768
	.field	72,16		; r_updateindexv[174] @ 2784
	.field	108,16		; r_updateindexv[175] @ 2800
	.field	0,16		; r_updateindexv[176] @ 2816
	.field	9,16		; r_updateindexv[177] @ 2832
	.field	72,16		; r_updateindexv[178] @ 2848
	.field	18,16		; r_updateindexv[179] @ 2864
	.field	0,16		; r_updateindexv[180] @ 2880
	.field	81,16		; r_updateindexv[181] @ 2896
	.field	72,16		; r_updateindexv[182] @ 2912
	.field	99,16		; r_updateindexv[183] @ 2928
	.field	0,16		; r_updateindexv[184] @ 2944
	.field	9,16		; r_updateindexv[185] @ 2960
	.field	72,16		; r_updateindexv[186] @ 2976
	.field	90,16		; r_updateindexv[187] @ 2992
	.field	0,16		; r_updateindexv[188] @ 3008
	.field	81,16		; r_updateindexv[189] @ 3024
	.field	72,16		; r_updateindexv[190] @ 3040
	.field	126,16		; r_updateindexv[191] @ 3056
	.field	0,16		; r_updateindexv[192] @ 3072
	.field	9,16		; r_updateindexv[193] @ 3088
	.field	72,16		; r_updateindexv[194] @ 3104
	.field	18,16		; r_updateindexv[195] @ 3120
	.field	0,16		; r_updateindexv[196] @ 3136
	.field	81,16		; r_updateindexv[197] @ 3152
	.field	72,16		; r_updateindexv[198] @ 3168
	.field	27,16		; r_updateindexv[199] @ 3184
	.field	0,16		; r_updateindexv[200] @ 3200
	.field	9,16		; r_updateindexv[201] @ 3216
	.field	72,16		; r_updateindexv[202] @ 3232
	.field	90,16		; r_updateindexv[203] @ 3248
	.field	0,16		; r_updateindexv[204] @ 3264
	.field	81,16		; r_updateindexv[205] @ 3280
	.field	72,16		; r_updateindexv[206] @ 3296
	.field	36,16		; r_updateindexv[207] @ 3312
	.field	0,16		; r_updateindexv[208] @ 3328
	.field	9,16		; r_updateindexv[209] @ 3344
	.field	72,16		; r_updateindexv[210] @ 3360
	.field	18,16		; r_updateindexv[211] @ 3376
	.field	0,16		; r_updateindexv[212] @ 3392
	.field	81,16		; r_updateindexv[213] @ 3408
	.field	72,16		; r_updateindexv[214] @ 3424
	.field	99,16		; r_updateindexv[215] @ 3440
	.field	0,16		; r_updateindexv[216] @ 3456
	.field	9,16		; r_updateindexv[217] @ 3472
	.field	72,16		; r_updateindexv[218] @ 3488
	.field	90,16		; r_updateindexv[219] @ 3504
	.field	0,16		; r_updateindexv[220] @ 3520
	.field	81,16		; r_updateindexv[221] @ 3536
	.field	72,16		; r_updateindexv[222] @ 3552
	.field	117,16		; r_updateindexv[223] @ 3568
	.field	0,16		; r_updateindexv[224] @ 3584
	.field	9,16		; r_updateindexv[225] @ 3600
	.field	72,16		; r_updateindexv[226] @ 3616
	.field	18,16		; r_updateindexv[227] @ 3632
	.field	0,16		; r_updateindexv[228] @ 3648
	.field	81,16		; r_updateindexv[229] @ 3664
	.field	72,16		; r_updateindexv[230] @ 3680
	.field	27,16		; r_updateindexv[231] @ 3696
	.field	0,16		; r_updateindexv[232] @ 3712
	.field	9,16		; r_updateindexv[233] @ 3728
	.field	72,16		; r_updateindexv[234] @ 3744
	.field	90,16		; r_updateindexv[235] @ 3760
	.field	0,16		; r_updateindexv[236] @ 3776
	.field	81,16		; r_updateindexv[237] @ 3792
	.field	72,16		; r_updateindexv[238] @ 3808
	.field	108,16		; r_updateindexv[239] @ 3824
	.field	0,16		; r_updateindexv[240] @ 3840
	.field	9,16		; r_updateindexv[241] @ 3856
	.field	72,16		; r_updateindexv[242] @ 3872
	.field	18,16		; r_updateindexv[243] @ 3888
	.field	0,16		; r_updateindexv[244] @ 3904
	.field	81,16		; r_updateindexv[245] @ 3920
	.field	72,16		; r_updateindexv[246] @ 3936
	.field	99,16		; r_updateindexv[247] @ 3952
	.field	0,16		; r_updateindexv[248] @ 3968
	.field	9,16		; r_updateindexv[249] @ 3984
	.field	72,16		; r_updateindexv[250] @ 4000
	.field	90,16		; r_updateindexv[251] @ 4016
	.field	0,16		; r_updateindexv[252] @ 4032
	.field	81,16		; r_updateindexv[253] @ 4048
	.field	72,16		; r_updateindexv[254] @ 4064


r_bitindexv
	.field	1,16		; r_bitindexv[0] @ 0
	.field	2,16		; r_bitindexv[1] @ 16
	.field	1,16		; r_bitindexv[2] @ 32
	.field	3,16		; r_bitindexv[3] @ 48
	.field	1,16		; r_bitindexv[4] @ 64
	.field	2,16		; r_bitindexv[5] @ 80
	.field	1,16		; r_bitindexv[6] @ 96
	.field	4,16		; r_bitindexv[7] @ 112
	.field	1,16		; r_bitindexv[8] @ 128
	.field	2,16		; r_bitindexv[9] @ 144
	.field	1,16		; r_bitindexv[10] @ 160
	.field	3,16		; r_bitindexv[11] @ 176
	.field	1,16		; r_bitindexv[12] @ 192
	.field	2,16		; r_bitindexv[13] @ 208
	.field	1,16		; r_bitindexv[14] @ 224
	.field	5,16		; r_bitindexv[15] @ 240
	.field	1,16		; r_bitindexv[16] @ 256
	.field	2,16		; r_bitindexv[17] @ 272
	.field	1,16		; r_bitindexv[18] @ 288
	.field	3,16		; r_bitindexv[19] @ 304
	.field	1,16		; r_bitindexv[20] @ 320
	.field	2,16		; r_bitindexv[21] @ 336
	.field	1,16		; r_bitindexv[22] @ 352
	.field	4,16		; r_bitindexv[23] @ 368
	.field	1,16		; r_bitindexv[24] @ 384
	.field	2,16		; r_bitindexv[25] @ 400
	.field	1,16		; r_bitindexv[26] @ 416
	.field	3,16		; r_bitindexv[27] @ 432
	.field	1,16		; r_bitindexv[28] @ 448
	.field	2,16		; r_bitindexv[29] @ 464
	.field	1,16		; r_bitindexv[30] @ 480
	.field	6,16		; r_bitindexv[31] @ 496
	.field	1,16		; r_bitindexv[32] @ 512
	.field	2,16		; r_bitindexv[33] @ 528
	.field	1,16		; r_bitindexv[34] @ 544
	.field	3,16		; r_bitindexv[35] @ 560
	.field	1,16		; r_bitindexv[36] @ 576
	.field	2,16		; r_bitindexv[37] @ 592
	.field	1,16		; r_bitindexv[38] @ 608
	.field	4,16		; r_bitindexv[39] @ 624
	.field	1,16		; r_bitindexv[40] @ 640
	.field	2,16		; r_bitindexv[41] @ 656
	.field	1,16		; r_bitindexv[42] @ 672
	.field	3,16		; r_bitindexv[43] @ 688
	.field	1,16		; r_bitindexv[44] @ 704
	.field	2,16		; r_bitindexv[45] @ 720
	.field	1,16		; r_bitindexv[46] @ 736
	.field	5,16		; r_bitindexv[47] @ 752
	.field	1,16		; r_bitindexv[48] @ 768
	.field	2,16		; r_bitindexv[49] @ 784
	.field	1,16		; r_bitindexv[50] @ 800
	.field	3,16		; r_bitindexv[51] @ 816
	.field	1,16		; r_bitindexv[52] @ 832
	.field	2,16		; r_bitindexv[53] @ 848
	.field	1,16		; r_bitindexv[54] @ 864
	.field	4,16		; r_bitindexv[55] @ 880
	.field	1,16		; r_bitindexv[56] @ 896
	.field	2,16		; r_bitindexv[57] @ 912
	.field	1,16		; r_bitindexv[58] @ 928
	.field	3,16		; r_bitindexv[59] @ 944
	.field	1,16		; r_bitindexv[60] @ 960
	.field	2,16		; r_bitindexv[61] @ 976
	.field	1,16		; r_bitindexv[62] @ 992
	.field	7,16		; r_bitindexv[63] @ 1008
	.field	1,16		; r_bitindexv[64] @ 1024
	.field	2,16		; r_bitindexv[65] @ 1040
	.field	1,16		; r_bitindexv[66] @ 1056
	.field	3,16		; r_bitindexv[67] @ 1072
	.field	1,16		; r_bitindexv[68] @ 1088
	.field	2,16		; r_bitindexv[69] @ 1104
	.field	1,16		; r_bitindexv[70] @ 1120
	.field	4,16		; r_bitindexv[71] @ 1136
	.field	1,16		; r_bitindexv[72] @ 1152
	.field	2,16		; r_bitindexv[73] @ 1168
	.field	1,16		; r_bitindexv[74] @ 1184
	.field	3,16		; r_bitindexv[75] @ 1200
	.field	1,16		; r_bitindexv[76] @ 1216
	.field	2,16		; r_bitindexv[77] @ 1232
	.field	1,16		; r_bitindexv[78] @ 1248
	.field	5,16		; r_bitindexv[79] @ 1264
	.field	1,16		; r_bitindexv[80] @ 1280
	.field	2,16		; r_bitindexv[81] @ 1296
	.field	1,16		; r_bitindexv[82] @ 1312
	.field	3,16		; r_bitindexv[83] @ 1328
	.field	1,16		; r_bitindexv[84] @ 1344
	.field	2,16		; r_bitindexv[85] @ 1360
	.field	1,16		; r_bitindexv[86] @ 1376
	.field	4,16		; r_bitindexv[87] @ 1392
	.field	1,16		; r_bitindexv[88] @ 1408
	.field	2,16		; r_bitindexv[89] @ 1424
	.field	1,16		; r_bitindexv[90] @ 1440
	.field	3,16		; r_bitindexv[91] @ 1456
	.field	1,16		; r_bitindexv[92] @ 1472
	.field	2,16		; r_bitindexv[93] @ 1488
	.field	1,16		; r_bitindexv[94] @ 1504
	.field	6,16		; r_bitindexv[95] @ 1520
	.field	1,16		; r_bitindexv[96] @ 1536
	.field	2,16		; r_bitindexv[97] @ 1552
	.field	1,16		; r_bitindexv[98] @ 1568
	.field	3,16		; r_bitindexv[99] @ 1584
	.field	1,16		; r_bitindexv[100] @ 1600
	.field	2,16		; r_bitindexv[101] @ 1616
	.field	1,16		; r_bitindexv[102] @ 1632
	.field	4,16		; r_bitindexv[103] @ 1648
	.field	1,16		; r_bitindexv[104] @ 1664
	.field	2,16		; r_bitindexv[105] @ 1680
	.field	1,16		; r_bitindexv[106] @ 1696
	.field	3,16		; r_bitindexv[107] @ 1712
	.field	1,16		; r_bitindexv[108] @ 1728
	.field	2,16		; r_bitindexv[109] @ 1744
	.field	1,16		; r_bitindexv[110] @ 1760
	.field	5,16		; r_bitindexv[111] @ 1776
	.field	1,16		; r_bitindexv[112] @ 1792
	.field	2,16		; r_bitindexv[113] @ 1808
	.field	1,16		; r_bitindexv[114] @ 1824
	.field	3,16		; r_bitindexv[115] @ 1840
	.field	1,16		; r_bitindexv[116] @ 1856
	.field	2,16		; r_bitindexv[117] @ 1872
	.field	1,16		; r_bitindexv[118] @ 1888
	.field	4,16		; r_bitindexv[119] @ 1904
	.field	1,16		; r_bitindexv[120] @ 1920
	.field	2,16		; r_bitindexv[121] @ 1936
	.field	1,16		; r_bitindexv[122] @ 1952
	.field	3,16		; r_bitindexv[123] @ 1968
	.field	1,16		; r_bitindexv[124] @ 1984
	.field	2,16		; r_bitindexv[125] @ 2000
	.field	1,16		; r_bitindexv[126] @ 2016
	.field	0,16		; r_bitindexv[127] @ 2032
	.field	1,16		; r_bitindexv[128] @ 2048
	.field	2,16		; r_bitindexv[129] @ 2064
	.field	1,16		; r_bitindexv[130] @ 2080
	.field	3,16		; r_bitindexv[131] @ 2096
	.field	1,16		; r_bitindexv[132] @ 2112
	.field	2,16		; r_bitindexv[133] @ 2128
	.field	1,16		; r_bitindexv[134] @ 2144
	.field	4,16		; r_bitindexv[135] @ 2160
	.field	1,16		; r_bitindexv[136] @ 2176
	.field	2,16		; r_bitindexv[137] @ 2192
	.field	1,16		; r_bitindexv[138] @ 2208
	.field	3,16		; r_bitindexv[139] @ 2224
	.field	1,16		; r_bitindexv[140] @ 2240
	.field	2,16		; r_bitindexv[141] @ 2256
	.field	1,16		; r_bitindexv[142] @ 2272
	.field	5,16		; r_bitindexv[143] @ 2288
	.field	1,16		; r_bitindexv[144] @ 2304
	.field	2,16		; r_bitindexv[145] @ 2320
	.field	1,16		; r_bitindexv[146] @ 2336
	.field	3,16		; r_bitindexv[147] @ 2352
	.field	1,16		; r_bitindexv[148] @ 2368
	.field	2,16		; r_bitindexv[149] @ 2384
	.field	1,16		; r_bitindexv[150] @ 2400
	.field	4,16		; r_bitindexv[151] @ 2416
	.field	1,16		; r_bitindexv[152] @ 2432
	.field	2,16		; r_bitindexv[153] @ 2448
	.field	1,16		; r_bitindexv[154] @ 2464
	.field	3,16		; r_bitindexv[155] @ 2480
	.field	1,16		; r_bitindexv[156] @ 2496
	.field	2,16		; r_bitindexv[157] @ 2512
	.field	1,16		; r_bitindexv[158] @ 2528
	.field	6,16		; r_bitindexv[159] @ 2544
	.field	1,16		; r_bitindexv[160] @ 2560
	.field	2,16		; r_bitindexv[161] @ 2576
	.field	1,16		; r_bitindexv[162] @ 2592
	.field	3,16		; r_bitindexv[163] @ 2608
	.field	1,16		; r_bitindexv[164] @ 2624
	.field	2,16		; r_bitindexv[165] @ 2640
	.field	1,16		; r_bitindexv[166] @ 2656
	.field	4,16		; r_bitindexv[167] @ 2672
	.field	1,16		; r_bitindexv[168] @ 2688
	.field	2,16		; r_bitindexv[169] @ 2704
	.field	1,16		; r_bitindexv[170] @ 2720
	.field	3,16		; r_bitindexv[171] @ 2736
	.field	1,16		; r_bitindexv[172] @ 2752
	.field	2,16		; r_bitindexv[173] @ 2768
	.field	1,16		; r_bitindexv[174] @ 2784
	.field	5,16		; r_bitindexv[175] @ 2800
	.field	1,16		; r_bitindexv[176] @ 2816
	.field	2,16		; r_bitindexv[177] @ 2832
	.field	1,16		; r_bitindexv[178] @ 2848
	.field	3,16		; r_bitindexv[179] @ 2864
	.field	1,16		; r_bitindexv[180] @ 2880
	.field	2,16		; r_bitindexv[181] @ 2896
	.field	1,16		; r_bitindexv[182] @ 2912
	.field	4,16		; r_bitindexv[183] @ 2928
	.field	1,16		; r_bitindexv[184] @ 2944
	.field	2,16		; r_bitindexv[185] @ 2960
	.field	1,16		; r_bitindexv[186] @ 2976
	.field	3,16		; r_bitindexv[187] @ 2992
	.field	1,16		; r_bitindexv[188] @ 3008
	.field	2,16		; r_bitindexv[189] @ 3024
	.field	1,16		; r_bitindexv[190] @ 3040
	.field	7,16		; r_bitindexv[191] @ 3056
	.field	1,16		; r_bitindexv[192] @ 3072
	.field	2,16		; r_bitindexv[193] @ 3088
	.field	1,16		; r_bitindexv[194] @ 3104
	.field	3,16		; r_bitindexv[195] @ 3120
	.field	1,16		; r_bitindexv[196] @ 3136
	.field	2,16		; r_bitindexv[197] @ 3152
	.field	1,16		; r_bitindexv[198] @ 3168
	.field	4,16		; r_bitindexv[199] @ 3184
	.field	1,16		; r_bitindexv[200] @ 3200
	.field	2,16		; r_bitindexv[201] @ 3216
	.field	1,16		; r_bitindexv[202] @ 3232
	.field	3,16		; r_bitindexv[203] @ 3248
	.field	1,16		; r_bitindexv[204] @ 3264
	.field	2,16		; r_bitindexv[205] @ 3280
	.field	1,16		; r_bitindexv[206] @ 3296
	.field	5,16		; r_bitindexv[207] @ 3312
	.field	1,16		; r_bitindexv[208] @ 3328
	.field	2,16		; r_bitindexv[209] @ 3344
	.field	1,16		; r_bitindexv[210] @ 3360
	.field	3,16		; r_bitindexv[211] @ 3376
	.field	1,16		; r_bitindexv[212] @ 3392
	.field	2,16		; r_bitindexv[213] @ 3408
	.field	1,16		; r_bitindexv[214] @ 3424
	.field	4,16		; r_bitindexv[215] @ 3440
	.field	1,16		; r_bitindexv[216] @ 3456
	.field	2,16		; r_bitindexv[217] @ 3472
	.field	1,16		; r_bitindexv[218] @ 3488
	.field	3,16		; r_bitindexv[219] @ 3504
	.field	1,16		; r_bitindexv[220] @ 3520
	.field	2,16		; r_bitindexv[221] @ 3536
	.field	1,16		; r_bitindexv[222] @ 3552
	.field	6,16		; r_bitindexv[223] @ 3568
	.field	1,16		; r_bitindexv[224] @ 3584
	.field	2,16		; r_bitindexv[225] @ 3600
	.field	1,16		; r_bitindexv[226] @ 3616
	.field	3,16		; r_bitindexv[227] @ 3632
	.field	1,16		; r_bitindexv[228] @ 3648
	.field	2,16		; r_bitindexv[229] @ 3664
	.field	1,16		; r_bitindexv[230] @ 3680
	.field	4,16		; r_bitindexv[231] @ 3696
	.field	1,16		; r_bitindexv[232] @ 3712
	.field	2,16		; r_bitindexv[233] @ 3728
	.field	1,16		; r_bitindexv[234] @ 3744
	.field	3,16		; r_bitindexv[235] @ 3760
	.field	1,16		; r_bitindexv[236] @ 3776
	.field	2,16		; r_bitindexv[237] @ 3792
	.field	1,16		; r_bitindexv[238] @ 3808
	.field	5,16		; r_bitindexv[239] @ 3824
	.field	1,16		; r_bitindexv[240] @ 3840
	.field	2,16		; r_bitindexv[241] @ 3856
	.field	1,16		; r_bitindexv[242] @ 3872
	.field	3,16		; r_bitindexv[243] @ 3888
	.field	1,16		; r_bitindexv[244] @ 3904
	.field	2,16		; r_bitindexv[245] @ 3920
	.field	1,16		; r_bitindexv[246] @ 3936
	.field	4,16		; r_bitindexv[247] @ 3952
	.field	1,16		; r_bitindexv[248] @ 3968
	.field	2,16		; r_bitindexv[249] @ 3984
	.field	1,16		; r_bitindexv[250] @ 4000
	.field	3,16		; r_bitindexv[251] @ 4016
	.field	1,16		; r_bitindexv[252] @ 4032
	.field	2,16		; r_bitindexv[253] @ 4048
	.field	1,16		; r_bitindexv[254] @ 4064


	.if	rom_compat
r_modnextbitv
	.field	1,16		; r_modnextbitv[0] @ 0
	.field	2,16		; r_modnextbitv[1] @ 16
	.field	3,16		; r_modnextbitv[2] @ 32
	.field	4,16		; r_modnextbitv[3] @ 48
	.field	5,16		; r_modnextbitv[4] @ 64
	.field	6,16		; r_modnextbitv[5] @ 80
	.field	7,16		; r_modnextbitv[6] @ 96
	.field	0,16		; r_modnextbitv[7] @ 112
	.field	1,16		; r_modnextbitv[8] @ 128
	.endif


r_updateindexun
	.field	0,16		; r_updateindexun[0] @ 0
	.field	7,16		; r_updateindexun[1] @ 16
	.field	42,16		; r_updateindexun[2] @ 32
	.field	14,16		; r_updateindexun[3] @ 48
	.field	0,16		; r_updateindexun[4] @ 64
	.field	49,16		; r_updateindexun[5] @ 80
	.field	42,16		; r_updateindexun[6] @ 96
	.field	21,16		; r_updateindexun[7] @ 112
	.field	0,16		; r_updateindexun[8] @ 128
	.field	7,16		; r_updateindexun[9] @ 144
	.field	42,16		; r_updateindexun[10] @ 160
	.field	56,16		; r_updateindexun[11] @ 176
	.field	0,16		; r_updateindexun[12] @ 192
	.field	49,16		; r_updateindexun[13] @ 208
	.field	42,16		; r_updateindexun[14] @ 224
	.field	28,16		; r_updateindexun[15] @ 240
	.field	0,16		; r_updateindexun[16] @ 256
	.field	7,16		; r_updateindexun[17] @ 272
	.field	42,16		; r_updateindexun[18] @ 288
	.field	14,16		; r_updateindexun[19] @ 304
	.field	0,16		; r_updateindexun[20] @ 320
	.field	49,16		; r_updateindexun[21] @ 336
	.field	42,16		; r_updateindexun[22] @ 352
	.field	63,16		; r_updateindexun[23] @ 368
	.field	0,16		; r_updateindexun[24] @ 384
	.field	7,16		; r_updateindexun[25] @ 400
	.field	42,16		; r_updateindexun[26] @ 416
	.field	56,16		; r_updateindexun[27] @ 432
	.field	0,16		; r_updateindexun[28] @ 448
	.field	49,16		; r_updateindexun[29] @ 464
	.field	42,16		; r_updateindexun[30] @ 480
	.field	35,16		; r_updateindexun[31] @ 496
	.field	0,16		; r_updateindexun[32] @ 512
	.field	7,16		; r_updateindexun[33] @ 528
	.field	42,16		; r_updateindexun[34] @ 544
	.field	14,16		; r_updateindexun[35] @ 560
	.field	0,16		; r_updateindexun[36] @ 576
	.field	49,16		; r_updateindexun[37] @ 592
	.field	42,16		; r_updateindexun[38] @ 608
	.field	21,16		; r_updateindexun[39] @ 624
	.field	0,16		; r_updateindexun[40] @ 640
	.field	7,16		; r_updateindexun[41] @ 656
	.field	42,16		; r_updateindexun[42] @ 672
	.field	56,16		; r_updateindexun[43] @ 688
	.field	0,16		; r_updateindexun[44] @ 704
	.field	49,16		; r_updateindexun[45] @ 720
	.field	42,16		; r_updateindexun[46] @ 736
	.field	70,16		; r_updateindexun[47] @ 752
	.field	0,16		; r_updateindexun[48] @ 768
	.field	7,16		; r_updateindexun[49] @ 784
	.field	42,16		; r_updateindexun[50] @ 800
	.field	14,16		; r_updateindexun[51] @ 816
	.field	0,16		; r_updateindexun[52] @ 832
	.field	49,16		; r_updateindexun[53] @ 848
	.field	42,16		; r_updateindexun[54] @ 864
	.field	63,16		; r_updateindexun[55] @ 880
	.field	0,16		; r_updateindexun[56] @ 896
	.field	7,16		; r_updateindexun[57] @ 912
	.field	42,16		; r_updateindexun[58] @ 928
	.field	56,16		; r_updateindexun[59] @ 944
	.field	0,16		; r_updateindexun[60] @ 960
	.field	49,16		; r_updateindexun[61] @ 976
	.field	42,16		; r_updateindexun[62] @ 992


r_bitindexun
	.field	1,16		; r_bitindexun[0] @ 0
	.field	2,16		; r_bitindexun[1] @ 16
	.field	1,16		; r_bitindexun[2] @ 32
	.field	3,16		; r_bitindexun[3] @ 48
	.field	1,16		; r_bitindexun[4] @ 64
	.field	2,16		; r_bitindexun[5] @ 80
	.field	1,16		; r_bitindexun[6] @ 96
	.field	4,16		; r_bitindexun[7] @ 112
	.field	1,16		; r_bitindexun[8] @ 128
	.field	2,16		; r_bitindexun[9] @ 144
	.field	1,16		; r_bitindexun[10] @ 160
	.field	3,16		; r_bitindexun[11] @ 176
	.field	1,16		; r_bitindexun[12] @ 192
	.field	2,16		; r_bitindexun[13] @ 208
	.field	1,16		; r_bitindexun[14] @ 224
	.field	5,16		; r_bitindexun[15] @ 240
	.field	1,16		; r_bitindexun[16] @ 256
	.field	2,16		; r_bitindexun[17] @ 272
	.field	1,16		; r_bitindexun[18] @ 288
	.field	3,16		; r_bitindexun[19] @ 304
	.field	1,16		; r_bitindexun[20] @ 320
	.field	2,16		; r_bitindexun[21] @ 336
	.field	1,16		; r_bitindexun[22] @ 352
	.field	4,16		; r_bitindexun[23] @ 368
	.field	1,16		; r_bitindexun[24] @ 384
	.field	2,16		; r_bitindexun[25] @ 400
	.field	1,16		; r_bitindexun[26] @ 416
	.field	3,16		; r_bitindexun[27] @ 432
	.field	1,16		; r_bitindexun[28] @ 448
	.field	2,16		; r_bitindexun[29] @ 464
	.field	1,16		; r_bitindexun[30] @ 480
	.field	0,16		; r_bitindexun[31] @ 496
	.field	1,16		; r_bitindexun[32] @ 512
	.field	2,16		; r_bitindexun[33] @ 528
	.field	1,16		; r_bitindexun[34] @ 544
	.field	3,16		; r_bitindexun[35] @ 560
	.field	1,16		; r_bitindexun[36] @ 576
	.field	2,16		; r_bitindexun[37] @ 592
	.field	1,16		; r_bitindexun[38] @ 608
	.field	4,16		; r_bitindexun[39] @ 624
	.field	1,16		; r_bitindexun[40] @ 640
	.field	2,16		; r_bitindexun[41] @ 656
	.field	1,16		; r_bitindexun[42] @ 672
	.field	3,16		; r_bitindexun[43] @ 688
	.field	1,16		; r_bitindexun[44] @ 704
	.field	2,16		; r_bitindexun[45] @ 720
	.field	1,16		; r_bitindexun[46] @ 736
	.field	5,16		; r_bitindexun[47] @ 752
	.field	1,16		; r_bitindexun[48] @ 768
	.field	2,16		; r_bitindexun[49] @ 784
	.field	1,16		; r_bitindexun[50] @ 800
	.field	3,16		; r_bitindexun[51] @ 816
	.field	1,16		; r_bitindexun[52] @ 832
	.field	2,16		; r_bitindexun[53] @ 848
	.field	1,16		; r_bitindexun[54] @ 864
	.field	4,16		; r_bitindexun[55] @ 880
	.field	1,16		; r_bitindexun[56] @ 896
	.field	2,16		; r_bitindexun[57] @ 912
	.field	1,16		; r_bitindexun[58] @ 928
	.field	3,16		; r_bitindexun[59] @ 944
	.field	1,16		; r_bitindexun[60] @ 960
	.field	2,16		; r_bitindexun[61] @ 976
	.field	1,16		; r_bitindexun[62] @ 992


	.if	rom_compat
r_modnextbituv
	.field	1,16		; r_modnextbituv[0] @ 0
	.field	2,16		; r_modnextbituv[1] @ 16
	.field	3,16		; r_modnextbituv[2] @ 32
	.field	4,16		; r_modnextbituv[3] @ 48
	.field	5,16		; r_modnextbituv[4] @ 64
	.field	0,16		; r_modnextbituv[5] @ 80
	.field	1,16		; r_modnextbituv[6] @ 96
	.endif


	.if	rom_compat
r_pcoefe
	.field	5615,16 		; r_pcoefe[0] @ 0
	.field	21871,16		; r_pcoefe[1] @ 16
	.field	32701,16		; r_pcoefe[2] @ 32
	.endif

;***************************************************************
;
;
;
; Description : Initialized static variables for half Rate 
;               Speech Codec Modified from the output of 
;               Lead C-compiler.
;
;***************************************************************
	.if	rom_compat

	.def	r_muteflagold
	.def	r_lastr0
	.def	r_state
	.def	r_lastflag
	.def	r_subfrmenergymem
	.def	r_levelmem
	.def	r_c0
	.def	r_c1
	.def	r_c2
	.def	r_wstatenum
	.def	r_wstatedenom



	.sect	"hstabrom"


r_muteflagold
	.field	0,16		; r_muteflagold @ 0

r_lastr0
	.field	0,16		; r_lastr0 @ 0

r_state
	.field	7,16		; r_state @ 0

r_lastflag
	.field	0,16		; r_lastflag @ 0


***	.align	2
r_subfrmenergymem
	.field	80,32		; r_subfrmenergymem[0] @ 0
	.field	80,32		; r_subfrmenergymem[1] @ 32
	.field	80,32		; r_subfrmenergymem[2] @ 64
	.field	80,32		; r_subfrmenergymem[3] @ 96


r_levelmem
	.field	-72,16		; r_levelmem[0] @ 0
	.field	-72,16		; r_levelmem[1] @ 16
	.field	-72,16		; r_levelmem[2] @ 32
	.field	-72,16		; r_levelmem[3] @ 48

r_c0
	.field	-11050,16		; r_c0 @ 0

r_c1
	.field	32709,16		; r_c1 @ 0

r_c2
	.field	-21712,16		; r_c2 @ 0

r_wstatenum
	.field	0,16		; r_wstatenum[0] @ 0
	.field	0,16		; r_wstatenum[1] @ 16
	.field	0,16		; r_wstatenum[2] @ 32
	.field	0,16		; r_wstatenum[3] @ 48
	.field	0,16		; r_wstatenum[4] @ 64
	.field	0,16		; r_wstatenum[5] @ 80
	.field	0,16		; r_wstatenum[6] @ 96
	.field	0,16		; r_wstatenum[7] @ 112
	.field	0,16		; r_wstatenum[8] @ 128
	.field	0,16		; r_wstatenum[9] @ 144

r_wstatedenom
	.field	0,16		; r_wstatedenom[0] @ 0
	.field	0,16		; r_wstatedenom[1] @ 16
	.field	0,16		; r_wstatedenom[2] @ 32
	.field	0,16		; r_wstatedenom[3] @ 48
	.field	0,16		; r_wstatedenom[4] @ 64
	.field	0,16		; r_wstatedenom[5] @ 80
	.field	0,16		; r_wstatedenom[6] @ 96
	.field	0,16		; r_wstatedenom[7] @ 112
	.field	0,16		; r_wstatedenom[8] @ 128
	.field	0,16		; r_wstatedenom[9] @ 144

	.endif

	.end
